// GrabsrvDlg.h : header file
//
//{{AFX_INCLUDES()
#include "srv.h"
//}}AFX_INCLUDES

#if !defined(AFX_GRABSRVDLG_H__F26604C7_51FD_11D6_9B36_0004769003D4__INCLUDED_)
#define AFX_GRABSRVDLG_H__F26604C7_51FD_11D6_9B36_0004769003D4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog
//
// This is the main dialog of the Grabber server application. In principle, this class 
// controls the whole application. All the other classes are just helper classes for
// this main class.
//

class CMainDlg : public CDialog
{
// Construction
public:
	void UpdateTineActive();
    // standard constructor
	CMainDlg(CWnd* pParent = NULL);	

    // prints out server message
    void PrintServerMessage(CString message);

    // sets a reference to the main application object into the 
	// CMainDlg class
	void setApp( CGrabsrvApp *the_app);

	// Dialog Data
	//{{AFX_DATA(CMainDlg)
	enum { IDD = IDD_GRABSRV_DIALOG };
	CButton	m_CCheckNewCamTriggerMod5;
	CButton	m_CCheckCurCamTriggerMod5;
	CButton	m_CCheckNewCamExternalTrigger;
	CButton	m_CCheckCurCamExternalTrigger;
	CStatic	m_CStaticLossyEnabled1;
	CStatic	m_CStaticLossyEnabled;
	CButton	m_CCheckLossyEnabled;
	CEdit	m_CEditTINEActive;
	CEdit	m_CEditNewCamWidth;
	CEdit	m_CEditNewCamScale;
	CEdit	m_CEditNewCamPRef;
	CEdit	m_CEditNewCamPort;
	CEdit	m_CEditNewCamNRef;
	CEdit	m_CEditNewCamOrient;
	CEdit	m_CEditNewCamName;
	CEdit	m_CEditNewCamID;
	CEdit	m_CEditNewCamHeight;
	CEdit	m_CEditNewCamBPP;
	CEdit	m_CEditLossyClients;
	CEdit	m_CEditCurCamWidth;
	CEdit	m_CEditCurCamScale;
	CEdit	m_CEditCurCamNRef;
	CEdit	m_CEditCurCamName;
	CEdit	m_CEditCurCamID;
	CEdit	m_CEditCurCamHeight;
	CEdit	m_CEditCurCamPRef;
	CEdit	m_CEditCurCamPort;
	CEdit	m_CEditCurCamOrient;
	CEdit	m_CEditCurCamBPP;
	CEdit	m_CEditNumClients;
	CEdit	m_CEditHeartbeat;
	CEdit	m_CEditFramerate;
	CButton	m_ButtonClose;
	CButton	m_CButtonStopGrabbing;
	CButton	m_CButtonStartGrabbing;
	CButton	m_CButtonSnapPicture;
	CButton	m_CButtonConfig;
	CEdit	m_CEditStatus;
	CEdit	m_CEditServerMessages;
	CSrv	m_CTineServer;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
    // own error handler
	int myErrorHandler( int errornum, const char *format, ... );
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CMainDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonConfig();
	afx_msg void OnButtonStartGrabbing();
	afx_msg void OnButtonStopGrabbing();
	afx_msg void OnNotifyGrabbed();
	afx_msg void OnButtonClose();
	afx_msg void OnEqpFcnSrvctrl1(LPCTSTR devName, LPCTSTR devProperty, long outArrayLen, long inArrayLen, short devAccess);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
    afx_msg LRESULT OnRemoveClient( WPARAM wParam, LPARAM lParam);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg BOOL OnQueryEndSession();
	afx_msg void OnEndSession(BOOL bEnding);
	afx_msg LRESULT OnMessageStartGrabbing(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnMessageStopGrabbing(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnMessageUpdateGrabbing(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnMessageCloseServer(WPARAM wParam, LPARAM lParam);
	afx_msg void OnTimer(UINT nIDEvent);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:

	BOOL CheckEffectiveBits(void *imagedata, UINT bpp, UINT bpp_eff, UINT numpixels);

    _timeb m_tLastFrameAcquiredAt;
	
	void UpdateTineTransferControl();
	BOOL UpdateCameraSettings();
	void AdjustNextCameraDisplayedSettings();
	void AdjustCurrentCameraDisplayedSettings();
	UINT m_nTimer;
	UINT m_nTineActiveTimer;
	BOOL m_bLossyEnabled;
	CJPEGCompression * m_pJPEGCompression;
	int m_iGrabBpp;
	int m_iGrabHeight;
	int m_iGrabWidth;
	// queue to hold the grabbed frames (CGrab -> CMainDlg)
	CQueue *m_pGrabQueue;

    // initialization file object
	CIniEx *m_pIniFile;
    
	// functions to initialize and deinitialize the ini file
	BOOL InitializeIniFile();
	void DeinitializeIniFile();

    // override base class behaviours
	// first deinitialize everything, then close the application
    void OnOK();
	void OnCancel();

    // reference to the application object in order to 
	// access the registry (not needed at the moment)
	CGrabsrvApp * m_pApp;

	int m_iAktFrameLength;
	int m_iJPEGFrameLength;
	int m_iJPEGMaxFrameLength;
	unsigned int m_iFrameNo;
	int m_iJPEGQuality;
	
	// pointer to store the actually acquired frame (compressed or uncompressed)
	// before it gets send out
	char *m_pAktFrameData;
	char *m_pJPEGFrameData;
	
	// grab class
	CGrab *m_pGrab;

    // TRUE: notify procedure is running (to acquire a new frame)
	BOOL m_bNotifyRunning;

	// needed for compression 
	BITMAPINFOHEADER m_InputFmt;
	LPBITMAPINFOHEADER m_pOutputFmt;
	CCompression *m_pCodec;
	
	// class that encapsulates all settings of the application
	// (includes loading and saving of configuration files)
	//CConfiguration *m_pConfig;

    // last error code, not used but needed at the moment
	int m_iLastError;
	
	// very first timestamp (needed to calculate frame rate)
	_timeb m_tVeryFirstTimestamp;

    // initialize/deinitialize socket part (to send out the video data)
    BOOL InitializeNetwork(int port, int nummaxconnections, int enabled2, int port2, int nummaxc2, CString tine_servername, int size_in_bytes);
    BOOL DeinitializeNetwork();
    
	// initialize/deinitialize TINE part (camera control connections
	// like get/set camera port, retrieve camera strings)
	BOOL InitializeTine();
    BOOL DeinitializeTine();

    // initialize/deinitialize compression codec and routines
	BOOL InitializeCompressionCodec(int width, int height, int bpp);
	BOOL DeinitializeCompressionCodec();

    // initialize/deinitialize ITEX grabber API
	BOOL InitializeITEXGrabber();
	BOOL DeinitializeITEX();

	CTime			m_tServerStartTime;

    // camera description strings of the four ports
	CTime			m_tCurCamStartTime;
	CString			m_sCurCamName;
	CString			m_sCurCamID;
	unsigned int    m_iCurCamWidth;
	unsigned int	m_iCurCamHeight;
	unsigned int	m_iCurCamBPP;
	unsigned int	m_iCurCamPort;
	double			m_dCurCamScale;
	unsigned int	m_iCurCamPRef;
	unsigned int	m_iCurCamNRef;
	CString			m_sCurCamOrient;
	unsigned int    m_iCurCamTrigger;
	unsigned int    m_iCurCamTrigMod5;

	CString			m_sNextCamName;
	CString			m_sNextCamID;
	unsigned int    m_iNextCamWidth;
	unsigned int	m_iNextCamHeight;
	unsigned int	m_iNextCamBPP;
	unsigned int	m_iNextCamPort;
	double			m_dNextCamScale;
	unsigned int	m_iNextCamPRef;
	unsigned int	m_iNextCamNRef;
	CString			m_sNextCamOrient;
	unsigned int    m_iNextCamTrigger;
	unsigned int    m_iNextCamTrigMod5;

    // socket encapsulation, listen thread and tine server for frame data
	CSocketEncapsulation m_CSockEncap;
	CSocketEncapsulation2 m_CSockEncap2;

    /* fourier variables */

    // TRUE: attention: fourier variables (see below) are updated
	// at the moment
    BOOL m_bFourierUpdate;

    // fourier variables: values needed for storing spot position and size (for laser)
	float m_fXMean;
	float m_fYMean;
	float m_fXRms;
	float m_fYRms;

    // fourier statistics class 
	CFourierStat *m_pFourierStat;

    // grabbing thread function
    static UINT threadDeadManFlipFlopStatic(LPVOID pParam);
	UINT threadDeadManFlipFlop();
    // CWinThread object for grabbing thread
    CWinThread *m_pDeadManFlipFlopThread;
	BOOL m_bDeadManFlipFlop;
	BOOL m_bDeadManFlipFlopRunning;
	BOOL m_bDeadManFlipFlopIsActive;
	
	BOOL getInteger( unsigned int &outdata, unsigned int lowbound, unsigned int highbound );
	BOOL getDouble( double &outdata, double lowbound, double highbound );
	BOOL getString( CString &outdata );
	BOOL sendString( CString str );
	BOOL sendInteger( unsigned int data );
	BOOL sendDouble( double data );

	BOOL m_bGrabbingStarted;
	BOOL m_iUpdateSuccessful;
	BOOL m_bGrabbingCanBeStarted;

	BOOL m_bTineTransferRunning;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GRABSRVDLG_H__F26604C7_51FD_11D6_9B36_0004769003D4__INCLUDED_)
