// MemoryManagement.h: Schnittstelle fr die Klasse CMemoryManagement.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MEMORYMANAGEMENT_H__334FEB30_2F91_49BE_98C5_EB9113631268__INCLUDED_)
#define AFX_MEMORYMANAGEMENT_H__334FEB30_2F91_49BE_98C5_EB9113631268__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


// define when using Intel compiler
// undefine when using microsoft visual c compiler
//#define __INTEL__

//////////////////////////////////////////////////////////////////////
// CMemoryManagement
//
// This class encapsulates the memory management routines. You can allocate
// and free aligned memory and use a memory copy routine. This memory copy
// routine at the moment maps only to memcpy(), but later it may contain
// a dispatcher to call platform-optimized memory copy routine(s).
//
class CMemoryManagement  
{
public:
	// construction and destruction
	CMemoryManagement();
	virtual ~CMemoryManagement();

    // malloc aligned memory
    void *sw_malloc( int size );

	// free memory allocated by aligned malloc function sw_malloc()
    void  sw_free( void *ptr );

    // memory copy wrapper
	static void memcpysw( char *dst, char *src, int length );

private:
    // classes needed for thread-safe behaviour
	//CCriticalSection m_CriticalSection;
	//CSingleLock *m_pSingleLock;
    CRITICAL_SECTION lock;
};


#endif // !defined(AFX_MEMORYMANAGEMENT_H__334FEB30_2F91_49BE_98C5_EB9113631268__INCLUDED_)
