#if !defined(AFX_SOCKETENCAPSULATION2_H__A584BC49_76CA_11D6_AFB3_0002B34B0F4F__INCLUDED_)
#define AFX_SOCKETENCAPSULATION2_H__A584BC49_76CA_11D6_AFB3_0002B34B0F4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SocketEncapsulation1.h : header file
//

//////////////////////////////////////////////////////////////////////////////
// CSocketEncapsulation class
//
// This class is responsible for all socket-based happenings. It starts up a
// listen thread which listens for incoming connections and accepts them. It 
// also fires up send and receive threads on the accepted sockets so that the
// application is able to send out the video frames. From application point of
// view you only have to initialize this class and put data in it. The data
// will be send out to all connected clients.
//
//////////////////////////////////////////////////////////////////////////////

class CSocketEncapsulation2 
//: public CWnd
{
// Construction
public:
	// update the number of clients on the main dialog window
	void doUpdateNumClients(BOOL isitokayto);
	
	// construction
	CSocketEncapsulation2();

	// destruction
	virtual ~CSocketEncapsulation2();

    // initialize socket encapsulation class
    BOOL Init( int listenport, int maxnumclients, CMainDlg *the_dlg );
	
	// sends out a frame to all connected clients 
	BOOL Send( char *buffer, int length);
	
	BOOL Done(); // frees up all clients, deinitializes class

    // remove a special client from "subscription" list
	UINT RemoveClient( CSendReceive2 *sendrecv);

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSocketEncapsulation2)
	//}}AFX_VIRTUAL

// Implementation
public:

	// Generated message map functions
protected:
	//{{AFX_MSG(CSocketEncapsulation2)
	//}}AFX_MSG
	//DECLARE_MESSAGE_MAP()
private:

    // TRUE: it is not allowed to shutdown the client now 
	// (because we are deinitializing the class)
	BOOL m_bNoRemoveClient;
	
    // TRUE: it is not allowed to shutdown the client now 
	// (because we are sending out data to all CSendReceive classes)
	BOOL m_bDoNotClose;
	
	// is it okay to update the number of clients on the main dialog
	BOOL m_bShowingPossible;
 
    // true if the class is initialized
	BOOL m_bInitialized;

    // reference to listen socket class
	SSyncSocket *m_pSSock;

    // list of all clients (pointer to responsible CSendReceive class)
	CQueue *m_pClientList;

    // number of connected clients
	int m_iNumClients;

	// maximum number of connected clients 
	int m_iMaxNumClients;

    // update the number of clients (on the main dialog window)
	void UpdateNumberClients();

    // listen-thread functions
	static UINT thread_listen_static(LPVOID *p);
	UINT thread_listen();

    // listen thread variables
	CWinThread *m_pListenThread;
	BOOL m_bListenThreadRunning;
	
	// reference to main dialog window
	CMainDlg *m_pMainDlg;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SOCKETENCAPSULATION2_H__A584BC49_76CA_11D6_AFB3_0002B34B0F4F__INCLUDED_)
