#ifndef __HEADERS__H__INCLUDED__

#define __HEADERS__H__INCLUDED__

#define UINT unsigned int
#define USINT unsigned short int
#define ID_REMOVE_CLIENT WM_USER+1212
#define ID_REMOVE_CLIENT_2 WM_USER+1213
#define ID_START_GRABBING WM_USER+1214
#define ID_CLOSE_SERVER   WM_USER+1215
#define WM_TIMER_SETENVVAR WM_USER+1216
#define ID_STOP_GRABBING WM_USER+1217
#define ID_UPDATE_GRABBING WM_USER+1218
#define WM_TIMER_CLEARTINE WM_USER+1219
#include <sys\timeb.h>
#include <sys\types.h>

typedef struct {
  UINT   kennung;      // 0x11223344;
  UINT   compression;  // FOURCC codec name
  UINT   len_total;    // length of data + formatheader + vidhdr
  UINT   len_data;     // length of the data (compressed image) 
  UINT   len_fmthdr;   // length of the format header (needed for decompression)
  UINT   frameno;      // since starting the grabserver
  _timeb timestamp;    // time in milliseconds since 1970 // _ftime() _timeb structure
  UINT   cameraport;   // port of the camera (0..3)
  UINT   widthframe;   // width of the video frame
  UINT   heightframe;  // height of the video frame
  UINT   compressed;   // 1= picture is compressed 
  // 0= picture is not compressed because if it would be compressed it would be too big
  double framerate;    // actual averaged framerate
  double scale;
  UINT   bpp; // bits per monochrome pixel (e.g. 8) 
  UINT	 bpp_effective;
  char   reserved[8];
} VIDHDR;

typedef struct {
  UINT   kennung;      // 0x11223344;
  UINT   compression;  // FOURCC codec name
  UINT   len_total;    // length of data + formatheader + vidhdr
  UINT   len_data;     // length of the data (compressed image) 
  UINT   len_fmthdr;   // length of the format header (needed for decompression)
  UINT   frameno;      // since starting the grabserver
  _timeb timestamp;    // time in milliseconds since 1970 // _ftime() _timeb structure
  USINT   cameraport;   // port of the camera (0..3)
  USINT   widthframe;   // width of the video frame
  USINT   heightframe;  // height of the video frame
  USINT   compressed;   // 1= picture is compressed 
  // 0= picture is not compressed because if it would be compressed it would be too big
  double scale;
  USINT   bpp; // bits per monochrome pixel (e.g. 8) 
  char   cportstring[30];
} JPEGVIDHDR;


#pragma pack(1)

// structure needed to send the spot data out using TINE 
// to some client which needs it

typedef struct {
  int   xm;
  float ym;
  float xrms;
  float yrms;
} SPOTDATA;

#include "MemoryManagement.h"

extern CMemoryManagement memman;

#endif

