#ifndef DATABASE_H_
#define DATABASE_H_

#include "project.def"
#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#define TXT 0
#define INT 1
#define FLT 2
#define HEX 3
#define SHT 4
#define FMT 5
#define ACC 6

typedef struct
{
	char ColName[40];
	long Type;
	void *Address;
}DataBaseElemsStruct;

typedef struct    /* local */
{
  char UserName[16];
}UserListStruct;

int ReadDataBase(DataBaseElemsStruct *elems);
int GetDataBaseProperties(char *properties,int size,char *file);
int GetDataBaseSize(char *filename);
int locateFecName(char *fecname);
int locateTagName(char *expname,char *context,int *rpcidx);
int asyncLocateFecName(char *fecname);
int asyncLocateTagName(char *expname,char *context);
int GetAddressFromNameFile(char *context,char *expname, char *fecname,int *rpcidx);
int GetAddressFromNameServer(char *context,char *expname, char *fecname,int *rpcidx);
int GetAllocSizesFromNameServer(int *RPCsize,int *FECsize);
int GetAllocSizesFromNameFile(int *RPCsize,int *FECsize);
int namcmp(char *name,char *str,int col,int limit);
int findcol(char *str,char *tag);
char *colptr(int col,char *str);
void BytesToHex(BYTE *b,char *s,int n);
void HextoBytes(char *s,BYTE *b,int nibs);
int GetNameServerAddress(void);
int getFecName(void);
int appendRegisteredUserList(char *user);
int removeRegisteredUser(char *user);
int getRegisteredUsers(UserListStruct **ul,char *fn,int *nr,char *accstr,int *accflg);
void dumpRegisteredUsers(void);
int getRegisteredExports(void);
char *GetExportedName(char *eqpname);
int dumpRegisteredProperties(char *name);
NAME32 *GetEqpModuleNames(char *eqname,int num);
char *GetDeviceName(char *eqm,int devnr);
int GetDeviceNumber(char *eqm,char *dev);
int AssignNumModules(char *eqname,int num);
int GetPropertyId(char *eqm,char *prpName);
int outputConsumerList(FILE *fp);
int outputContractList(FILE *fp);
int outputContractStats(FILE *fp,int i);
int outputConnectionStats(int k);
int dumpContractStats(int i);
int dumpConnectionStats(int i);

extern FILE *dbgfp;
extern char dbgbuf[256];
extern char tagNameFilter[64];
extern int dbaseloaded;
extern DataBaseElemsStruct UserListElems[];
extern DataBaseElemsStruct BrdcstListElems[];
extern DataBaseElemsStruct PropertyListElems[];
extern DataBaseElemsStruct RPCDataElems[];
extern DataBaseElemsStruct RPCFecElems[];
extern int MaxRPCAllocation;
extern char ControlDBpath[80];
extern int WRITEaccess;
extern int DENYaccess;
extern int NrOfUsers;
extern int NrOfDeniedUsers;
extern char FecDBpath[80];
extern char fecname[17];
extern int FecNameRegistered;
extern int ExportsRegistered;
extern UserListStruct *UserList;
extern UserListStruct *DeniedUserList;

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif /* DATABASE_H_ */
