#ifndef _TOOLKIT_H_
#define _TOOLKIT_H_

#include "project.def"
#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#include "errors.h"
#include "rpctypes.h"

extern char fecname[17];
extern int fecLogFileDepth;

int getValuesAsShort(DTYPE *d,short *sval,short num);
#define GetValuesAsShort(d,s,n) getValuesAsShort(d,s,n)
int putValuesFromShort(DTYPE *d,short *sval,short num);
#define PutValuesFromShort(d,s,n) putValuesFromShort(d,s,n)
int getValuesAsFloat(DTYPE *d,float *fval,short num);
#define GetValuesAsFloat(d,s,n) getValuesAsFloat(d,s,n)
int putValuesFromFloat(DTYPE *d,float *fval,short num);
#define PutValuesFromFloat(d,s,n) putValuesFromFloat(d,s,n)
int getValuesAsDouble(DTYPE *d,double *dval,short num);
#define GetValuesAsDouble(d,s,n) getValuesAsDouble(d,s,n)
int putValuesFromDouble(DTYPE *d,double *dval,short num);
#define PutValuesFromDouble(d,s,n) putValuesFromDouble(d,s,n)
int getValuesAsLong(DTYPE *d,UINT32 *lval,short num);
#define GetValuesAsLong(d,s,n) getValuesAsLong(d,s,n)
int putValuesFromLong(DTYPE *d,UINT32 *lval,short num);
#define PutValuesFromLong(d,s,n) putValuesFromLong(d,s,n)
int putValuesFromUnsignedShort(DTYPE *d,UINT16 *sval,short num);
#define PutValuesFromUnsignedShort(d,s,n) putValuesFromUnsignedShort(d,s,n)

void AppendHistoryLog(char *str);
int sendPMTrigger(char *dev,char *cmt,short triggerLevel);
int GetTagList(char *context,char *tagtype,NAME16 *taglist,int *num);
int GetDeviceServers(NAME16 *dslist,int *num);
int GetDeviceServersEx(char *context,NAME16 *dslist,int *num);
int GetDeviceContexts(NAME16 *clist,int *num);
int GetServers(NAME16 *slist,int *num);
int GetServersEx(char *context,NAME16 *slist,int *num);
int GetDeviceProperties(char *srv,NAME32 *props,int *num);
int GetTargetPropertyInformation(char *srv,char *prp,int *fmt,int *siz,char *dsc);
int GetDevicePropertyInformation(char *srv,PropertyQueryStruct *srvProps,int *num);
int GetDeviceNames(char *srv,NAME16 *devs,int *num);
int GetDevicePropertyEGU(char *srv,char *prp,float *max,float *min,char *egu);
int GetArchivedData(char *keyword,int keyindex,time_t start,time_t stop,FLTINT *fiDataArray,short *num);
int GetArchivedDataAsText(char *devsrv,time_t start,time_t stop,NAME32I *niDataArray,int *num);
int GetArchivedDataAsFloat(char *devsrv,time_t start,time_t stop,FLTINT *fiDataArray,int *num);
int PropertyDataExchange(void *data,short fmt,short siz,
                        DTYPE *dout, DTYPE *din,short access);

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif /* _TOOLKIT_H_ */
