// BogusTineServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "oleauto.h"
#include "Oaidl.h"
#include <ifcapi.h>
#include <vfw.h>
#include "rpcdefs.h"
#include "Grabsrv.h"
#include "headers.h"
#include "BogusTineServerDlg.h"
#include "Compression.h"
class CGrab;
class CGrabsrvApp;
class CSocketEncapsulation;
class CSocketEncapsulation2;
class CMainDlg;
class CSendReceive;
class CSendReceive2;
class CFourierStat;
class CStat;
class CIniEx;
class CBogusTineServerDlg;
#include "Queue.h"
#include "Resource.h"
#include "ConfigDlg.h"
#include "SSyncSocket.h"
#include "SocketEncapsulation1.h"
#include "SocketEncapsulation2.h"
#include "JPEGCompression.h"
#include "Grabsrv.h"
#include "GrabsrvDlg.h"
#include "Grab.h"
#include "SendReceive.h"
#include "SendReceive2.h"
#include "fourierstat.h"
#include "IniEx.h"
#include "stat.h"
#include "BogusTineServerDlg.h"
#include "OrientationHelper.h"




#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBogusTineServerDlg dialog
//
// This class implements the TINE Server for delivering the video data using 
// multicast transmission to all via TINE protocol connected clients.
// After instantiating the class you have to call the InitializeTine() method 
// to initialize the underlying ActiveX-control and all data structures needed
// for the transfer. If the function returns TRUE everything is fine and you can
// call PutFrame() to input a single video frame into the class. This frame gets 
// send out on the next client request that asks for frame data.
//
// The TINE property where the frame data resides is:
// Device Context  : 'PITZ'
// Device Server   : (hostname of the server computer in upper case)+'F' e.g. 'ZNPPITZFG1F'
// Device Name     : 'device_0'
// Device Property : 'FRAME.GET'
//
// A valid video frame memory block (for PutFrame() ) consists of a video header (VIDHDR) 
// plus sometimes a frame header plus the frame data (bits), either compressed or 
// uncompressed.
//
// After sending out all frames (mostly this is the case when shutting down the server), one
// has to call the DeinitializeTine() method to stop the TINE server and to clean up the 
// memory structures and variables. After calling DeinitializeTine(), the class can be safely 
// destructed.
//


CBogusTineServerDlg::CBogusTineServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBogusTineServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBogusTineServerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	
	// TINE is not yet initialized
	m_bTineInitialized = FALSE;
}


void CBogusTineServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBogusTineServerDlg)
	DDX_Control(pDX, IDC_SRVCTRL1_BOGUS, m_CTineFrameServer);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBogusTineServerDlg, CDialog)
	//{{AFX_MSG_MAP(CBogusTineServerDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBogusTineServerDlg message handlers

BEGIN_EVENTSINK_MAP(CBogusTineServerDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CBogusTineServerDlg)
	ON_EVENT(CBogusTineServerDlg, IDC_SRVCTRL1_BOGUS, 1 /* EqpFcn */, OnEqpFcnSrvctrl1Bogus, VTS_BSTR VTS_BSTR VTS_I4 VTS_I4 VTS_I2)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

extern "C" {

__declspec(dllexport) short PASCAL ScheduleProperty(char *eqm, char *prp);

}

/////////////////////////////////////////////////////////////////////////////
// OnEqpFcnSrvctrl1Bogus - TINE server equipment function
// 
// Using this function the current frame is sent out if the variable
// m_iFirstTimeFrame is set to TRUE, we are using multicast here so it is 
// okay if we send out the frame only once. In multicast operation mode 
// the frame is send out once and delivered to all connected clients.
//
void CBogusTineServerDlg::OnEqpFcnSrvctrl1Bogus(LPCTSTR devName, LPCTSTR devProperty, long outArrayLen, long inArrayLen, short devAccess) 
{
   CString devNam = CString(devName); // passed device name
   CString devProp = CString(devProperty); // passed device property
   
   CString myName = CString("device_0"); // my device 
   CString myGetFrameProperty = CString("FRAME.GET"); // my property
   CString myGetFrameProperty2 = CString("NONSCHED.GET"); // my property

   //CMainDlg *m_pMainDlg = (CMainDlg *) AfxGetMainWnd();

	if (devNam == myName) // is this my device ? 
	{
     if (devProp == myGetFrameProperty) // is this my property ? 
	 {
		 // call function inside MainDlg (with idletimer)

		 ((CMainDlg *)AfxGetMainWnd())->UpdateTineActive();

		 //m_pMainDlg->PrintServerMessage("TINE send out!\n");
         if (m_iFirstTimeFrame == TRUE) // frame was not send out up to now ? 
		 {
 		   // a size variant
		   VARIANT size;

		   // fill memory block of variant m_vData with the current video frame  

           memman.memcpysw( m_pVariantData, m_pAktFrameData, m_iAktFrameLength);

           // make a variant to specify the amount of data to send to clients
		   VariantInit( &size );
		   size.vt = VT_I4;
		   size.lVal = m_iAktFrameLength; 

		   // call EqpSendDataEx() to send out the array
		   short ret = m_CTineFrameServer.EqpSendDataEx(&m_vData,size);
		 
		   // clean up the size variant
		   VariantClear( &size ); 

		   if (ret != 0) // error while sending ? 
		   {
		    // set error message and code
		    m_CTineFrameServer.EqpSetCompletion(606,"Could not send data.");
           }
		    else
		   {
	        m_CTineFrameServer.EqpSetCompletion(0, ""); // everything okay
		   }
           // frame was send out, so we clear the 'frame was not send out' flag  
           m_iFirstTimeFrame = FALSE;
		 }
		  else
		 {
		  // frame was already send out, so deliver error code to the clients
		  m_CTineFrameServer.EqpSetCompletion(607,"No data to send."); 
		 }

	 }
	 else if (devProp == myGetFrameProperty2)
	 {
		 ((CMainDlg *)AfxGetMainWnd())->UpdateTineActive();

 		 // a size variant
		 VARIANT size;

		 // fill memory block of variant m_vData with the current video frame  
         memman.memcpysw( m_pVariantData, m_pAktFrameData, m_iAktFrameLength);

         // make a variant to specify the amount of data to send to clients
		 VariantInit( &size );
		 size.vt = VT_I4;
		 size.lVal = m_iAktFrameLength; 

		 // call EqpSendDataEx() to send out the array
		 short ret = m_CTineFrameServer.EqpSendDataEx(&m_vData,size);
		 
		 // clean up the size variant
		 VariantClear( &size ); 

		 if (ret != 0) // error while sending ? 
		 {
			 // set error message and code
			 m_CTineFrameServer.EqpSetCompletion(606,"Could not send data.");
         }
		 else
		 {
			 m_CTineFrameServer.EqpSetCompletion(0, ""); // everything okay
		 }
	 }
    }
	
}
	
/////////////////////////////////////////////////////////////////////////////////////
// InitializeTine() - initializes the TINE 'frame data' server
//
// This function initializes the TINE frame data server. The underlying ActiveX control 
// and the TINE dll's are initialized properly. In addition, some memory structures get
// initialized.
//
// The function returns TRUE on success and FALSE on failure. If FALSE is returned, one 
// can not send out frames using TINE multicast. But when the function returns TRUE, the
// PutFrame() method can be used to inject frames into the TINE frame server.
//
// Parameter:
//   size_in_bytes   maximum size in bytes a single video frame (pure bits) can get
//                   most times it equals to the length of an uncompressed frame (width*height*bpp/8)
//   servername      name of the TINE "Device Server" used for frame data transfer
//
BOOL CBogusTineServerDlg::InitializeTine( CString servername, int size_in_bytes )
{
	// do RegisterFecNameEx only once per instance
	static int register_1 = 1;

	int max_length_array = size_in_bytes + sizeof(VIDHDR);
	
	// variables needed for initializing a safe array
	SAFEARRAY *psa;
    SAFEARRAYBOUND rgsabound[1];
	
    // already initialized: nothing to do 
    if (m_bTineInitialized == TRUE) return( TRUE );

    // make TINE server accessible on 'servername'
	m_CTineFrameServer.SetExportName( (LPCTSTR) servername );

    // enable the TINE server ActiveX control
    m_CTineFrameServer.SetEnabled(TRUE);
    
	// get status whether the server was started up successfully
	short retval = m_CTineFrameServer.GetEqpStatus();
 	if (retval != 0)
 	{
      // some error
      CString msg;
   	  msg.Format("InitTineFrame: EqpStatus=%d", retval);
      AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	  return FALSE;
 	}
 
    // register module (device name) on the server
	m_CTineFrameServer.EqpRegisterModule("device_0", 0);

    // from now on, the property that the server offers the clients
	// is registered.

    if (register_1 == 1) // do it only one time per instance
	{
     // register property that allows clients to acquire video frames
 	 retval = m_CTineFrameServer.EqpRegisterPropertyEx("FRAME.GET", 1, CF_BYTE, "", max_length_array, CF_BYTE, "", CA_READ, "read single frame");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("Could not register property for video frame data. EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
	   m_CTineFrameServer.SetEnabled(FALSE);
 	   return FALSE; // failure
 	 }

 	 retval = m_CTineFrameServer.EqpRegisterPropertyEx("NONSCHED.GET", 1, CF_BYTE, "", max_length_array, CF_BYTE, "", CA_READ, "read single frame");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("Could not register property for nonscheduled video frame data. EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
	   m_CTineFrameServer.SetEnabled(FALSE);
 	   return FALSE; // failure
 	 }


	 register_1 = 0;
	}

    // create safe array that is big enough to hold the frame data
	// that is: sizeof(VIDHDR)+size_in_bytes
    rgsabound[0].lLbound = 0;
    rgsabound[0].cElements = max_length_array;
    if ((psa=SafeArrayCreate(VT_I1,1,rgsabound)) == NULL) // could not allocate ? 
    {
      // error allocating the safearray for the video frame data
	  CString msg;
 	  msg.Format("Could not allocate tine video frame data.");
      AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
	  m_CTineFrameServer.SetEnabled(FALSE);
      return FALSE; // failure
	}

    // initialize array variant with the created safe array
	VariantInit( &m_vData );
	V_VT( &m_vData ) = VT_I1 | VT_ARRAY;
	V_ARRAY( &m_vData ) = psa;

    // put the pointer to the safe array to m_pVariantData for easier access
	m_pVariantData = (char *) psa->pvData;

    // no frame has been put in up to now, so 
	// initialize an empty frame
    m_pAktFrameData = NULL;
	m_iAktFrameLength = 0;

    // no frame to send out, so disable any tries to send out something by 
	// specifying that the actual frame was send out	
	m_iFirstTimeFrame = FALSE;
	
	// TINE is successfully initialized
	m_bTineInitialized = TRUE;

    return TRUE; // success
}

/////////////////////////////////////////////////////////////////////////////////////
// DeinitializeTine() - deinitializes the TINE 'frame data' server
//
// This function deinitialized the TINE server. After cleaning up the 
// memory structures the ActiveX server is shut down. This function returns
// always TRUE.
//
BOOL CBogusTineServerDlg::DeinitializeTine()
{
 
 if (m_bTineInitialized == TRUE) // TINE initialized ? -> clear memory structures
 {
  // clean up the variant and the underlying safe array (done automatically)
  VariantClear( &m_vData );
 
  if (m_pAktFrameData != NULL) // m_pAktFrameData points to allocated memory ? 
  {
   memman.sw_free( (void *) m_pAktFrameData ); // then free it
  }
 
 }
 
 // disable TINE ActiveX server
 m_CTineFrameServer.SetEnabled(FALSE);
 
 // TINE is not initialized any more
 m_bTineInitialized = FALSE;
 return TRUE;
}

/////////////////////////////////////////////////////////////////////////////////////
// PutFrame() - injects a video frame into the TINE server
//
// Inside this function, the frame bits are copied into the m_pAktFrameData memory 
// buffer and the boolean variable m_iFirstTimeFrame is set to true. On the next request 
// from the clients, the frame will be send out.
// 
// If this function returns TRUE, the frame was successfully copied into the memory 
// location. On FALSE, something went wrong and the frame will not be sent out.
//
BOOL CBogusTineServerDlg::PutFrame(unsigned char *framebits, int framelength)
{
 if (m_bTineInitialized == FALSE) return( FALSE ); // TINE not initialized -> return failure

 if (m_pAktFrameData != NULL) // a valid frame inside m_pAktFrameData ? 
 {
  memman.sw_free( (void *) m_pAktFrameData ); // free up the memory
  m_pAktFrameData = NULL;
 }
 
 m_pAktFrameData = (char *) memman.sw_malloc( framelength ); // allocate enough memory to hold the frame
 if (m_pAktFrameData == NULL) // error on allocate ?
 {
  m_iFirstTimeFrame = FALSE; // no frame to send out
  return( FALSE ); // failure
 }
 m_iAktFrameLength = framelength; // set the length of the memory block

 // copy the frame bits 
 memman.memcpysw( (char *) m_pAktFrameData, (char *) framebits, framelength );
 
 // set flag that there is a frame to be sent out 
 m_iFirstTimeFrame = TRUE; 

 ScheduleProperty( (char *) (LPCTSTR) m_CTineFrameServer.GetEqpName(), "FRAME.GET" );

 return( TRUE ); // success
}
