/////////////////////////////////////////////////////////////////////////////
//
// Grabsrv.cpp : Defines the class behaviors for the application.
//
// This is the main application class. It just initializes the main dialog
// window and calls DoModal(). Every processing of the main application is
// done in the main application window (CMainDlg).
//

#include "stdafx.h"
#include <ifcapi.h>
#include <vfw.h>
#include "headers.h"
#include "rpcdefs.h"
#include "Compression.h"
class CGrab;
class CSocketEncapsulation;
class CSocketEncapsulation2;
class CMainDlg;
class CSendReceive;
class CSendReceive2;
class CFourierStat;
class CStat;
class CIniEx;
class CBogusTineServerDlg;
#include "Queue.h"
#include "Grabsrv.h"
#include "SSyncSocket.h"
#include "SocketEncapsulation1.h"
#include "SocketEncapsulation2.h"
#include "JPEGCompression.h"
#include "GrabsrvDlg.h"
#include "Grab.h"
#include "SendReceive.h"
#include "SendReceive2.h"
#include "IniEx.h"
#include "fourierstat.h"
#include "stat.h"
#include "BogusTineServerDlg.h"
#include "notquitenulldacl.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGrabsrvApp

BEGIN_MESSAGE_MAP(CGrabsrvApp, CWinApp)
	//{{AFX_MSG_MAP(CGrabsrvApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGrabsrvApp construction

CGrabsrvApp::CGrabsrvApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CGrabsrvApp object

CGrabsrvApp theApp;

extern "C" {

__declspec(dllexport) int PASCAL feclog(char *text);

//__declspec(dllexport) int  SetCycleDelay(int msecs);

}


/////////////////////////////////////////////////////////////////////////////// CGrabsrvApp initialization

BOOL CGrabsrvApp::InitInstance()
{

	startuperrorstring = "";
	

	BOOL bStartup=FALSE;
	CString stCmdLine = GetCommandLine();
	int n = stCmdLine.Find('/', 0);
	char c = stCmdLine.GetAt(n+1);

    BeginWaitCursor();
  
	if (MutexCheck() == TRUE)
	{
			HWND hwnd = FindWindow(NULL,"GrabServer2");
			if (hwnd != NULL) // found? 
			{
				//ShowWindow(hwnd, SW_SHOW); // show it
				//SetForegroundWindow( hwnd ); // set to foreground
				//SetFocus(hwnd); // set focus

				//CString tmp1;
				//tmp1.Format("hwnd=%xh, stCmdLine=%s c=%c", hwnd, stCmdLine, c);
				//AfxMessageBox(tmp1);

				if ((c == 'a') || (c == 'A')) 
				{
					::PostMessage(hwnd, ID_START_GRABBING, 0, 0);
				} 
				if ((c == 'q') || (c == 'Q'))
				{
					::PostMessage(hwnd, ID_CLOSE_SERVER, 0, 0);
				}
			}
			else
			{
				startuperrorstring.Format("Huh ?, I am second instance, but GrabServer2 window could not be found?");
			}

	}
	else // first instance
	{
		bStartup = TRUE;
	}

    // if we are here then this program is not in memory and we can start
	// to create the instance

	if (bStartup == TRUE)
	{
		if (!AfxSocketInit())
		{
			AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
			return FALSE;
		}

		AfxEnableControlContainer();

		// Standard initialization
		// If you are not using these features and wish to reduce the size
		//  of your final executable, you should remove from the following
		//  the specific initialization routines you do not need.

		#ifdef _AFXDLL
			Enable3dControls();			// Call this when using MFC in a shared DLL
		#else
			Enable3dControlsStatic();	// Call this when linking to MFC statically
		#endif


		CMainDlg dlg;
		m_pMainWnd = &dlg;
		dlg.setApp(this);

		// call main dialog window
		int nResponse = dlg.DoModal();
		if (nResponse == IDOK)
		{
			// TODO: Place code here to handle when the dialog is
			//  dismissed with OK
		}
		else if (nResponse == IDCANCEL)
		{
			// TODO: Place code here to handle when the dialog is
			//  dismissed with Cancel
		}
	}

	// close semaphore
	if (m_hMutex != NULL) CloseHandle( m_hMutex );

	if (startuperrorstring != "")
	{
		feclog("before last VERSION string of TINE something happened, see below:");
		feclog((char *) (LPCTSTR) startuperrorstring);
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	// application, rather than start the application's message pump.
	return FALSE;
}



// false: error or first application instance
// true: second application instance

BOOL CGrabsrvApp::MutexCheck()
{
	NotQuiteNullDacl Dacl;

	m_hMutex = NULL;
	bool bDaclOk = Dacl.Create();

	if ( bDaclOk)
	{
		bool bSetupOk = false;
		
		// declare and initialize a security attributes structure
		SECURITY_ATTRIBUTES MutexAttributes;
		ZeroMemory( &MutexAttributes, sizeof(MutexAttributes) );
		MutexAttributes.nLength = sizeof( MutexAttributes );
		MutexAttributes.bInheritHandle = FALSE; // object uninheritable

		// declare and initialize a security descriptor
		SECURITY_DESCRIPTOR SD;
		BOOL bInitOk = InitializeSecurityDescriptor( &SD, SECURITY_DESCRIPTOR_REVISION );
		if ( bInitOk )
		{
			// assign the dacl to it
			BOOL bSetOk = SetSecurityDescriptorDacl( &SD, TRUE, Dacl.GetPDACL(), FALSE );
			if ( bSetOk )
			{
				// Make the security attributes point to
				//the security descriptor
				MutexAttributes.lpSecurityDescriptor = &SD;
				bSetupOk = true;
			}
		}	

		if ( bSetupOk )
		{
			// use the security attributes to call CreateMutex

			m_hMutex = OpenMutex( SYNCHRONIZE, FALSE, "Global\\Grabserver2_instance_loaded" );

			if (m_hMutex == NULL)
			{
				startuperrorstring.Format("OpenMutex NULL, GetLastError=%u ... try to create now", GetLastError() );

				//CString msg;
				//msg.Format("OpenMutex NULL, GetLastError=%u ... try to create now", GetLastError() );
				//AfxMessageBox(msg);

				m_hMutex = CreateMutex( &MutexAttributes, TRUE, "Global\\Grabserver2_instance_loaded");

				if (m_hMutex == NULL)
				{
					startuperrorstring.Format("OpenMutex returned NULL, CreateMutex failed (GetLastError=%u).", GetLastError() );
					//CString msg;
					//msg.Format("Subsequent CreateMutex NULL, GetLastError=%u ", GetLastError() );
					//AfxMessageBox(msg);
				}
				else
				{
					return FALSE;
				}
			}
			else
			{
				return TRUE; // mutex could be opened, so we are second instance!
			}

			
		}
		else
		{
			startuperrorstring.Format("Setup of DACL failed somehow: GetLastError=%u.", GetLastError() );

			//CString msg;
			//msg.Format("Setup failed somehow, GetLastError=%u ", GetLastError() );
			//AfxMessageBox(msg);

			// SW! add error message if it failes 

			// the setup failed somehow, use GetLastError()
			// to find out why
		}
	}
	else
	{
		
		startuperrorstring.Format("Dacl.Create() failed: Err=%u", Dacl.GetErr() );
		
		// nqnDacl create failed,
		// use Dacl.GetErr() to find out how
	}

	return FALSE;
}
