// OrientationHelper.h: interface for the COrientationHelper class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ORIENTATIONHELPER_H__C358D423_4332_11D7_AFE9_0002B34B0F4F__INCLUDED_)
#define AFX_ORIENTATIONHELPER_H__C358D423_4332_11D7_AFE9_0002B34B0F4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////
// COrientationHelper - rotates or mirrors a video frame
//

class COrientationHelper  
{
public:
    // default construction and destruction
	COrientationHelper();
	virtual ~COrientationHelper();

	// rotate or mirrot src array into dst array using information in 'orientation'
	// widthbefore and heightbefore are width and height of the image before rotating or mirroring
	static void CalcOrientation( char *dst, char *src, CString orientation, int widthbefore, int heightbefore, int physbpp);
	
private:
	static void ROT90ANDMIRRHORIZ( char *dst, char *src, int widthbefore, int heightbefore, int physbpp);
    // rotate by 90 clockwise from src to dst 
	static void ROT90CW( char *dst, char *src, int widthbefore, int heightbefore, int physbpp );
	// rotate by 180 from src to dst 
	static void ROT180CW( char *dst, char *src, int widthbefore, int heightbefore, int physbpp );
	// rotate by 270 clockwise from src to dst 
	static void ROT270CW( char *dst, char *src, int widthbefore, int heightbefore, int physbpp );
	// mirror src to dst along horizontal axis
	static void MIRRORHORIZ( char *dst, char *src, int widthbefore, int heightbefore, int physbpp );
	// mirror src to dst along vertical axis
	static void MIRRORVERT( char *dst, char *src, int widthbefore, int heightbefore, int physbpp );
};

#endif // !defined(AFX_ORIENTATIONHELPER_H__C358D423_4332_11D7_AFE9_0002B34B0F4F__INCLUDED_)
