#include "stdafx.h"
#include "Queue.h"

   //----------------
   // Queue
   //----------------
   CQueue::CQueue()
     {
      ::InitializeCriticalSection(&lock);
     } // Queue

   //----------------
   // ~Queue
   //----------------
   CQueue::~CQueue()
     {
      ::DeleteCriticalSection(&lock);
     } // ~Queue


   //----------------
   // AddTail
   //----------------
   BOOL CQueue::AddTail(LPVOID p)
     { 
	  BOOL result=TRUE;
      ::EnterCriticalSection(&lock);
	  queue.AddTail(p);
      ::LeaveCriticalSection(&lock);
	  return result;
     } // AddTail

   //----------------
   // RemoveHead
   //----------------
   LPVOID CQueue::RemoveHead()
     { 
      LPVOID result;

              ::EnterCriticalSection(&lock);
			  if (queue.IsEmpty() == TRUE) result = NULL; else result = queue.RemoveHead();
              ::LeaveCriticalSection(&lock);
              return result;

      } // RemoveHead


   int CQueue::GetSize()
   {
      int result1;
      ::EnterCriticalSection(&lock);
      if (queue.IsEmpty() == TRUE) result1 = 0; else result1 = queue.GetCount();
      ::LeaveCriticalSection(&lock);
      return result1;
   }



LPVOID CQueue::GetElem( int index )
{
      LPVOID result;


      ::EnterCriticalSection(&lock);
	  if (queue.IsEmpty() == TRUE) result = NULL; else result = queue.GetAt( queue.FindIndex(index));
      ::LeaveCriticalSection(&lock);
      return result;

}

void CQueue::RemoveElem( int index )
{
      ::EnterCriticalSection(&lock);
      if (queue.IsEmpty() == FALSE)
	  {
   	   queue.RemoveAt( queue.FindIndex(index));
	  }
      ::LeaveCriticalSection(&lock);
}

LPVOID CQueue::RemoveElem( void *ptr )
{
      LPVOID result;


      ::EnterCriticalSection(&lock);

	  if (queue.IsEmpty() == FALSE) 
	  {
 	    POSITION pos = queue.Find((void *) ptr);
	    if (pos == NULL) result = NULL; else { result = (void *)  1; queue.RemoveAt( pos ); }
	  }
	  else result = NULL;

      ::LeaveCriticalSection(&lock);
      return result;

}



LPVOID CQueue::GetHead()
{ 
      
	LPVOID result;

              ::EnterCriticalSection(&lock);
			  if (queue.IsEmpty())
			  {
				  result = NULL;
			  }
			  else
			  {
				  result = queue.GetHead();
			  }
              ::LeaveCriticalSection(&lock);
              return result;
      } // RemoveHead



BOOL CQueue::IsEmpty()
{
  ::EnterCriticalSection(&lock);
  BOOL retval = queue.IsEmpty();
  ::LeaveCriticalSection(&lock);
  return( retval );
}
