#if !defined(AFX_SENDRECEIVE_H__A584BC4A_76CA_11D6_AFB3_0002B34B0F4F__INCLUDED_)
#define AFX_SENDRECEIVE_H__A584BC4A_76CA_11D6_AFB3_0002B34B0F4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SendReceive.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSendReceive class, handles socket data transfer to the video clients

class CSendReceive : public CWnd
{
public:
	// construction: initialize class
	CSendReceive( CSocketEncapsulation *parent, SSyncSocket *the_sock);
	
	// destruction
	virtual ~CSendReceive();

    // start up data transfer (start up threads)
	BOOL Start();
	
	// put a video frame with size 'length' in the queue
	BOOL PutInQueue( char *videoframe, int length );

    // force send and receive thread to stop
    void ForceThreadsToStop();
    // TRUE: threads are not running and thus properly shut down
	BOOL ThreadsShutDown();

    // returns the socket reference
	SSyncSocket *GetSocket();
    
// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSendReceive)
	//}}AFX_VIRTUAL

	// Generated message map functions
protected:
	//{{AFX_MSG(CSendReceive)
		// NOTE - the ClassWizard will add and remove member functions here.
    //}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	// flag: dropping frames is in progress
	BOOL m_bDropInProgress;
    
	// fast memory copy routine
	void memcpysw( char *dst, char *src, int lengthsize);

    // receive thread functions  
	static UINT thread_receive_static(LPVOID *p);
	UINT thread_receive();

    // receive thread variables
	CWinThread * m_pReceiveThread;
	BOOL m_bForceReceiveThreadToStop;
	BOOL m_bReceiveThreadRunning;

    // send thread functions
	static UINT thread_send_static(LPVOID *p);
	UINT thread_send();
	
	// send thread variables
	CWinThread * m_pSendThread;
	BOOL m_bForceSendThreadToStop;
	BOOL m_bSendThreadRunning;

    // video frame queue 
	CQueue m_video_queue;
	
	// reference to the socket encapsulation instance
	CSocketEncapsulation *m_pSockEncap;
	
	// underlying socket to transfer the data
	SSyncSocket *m_pSock;

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SENDRECEIVE_H__A584BC4A_76CA_11D6_AFB3_0002B34B0F4F__INCLUDED_)

