#ifndef BRDCAST_H_
#define BRDCAST_H_

#include "project.def"
#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#ifndef GLOBALGRACE
# define GLOBALGRACE  3       /* retries for missing heartbeat */
#endif

typedef struct
{
  char keyword[16];          /* broadcast keyword */
  short size;                /* number of elements in broadcast array */
  short format;              /* broadcast data format */
  time_t time;               /* timestamp of broadcast data */
  BYTE *data;                /* data pointer */
  BYTE *olddata;             /* for comparison */
  int  minPeriod,            /* minimum period between broadcasts */
       maxPeriod;            /* maximum period between broadcasts */
  double tolerance;          /* allowed deviation of data (data units) */
  UINT32 callbackID;         /* private callback ID */
  void (*fcn)(int,int);      /* call back function */
} GlobalListStruct;

#ifndef GLOBALSRV
# define GLOBALSRV "GLOBALS"
#endif
#ifndef MAXGLOBALS
# define MAXGLOBALS 25
#endif
#ifndef GLOBALHEARTBEAT
# define GLOBALHEARTBEAT 60
#endif

extern int nglobals, nbroadcasts;
extern int GlobalHeartbeat;
extern int MaxNumGlobals;

extern GlobalListStruct **BrdcstList;
extern GlobalListStruct **NGlobalList;

int sendNetGlobal(char *keyword,DTYPE *din,void (*callback)(int,int),
                  int minPeriod,int maxPeriod,double tolerance);

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif
