

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include "stringfunc.h"
#include <assert.h>

#define ASSERT assert

void SetAtInternal( char **stringarray, int index, const char *value, int checkbounds);


void SetAt( char **stringarray, int index, const char *value)
{
  SetAtInternal( stringarray, index, value, 1);
}


void SetAtInternal( char **stringarray, int index, const char *value, int checkbounds)
{
	ASSERT(stringarray != NULL);
	ASSERT(*stringarray != NULL);
	ASSERT(value != NULL);

	char *bytearray = (char *) *stringarray;

	//BOOL inserted = TRUE;

	// get WHOLE len from stringarray
	char *tempstrarray = *stringarray;
	int len=0,len1,num=0;

	while(1)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		len1 = strlen(tempstrarray);
		len += (len1 + 1);
		tempstrarray += (len1 + 1);
		num++;
	}
    
	len++;

	int lennew = len + 1;

	if (checkbounds != 0) if (index >= num && (index != 0)) return; 

	// seek through whole stringarray

	num = 0;
	int postorepl=0, lentorepl=0;
    
	tempstrarray = *stringarray;
	
	while(1)
	{
		if (num == index) { postorepl = (int) (tempstrarray - *stringarray); lentorepl = strlen(tempstrarray)+1; }
		
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		len1 = strlen(tempstrarray);
		tempstrarray += (len1 + 1);
		num++;
		
    }

	lennew -= lentorepl;
	lennew += strlen(value)+1;

	*stringarray = (char *) new char[lennew];
	memset(*stringarray, 0, lennew);

	memcpy(*stringarray, bytearray, postorepl);

	memcpy(*stringarray + postorepl, value, strlen(value)+1 );

	memcpy(*stringarray + postorepl + strlen(value)+1, bytearray+postorepl+lentorepl, (len-postorepl)-lentorepl );

	//!!!(*stringarray)[len + strlen(string)] = 0;
	//!!!(*stringarray)[len + strlen(string)-1] = 0;

	delete [] bytearray;
}

void SetAtGrow( char **stringarray, int index, const char *value)
{
	ASSERT(stringarray != NULL);
	ASSERT(*stringarray != NULL);
	ASSERT(value != NULL);

	char *bytearray = (char *) *stringarray;

	//BOOL inserted = TRUE;

	// get WHOLE len from stringarray
	char *tempstrarray = *stringarray;

	int len=0,len1,num=0;

	while(1)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		len1 = strlen(tempstrarray);
		len += (len1 + 1);
		tempstrarray += (len1 + 1);
		num++;
	}
    
	len++;
	
	if (len == 1) len = 0;

	int lennew = len + 1;
	int newnum = num;

	if (index >= num) 
	{
		newnum = index+1; 

		// seek through whole stringarray
		lennew = lennew + (newnum-num) + 1;

		*stringarray = (char *) new char[lennew];
		memset( *stringarray, 0, lennew);

		if (len >= 1) memcpy(*stringarray, bytearray, len);
	
		delete [] bytearray;
	}

	SetAtInternal(stringarray, index, value, 0);
}



BOOL RemoveAt(char **stringarray, int index)
{
	ASSERT(stringarray != NULL);
	ASSERT(*stringarray != NULL);

	char *bytearray = (char *) *stringarray;

	//BOOL inserted = TRUE;

	// get WHOLE len from stringarray
	char *tempstrarray = *stringarray;
	int len=0,len1,num=0;

	while(1)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		len1 = strlen(tempstrarray);
		len += (len1 + 1);
		tempstrarray += (len1 + 1);
		num++;
	}
    
	len++;

	int lennew = len + 1;

	if (index >= num) return FALSE; 

	// seek through whole stringarray

	num = 0;
	int postodel=0, lentodel=0;
    
	tempstrarray = *stringarray;
	
	while(1)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		if (num == index) { postodel = (int) (tempstrarray - *stringarray); lentodel = strlen(tempstrarray)+1; }

		len1 = strlen(tempstrarray);
		tempstrarray += (len1 + 1);
		num++;
    }

	lennew -= lentodel;

	*stringarray = (char *) new char[lennew];
	memset(*stringarray, 0, lennew);

	memcpy(*stringarray, bytearray, postodel);

	memcpy(*stringarray + (len-postodel), bytearray+postodel+lentodel, (len-postodel)-lentodel );

	//!!!(*stringarray)[len + strlen(string)] = 0;
	//!!!(*stringarray)[len + strlen(string)-1] = 0;

	delete [] bytearray;

	return TRUE;
}


BOOL Add( char **stringarray, const char *string )
{
	ASSERT(stringarray != NULL);
	ASSERT(*stringarray != NULL);
	ASSERT(string != NULL);

	char *bytearray = (char *) *stringarray;

	BOOL inserted = TRUE;

	// get WHOLE len from stringarray
	char *tempstrarray = *stringarray;
	int len=0,len1,num=0;

	while (1)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		len1 = strlen(tempstrarray);
		len += (len1 + 1);
		tempstrarray += (len1 + 1);
		num++;
	}
    
	len++;

	int lennew = len + strlen(string) + 1;

	// seek through whole stringarray

    tempstrarray = *stringarray;
	while(1)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		//if (strcmp(string, tempstrarray) == 0)
		//{
		//	inserted = FALSE;
		//	return inserted;
		//}
		len1 = strlen(tempstrarray);
		tempstrarray += (len1 + 1);
		num++;
    }

	*stringarray = (char *) new char[lennew];
	memset(*stringarray, 0, lennew);

	memcpy(*stringarray, bytearray, len);

	memcpy(*stringarray + len - 1, string, strlen(string) );

	(*stringarray)[len + strlen(string)] = 0;
	(*stringarray)[len + strlen(string)-1] = 0;

	delete [] bytearray;

	inserted = TRUE;
	return inserted;
}




// 0 for failure
int GetUpperBound( const char *stringarray )
{
	ASSERT( stringarray != NULL);
	return( GetSize(stringarray) - 1 );
}


int GetSize( const char *stringarray )
{
	ASSERT( stringarray != NULL);

	// get WHOLE len from stringarray
	char *tempstrarray = (char *) stringarray;
	
	int len1,num=0;

	while(1)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		len1 = strlen(tempstrarray);
		tempstrarray += (len1 + 1);
		num++;
	}
    
	return( num );
}

// gives reference !!!!! or NULL if not found!
char *GetAt( const char *stringarray, int index)
{
	ASSERT( stringarray != NULL);

	char *tempstrarray = (char *) stringarray;
	
	int len1,num=0;

	while(1)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		if (num == index) return( tempstrarray );

		len1 = strlen(tempstrarray);
		tempstrarray += (len1 + 1);
		num++;
	}

    return( NULL );
}

void copywholestring(char *dest, const char *src)
{
	ASSERT( dest != NULL);
	ASSERT( src != NULL);

	strncpy(dest, src, strlen(src)+1 );
}

int find( const char *str, const char *search)
{
	ASSERT( str != NULL);
	ASSERT( search != NULL);

	char *res = strstr(str, search);

	if ((res == NULL) || (res == str)) 
		return( -1 );
	else
		return( (int) (res-str));
}


int reversefind( const char *str, int c )
{
	ASSERT( str != NULL);

	char *res = strrchr(str, c);

	if (res == NULL) 
		return( -1 );
	else
		return( (int) (res-str));
}

int DeleteString( char *string, int nIndex, int nCount)
{
	ASSERT( string != NULL);

	int len = strlen(string);
 
	if (nIndex < len)
	{
		if ((nIndex + nCount)>len ) nCount = (nIndex + nCount) - len + 1;

		int amount = len-(nIndex+nCount);
		char *dest = &string[nIndex];
		const char *src = &string[nIndex+nCount];

		memcpy(dest, src, amount);
	}

	return( strlen( string ) );
}


void Left(char *dest, const char *src, int num)
{
	ASSERT( dest != NULL);
	ASSERT( src != NULL);

	strncpy(dest, src, num);
	dest[num] = 0;
}

void Mid( char *dest, const char *src, int left, int count)
{
	ASSERT( dest != NULL);
	ASSERT( src != NULL);

	strncpy(dest, &src[left], count);
	dest[count]=0;
}

void Mid( char *dest, const char *src, int left)
{
	ASSERT( dest != NULL);
	ASSERT( src != NULL);

	strncpy(dest, &src[left], strlen(src)-left);
	dest[strlen(src)-left]=0;
}

void Right( char *dest, const char *src, int num)
{
	ASSERT( dest != NULL);
	ASSERT( src != NULL);

	strncpy(dest, &src[strlen(src)-num], num);
	dest[num] = 0;
}


BOOL isLeftmostChar(const char *str, int c)
{
	ASSERT( str != NULL);

	if (str[0] == (char) c) return TRUE;

	return FALSE;
}

BOOL isRightmostChar( const char *str, int c)
{
	ASSERT( str != NULL);

	int len = strlen(str);

	if (str[len-1] == (char) c) return TRUE;

	return FALSE;
}


void addstr( char *dest, const char *add)
{
	ASSERT( dest != NULL);
	ASSERT( add != NULL);

	strcat(dest, add);
}

int IsEmpty( char *str )
{
	ASSERT( str != NULL);

	if (strlen(str) == 0) 
		return( 1 ); 
	else 
		return( 0 );
}

int ReadStringInt(FILE *fp, char *line)
{
	ASSERT( fp != NULL);
	ASSERT( line != NULL);
	
	*line = 0;
	
	char *ret=fgets(line, MAX_STRING_LENGTH, fp);
	if (ret == NULL) 
	{ 
		if (feof(fp) != 0) return( 0 );
		if (ferror(fp) != 0) return( -1 );
	}
	return( strlen(line) );
}

BOOL ReadString(FILE *fp, char *line)
{
	ASSERT( fp != NULL);
	ASSERT( line != NULL);

	int r = ReadStringInt(fp, line);
	if (r>0) return TRUE;

	return FALSE;
}

void TrimRight(char *line, char *defaultset)
{
	ASSERT( line != NULL );
	ASSERT( defaultset != NULL );

	int length = strlen(line);
	if (length == 0) return;

	while( length>=0 )
	{
		for (unsigned int i=0;i<strlen(defaultset);i++)
		{
			if (line[length-1] == defaultset[i]) { line[length-1] = 0; break; }
		}
		if (i == strlen(defaultset)) break;

		length--;
	}
}
