#ifndef __DICTIONARY_4_ROOT_SW__
#define __DICTIONARY_4_ROOT_SW__

// required root dictionary in order to find symbols and understand the interpreted code (Root C Interpreter (CINT))

extern "C" {

#define		VOID			void
typedef		void	*		VOIDP;
typedef		int				INT32;
typedef		unsigned int	UINT32;
typedef		double			DOUBLE;
typedef		char			CHAR;
typedef		unsigned char	UCHAR; 
typedef		unsigned short	UINT16;
typedef		signed short	INT16;
typedef		int				socktype;
typedef   unsigned int	DWORD; // only on unix


// type of file, also used as type information for data stored in a VIDINFHDR

#define		TYPE_NONE_EMPTY		-1
#define		TYPE_CHOOSE				0
#define		TYPE_IMM					1
#define		TYPE_IMC					2 
#define		TYPE_BKG					3
#define		TYPE_BKC					4

#define		FCN_NONE				0
#define		FCN_AVERAGE			1
#define		FCN_ENVELOPE		2


// required structure

struct VIDINFHDR
{
	UINT32	width;
	UINT32	height;
	UINT32	bpp;
	
	DOUBLE	scale;
	
	INT32	numframes;
	
	INT32	type; // TYPE_

	VOIDP  *framebits;
	DOUBLE *framescales;

};

// function prototypes

extern VOID		initialize_vidinfhdr		( struct VIDINFHDR *vinf );
extern VOID		free_vidinfhdr			( struct VIDINFHDR *vinf );

extern INT32	load_imm_file			( CHAR *filename, struct VIDINFHDR *vinf );
extern INT32	load_bkg_file			( CHAR *filename, struct VIDINFHDR *vinf );
extern INT32	load_imc_bkc_file		( CHAR *filename, struct VIDINFHDR *vinf, INT32 type);
extern INT32	load_imc_file			( CHAR *filename, struct VIDINFHDR *vinf );
extern INT32	load_bkc_file			( CHAR *filename, struct VIDINFHDR *vinf );
extern INT32	load_file			( INT32 type, char *filename, struct VIDINFHDR *vinf );

extern INT32	save_file			( INT32 type, char *filename, struct VIDINFHDR *vinf );
extern INT32	save_imm_file			( char *outfilename, struct VIDINFHDR *vinf );
extern INT32	save_bkg_file			( char *outfilename, struct VIDINFHDR *vinf );
extern INT32	save_bkc_file			( char *outfilename, struct VIDINFHDR *vinf );
extern INT32	save_imc_file			( char *outfilename, struct VIDINFHDR *vinf );

extern INT32 grabframes( const CHAR *servername, const UINT16 net_port, UINT32 num_frames, struct VIDINFHDR *vinf);
extern INT32 convert_format( struct VIDINFHDR *vinf, UINT32 newtype, UINT32 downscale_function);


}

#endif  // __DICTIONARY_4_ROOT_SW__
