#ifndef __PLATFORM_H_INCLUDED_SW__
#define __PLATFORM_H_INCLUDED_SW__

// includes and declarations that are platform-specific
// Linux (32 and 64 bit) platform wrapper includes and declarations

#include <unistd.h>     // function to close a socket
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/socket.h> // core socket function
#include <unistd.h>     // function to close a socket
#include <sys/types.h>
#include <arpa/inet.h>  // some additional defines for internet (tcp/ip) sockets 
#include <netinet/in.h> // internet structures for socket
#include <netdb.h>      // gethostbyname
#include <fcntl.h>

#define		VOID			void
typedef		void	*		VOIDP;
typedef		int				INT32;
typedef		unsigned int	UINT32;
typedef		double			DOUBLE;
typedef		char			CHAR;
typedef		unsigned char	UCHAR; 
typedef		unsigned short	UINT16;
typedef		signed short	INT16;
//typedef		int				time_t;
typedef		int				socktype;
typedef   unsigned int	DWORD; // only on unix

// win32: already defined, but here we have to add these two constants (defined in platform.c)
extern const	INT32	SOCKET_ERROR;
extern const	INT32	INVALID_SOCKET;


// function declaration
extern		INT32		getlasterror();
extern		socktype	create_inet_socket( INT32 type );
extern		INT32		receive_socket_function( socktype s, UCHAR *buf, UINT32 buflen);
extern		INT32		close_socket( socktype s);
extern		INT32		connect_socket(socktype s, const struct sockaddr * Saddr, size_t size_sockaddr);
extern		INT32		set_socket_nonblocking ( socktype s );
extern		VOID		sleep_milliseconds(UINT32 milliseconds);

#endif //__PLATFORM_H_INCLUDED_SW__
