
WORLDSRC    	= ../src
INCL          = ../include

# set ROOTSYS if it is not already set by commandline (it should be)
# ROOTSYS		= /opt/products/root/5.08.00
#

LD            = gcc -shared -ldl -I$(ROOTSYS)/include 
CC	      		= gcc -O2 -fPIC -I$(ROOTSYS)/include -I$(INCL) -I.

OBJS          = videofileload.o zlibcompr_excerpt.o getframesDict.o platform.o decompression.o getframes.o

PROGRAM       = getframes.sl

all:          $(PROGRAM)


videofileload.o: $(WORLDSRC)/videofileload.c $(INCL)/videofileload.h $(INCL)/zlibcompr_excerpt.h
		 ${CC} -c -o $@ $(WORLDSRC)/videofileload.c 

zlibcompr_excerpt.o: $(WORLDSRC)/zlibcompr_excerpt.c $(INCL)/zlibcompr_excerpt.h
	  	 ${CC} -c -o $@ $(WORLDSRC)/zlibcompr_excerpt.c 

platform.o: platform.c platform.h
	  	 ${CC} -c -o $@ platform.c

decompression.o: $(WORLDSRC)/decompression.c platform.h
	  	 ${CC} -c -o $@ $(WORLDSRC)/decompression.c

getframes.o: $(WORLDSRC)/getframes.c $(INCL)/getframes.h $(INCL)/videofileload.h platform.h
	  	 ${CC} -c -o $@ $(WORLDSRC)/getframes.c

getframesDict.o: getframesDict.C getframesDict.h
		 ${CC} -c -o $@ getframesDict.C 


$(PROGRAM):     $(OBJS)
		@echo "Linking $(PROGRAM) ..."
		@/bin/rm -f $(PROGRAM)
		@$(LD) $(OBJS) -o $(PROGRAM)
		@chmod 555 $(PROGRAM)
		@echo "done"

clean:		
		@rm -f $(OBJS) core
		@rm -f getframesDict.*
		@rm -f *.o
		@rm -f getframes.sl
		

getframesDict.C: dictionary.h
	@echo "Generating dictionary for getting frames..."
	@rootcint getframesDict.C -c dictionary.h LinkDef.h

