WORLDSRC = ../src
LIBS = /usr/lib
INCL = ../include

CC  = gcc -c -g -O0 -Wall -I${INCL} -I.
CPP = g++ -c -g -O0 -Wall -I${INCL} -I.
CCL = gcc -g -I${INCL} -I.
LM = -lm -I${INCL} -I.

getsequence:   main.o videofileload.o significancemap.o zlibcompr_excerpt.o decompression.o getframes.o platform.o
	${CCL} -o getsequence main.o significancemap.o videofileload.o zlibcompr_excerpt.o decompression.o getframes.o platform.o ${LM}
	chmod a+x getsequence

main.o: main.c $(INCL)/videofileload.h $(INCL)/getframes.h platform.h
	${CC} main.c 

platform.o: platform.c platform.h
	${CC} platform.c 

decompression.o: $(WORLDSRC)/decompression.c platform.h
	${CC} $(WORLDSRC)/decompression.c 

getframes.o: $(WORLDSRC)/getframes.c $(INCL)/getframes.h platform.h
	${CC} $(WORLDSRC)/getframes.c 

significancemap.o: $(WORLDSRC)/significancemap.c $(INCL)/getframes.h $(INCL)/significancemap.h platform.h
	${CC} $(WORLDSRC)/significancemap.c 

videofileload.o: $(WORLDSRC)/videofileload.c $(INCL)/videofileload.h $(INCL)/zlibcompr_excerpt.h platform.h
	${CC} $(WORLDSRC)/videofileload.c 

zlibcompr_excerpt.o: $(WORLDSRC)/zlibcompr_excerpt.c $(INCL)/zlibcompr_excerpt.h
	${CC} $(WORLDSRC)/zlibcompr_excerpt.c 

clean:
	@rm -f *.o
	@rm -f core
	@rm -f getsequence
	
