// BMPFileHelper.h: interface for the CBMPFileHelper class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BMPFILEHELPER_H__C3E01503_3769_11D7_AFE7_0002B34B0F4F__INCLUDED_)
#define AFX_BMPFILEHELPER_H__C3E01503_3769_11D7_AFE7_0002B34B0F4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////
// CBMPFileHelper class
//
// This class has functions that will be used to load and save frame data from/into 
// BMP files.
//
class CBMPFileHelper  
{
public:
	// construction / destruction
	CBMPFileHelper();
	virtual ~CBMPFileHelper();

    // write BMP file 
    //old:BOOL WriteBMP( LPTSTR szFile, char *imagebits, PALETTEENTRYSW *hpal, int Width, int Height, BOOL adjusted);
	BOOL WriteBMP( LPTSTR szFile, void *imagebits, PALETTEENTRYSW *hpal, int Width, int Height, int physbpp, int effbpp, BOOL adjusted);

    // load in bmp file
    HBITMAP CBMPFileHelper::LoadDIBSectionFromFile( LPCTSTR lpszFileName, LPVOID *ppvBits, 
					HANDLE hSection, DWORD dwOffset) ;
private:
	void DownScaleTo8Bit(unsigned char *src, unsigned char *dst, unsigned int width, unsigned int height, unsigned int bpp);

    // helper function that flips a video frame horizontally (first line will be last line, 
	// last line will be first line, etc.)
	void flipframemmx_without_adjustment(unsigned char *dest, unsigned char *src, int width, int height, int bpp);
	void flipframemmx_with_adjustment(unsigned char *dest, unsigned char *src, int width, int height, int bpp);

};

#endif // !defined(AFX_BMPFILEHELPER_H__C3E01503_3769_11D7_AFE7_0002B34B0F4F__INCLUDED_)
