//{{AFX_INCLUDES()
#include "acop.h"
//}}AFX_INCLUDES
#if !defined(AFX_BOGUSTINEDLG_H__A4654546_2D33_11D7_AFE1_0002B34B0F4F__INCLUDED_)
#define AFX_BOGUSTINEDLG_H__A4654546_2D33_11D7_AFE1_0002B34B0F4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BogusTineDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CBogusTineDlg dialog
//
// This bogus dialog class handles the polling and grabbing of video frames using 
// TINE protocol multicast mode.

//#define MAX_TINE_SIZE 440920
// maximum size of the receive data buffer in bytes + sizeof(VIDHDR)
// should be enough for 768x574

class CBogusTineDlg : public CDialog
{
// Construction
public:
	CBogusTineDlg(CWnd* pParent = NULL);   // standard constructor

    // sets the compression class and the output format in order to properly decompress
	// the video frames
	void SetCompressionClass( CCompression *compr, LPBITMAPINFOHEADER outfmt );

    // starts up grabbing of frames using TINE protocol 
	BOOL StartTineGrabTransfer( CString context, CString server, CString device, CString property, CString servernormal, CQueue *grabqueue, int numframes, int maxbuffersize, CString pollmode);
	
	// must be called after finishing the tine grab transfer, cleans up the memory structures and
	// deinitializes grab mode properly
	BOOL StopTineGrabTransferCleanup();

	// starts up polling frames using TINE multicast
	BOOL StartTinePollTransfer( CString context, CString server, CString device, CString property, CString servernormal, CQueue *pollqueue, int maxbuffersize, CString pollmode);
	
	// stops polling of frames using TINE, must be called when polling frames is finished
	BOOL StopTinePollTransfer();

// Dialog Data
	//{{AFX_DATA(CBogusTineDlg)
	enum { IDD = IDD_DIALOG2_BOGUSTINE };
	CACOP	m_CACOPFrameData;
	CACOP	m_CACOPControl;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBogusTineDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CBogusTineDlg)
	afx_msg void OnReceiveAcopctrl1Framedata(long LinkIndex, long StatusCode);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:

    /* compression variables */

	// pointer to output format header
	LPBITMAPINFOHEADER m_pOutHdr;
	// reference to compression class
	CCompression * m_pCompression;
	
    /* variables needed for timeout in grab mode */

    // indicates how much requests to the tine server in the past resulted in no frame
	// sent back to client
	int m_iNoFrame;
	// status code of last grabbed frame
	long m_lLastStatusCode;
	
	/* functions to acquire important frame data from the server */
	
	// gets bits per pixel setting (in bits)
	// get height of a single video frame (in pixels)
	// get width of a single video frame (in pixels)
	
	/* poll mode variables */
	
	// pointer to TINE data block for poll mode
	char *m_pTineData;
	// variant-type pointer to TINE data block for poll mode
	VARIANT m_vTineData;
	// TRUE: TINE poll transfer is up and running
	BOOL m_bTinePollTransferRunning;
	// queue to hold the last polled video frame 
	CQueue *m_pPollQueue;
	// TINE link id of the receive transfer
	long m_lReceiveTineLink;

    /* grab mode variables */
   
    // pointer to TINE data block for grab mode
    char *m_pTineGrabData;
	// variant-type pointer to TINE data block for grab mode
	VARIANT m_vTineGrabData;
    // TRUE: TINE grab transfer is up and running
	BOOL m_bTineGrabTransferRunning;
	// queue to hold the last grabbed video frame 
	CQueue *m_pGrabQueue;
	// TINE link id of the grab transfer
	long m_lGrabTineLink;
	// TRUE: indicates that grabbing has finished
	BOOL m_bGrabFinished;
	// number of frames that should be grabbed
	int m_iGrabNumFrames;
	// frames grabbed up to now
	int m_iFramesGrabbed;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BOGUSTINEDLG_H__A4654546_2D33_11D7_AFE1_0002B34B0F4F__INCLUDED_)
