// Compression.h: interface for the CCompression class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMPRESSION_H__180F6491_55C2_11D6_9B36_0004769003D4__INCLUDED_)
#define AFX_COMPRESSION_H__180F6491_55C2_11D6_9B36_0004769003D4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*
  This class is to encapsulate the decompression of the HuffYUV-compressed images. 
  For detailed information please have a look at the corresponding c++ - file 
  (compression.cpp).

*/



class CCompression  
{
public:
	CCompression(); //standard construction
	virtual ~CCompression(); // standard destruction

	// initialize the class, the parameter is not used at the moment
    BOOL Init( DWORD fourcc_codec); 

	// decompresses a single frame
	BOOL DecompressFrame( LPBITMAPINFOHEADER comprFmt, char *compressedframe, LPBITMAPINFOHEADER rawFmt, char *frame);

	// clean up function to be called after finishing decompressing frames
	BOOL Done();

protected:
    // error handler, not used at the moment, maybe needed if the class is rewritten/upgraded
    int myErrorHandler( int errornum, const char *format, ... );

    BOOL m_bInitialized; // is the class properly initialized
private:

    // internal decompressing function wrapper
	void InternalDecompress( LPBITMAPINFOHEADER compFmt, void *compressed, LPBITMAPINFOHEADER rawFmt, void *uncompressed);

	// core low-level decompressing function
    void DecompressRGB( void *compressed, void *uncompressed, DWORD dwSize, int sizeimage);

	// last error variable, not used at the moment
	int m_iLastError;
};

#endif // !defined(AFX_COMPRESSION_H__180F6491_55C2_11D6_9B36_0004769003D4__INCLUDED_)
