// FileDialogOpenThumbnail.cpp : implementation file
//

#include "stdafx.h"
#include "videoclnt.h"
#include "headers.h"
#include "MemoryManagement.h"
#include <vfw.h>
#include <atlbase.h>
#include "resource.h"
#include "rpcdefs.h"
#include "Queue.h"
#include "compression.h"
#include "BMPFileHelper.h"
class CVideoclntDlg;
class CImageSequence;
#include <windows.h>
#include <winsock.h>
#undef fd_set
#include "acop.h"
#include "CATineDlg.h"
#include "TineALDlg.h"
#include "IniEx.h"
#include "Server.h"
#include "ServerList.h"
#include "SSyncSocket.h"
#include "BogusTineDlg.h"
#include "ImageAcquire.h"
#include "configdlg.h"
#include "Stat.h"
#include "FourierStat.h"
#include "StatFile.h"
#include "MessagesDlg.h"
#include "MyVideoFrame.h"
#include "PrinterSettings.h"
#include "oleauto.h"
#include "AdditionalInformation.h"
#include "MarkedComboBox.h"
#include "InformationDialog.h"
#include "videoclntDlg.h"
#include "ImageSequence.h"
#include "IMCFileHelper.h"
#include "FilePreview.h"
#include "FileDialogOpenThumbnail.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFileDialogOpenThumbnail

IMPLEMENT_DYNAMIC(CFileDialogOpenThumbnail, CFileDialog)

CFileDialogOpenThumbnail::CFileDialogOpenThumbnail(
	    BOOL disglbl, LPCTSTR lpszDefExt, LPCTSTR lpszFileName,
		DWORD dwFlags, LPCTSTR lpszFilter, CWnd* pParentWnd) :
		CFileDialog(TRUE, lpszDefExt, lpszFileName, dwFlags, lpszFilter, pParentWnd)

		{
			m_pFilePrev = NULL;
			m_bDisableGlobal = disglbl;
		}


BEGIN_MESSAGE_MAP(CFileDialogOpenThumbnail, CFileDialog)
	//{{AFX_MSG_MAP(CFileDialogOpenThumbnail)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CFileDialogOpenThumbnail::OnFileNameChange()
{
	if (m_bDisableGlobal == TRUE) return;
	BOOL couldbeopened=FALSE;

	CString fnpath = this->GetPathName();

    int pos = fnpath.ReverseFind('.');

    if (pos == -1) return;

    CString ext = fnpath.Right(fnpath.GetLength()-pos-1);

    ext.MakeUpper();

	if ((ext == "BMP") || (ext == "BKC") || (ext == "IMM") || (ext == "IMC") || (ext == "BKG"))
	{
		FILE *fp = fopen((const char *) (LPCTSTR) fnpath, "rb");
		if (fp != NULL) { couldbeopened = TRUE; fclose(fp); }
	}

	if (couldbeopened == FALSE)
	{
		//AfxMessageBox("Could not be opened.");
	}

	if (couldbeopened == TRUE)
	{
		if (m_pFilePrev == NULL)
		{
			m_pFilePrev = new CFilePreview( fnpath );
			if (m_pFilePrev != NULL)
			{
                if (m_pFilePrev->Initialize() == FALSE)
				{
					delete m_pFilePrev;
				}
				else
				{
					m_pFilePrev->Create( IDD_FILEPREVIEW_DIALOG, GetDesktopWindow() );

					RECT r1;

					this->GetParent()->GetWindowRect( &r1 ); //works, GetParent()

					// adjust size
					m_pFilePrev->SetWindowPos( &wndTopMost, r1.left,r1.bottom,r1.right-r1.left,360, 0 );
				
					// show it
					m_pFilePrev->ShowWindow(SW_SHOW);
				}
			}
		}

		if (m_pFilePrev != NULL)
		{
			if (m_pFilePrev->WasClosed() == FALSE) 
			{
				m_pFilePrev->UpdateFile( fnpath );
			}
		}
	}
			
}

void CFileDialogOpenThumbnail::OnOK()
{
 if (m_bDisableGlobal == TRUE) return;
 if (m_pFilePrev != NULL)
 {
	 m_pFilePrev->ShowWindow(SW_HIDE); //hide it
	 m_pFilePrev->OnClosePublic();
	 m_bDisableGlobal = m_pFilePrev->ReturnDisableGlobal();
	 m_pFilePrev->DestroyWindow(); // destroy it 

	 delete m_pFilePrev;
	 m_pFilePrev = NULL;
 }

 CFileDialog::OnOK();
}

void CFileDialogOpenThumbnail::OnCancel()
{
 if (m_bDisableGlobal == TRUE) return;
 if (m_pFilePrev != NULL)
 {
	 m_pFilePrev->ShowWindow(SW_HIDE); //hide it
	 m_pFilePrev->OnClosePublic();
	 m_bDisableGlobal = m_pFilePrev->ReturnDisableGlobal();
	 m_pFilePrev->DestroyWindow(); // destroy it 

	 delete m_pFilePrev;
	 m_pFilePrev = NULL;
 }

 CFileDialog::OnCancel();

}


BOOL CFileDialogOpenThumbnail::OnFileNameOK()
{
 if (m_bDisableGlobal == TRUE) return(0);
 if (m_pFilePrev != NULL)
 {
	 m_pFilePrev->ShowWindow(SW_HIDE); //hide it
	 m_pFilePrev->OnClosePublic();
	 m_bDisableGlobal = m_pFilePrev->ReturnDisableGlobal();
	 m_pFilePrev->DestroyWindow(); // destroy it 

	 delete m_pFilePrev;
	 m_pFilePrev = NULL;
 }

 CFileDialog::OnCancel();

 return(0); // valid filename
}

BOOL CFileDialogOpenThumbnail::ReturnDisableGlobal()
{
 return( m_bDisableGlobal );
}
