// FilePreview.cpp : implementation file
//

#include "stdafx.h"
#include "videoclnt.h"
#include "headers.h"
#include "MemoryManagement.h"
#include <vfw.h>
#include <atlbase.h>
#include "rpcdefs.h"
#include "Queue.h"
#include "compression.h"
#include "BMPFileHelper.h"
class CVideoclntDlg;
class CImageSequence;
#include <windows.h>
#include <winsock.h>
#undef fd_set
#include "acop.h"
#include "CATineDlg.h"
#include "TineALDlg.h"
#include "IniEx.h"
#include "Server.h"
#include "ServerList.h"
#include "SSyncSocket.h"
#include "BogusTineDlg.h"
#include "ImageAcquire.h"
#include "configdlg.h"
#include "Stat.h"
#include "FourierStat.h"
#include "StatFile.h"
#include "MessagesDlg.h"
#include "MyVideoFrame.h"
#include "PrinterSettings.h"
#include "oleauto.h"
#include "AdditionalInformation.h"
#include "MarkedComboBox.h"
#include "InformationDialog.h"
#include "videoclntDlg.h"
#include "ImageSequence.h"
#include "IMCFileHelper.h"
#include "FilePreview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static int initialFalseColor=1;
static BOOL initialKeepAspectRatio=TRUE;

/////////////////////////////////////////////////////////////////////////////
// CFilePreview dialog


CFilePreview::CFilePreview(CString initialFile, CWnd* pParent /*=NULL*/)
	: CDialog(CFilePreview::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFilePreview)
	//}}AFX_DATA_INIT
	m_sFileName = initialFile;
	m_pImageSequence = NULL;
	m_bInitialized = FALSE;
	m_bWasClosed = FALSE;
	m_dcRW = NULL;
	m_bmp = NULL;
	m_destDC = NULL;
	m_iCurrentImage = 0;
	m_bDrawingInitialized = FALSE;
	m_bPaletteChangeInProgress = FALSE;
	m_pBitmapInfo = NULL;
	m_hPalette = NULL;
	m_bFileSuccessfullyLoaded = FALSE;
	m_bDisableGlobal = FALSE;


	m_pLastFrame = NULL;

	m_iFalseColor = initialFalseColor;
	m_bKeepAspectRatio = initialKeepAspectRatio;
}


void CFilePreview::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFilePreview)
	DDX_Control(pDX, IDOK, m_CButtonClose);
	DDX_Control(pDX, IDC_STATIC_SCALESTR, m_CStaticScaleString);
	DDX_Control(pDX, IDC_STATIC_WIDTHHEIGHT, m_CStaticWidthHeight);
	DDX_Control(pDX, IDC_BUTTON2_5FORW, m_CButton5Forw);
	DDX_Control(pDX, IDC_BUTTON1_5BACK, m_CButton5Back);
	DDX_Control(pDX, IDC_CHECK1_DISDLG, m_CCheckDisableDialog);
	DDX_Control(pDX, IDC_EDIT1, m_CEditScale);
	DDX_Control(pDX, IDC_STATIC_IMGNUM, m_CStaticImageNumber);
	DDX_Control(pDX, IDC_RADIO3_JET, m_CRadioJetFalseColor);
	DDX_Control(pDX, IDC_RADIO2_FALSE, m_CRadioFalseColor);
	DDX_Control(pDX, IDC_RADIO1_GREY, m_CRadioGreyscale);
	DDX_Control(pDX, IDC_CHECK2_KEEPASPECTRATIO, m_CCheckKeepAspectRatio);
	DDX_Control(pDX, IDC_BUTTON4_IMGSTART, m_CButtonJumpToStart);
	DDX_Control(pDX, IDC_BUTTON3_JUMPTOEND, m_CButtonJumpToEnd);
	DDX_Control(pDX, IDC_BUTTON2_ONEIMGFORW, m_CButtonOneImageForward);
	DDX_Control(pDX, IDC_BUTTON1_ONEIMGBACK, m_CButtonOneImageBack);
	DDX_Control(pDX, IDC_STATIC_IMGPREV, m_CMyVideoFrame);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFilePreview, CDialog)
	//{{AFX_MSG_MAP(CFilePreview)
	ON_BN_CLICKED(IDC_BUTTON4_IMGSTART, OnButton4Imgstart)
	ON_BN_CLICKED(IDC_BUTTON3_JUMPTOEND, OnButton3Jumptoend)
	ON_BN_CLICKED(IDC_BUTTON2_ONEIMGFORW, OnButton2Oneimgforw)
	ON_BN_CLICKED(IDC_BUTTON1_ONEIMGBACK, OnButton1Oneimgback)
	ON_BN_CLICKED(IDC_CHECK1_DISDLG, OnCheck1Disdlg)
	ON_BN_CLICKED(IDC_CHECK2_KEEPASPECTRATIO, OnCheck2Keepaspectratio)
	ON_BN_CLICKED(IDC_RADIO1_GREY, OnRadio1Grey)
	ON_BN_CLICKED(IDC_RADIO2_FALSE, OnRadio2False)
	ON_BN_CLICKED(IDC_RADIO3_JET, OnRadio3Jet)
	ON_WM_CLOSE()
	ON_WM_CANCELMODE()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON2_5FORW, OnButton5forw)
	ON_BN_CLICKED(IDC_BUTTON1_5BACK, OnButton5back)
	ON_WM_SIZE()
	ON_WM_SIZING()
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFilePreview message handlers

void CFilePreview::OnButton4Imgstart() 
{
	m_iCurrentImage = 0;
 	UpdateDialog();
}

void CFilePreview::OnButton3Jumptoend() 
{
	m_iCurrentImage = m_pImageSequence->Count()-1;
	UpdateDialog();
}

void CFilePreview::OnButton2Oneimgforw() 
{
	m_iCurrentImage++;
	if (m_iCurrentImage >= m_pImageSequence->Count()-1) m_iCurrentImage = m_pImageSequence->Count()-1;
	UpdateDialog();
	
}

void CFilePreview::OnButton1Oneimgback() 
{
  m_iCurrentImage--;
  if (m_iCurrentImage < 0) m_iCurrentImage = 0;
	UpdateDialog();
}

void CFilePreview::OnOK() 
{
	CDialog::OnOK();
}

void CFilePreview::OnCheck1Disdlg() 
{
	if (m_CCheckDisableDialog.GetCheck() == 1) m_bDisableGlobal = TRUE; else m_bDisableGlobal = FALSE;
}

void CFilePreview::OnCheck2Keepaspectratio() 
{
	if (m_CCheckKeepAspectRatio.GetCheck() == 1) m_bKeepAspectRatio = TRUE; else m_bKeepAspectRatio = FALSE;

	UpdateDialog();
}

void CFilePreview::OnRadio1Grey() 
{
	m_CRadioGreyscale.SetCheck(1);

	m_CRadioFalseColor.SetCheck(0);
	m_CRadioJetFalseColor.SetCheck(0);

	m_iFalseColor = 0;
	UpdatePalette();
	UpdateBitmapInfo();
	UpdateDialog();
}

void CFilePreview::OnRadio2False() 
{
	m_CRadioGreyscale.SetCheck(0);

	m_CRadioFalseColor.SetCheck(1);
	m_CRadioJetFalseColor.SetCheck(0);

	m_iFalseColor = 1;
	UpdatePalette();
	UpdateBitmapInfo();
	UpdateDialog();	
}

void CFilePreview::OnRadio3Jet() 
{
	m_CRadioGreyscale.SetCheck(0);

	m_CRadioFalseColor.SetCheck(0);
	m_CRadioJetFalseColor.SetCheck(1);

	m_iFalseColor = 2;
	UpdatePalette();
	UpdateBitmapInfo();
	UpdateDialog();
}

BOOL CFilePreview::OnInitDialog() 
{
	CDialog::OnInitDialog();
	// TODO: Add extra initialization here

	InitializeDrawing();

	m_CRadioGreyscale.SetCheck(0);
	m_CRadioFalseColor.SetCheck(0);
	m_CRadioJetFalseColor.SetCheck(0);

	switch( m_iFalseColor )
	{
	case 1: m_CRadioFalseColor.SetCheck(1);
		break;
	case 2: m_CRadioJetFalseColor.SetCheck(1);
		break;

	default: m_CRadioGreyscale.SetCheck(1);
		break;
    }

	int lm = m_bKeepAspectRatio; 

	if (lm != 0) lm = 1;

	m_CCheckKeepAspectRatio.SetCheck(lm);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CFilePreview::UpdateFile(CString newfilename)
{
 if (m_bInitialized == FALSE) return;
 if (m_bDrawingInitialized == FALSE) return;

 if (UpdateWithNewFile(newfilename) == TRUE)
 {
	m_sFileName = newfilename;
	
	RECT rect;
    HDC hdc;

	GetWindowRect(&rect);
    hdc = this->GetDC()->m_hDC;
  
	char buffer_2[MAX_PATH];
	char *bufptr2;
	bufptr2 = buffer_2;

    int length = rect.right - rect.left;
    length -= 200;

    sprintf( buffer_2, "%s", (const char *)  (LPCTSTR) m_sFileName );

    PathCompactPath(hdc,bufptr2,length);	

    CString msg;
    msg.Format("File Preview: \"%s\" (%d frames)", buffer_2, m_pImageSequence->Count());

    SetWindowText( (LPCTSTR) msg );  
 }
}

BOOL CFilePreview::UpdateWithNewFile(CString newfn)
{
 BOOL ret = FALSE;

 m_bFileSuccessfullyLoaded = FALSE;

 m_pImageSequence->EmptySequence();

 int pos = newfn.ReverseFind('.');

 if (pos == -1) return FALSE;

 CString ext = newfn.Right(newfn.GetLength()-pos-1);

 ext.MakeUpper();

 if (ext == "BMP")
 {
	 ret = m_pImageSequence->LoadFromFile(FILE_BMP, newfn);
 }
 else if (ext == "IMM")
 {
	 ret = m_pImageSequence->LoadFromFile(FILE_IMM, newfn);
 }
 else if (ext == "IMC")
 {
	 ret = m_pImageSequence->LoadFromFile(FILE_IMC, newfn);
 }
 else if (ext == "BKC")
 {
     ret = m_pImageSequence->LoadFromFile(FILE_BKC, newfn);
 }
 else if (ext == "BKG")
 {
  FILE *fp = fopen(newfn, "rb");

  if (fp != NULL) // file could be opened
  {
   unsigned int w, h, bpp;

   // read width and height of the image
   fread(&w, 1, 4, fp);
   fread(&h, 1, 4, fp);
   
   bpp = (w&0xff0000)>>16;
   w = w&0xffff;
   if (bpp == 0) bpp = 8;

   VIDHDR vidH;

   vidH.kennung = 0x11223344;
   vidH.len_fmthdr = 0;
   vidH.bpp = bpp;
   vidH.widthframe = w;
   vidH.heightframe = h;
   vidH.compressed = 0;
   vidH.compression = 0;
   vidH.cameraport = 0;
   vidH.frameno = 0;
   vidH.scale = 1.000;
   vidH.len_data = w*h*bpp/8;
   vidH.len_total = vidH.len_fmthdr + sizeof(VIDHDR) + vidH.len_data;

   char *bits = (char *) memman.sw_malloc( sizeof(VIDHDR) + (w*h*bpp/8) );
   if (bits == NULL) return FALSE;
   memman.memcpysw( bits, (char *) &vidH, sizeof(VIDHDR) );

   char *frmbits = bits + sizeof(VIDHDR);

   int retread = fread( frmbits, w*h*bpp/8, 1, fp);
   if (retread == 1)
   {
	   m_pImageSequence->Add( (unsigned char *) bits );
	   m_pImageSequence->SetScale( vidH.scale );
   }
   fclose(fp);
   ret = TRUE;

  }
 }
 else ret = FALSE;

 if (ret == TRUE)
 {
	 m_bFileSuccessfullyLoaded = TRUE;

   	 UpdatePalette();
	 UpdateBitmapInfo();
	 m_iCurrentImage = 0; // means first image
	
	 UpdateDialog();
 }
 return ret;
}


// initializes basics of class (palette creation and image sequence)
BOOL CFilePreview::Initialize()
{
	if (m_bInitialized == TRUE) return TRUE;
	
	CWnd *wnd = AfxGetMainWnd();
	CVideoclntDlg *dlg = (CVideoclntDlg *) wnd;

	if (m_bInitialized == FALSE) 
	{
		m_pImageSequence = new CImageSequence(NULL, FALSE, NULL, dlg);
		if (m_pImageSequence == NULL) { return FALSE; }
	}

	UpdatePalette();

    m_bInitialized = TRUE;

	if (m_bInitialized == TRUE) return TRUE;
	return FALSE;
}

void CFilePreview::OnClose() 
{
	if (m_bDrawingInitialized == TRUE) DeinitializeDrawing();
	
	if (m_bInitialized == TRUE)
	{
		if (m_pImageSequence != NULL)
		{
			m_pImageSequence->EmptySequence();
			delete m_pImageSequence;
			m_pImageSequence = NULL;
		}
		m_bInitialized = FALSE;
	}

	if (m_pLastFrame != NULL)
	{
		memman.sw_free( (void *) m_pLastFrame);
		m_pLastFrame = NULL;
	}

	m_bWasClosed = TRUE;

	initialFalseColor = m_iFalseColor;
    initialKeepAspectRatio = m_bKeepAspectRatio;

	if (m_bDisableGlobal == TRUE)
	{
		((CVideoclntDlg *)AfxGetMainWnd())->OwnMessageBox(MB_ICONINFORMATION, "You have chosen to permanently disable the file preview dialog.\n\nYou can undo this via Application->Preferences.");
	}

	CDialog::OnClose();
}

void CFilePreview::OnCancelMode() 
{
	CDialog::OnCancelMode();
}

BOOL CFilePreview::WasClosed()
{
 return( m_bWasClosed );
}

void CFilePreview::UpdateButtonsAndControls()
{
 // must only be called from DisplayFunction !!!
 if (m_bWasClosed == TRUE) return;

 int imgcount = m_pImageSequence->Count();

 m_CButtonJumpToEnd.EnableWindow(TRUE);
 m_CButtonJumpToStart.EnableWindow(TRUE);
 m_CButtonOneImageForward.EnableWindow(TRUE);
 m_CButtonOneImageBack.EnableWindow(TRUE);
 m_CButton5Back.EnableWindow(TRUE);
 m_CButton5Forw.EnableWindow(TRUE);

 if (m_iCurrentImage < 0) m_iCurrentImage = 0;
 if (m_iCurrentImage > (imgcount-1)) m_iCurrentImage = imgcount - 1;

 int ci = m_iCurrentImage;
 int cip5 = m_iCurrentImage+5;
 int cim5 = m_iCurrentImage-5;
 int cimin = 0;
 int cimax = imgcount-1;

 if (cimax == 0)
 {
 	 m_CButtonJumpToEnd.EnableWindow(FALSE);
	 m_CButtonJumpToStart.EnableWindow(FALSE);
	 m_CButtonOneImageForward.EnableWindow(FALSE);
	 m_CButtonOneImageBack.EnableWindow(FALSE);
	 m_CButton5Forw.EnableWindow(FALSE);
	 m_CButton5Back.EnableWindow(FALSE);
 }
 else
 {
	 if (ci == cimax) 
	 {
		 m_CButtonJumpToEnd.EnableWindow(FALSE);
		 m_CButtonOneImageForward.EnableWindow(FALSE);
	 }

	 if (ci == cimin) 
	 {
		 m_CButtonJumpToStart.EnableWindow(FALSE);
		 m_CButtonOneImageBack.EnableWindow(FALSE);
	 }

	 if (cip5 > cimax) m_CButton5Forw.EnableWindow(FALSE);
	 if (cim5 < cimin) m_CButton5Back.EnableWindow(FALSE);
 }

 CString msg;

 double scale = m_pImageSequence->GetScale();
 msg.Format("%f", scale);
 m_CEditScale.SetWindowText( (LPCTSTR) msg );
 m_CEditScale.EnableWindow(TRUE);

 msg.Format("%d/%d", m_iCurrentImage+1, imgcount);

 m_CStaticImageNumber.SetWindowText((LPCTSTR) msg);

 msg.Format( "%d x %d pixels", m_pImageSequence->GetImageWidth(), m_pImageSequence->GetImageHeight()); // , m_pImageSequence->GetBpp() 
 m_CStaticWidthHeight.SetWindowText( (LPCTSTR) msg);

 //if (m_bDrawingInitialized == TRUE)
 //{
 //	 if (m_bFileSuccessfullyLoaded == TRUE) DisplayFunction();
 //}
}

void CFilePreview::OnClosePublic()
{
 OnClose();
}

void CFilePreview::DisplayFunction()
{
 if (m_bWasClosed == TRUE) return;

 if (IsIconic()) return;

	// drawing is not initialized, better not draw
 if (m_bDrawingInitialized == FALSE) return;
 
 // changing the palette - better not draw
 if (m_bPaletteChangeInProgress == TRUE) return;

 if (m_pImageSequence->Count() == 0) return;

 RECT r;

 m_CMyVideoFrame.GetWindowRect( &r );

 //r.bottom -= 2;
 //r.top += 2;

 const char *bits;

 m_pImageSequence->GetFrame( m_iCurrentImage, &bits );

 VIDHDR vidH;

 memman.memcpysw( (char *) &vidH, (char *) bits, sizeof(VIDHDR) );

 bits += vidH.len_total - vidH.len_data;

 int destw = r.right - r.left + 1;
 int desth = r.bottom - r.top + 1;

 int srcw = m_pImageSequence->GetImageWidth();
 int srch = m_pImageSequence->GetImageHeight();
 int srcbpp = m_pImageSequence->GetBpp();

 SelectPalette(m_destDC->m_hDC, m_hPalette, FALSE);

 if (m_pLastFrame == NULL)
 {
   m_pLastFrame = (char *) memman.sw_malloc( (srcw+(srcw%4))*srch );
   if (m_pLastFrame == NULL) { return; }
 }

 if (srcbpp > 8)
 {
	 const char *bitsold = bits;

	 bits = (const char *) memman.sw_malloc(srcw*srch);

	 if (bits != NULL) DownScaleTo8Bit((unsigned char *) bitsold, (unsigned char *) bits, srcw, srch, srcbpp);
 }

 flipframemmx(m_pLastFrame, (char *) bits, srcw, srch);

 if (srcbpp > 8) { if (bits != NULL) memman.sw_free( (void *) bits ); }

 // bildspeicher auf grau setzen

 CBrush br1;
 LOGBRUSH logbrush;

 br1.CreateSysColorBrush(COLOR_BTNFACE);
 br1.GetLogBrush( &logbrush );
    
 m_destDC->FillSolidRect( 0,0, destw, desth, logbrush.lbColor );

 int destx = 0;
 int desty = 0;
 int destwadj = destw;
 int desthadj = desth;

 if (m_bKeepAspectRatio == TRUE)
 {
    double whratiovideo = 1.0;
	if (destwadj != 0) whratiovideo = ((double)srcw)/((double)srch);

	double whratioclient = ((double)destwadj)/((double)desthadj);

   here:
	desthadj = (int) (((double)destwadj)/whratiovideo);
	if (desthadj > desth) { destwadj--; goto here; }
 }

 if (destwadj != destw) destx += abs( destwadj - destw ) / 2;
 if (desthadj != desth) desty += abs( desthadj - desth ) / 2;


 int ret = StretchDIBits(m_destDC->m_hDC,destx,desty,destwadj,desthadj,0,0,srcw,srch, /* dest xywh src xywh */
			  (const void *) m_pLastFrame,(BITMAPINFO *) m_pBitmapInfo, DIB_RGB_COLORS, SRCCOPY);

 //UpdateButtonsAndControls();
}


void CFilePreview::UpdatePalette()
{
 if (m_iFalseColor < 0 || m_iFalseColor > 2) return;

 m_bPaletteChangeInProgress = TRUE;

 if (m_iFalseColor == 0)
 {
	 // fill in false colors
	 for (int i=0; i<256; i++)
	 {
	  m_ColorTable[i].rgbRed      = i;
      m_ColorTable[i].rgbGreen    = i;
      m_ColorTable[i].rgbBlue     = i;
      m_ColorTable[i].rgbReserved = 0;
	 }
 }
 else if (m_iFalseColor == 1)
 {
	 // fill in false colors
	 for (int i=0; i<256; i++)
	 {
	  m_ColorTable[i].rgbRed      = (i>170)*((i-170)*190/85+65);
      m_ColorTable[i].rgbGreen    = (i>85)*(i<171)*(190*(i-85)/85+65)+255*(i==255);
      m_ColorTable[i].rgbBlue     = (i>0)*(i<150)*255*(150-i+1)/150+255*(i==255);
      m_ColorTable[i].rgbReserved = 0;
	 }
 }
 else if (m_iFalseColor == 2) // MATLAB JET false color
 {
	 unsigned char redchn[256]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,7,11,15,19,23,27,31,35,39,43,47,51,55,59,63,67,71,75,79,83,87,91,95,99,103,107,111,115,119,123,127,131,135,139,143,147,151,155,159,163,167,171,175,179,183,187,191,195,199,203,207,211,215,219,223,227,231,235,239,243,247,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,247,243,239,235,231,227,223,219,215,211,207,203,199,195,191,187,183,179,175,171,167,163,159,155,151,147,143,139,135,131,255};
	 unsigned char grnchn[256]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,7,11,15,19,23,27,31,35,39,43,47,51,55,59,63,67,71,75,79,83,87,91,95,99,103,107,111,115,119,123,127,131,135,139,143,147,151,155,159,163,167,171,175,179,183,187,191,195,199,203,207,211,215,219,223,227,231,235,239,243,247,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,247,243,239,235,231,227,223,219,215,211,207,203,199,195,191,187,183,179,175,171,167,163,159,155,151,147,143,139,135,131,127,123,119,115,111,107,103,99,95,91,87,83,79,75,71,67,63,59,55,51,47,43,39,35,31,27,23,19,15,11,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255};
	 unsigned char bluchn[256]={0,135,139,143,147,151,155,159,163,167,171,175,179,183,187,191,195,199,203,207,211,215,219,223,227,231,235,239,243,247,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,247,243,239,235,231,227,223,219,215,211,207,203,199,195,191,187,183,179,175,171,167,163,159,155,151,147,143,139,135,131,127,123,119,115,111,107,103,99,95,91,87,83,79,75,71,67,63,59,55,51,47,43,39,35,31,27,23,19,15,11,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255};
	
	 // fill in false colors
	 for (int i=0; i<256; i++)
	 {
	  m_ColorTable[i].rgbRed      = redchn[i];
      m_ColorTable[i].rgbGreen    = grnchn[i];
      m_ColorTable[i].rgbBlue     = bluchn[i];

      m_ColorTable[i].rgbReserved = 0;
	 }

 }

 // update log palette

 LOGPALETTE *lpLogPalG;

 lpLogPalG = (LOGPALETTE *) malloc( sizeof(LOGPALETTE) + (sizeof(PALETTEENTRY)*255) );
 if (lpLogPalG == NULL) return;

 lpLogPalG->palVersion = 0x0300;
 lpLogPalG->palNumEntries = 256;
 for (int i=0; i<256; i++)
 {
  lpLogPalG->palPalEntry[i].peRed   = m_ColorTable[i].rgbRed;
  lpLogPalG->palPalEntry[i].peGreen = m_ColorTable[i].rgbGreen;
  lpLogPalG->palPalEntry[i].peBlue  = m_ColorTable[i].rgbBlue;
  lpLogPalG->palPalEntry[i].peFlags = 0;
 }
 
 if (m_hPalette != NULL) DeleteObject( (HGDIOBJ) m_hPalette );

 m_hPalette = ::CreatePalette(lpLogPalG);

 free( (void *) lpLogPalG );

 m_bPaletteChangeInProgress = FALSE;
}

void CFilePreview::UpdateBitmapInfo()
{
    if (m_bInitialized == FALSE || m_bWasClosed == TRUE) return;

	if (m_pBitmapInfo == NULL) 
	{
		m_pBitmapInfo = (BITMAPINFO *) malloc(sizeof(BITMAPINFO)+256*sizeof(RGBQUAD));
		if (m_pBitmapInfo == NULL) return;
	}

	int w = 768;  
	int h = 574;  
    int bpp = 8; 

	if (m_pImageSequence != NULL)
	{
		if (m_pImageSequence->Count() > 0)
		{
			w = m_pImageSequence->GetImageWidth();
			h = m_pImageSequence->GetImageHeight();
			bpp = m_pImageSequence->GetBpp(); 
		}
	
	}
 
	if (m_pLastFrame != NULL) { memman.sw_free( ( void *) m_pLastFrame ); m_pLastFrame = NULL; }

	/* SW! May 08, 2006
	CString msg;
	msg.Format("UpdateBitmapInfo: w=%d, h=%d, bpp=%d", w, h, bpp);
	AfxMessageBox(msg);
	*/

	m_pLastFrame = (char *) memman.sw_malloc( (w+(w%4))*h*bpp/8 );
	if (m_pLastFrame == NULL) { m_bDrawingInitialized = FALSE; return; }

	// copy color table
	for (int i=0;i<256;i++)
	{
		m_pBitmapInfo->bmiColors[i].rgbRed = m_ColorTable[i].rgbRed;
		m_pBitmapInfo->bmiColors[i].rgbGreen = m_ColorTable[i].rgbGreen;
		m_pBitmapInfo->bmiColors[i].rgbBlue = m_ColorTable[i].rgbBlue;
		m_pBitmapInfo->bmiColors[i].rgbReserved = 0;
	}

	// fill in proper bitmpapinfoheader values
	m_pBitmapInfo->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	m_pBitmapInfo->bmiHeader.biWidth = m_pImageSequence->GetImageWidth();
	m_pBitmapInfo->bmiHeader.biHeight = m_pImageSequence->GetImageHeight();
	m_pBitmapInfo->bmiHeader.biPlanes = 1;
	m_pBitmapInfo->bmiHeader.biBitCount = 8;
	m_pBitmapInfo->bmiHeader.biCompression = BI_RGB;
	m_pBitmapInfo->bmiHeader.biSizeImage = 0;
	m_pBitmapInfo->bmiHeader.biXPelsPerMeter = 0;
	m_pBitmapInfo->bmiHeader.biYPelsPerMeter = 0;
	m_pBitmapInfo->bmiHeader.biClrUsed = 0;
	m_pBitmapInfo->bmiHeader.biClrImportant = 0;
}

// initializes drawing (bitmapinfo, Device contexts)
void CFilePreview::InitializeDrawing()
{
	if (m_bInitialized == FALSE) return;
	if (m_bDrawingInitialized == TRUE) return;

    BOOL ret;
	HGDIOBJ ret1;

	RECT videoArea;

	m_CMyVideoFrame.GetClientRect( &videoArea );

	m_dcRW = new CClientDC( &m_CMyVideoFrame );
    m_destDC = new CDC();
    if (m_dcRW != NULL && m_destDC != NULL)
	{
      ret = m_destDC->CreateCompatibleDC( m_dcRW );
	  if (ret == FALSE) return;
      m_bmp = new CBitmap();
	  if (m_bmp == NULL) return;
	  ret = m_bmp->CreateCompatibleBitmap(m_dcRW, videoArea.right - videoArea.left + 1, videoArea.bottom - videoArea.top + 1);
	  if (ret == FALSE) return;
	  ret1 = SelectObject(m_destDC->m_hDC,m_bmp->m_hObject);

      m_pBitmapInfo = (BITMAPINFO *) malloc(sizeof(BITMAPINFO)+256*sizeof(RGBQUAD));
	  if (m_pBitmapInfo == NULL) return;

	  UpdateBitmapInfo();

      m_bDrawingInitialized = TRUE;
    }
}

// deinitializes drawing ( Palette, Device Contexts, BitmapInfo)
void CFilePreview::DeinitializeDrawing()
{
    if (m_bDrawingInitialized == FALSE) return;

    if (m_hPalette != NULL) DeleteObject( (HGDIOBJ) m_hPalette );

	if (m_bmp != NULL) delete m_bmp;
	m_bmp = NULL;
	if (m_destDC != NULL) delete m_destDC;
	m_destDC = NULL;
	
	// release device context and free up memory
    if (m_dcRW != NULL) m_CMyVideoFrame.ReleaseDC(m_dcRW);
	if (m_dcRW != NULL) delete m_dcRW;
	m_dcRW = NULL;

	if (m_pBitmapInfo != NULL) free( (void *) m_pBitmapInfo );
	m_pBitmapInfo = NULL;

	m_bDrawingInitialized = FALSE;
}

void CFilePreview::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		//dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dcP(this);

        RedrawClientArea(&dcP);

		RECT r;

		m_CMyVideoFrame.GetWindowRect( &r );

		int destw = r.right - r.left;
		int desth = r.bottom - r.top;
        
		m_dcRW->BitBlt(0,0,destw,desth, m_destDC,0,0,SRCCOPY);

		CDialog::OnPaint();
	}

}

void CFilePreview::OnButton5forw() 
{
	m_iCurrentImage += 5;
	if (m_iCurrentImage >= m_pImageSequence->Count()-1) m_iCurrentImage = m_pImageSequence->Count()-1;
	UpdateDialog();
}

void CFilePreview::OnButton5back() 
{
	m_iCurrentImage -= 5;
	if (m_iCurrentImage < 0) m_iCurrentImage = 0;
	UpdateDialog();
}

void CFilePreview::flipframemmx(char *dest, char *src, int width, int height)
{
	int bpp = 8;

 char *srcptr = src;
 char *destptr = dest;
 int lastline = (width*height*bpp/8)-(width*bpp/8);
 int adddst = width%4;
 int widthdiv8 = width / 8;
 int subtract = width*2;
 
 BOOL mmxdetected = FALSE;

 __asm
 {
     mov EAX, 1 
     CPUID 
     test EDX, 00800000h 
 
     jz MMX_Technology_Not_Found
     mov mmxdetected, 1
     MMX_Technology_Not_Found:
 }

 if (mmxdetected == TRUE)
 {
   __asm
   {
     emms
     mov esi, srcptr
     add esi, lastline
     mov edi, destptr
     mov edx, height
	 mov eax, width
	 and eax, 7
    yloop:
     mov ecx, widthdiv8
    xloop:
     movq mm1, [esi]
     add  esi,8
     movq [edi], mm1
     add edi,8

     dec ecx
     jnz xloop

     push eax
     cmp eax,0
	 jg  dosmallloop
    backhere:
	 pop eax

     sub esi, subtract
	 add edi, adddst

     dec edx
     jnz yloop

     emms
	 jmp outofhere

    dosmallloop:
	 mov bl, [esi]
	 add esi, 1
	 mov [edi], bl
	 add edi, 1
	 dec eax
	 jnz dosmallloop
	 jmp backhere

    outofhere:
   }
 }
  else
 {
    int add = (width*bpp/8)%4;

    srcptr += lastline;

    int addsrc = (width*bpp/8);
    int adddst1 = addsrc + add;

    for (int i=0;i<height;i++)
    {
     memman.memcpysw( (char *) destptr, (char *) srcptr, width);
     destptr += adddst1;
     srcptr -= addsrc; 
    }
 }
}


void CFilePreview::OnSize(UINT nType, int cx, int cy) 
{
    BOOL ret;
	HGDIOBJ ret1;
	
	int minw = 425;
	int minh = 340;

	CDialog::OnSize(nType, cx, cy); // call base class

	// drawing is not yet initialized, then go immediately out here
	if (m_bDrawingInitialized == FALSE) return;

	// indicate that other functions should not draw at the moment
	m_bDrawingInitialized = FALSE;

	// reinitialize drawing objects 

	RECT clientArea;
	RECT videoArea;

	this->GetClientRect( &clientArea );
	videoArea = clientArea;
	videoArea.bottom -= 120;

	m_CMyVideoFrame.MoveWindow( &videoArea, TRUE);
	
    if (m_hPalette != NULL) DeleteObject( (HGDIOBJ) m_hPalette );

	if (m_bmp != NULL) delete m_bmp;
	m_bmp = NULL;
	if (m_destDC != NULL) delete m_destDC;
	m_destDC = NULL;
	
	// release device context and free up memory
    if (m_dcRW != NULL) m_CMyVideoFrame.ReleaseDC(m_dcRW);
	if (m_dcRW != NULL) delete m_dcRW;
	m_dcRW = NULL;

	if (m_pBitmapInfo != NULL) free( (void *) m_pBitmapInfo );
	m_pBitmapInfo = NULL;

	// initialize again 

	m_dcRW = new CClientDC( &m_CMyVideoFrame );
    m_destDC = new CDC();
    if (m_dcRW != NULL && m_destDC != NULL)
	{
      ret = m_destDC->CreateCompatibleDC( m_dcRW );
	  if (ret == FALSE) { return; }
      m_bmp = new CBitmap();
	  if (m_bmp == NULL) { return; }
	  ret = m_bmp->CreateCompatibleBitmap(m_dcRW, videoArea.right - videoArea.left + 1, videoArea.bottom - videoArea.top + 1);
	  if (ret == FALSE) { return; }
	  ret1 = SelectObject(m_destDC->m_hDC,m_bmp->m_hObject);

      m_pBitmapInfo = (BITMAPINFO *) malloc(sizeof(BITMAPINFO)+256*sizeof(RGBQUAD));
	  if (m_pBitmapInfo == NULL) { return; }
	}
	else
	{
		m_bDrawingInitialized = FALSE;
	}

	m_bDrawingInitialized = TRUE;
	UpdatePalette();
	UpdateBitmapInfo();

	UpdateDialog();
}
	

BOOL CFilePreview::ReturnDisableGlobal()
{
 return( m_bDisableGlobal );
}

void CFilePreview::OnSizing(UINT fwSide, LPRECT pRect) 
{
    if (IsIconic()) return;

	int minw = 425;
	int minh = 340;

	if ((pRect->right - pRect->left)<minw) pRect->right = pRect->left + minw;
	if ((pRect->bottom - pRect->top)<minh) pRect->bottom = pRect->top + minh;

	CDialog::OnSizing(fwSide, pRect);
}

void CFilePreview::RedrawClientArea( CPaintDC *dcP )
{
	int minw = 425;
	int minh = 340;

	// anpassen der DialogElemente

	RECT clientArea;
	RECT videoArea;
	RECT controlsArea;
	RECT screenArea;

	this->GetClientRect( &clientArea );
	screenArea = clientArea;
	this->ClientToScreen( &screenArea );

	videoArea = clientArea;
	controlsArea = clientArea;

	videoArea.bottom -= 120;
	
	controlsArea.top = videoArea.bottom+1;

	m_CMyVideoFrame.MoveWindow( &videoArea, TRUE);

	CBrush br1;
	LOGBRUSH logbrush;

	br1.CreateSysColorBrush(COLOR_BTNFACE);
    br1.GetLogBrush( &logbrush );
    
	//dcP->FillSolidRect(&clientArea, logbrush.lbColor );
	//dcP->FillSolidRect(&clientArea, RGB(255,0,255) );

	int startx = (( controlsArea.right - controlsArea.left + 1)/2)-((minw)/2);
	if (startx < 0) startx = 0;
	int starty = controlsArea.top;
	if (starty < 0) starty = 0;

	RECT r;
	m_CButtonJumpToStart.GetClientRect(&r);
	m_CButtonJumpToStart.MoveWindow( startx+20, starty+5, r.right, r.bottom, TRUE);

	m_CButton5Back.GetClientRect(&r);
	m_CButton5Back.MoveWindow( startx+60, starty+5, r.right, r.bottom, TRUE);

	m_CButtonOneImageBack.GetClientRect(&r);
	m_CButtonOneImageBack.MoveWindow( startx+100, starty+5, r.right, r.bottom, TRUE);

	m_CStaticImageNumber.GetClientRect(&r);
	m_CStaticImageNumber.MoveWindow( startx+160, starty+11, r.right, r.bottom, TRUE);
	
	m_CButtonOneImageForward.GetClientRect(&r);
	m_CButtonOneImageForward.MoveWindow( startx+300, starty+5, r.right, r.bottom, TRUE);

	m_CButton5Forw.GetClientRect(&r);
	m_CButton5Forw.MoveWindow( startx+340, starty+5, r.right, r.bottom, TRUE);

	m_CButtonJumpToEnd.GetClientRect(&r);
	m_CButtonJumpToEnd.MoveWindow( startx+380, starty+5, r.right, r.bottom, TRUE);

    m_CButtonClose.GetClientRect(&r);
	m_CButtonClose.MoveWindow( startx+minw-20-r.right, starty+70-r.bottom, r.right, r.bottom, TRUE);

    m_CCheckDisableDialog.GetClientRect(&r);
	m_CCheckDisableDialog.MoveWindow( startx+minw-20-r.right, starty+105-r.bottom, r.right, r.bottom, TRUE);

/*	m_CStaticPropertiesFrame.GetClientRect(&r);
	m_CStaticPropertiesFrame.MoveWindow( startx+10, starty+35, r.right, r.bottom, TRUE);
	m_CStaticPropertiesFrame.UpdateWindow();
*/
	m_CRadioGreyscale.GetClientRect(&r);
	m_CRadioGreyscale.MoveWindow( startx+15, starty+50, r.right, r.bottom, TRUE);
	//m_CRadioGreyscale.UpdateWindow();
	
	m_CRadioFalseColor.GetClientRect(&r);
	m_CRadioFalseColor.MoveWindow( startx+15, starty+70, r.right, r.bottom, TRUE);
	//m_CRadioFalseColor.UpdateWindow();
		
	m_CRadioJetFalseColor.GetClientRect(&r);
	m_CRadioJetFalseColor.MoveWindow( startx+15, starty+90, r.right, r.bottom, TRUE);
	//m_CRadioJetFalseColor.UpdateWindow();

	m_CStaticScaleString.GetClientRect(&r);
	m_CStaticScaleString.MoveWindow( startx+135, starty+50, r.right, r.bottom, TRUE);
	//m_CStaticScaleString.UpdateWindow();
	
	m_CEditScale.GetClientRect(&r);
	m_CEditScale.MoveWindow( startx+175, starty+45, 80, 20, TRUE);
	//m_CEditScale.InvalidateRect(NULL, TRUE);
	
	m_CStaticWidthHeight.GetClientRect(&r);
	m_CStaticWidthHeight.MoveWindow( startx+135, starty+70, r.right, r.bottom, TRUE);
	//m_CStaticWidthHeight.UpdateWindow();
		
	m_CCheckKeepAspectRatio.GetClientRect(&r);
	m_CCheckKeepAspectRatio.MoveWindow( startx+135, starty+90, r.right, r.bottom, TRUE);
	//m_CCheckKeepAspectRatio.UpdateWindow();
}

void CFilePreview::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	static BOOL first = TRUE;

	// call base class
	CDialog::OnShowWindow(bShow, nStatus);
	
	// very first time ?
	if (first)
	{
		first = FALSE;
	}

	// every time we show the window, redraw the last frame
	if (bShow == TRUE)
	{
        UpdateDialog();
	}

}

void CFilePreview::UpdateDialog()
{
    CPaintDC dcP(this);

	RedrawClientArea(&dcP);

	if (m_bFileSuccessfullyLoaded == TRUE)
	{
		DisplayFunction();
	}
	
	UpdateButtonsAndControls();
	this->InvalidateRect(NULL, TRUE);
	OnPaint();
}

void CFilePreview::DownScaleTo8Bit(unsigned char *src, unsigned char *dst, unsigned int width, unsigned int height, unsigned int bpp)
{

 if (bpp == 8)  // 8 bits per pixel, then just copy the data
 {
  memman.memcpysw( (char *) dst, (char *) src, width*height);
 }

 else if (bpp == 16) // 16 bits per pixel 
 {
  unsigned short maxval=0;
  unsigned short *srci = (unsigned short *) src;

  // look into source for maximum value
  for (unsigned int j=0;j<width*height;j++)
  {
   if (srci[j] > maxval) maxval = srci[j];
  }
  
  // scale into 8 bits accordingly to the maximum value
  unsigned long tmp = 65536L / (((unsigned long)maxval)+1);
  unsigned short tmp1 = (unsigned short) tmp;
  for (j=0;j<width*height;j++)
  {
   dst[j] = (unsigned char) ((srci[j] * tmp1) >> 8);
  }
 }
 else if (bpp == 32) // 32 bits per pixel
 {
  unsigned long *srcl = (unsigned long *) src;
  unsigned long maxval=0;

  // look into source for maximum value
  for (unsigned int j=0;j<width*height;j++)
  {
   if (srcl[j] > maxval) maxval = srcl[j];
  }
  
  // scale into 8 bits accordingly to the maximum value
  unsigned long tmp = 0xFFFFFFFF / (maxval);
  for (j=0;j<width*height;j++)
  {
   dst[j] = (unsigned char) ((srcl[j] * tmp) >> 24);
  }
 
 }

}
