#if !defined(AFX_FILEPREVIEW_H__EBF6B3F2_F07C_4154_825C_EFD5EFC2EEF3__INCLUDED_)
#define AFX_FILEPREVIEW_H__EBF6B3F2_F07C_4154_825C_EFD5EFC2EEF3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FilePreview.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFilePreview dialog

class CFilePreview : public CDialog
{
// Construction
public:
	BOOL ReturnDisableGlobal();
	void DeinitializeDrawing();
	void InitializeDrawing();
	void OnClosePublic();
	BOOL Initialize();
	BOOL WasClosed();
	void UpdateFile( CString newfilename );
	CFilePreview(CString initialFile, CWnd* pParent = NULL);   // standard constructor
	void DownScaleTo8Bit(unsigned char *src, unsigned char *dst, unsigned int width, unsigned int height, unsigned int bpp);

// Dialog Data
	//{{AFX_DATA(CFilePreview)
	enum { IDD = IDD_FILEPREVIEW_DIALOG };
	CButton	m_CButtonClose;
	CStatic	m_CStaticScaleString;
	CStatic	m_CStaticWidthHeight;
	CButton	m_CButton5Forw;
	CButton	m_CButton5Back;
	CButton	m_CCheckDisableDialog;
	CEdit	m_CEditScale;
	CStatic	m_CStaticImageNumber;
	CButton	m_CRadioJetFalseColor;
	CButton	m_CRadioFalseColor;
	CButton	m_CRadioGreyscale;
	CButton	m_CCheckKeepAspectRatio;
	CButton	m_CButtonJumpToStart;
	CButton	m_CButtonJumpToEnd;
	CButton	m_CButtonOneImageForward;
	CButton	m_CButtonOneImageBack;
	CStatic	m_CMyVideoFrame;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFilePreview)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CFilePreview)
	afx_msg void OnButton4Imgstart();
	afx_msg void OnButton3Jumptoend();
	afx_msg void OnButton2Oneimgforw();
	afx_msg void OnButton1Oneimgback();
	virtual void OnOK();
	afx_msg void OnCheck1Disdlg();
	afx_msg void OnCheck2Keepaspectratio();
	afx_msg void OnRadio1Grey();
	afx_msg void OnRadio2False();
	afx_msg void OnRadio3Jet();
	virtual BOOL OnInitDialog();
	afx_msg void OnClose();
	afx_msg void OnCancelMode();
	afx_msg void OnPaint();
	afx_msg void OnButton5forw();
	afx_msg void OnButton5back();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSizing(UINT fwSide, LPRECT pRect);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void UpdateDialog();
	void RedrawClientArea( CPaintDC *dcP );
	BOOL m_bDisableGlobal;
    void flipframemmx(char *dest, char *src, int width, int height);

	BOOL m_bFileSuccessfullyLoaded;
	void UpdateBitmapInfo();
	BITMAPINFO * m_pBitmapInfo;
	void UpdatePalette();
	BOOL m_bPaletteChangeInProgress;
	void DisplayFunction();
	BOOL m_bDrawingInitialized;
	void UpdateButtonsAndControls();
	int  m_iCurrentImage;
	BOOL m_bInitialized;
	BOOL m_bKeepAspectRatio;
	int  m_iFalseColor;
	CImageSequence *m_pImageSequence;
	BOOL UpdateWithNewFile( CString newfn );
	CString m_sFileName;
	BOOL m_bWasClosed;
	CClientDC *m_dcRW;
	CDC *m_destDC;
	CBitmap *m_bmp;
    RGBQUAD m_ColorTable[256]; 
	HPALETTE m_hPalette;
	char *m_pLastFrame;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FILEPREVIEW_H__EBF6B3F2_F07C_4154_825C_EFD5EFC2EEF3__INCLUDED_)
