// Fit.h: interface for the CFit class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FIT_H__E2F499D2_6780_11D7_92C9_000102FA37F9__INCLUDED_)
#define AFX_FIT_H__E2F499D2_6780_11D7_92C9_000102FA37F9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FourierStat.h"
#include "FitParam.h"	// Added by ClassView

class CFit : public CFourierStat  
{


public:
	//CFit();
	CFit(unsigned char* data,unsigned char* Back, unsigned char *out, CRect AOI,BOOL XFilt, BOOL circular, BOOL normalize, 
		 unsigned short deg,unsigned short recdep,unsigned int ImWi,unsigned int ImHi, unsigned int rep_rate, unsigned int bpp, unsigned int bpp_eff);
	virtual ~CFit();

    double*  CFit::X_DIST_FIT();
    double*  CFit::Y_DIST_FIT();
    double  CFit::X_RMS();
    double  CFit::Y_RMS();
    double  CFit::XM();
    double  CFit::YM();

private:
	unsigned int m_iRepRate;
	double* tolerances;
	void FillFitDist(double* ziel, FitParam *FP,int l,int r);
	double Derivative(FitParam* inParam,double* Source,int length,int currnum,BOOL XY);
	double PreFit(double* Source, int leftborder,int rightborder,double xmean,double sigmamin,double sigmamax, BOOL XY);
	double CalcGauss(double sigma, double x, double xmean);
	double Residual(double sigma, double xmean, double* Source, int leftborder, int rightborder, BOOL XY, double maxval);
	double MutipleRes(FitParam* inParam,double* Source,int length,BOOL XY, int rep_rate);
	FitParam* FitMultiGauss(FitParam* inParam,FitParam* OutVal,int currnum,double* Source, int len,BOOL XY);
	int len_Y;
	int len_X;
	double* TEMP_YDIST;
	double* TEMP_XDIST;
	FitParam *FitPar_Y;
	FitParam *FitPar_X;
	double sigma_Y;
	double sigma_X;
	double offset_X,offset_Y;
	double pos_X,pos_Y;
	double* FitDist_Y;
	double* FitDist_X;

	double MinXDIST;
	double MaxXDIST;
	double MinYDIST;
	double MaxYDIST;

};

#endif // !defined(AFX_FIT_H__E2F499D2_6780_11D7_92C9_000102FA37F9__INCLUDED_)
