// InformationDialog.cpp : implementation file
//
//
///////////////////////////////////////////////////////////////////////////////
//
// This class can be used to show a small information dialog on the screen for 
// example if the program does some heavy calculations.
//
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "videoclnt.h"
#include "InformationDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInformationDialog dialog


CInformationDialog::CInformationDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CInformationDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInformationDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_bSuccessfullyCreated = FALSE;
}


void CInformationDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInformationDialog)
	DDX_Control(pDX, IDC_EDIT1, m_CEditInformation);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInformationDialog, CDialog)
	//{{AFX_MSG_MAP(CInformationDialog)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInformationDialog message handlers

/////////////////////////////////////////////////
// Show( CString message)
//
// Using this function the message 'message' is
// displayed on screen.
//
void CInformationDialog::Show(CString message)
{
 if (m_bSuccessfullyCreated == TRUE) return;

 BOOL ret = CDialog::Create(IDD_DIALOG_MSGBOX, AfxGetMainWnd()->GetDesktopWindow() );
 if (ret == TRUE)
 {
   CDialog::ShowWindow( SW_SHOW );
   m_CEditInformation.SetWindowText( (LPCTSTR) message );
   m_CEditInformation.UpdateWindow();
   m_bSuccessfullyCreated = TRUE;
 }
 
}

/////////////////////////////////////////////////
// Hide()
//
// Using this function one can hide the message that was
// shown using the show method. 
//
void CInformationDialog::Hide()
{
  if (m_bSuccessfullyCreated == TRUE)
  {
   CDialog::ShowWindow(SW_HIDE);
   CDialog::DestroyWindow();
   m_bSuccessfullyCreated = FALSE;
  }
}

/////////////////////////////////////////////////
// UpdateText()
//
// Once a message box is shown, one can update the 
// test that is written there using this function.
//
void CInformationDialog::UpdateText(CString newmessage)
{
 if (m_bSuccessfullyCreated == TRUE)
 {
   m_CEditInformation.SetWindowText( (LPCTSTR) newmessage );
   m_CEditInformation.UpdateWindow();
 }
}
