// LaserPowerCalc.h: interface for the CLaserPowerCalc class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LASERPOWERCALC_H__D1CB2793_3444_11D7_AFE6_0002B34B0F4F__INCLUDED_)
#define AFX_LASERPOWERCALC_H__D1CB2793_3444_11D7_AFE6_0002B34B0F4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////
// CLaserPowerCalc - calculates the laser power according to a lookup-table
//                   with envelope-points kind of style

class CLaserPowerCalc  
{
public:
	// construction/destruction
	CLaserPowerCalc();
	virtual ~CLaserPowerCalc();

    // initializes the laser power table with hardwired values
    BOOL Init();

	// initializes the laser power table with data obtained from file 'filename'
    BOOL Init( CString filename );

    // load a laser power table from file 'filename'
    BOOL LoadProfile( CString filename );

    // calculate laser power out of the parameter sum_pixels
    double CalcLaserPower( unsigned int sum_pixels );

private:
	BOOL m_bInitialized;   // successfully initialized ? 
	int m_iEntries;        // entries in the lookup tables
	double *m_pLaserPower; // laser power lookup table
	unsigned int *m_pSumPixels; // sum pixels lookup table
};

#endif // !defined(AFX_LASERPOWERCALC_H__D1CB2793_3444_11D7_AFE6_0002B34B0F4F__INCLUDED_)
