// MarkedComboBox.cpp : implementation file
//

#include "stdafx.h"
#include "headers.h"
#include "videoclnt.h"
#include <math.h>
#include <vfw.h>
#include "Queue.h"
#include "BMPFileHelper.h"
#include "compression.h"
#include "rpcdefs.h"
#include "EnvelopeAverage.h"
class CVideoclntDlg;
#include <windows.h>
#include <winsock.h>
#undef fd_set
#include "IniEx.h"
#include "Server.h"
#include "ServerList.h"
#include "SSyncSocket.h"
#include "configdlg.h"
#include "CATineDlg.h"
#include "TineALDlg.h"
#include "ImageSequence.h"
#include "Stat.h"
#include "BogusTineDlg.h"
#include "ImageAcquire.h"
#include "FourierStat.h"
#include "StatFile.h"
#include "StatEmpty.h"
#include "MessagesDlg.h"
#include "MyVideoFrame.h"
#include "acop.h"
#include "oleauto.h"
#include "AdditionalInformation.h"
#include "PrinterSettings.h"
#include "AboutDialog.h"
#include "CATineDlg.h"
#include "InformationDialog.h"
#include "ShutterControl.h"
#include "Shlwapi.h"
#include "TineALDlg.h"
#include "MarkedComboBox.h"
#include "videoclntDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define RED RGB(255,0,0)

/////////////////////////////////////////////////////////////////////////////
// CMarkedComboBox

CMarkedComboBox::CMarkedComboBox()
//
// Return Value:	None.
//
// Parameters	:	None.
//
// Remarks		:	Standard constructor.
//
{
	m_iFlash = 0;
	m_iFlashFlag = 0;
}

CMarkedComboBox::~CMarkedComboBox()
//
// Return Value:	None.
//
// Parameters	:	None.
//
// Remarks		:	Destructor.
//
{
}


BEGIN_MESSAGE_MAP(CMarkedComboBox, CComboBox)
	//{{AFX_MSG_MAP(CMarkedComboBox)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMarkedComboBox message handlers


// ColorListBox.cpp : implementation file

//-------------------------------------------------------------------
//
//	CColorListBox class - 
//		A CListBox-derived class with optional colored items.
//
//		Version: 1.0	01/10/1998 Copyright  Patrice Godard
//
//		Version: 2.0	09/17/1999 Copyright  Paul M. Meidinger
//
//-------------------------------------------------------------------

/////////////////////////////////////////////////////////////////////////////
// CColorListBox

/////////////////////////////////////////////////////////////////////////////
// CColorListBox message handlers

//-------------------------------------------------------------------
//
void CMarkedComboBox::DrawItem(LPDRAWITEMSTRUCT lpDIS) 
//
// Return Value:	None.
//
// Parameters	:	lpDIS - A long pointer to a DRAWITEMSTRUCT structure 
//							that contains information about the type of drawing required.
//
// Remarks		:	Called by the framework when a visual aspect of 
//						an owner-draw list box changes. 
//
{
	if ((int)lpDIS->itemID < 0)
		return; 

	CDC* pDC = CDC::FromHandle(lpDIS->hDC);

    COLORREF crText;
	CString sText;

	// If item has been selected, draw the highlight rectangle using the item's color.

	if (lpDIS->itemState & ODS_COMBOBOXEDIT)
	{
		CBrush brush(::GetSysColor(COLOR_WINDOW));
		pDC->FillRect(&lpDIS->rcItem, &brush);
	}
	else
	{

	 if ((lpDIS->itemState & ODS_SELECTED) &&
 		 (lpDIS->itemAction & (ODA_SELECT | ODA_DRAWENTIRE)))
	 {
		 CBrush brush(::GetSysColor(COLOR_HIGHLIGHT) );
		pDC->FillRect(&lpDIS->rcItem, &brush);
	 }
	}

	// If item has been deselected, draw the rectangle using the window color.
	if (!(lpDIS->itemState & ODS_SELECTED) && (lpDIS->itemAction & ODA_SELECT))
	{
		CBrush brush(::GetSysColor(COLOR_WINDOW));
		pDC->FillRect(&lpDIS->rcItem, &brush);
	}	 	

	// If item has focus, draw the focus rect.
	if ((lpDIS->itemAction & ODA_FOCUS) && (lpDIS->itemState & ODS_FOCUS))
	{
		pDC->DrawFocusRect(&lpDIS->rcItem); 
	}


	// If item does not have focus, redraw (erase) the focus rect.
	if ((lpDIS->itemAction & ODA_FOCUS) &&	!(lpDIS->itemState & ODS_FOCUS))
	{
		pDC->DrawFocusRect(&lpDIS->rcItem); 
	}

	// Set the background mode to TRANSPARENT to draw the text.
	int nBkMode = pDC->SetBkMode(TRANSPARENT);

	if (m_iFlash == 1) 
	{
		pDC->SetBkMode( OPAQUE );
		CBrush brushwnd(::GetSysColor(COLOR_WINDOW));
		CBrush brushflash( m_flashcolor );
		CBrush brushbcksel(::GetSysColor(COLOR_HIGHLIGHT) );
			
		CBrush *tmp;

		tmp = &brushwnd;

		if (lpDIS->itemState & ODS_COMBOBOXEDIT)
		{
			tmp = &brushwnd; 
		}
		else if (lpDIS->itemState & ODS_SELECTED)
		{
			tmp = &brushbcksel;
		}
				
		if ((m_iFlashFlag == 1) && (CComboBox::GetDroppedState() == FALSE)) tmp = &brushflash;
		
		pDC->FillRect(&lpDIS->rcItem, tmp);
			
		m_iFlashFlag = 1-m_iFlashFlag;
		
		pDC->SetBkMode(TRANSPARENT);
	
		if (lpDIS->itemState & ODS_COMBOBOXEDIT)
		{
			crText = pDC->SetTextColor(::GetSysColor(COLOR_WINDOWTEXT)); 
		}
		else if (lpDIS->itemState & ODS_SELECTED)
			crText = pDC->SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
		else if (lpDIS->itemState & ODS_DISABLED)
			crText = pDC->SetTextColor(::GetSysColor(COLOR_GRAYTEXT));
		else
			crText = pDC->SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));


	}
	// Else the item's color information is not set, so use the
	// system colors for the text.
	else
	{
		if (lpDIS->itemState & ODS_COMBOBOXEDIT)
		{
			crText = pDC->SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));
		}
		else if (lpDIS->itemState & ODS_SELECTED)
			crText = pDC->SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
		else if (lpDIS->itemState & ODS_DISABLED)
			crText = pDC->SetTextColor(::GetSysColor(COLOR_GRAYTEXT));
		else
		{
			crText = pDC->SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));
		}
	}

	// Get and display item text.
	GetLBText(lpDIS->itemID, sText);
	CRect rect = lpDIS->rcItem;

	// Setup the text format.
	UINT nFormat = DT_LEFT | DT_SINGLELINE | DT_VCENTER;
	if (GetStyle() & LBS_USETABSTOPS)
		nFormat |= DT_EXPANDTABS;
	
	// Calculate the rectangle size before drawing the text.
	pDC->DrawText(sText, -1, &rect, nFormat | DT_CALCRECT);
	pDC->DrawText(sText, -1, &rect, nFormat);

	pDC->SetTextColor(crText); 
	pDC->SetBkMode(nBkMode);
	
}	// DrawItem

//-------------------------------------------------------------------
//
void CMarkedComboBox::MeasureItem(LPMEASUREITEMSTRUCT lpMIS)
//
// Return Value:	None.
//
// Parameters	:	lpMIS - A long pointer to a 
//							MEASUREITEMSTRUCT structure.
//
// Remarks		:	Called by the framework when a list box with 
//						an owner-draw style is created. 
//
{
	// ### Is the default list box item height the same as
	// the menu check height???
	lpMIS->itemHeight = ::GetSystemMetrics(SM_CYMENUCHECK);
}	// MeasureItem



// change = TRUE:  flash
//          FALSE: restore
void CMarkedComboBox::Flash( BOOL change, COLORREF col )
{
	if (change == FALSE) 
	{
		m_iFlash = 0;
	}		
	else
	{
		m_iFlash = 1;
		m_flashcolor = col;
	}

	RedrawWindow();
}
