// MyVideoFrame.cpp : implementation file
//

#include "stdafx.h"
#include "videoclnt.h"
#include "headers.h"
#include <math.h>
#include <vfw.h>
#include "Queue.h"
#include "compression.h"
class CVideoclntDlg;
#include <windows.h>
#include <winsock.h>
#undef fd_set
#include "IniEx.h"
#include "Server.h"
#include "ServerList.h"
#include "SSyncSocket.h"
#include "configdlg.h"
#include "acop.h"
#include "CATineDlg.h"
#include "TineALDlg.h"
#include "BogusTineDlg.h"
#include "ImageAcquire.h"
#include "Stat.h"
#include "FourierStat.h"
#include "ImageSequence.h"
#include "StatFile.h"
#include "MessagesDlg.h"
#include "MyVideoFrame.h"
#include "PrinterSettings.h"
#include "MarkedComboBox.h"
#include "InformationDialog.h"
#include "videoclntDlg.h"
#include "acop.h"
#include "oleauto.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyVideoFrame CStatic child
//
// This is just a child class of CStatic, so that we are able to catch some 
// window messages. The class is bound to the region of the main window where 
// the video frames are shown. Using this class we are able to catch important
// mouse messages like LeftButtonUp, LeftButtonDown and MouseMove. These 
// messages are catched and then delivered to the main application class.
//
// The class is needed for the drawing of the cross (mouse cross) and the 
// selection of the area of interest.

/////////////////////////////////////////////////////////////////////////////
// Construction/Deconstruction

CMyVideoFrame::CMyVideoFrame()
{
    // initialize the main dlg 
	m_pMainDlg = NULL;
}

CMyVideoFrame::~CMyVideoFrame()
{
}


BEGIN_MESSAGE_MAP(CMyVideoFrame, CStatic)
	//{{AFX_MSG_MAP(CMyVideoFrame)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyVideoFrame message handlers

/////////////////////////////////////////////////////////////////////////////
// This function is called if the left button is pressed while the mouse is over the 
// CStatic frame this class is attached to. It just passes the proper data to the 
// main application class.
//
void CMyVideoFrame::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (m_pMainDlg != NULL) m_pMainDlg->OnVideoLeftButtonDown(nFlags, point);

	CStatic::OnLButtonDown(nFlags, point);
}

/////////////////////////////////////////////////////////////////////////////
// This function is called if the left button is released while the mouse is over the 
// CStatic frame this class is attached to. It just passes the proper data to the 
// main application class.
//
void CMyVideoFrame::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if (m_pMainDlg != NULL) m_pMainDlg->OnVideoLeftButtonUp(nFlags, point);
	
	CStatic::OnLButtonUp(nFlags, point);
}

/////////////////////////////////////////////////////////////////////////////
// This function is called when the user moves the mouse and the mouse pointer 
// is over the CStatic frame this class is attached to. It just passes the 
// proper data to the main application class.
//
void CMyVideoFrame::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (m_pMainDlg != NULL) m_pMainDlg->OnVideoMouseMove(nFlags, point);
	
	CStatic::OnMouseMove(nFlags, point);
}

/////////////////////////////////////////////////////////////////////////////
// This function is needed to set the proper pointer to the main application
// class. You have to call this function before the frame is shown 
// (e.g. in OnInitDialog).
//
void CMyVideoFrame::SetMainDlg(CVideoclntDlg *main_dlg)
{
 m_pMainDlg = main_dlg;
}

void CMyVideoFrame::OnRButtonDown(UINT nFlags, CPoint point) 
{
	if (m_pMainDlg != NULL) m_pMainDlg->OnVideoRightButtonDown(nFlags, point);
	
	CStatic::OnRButtonDown(nFlags, point);
}

void CMyVideoFrame::OnRButtonUp(UINT nFlags, CPoint point) 
{
	if (m_pMainDlg != NULL) m_pMainDlg->OnVideoRightButtonUp(nFlags, point);
	
	CStatic::OnRButtonUp(nFlags, point);
}
