#ifndef _CQUEUE_H_INCL_
#define _CQUEUE_H_INCL_

// thread safe at object level wrapper around CList

class CQueue
{
 public:
   //construction/destruction
   CQueue();
   ~CQueue();

   // is the queue empty ? 
   BOOL IsEmpty();

   // add a pointer to the tail of the list
   BOOL AddTail(LPVOID p);
   
   // remove the first element and return it
   LPVOID RemoveHead();
   
   // remove element at specified index
   void RemoveElem( int index );
   
   // remove element 'ptr' from list and return it
   LPVOID RemoveElem( void *ptr );
   
   // get number of elements inside the queue
   int    GetSize();

   // get a single element somewhere (index) out of the queue
   // index=0..GetSize()-1
   LPVOID GetElem( int index );
   
   // get head element from list without removing it
   LPVOID GetHead();

   // removes all elements inside and frees them via memman.sw_free()  (!)
   void	  EmptyQueue();

  protected:

   // critical section for thread safe access
   CRITICAL_SECTION lock;
   
   // base class list 
   CList<LPVOID, LPVOID> queue;

  private:

};

#endif