// Server.cpp: implementation of the CServer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "videoclnt.h"
#include "Server.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// CServer 
//
// This class is needed to store all properties of a server into a 
// unique data structure
//

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// plain construction
CServer::CServer()
{
 // initialize default values

 m_iPosition=-1;
 m_iListenport = 0;
 m_sNickname = "";
 m_sServername = "";
 m_sTineFrameEqpName = "";

 m_sCamString = "";
}

// initialize server with the values passed as parameters
CServer::CServer(int pos, CString nickname, CString servername, int listenport, CString TineFrameEqpName,
				 CString CamString, CString CamID, CString TineControlName, CString TineContext )

{
 m_iPosition = pos;

 m_iListenport = listenport;
 m_sNickname = nickname;
 m_sServername = servername;
 m_sTineFrameEqpName = TineFrameEqpName;
 m_sTineControlName = TineControlName;
 m_sTineContext = TineContext;

 m_sCamString = CamString;
 m_sCamID = CamID;
}

// plain destruction
CServer::~CServer()
{

}

// reinitialize the server settings using passed parameters
void CServer::Reintialialize( int pos, CString nickname, CString servername, int listenport, 
							  CString TineFrameEqpName, CString CamString, CString CamID, 
							  CString TineControlName, CString TineContext)
{
 m_iPosition = pos;
 m_iListenport = listenport;
 m_sNickname = nickname;
 m_sServername = servername;
 m_sTineFrameEqpName = TineFrameEqpName;
 m_sTineControlName = TineControlName;
 m_sTineContext = TineContext;

 m_sCamString = CamString;
 m_sCamID = CamID;

}

////////////////////////////////////////////////////////////////////////////////
// returns the position
//
int     CServer::getPosition()
{
 return( m_iPosition ); 
}

////////////////////////////////////////////////////////////////////////////////
// returns the nickname
//
CString CServer::getNickname()
{
 return( m_sNickname );
}

////////////////////////////////////////////////////////////////////////////////
// returns the server name
//
CString CServer::getServername()
{
 return( m_sServername );
}

////////////////////////////////////////////////////////////////////////////////
// returns the tine control name (for control connections)
CString CServer::getTineControlName()
{
 return( m_sTineControlName );
}

CString CServer::getTineContext()
{
 return( m_sTineContext );
}


////////////////////////////////////////////////////////////////////////////////
// returns the TINE eqp name (for frame transfer)
//
CString CServer::getTineFrameEqpName()
{
 return( m_sTineFrameEqpName );
}

////////////////////////////////////////////////////////////////////////////////
// returns the listen port
//
int CServer::getListenport()
{
 return( m_iListenport );
}

////////////////////////////////////////////////////////////////////////////////
// returns the port description string of the passed server port (0..3)
//
CString CServer::getCamString()
{
 return( m_sCamString );
}

CString CServer::getCamID()
{
	return( m_sCamID );
}

