// Server.h: interface for the CServer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERVER_H__C1DD4A53_2949_11D7_AFE0_0002B34B0F4F__INCLUDED_)
#define AFX_SERVER_H__C1DD4A53_2949_11D7_AFE0_0002B34B0F4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CServer  
{
public:
	// plain construction/destruction
	CServer();
	virtual ~CServer();

	// construction using parameters of server
	CServer( int pos, CString nickname, CString servername, int listenport, CString TineFrameEqpName,
				 CString CamString, CString CamID,  
				 CString TineControlName, CString TineContext );

	
    // reinitialize the server
    void    Reintialialize( int pos, CString nickname, CString servername, int listenport, CString TineFrameEqpName,
				 CString CamString, CString CamID, 
				 CString TineControlName, CString TineContext );
							
    // returns nickname of server
    CString getNickname();
	// returns server name (hostname for sockets)
	CString getServername();
	// returns tine frame transfer eqp name
	CString getTineFrameEqpName();
    // returns tine control connection eqp name
	CString getTineControlName();

	CString getTineContext();

	// returns listen port
	int     getListenport();
    // get port description string of desired port
	CString getCamString();
	CString getCamID();
    // get port scale value of desired port
	
	// get position number of server
	int     getPosition();

    // returns whether port is enabled or not (visible inside the camera selectbox)

private:
	CString m_sTineControlName;
    // nickname of server
	CString m_sNickname;
	// server hostname (for sockets)
	CString m_sServername;
	// tine eqp name (for frame transfer)
	CString m_sTineFrameEqpName;
	
	// listen port
	int m_iListenport;

    // port 0 description string, scale value and enable boolean
	CString m_sCamString;
	CString m_sCamID;

	CString m_sTineContext;

    // position of the server
	int m_iPosition;

};

#endif // !defined(AFX_SERVER_H__C1DD4A53_2949_11D7_AFE0_0002B34B0F4F__INCLUDED_)
