// ServerList.h: interface for the CServerList class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERVERLIST_H__C1DD4A56_2949_11D7_AFE0_0002B34B0F4F__INCLUDED_)
#define AFX_SERVERLIST_H__C1DD4A56_2949_11D7_AFE0_0002B34B0F4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CServerList  
{
public:
	BOOL modifyServer( int serverpos, CServer srv);
	// construction/destruction
	CServerList();
	virtual ~CServerList();

    // add a single server to the list
    BOOL addServer( CServer srv );
	// remove all servers from list
	BOOL deleteAllServers();

	// (finds and) gets a single server based on the nickname
	BOOL getServer( CString nickname, CServer& server);
	// (finds and) gets a single server based on the position value
	BOOL getServer( int position, CServer& server);

    // deletes a single server based on the position value
	BOOL deleteServer( int serverpos );
	BOOL Reorganize(); // needs to be called after deleteServer()

    // returns how many servers (position = 1..Count()) are installed
    int Count(); 

private:
    // server list 
	CPtrList m_ServerList; 

    // synchronization stuff
    // critical section for thread safe access
    CRITICAL_SECTION lock;

};

#endif // !defined(AFX_SERVERLIST_H__C1DD4A56_2949_11D7_AFE0_0002B34B0F4F__INCLUDED_)
