// TineALDlg.cpp : implementation file
//

#include "stdafx.h"
#include "headers.h"
#include "videoclnt.h"
#include <math.h>
#include <vfw.h>
#include "Queue.h"
#include "BMPFileHelper.h"
#include "compression.h"
#include "rpcdefs.h"
#include "EnvelopeAverage.h"
class CVideoclntDlg;
#include <windows.h>
#include <winsock.h>
#undef fd_set
#include "IniEx.h"
#include "Server.h"
#include "ServerList.h"
#include "SSyncSocket.h"
#include "configdlg.h"
#include "CATineDlg.h"
#include "TineALDlg.h"
#include "ImageSequence.h"
#include "Stat.h"
#include "BogusTineDlg.h"
#include "ImageAcquire.h"
#include "FourierStat.h"
#include "StatFile.h"
#include "StatEmpty.h"
#include "MessagesDlg.h"
#include "MyVideoFrame.h"
#include "acop.h"
#include "oleauto.h"
#include "AdditionalInformation.h"
#include "PrinterSettings.h"
#include "MarkedComboBox.h"
#include "AboutDialog.h"
#include "CATineDlg.h"
#include "InformationDialog.h"
#include "videoclntDlg.h"
#include "ShutterControl.h"
#include "Shlwapi.h"
#include "TineALDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CTineALDlg dialog


CTineALDlg::CTineALDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTineALDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTineALDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_iLoadedDAQProperties	= 0;
	m_iLoadedAdditionalProperties	= 0;
	m_pAdditionalProperties = NULL;

	m_bSuccessfulInitialized = FALSE;

    m_pMainDlg = NULL;
}


void CTineALDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTineALDlg)
	DDX_Control(pDX, IDC_ACOPCTRL_145676, m_CACOPAL);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTineALDlg, CDialog)
	//{{AFX_MSG_MAP(CTineALDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTineALDlg message handlers

BEGIN_EVENTSINK_MAP(CTineALDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CTineALDlg)
	ON_EVENT(CTineALDlg, IDC_ACOPCTRL_145676, 1 /* Receive */, OnReceiveAcopctrlAL, VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CTineALDlg::OnReceiveAcopctrlAL(long LinkIndex, long StatusCode) 
{
	CString msg;

	// look for property link...
	int prop = 0;
	BOOL found = FALSE;
	while( prop < m_iLoadedDAQProperties )
	{
	 if (m_daqprop_linkid[prop] == LinkIndex) 
	 {
		 found = TRUE;
		 break;
	 }
      
     prop++;
	}

	if (found == TRUE)
	{
		if (StatusCode == 0)
		{
			m_daqprop_read[prop] = TRUE;
			m_daqprop_var_ro[prop] = m_daqprop_var[prop];
		}
		else
		{
		   m_daqprop_read[prop] = FALSE;
		   
		   // DEBUG !!! SW !!! SW!!! !!!!
		   msg.Format("DAQ Prop #%d (%s): read error: code=%d", prop, m_daqprop_name_str[prop], StatusCode);
		   m_pMainDlg->PrintServerMessage(msg);
		}

	}

	// look through additional properties

	found = FALSE;
	prop = 0;
	while( prop < m_iLoadedAdditionalProperties )
	{
			if( m_addprop_linkid[prop] == LinkIndex)
			{
				found = TRUE;
				break;
			}
			prop++;
	}

	if (found == TRUE)
	{
		if (StatusCode == 0)
		{
			m_addprop_read[prop] = TRUE;
			m_addprop_var_ro[prop] = m_addprop_var[prop];
		}
		else
		{
		   m_addprop_read[prop] = FALSE;
		   
		   // DEBUG !!! SW !!! SW!!! !!!!
		   msg.Format("Additional Prop #%d (%s): read error: code=%d", prop, m_daqprop_name_str[prop], StatusCode);
		   m_pMainDlg->PrintServerMessage(msg);
		}

	}


}

//extern "C" {
//__declspec(dllimport) short PASCAL RPCDBG(short level);
//}

// maindlg: only used temporary for printing a message to the status bar
// addprops // from main dialog the initialized additional properties
BOOL CTineALDlg::InitializeTine( CVideoclntDlg *maindlg, AdditionalProperty *addprops)
{
 int errorcode;
 CString errormessage;

 CString msg1;
 CString finalmsg("This means that online DAQ could not be set up properly. DAQ function will not be available !");

 BOOL retval = TRUE;
 CIniEx daqIniFile;
 int i,j, numprop;

 int daqcheck = 0;
 int addcheck = 0;
 CString msg11, msg12;
 CString msg;

 m_pMainDlg = maindlg;
 m_pAdditionalProperties = addprops;
 //RPCDBG(3);

 if (m_bSuccessfulInitialized == TRUE) return TRUE;

 BOOL ret = FALSE;

 m_bSuccessfulInitialized = FALSE;

 char curDir[MAX_PATH];
 ::GetCurrentDirectory(MAX_PATH,curDir);

 ::SetCurrentDirectory( (LPCTSTR) maindlg->GetExecutableDirectory() );

 ret = daqIniFile.Open( maindlg->ReturnLoadedDaqFileName(), FALSE, FALSE, TRUE, FALSE );
 if (ret == FALSE)
 {
	 /*if (maindlg->ReturnDefaultDaqFileName() == maindlg->ReturnLoadedDaqFileName() )
	 {
		 CString msg;
		 msg.Format("Could not load in DAQ config file \"%s\" !", maindlg->ReturnDefaultDaqFileName());
		 CCERRC(-2, msg);
	 }*/

	 ((CVideoclntDlg *)AfxGetMainWnd())->OwnMessageBox( MB_ICONINFORMATION, "Could not load in DAQ config file \"%s\". I will try default daq config file now.", maindlg->ReturnLoadedDaqFileName());

	 ret = daqIniFile.OpenAtExeDirectory( maindlg->ReturnDefaultDaqFileName(), FALSE, FALSE, TRUE, FALSE );

 	 if (ret == FALSE) 
	 {
		::SetCurrentDirectory( (LPCTSTR) curDir );
		msg.Format("Could not load in default DAQ config file \"%s\" !", maindlg->ReturnDefaultDaqFileName());
		CCERRC(-3, msg);
	 }
 }

 ::SetCurrentDirectory( (LPCTSTR) curDir );

 // directory is set back to current

 numprop = daqIniFile.GetValueInt("MAIN", "NumProperties", -1);
 if (numprop == -1) CCERRC(-1, "Could not read out number of properties from DAQ config file!");
 if (numprop > NUM_MAX_DAQ_PROPERTIES) CCERRC(-1*numprop, "The amount of DAQ properties is too high and thus, not supported !");

 m_iLoadedDAQProperties = numprop;

 for (i=0;i<numprop;i++)
 {
	 CString sect;

	 if (i < 9) sect.Format("Prop0%d", i+1); else sect.Format("Prop%d", i+1);

     m_daqprop_context[i] = daqIniFile.GetValue(sect, "Context", "");
	 if (m_daqprop_context[i] == "") CCERRC(i+1, "Property has no context specified !");
	 m_daqprop_server[i] = daqIniFile.GetValue(sect, "Server", "");
	 if (m_daqprop_server[i] == "") CCERRC(i+1, "Property has no server specified !");
	 m_daqprop_device[i] = daqIniFile.GetValue(sect, "Device", "");
	 if (m_daqprop_device[i] == "") CCERRC(i+1, "Property has no device specified !");
	 m_daqprop_property[i] = daqIniFile.GetValue(sect, "Property", "");
	 if (m_daqprop_property[i] == "") CCERRC(i+1, "Property is not specified !");

	 m_daqprop_unit_str[i] = daqIniFile.GetValue(sect, "FriendlyUnit", "none");
	 if (m_daqprop_unit_str[i] == "none") m_daqprop_unit_str[i] = "";

	 m_daqprop_name_str[i] = daqIniFile.GetValue(sect, "FriendlyName", "<NameNotSpecified>");
	 m_daqprop_name_str[i].Replace(" ", "_");

     CString datatype = daqIniFile.GetValue(sect, "Datatype", "Float");

	 datatype.MakeUpper();

	 if (datatype == "FLOAT")
	 {
		 m_daqprop_datatype[i] = VT_R4;
	 }
	 else if (datatype == "DOUBLE")
	 {
		 m_daqprop_datatype[i] = VT_R8;
	 }
	 else if (datatype == "BYTE")
	 {
		 m_daqprop_datatype[i] = VT_UI1;
	 }
	 else if (datatype == "INT")
	 {
		 m_daqprop_datatype[i] = VT_I2;
	 }
	 else if (datatype == "LONG")
	 {
		 m_daqprop_datatype[i] = VT_I4;
	 }
	 else if (datatype == "DOUBLE")
	 {
		 m_daqprop_datatype[i] = VT_R8;
	 }
	 else CCERRC(i+1, "Property has no valid datatype assigned !");

	 VariantInit( &(m_daqprop_var[i]) );
	 V_VT( &(m_daqprop_var[i]) ) = (unsigned short) m_daqprop_datatype[i];
	 m_daqprop_read[i] = FALSE;
     //// m_mainsolenoid_var.fltVal = 0.0; default initialization took place in old version here
 }

 // add additional properties 

 m_iLoadedAdditionalProperties = 0;

 for (i=0;i<NUM_MAX_ADDITIONAL_PROPERTIES;i++)
 {
	 AdditionalProperty *p = &(m_pAdditionalProperties[i]);
	 m_addprop_enabled[i] = FALSE;

	 int pos = m_iLoadedAdditionalProperties;

	 if (p->enabled == TRUE)
	 {
		 m_addprop_enabled[pos] = TRUE;

		 m_addprop_context[pos] = p->Context; 
		 if (m_addprop_context[pos] == "") CCERRC(pos+1, "Additional Property has no context specified !");

		 m_addprop_server[pos] = p->Server;
		 if (m_addprop_server[pos] == "") CCERRC(pos+1, "Additional Property has no server specified !");
	 
		 m_addprop_device[pos] = p->Device;
		 if (m_addprop_device[pos] == "") CCERRC(pos+1, "Additional Property has no device specified !");
	 
		 m_addprop_property[pos] = p->Property;
		 if (m_addprop_property[pos] == "") CCERRC(pos+1, "Additional Property is not specified !");

		 m_addprop_unit_str[pos] = p->FriendlyUnit;
		 if (m_addprop_unit_str[pos] == "none") m_addprop_unit_str[pos] = "";

		 m_addprop_name_str[pos] = p->FriendlyName;
	 
		 if (p->type == 1) // int
		 {
			 m_addprop_datatype[pos] = VT_I4;
		 }
		 else if (p->type == 2) // float
		 {
			 m_addprop_datatype[pos] = VT_R4;
		 }
		 else
		 {
			 CCERRC(pos+1, "Additional Property has no valid datatype assigned !");
		 }

		 VariantInit( &(m_addprop_var[pos]) );
		 V_VT( &(m_addprop_var[pos]) ) = (unsigned short) m_addprop_datatype[pos];

		 p->pos_for_ALDlg = pos;
         m_addprop_read[pos] = FALSE;

		 m_iLoadedAdditionalProperties++;
	 }
 }


 // check DAQ TINE properties ExecLink
 for (j=0; j<m_iLoadedDAQProperties; j++)
 {
	m_CACOPAL.SetDeviceContext((LPCTSTR) m_daqprop_context[j]);
	m_CACOPAL.SetDeviceGroup((LPCTSTR) m_daqprop_server[j]);
	m_CACOPAL.SetDeviceName((LPCTSTR) m_daqprop_device[j]);
	m_CACOPAL.SetDeviceProperty((LPCTSTR) m_daqprop_property[j]); 

	VARIANT olvdx, m_datax_var;
	VariantInit( &olvdx );
		
	VariantInit( &m_datax_var );
    V_VT( &m_datax_var ) = VT_R4;
    m_datax_var.fltVal = 0.0;
 
	// call the server
	m_CACOPAL.SetAccessRate("1000");
	m_CACOPAL.SetAccessMode("READ");
	long ret = m_CACOPAL.Execute(&m_daqprop_var[j], olvdx, olvdx, &m_datax_var, olvdx, olvdx);

	VariantClear( &olvdx );
	VariantClear( &m_datax_var );

	if (ret != 0) 
	{
		daqcheck = 1;
		msg11.Format("%s,\nonline DAQ property #%d (%s/%s/%s/%s) could not be read out ! (Status was: \"%s\")", msg11, j+1, m_daqprop_context[j], m_daqprop_server[j], m_daqprop_device[j],m_daqprop_property[j],m_CACOPAL.GetStatus());
	}
 }		


 // check Additional TINE properties ExecLink
 for (j=0; j<m_iLoadedAdditionalProperties; j++)
 {
	m_CACOPAL.SetDeviceContext((LPCTSTR) m_addprop_context[j]);
	m_CACOPAL.SetDeviceGroup((LPCTSTR) m_addprop_server[j]);
	m_CACOPAL.SetDeviceName((LPCTSTR) m_addprop_device[j]);
	m_CACOPAL.SetDeviceProperty((LPCTSTR) m_addprop_property[j]);

	VARIANT olvdx, m_datax_var;
	VariantInit( &olvdx );
		
	VariantInit( &m_datax_var );
    V_VT( &m_datax_var ) = VT_R4;
    m_datax_var.fltVal = 0.0;
 
	// call the server
	m_CACOPAL.SetAccessRate("1000");
	m_CACOPAL.SetAccessMode("READ");
	long ret = m_CACOPAL.Execute(&m_addprop_var[j], olvdx, olvdx, &m_datax_var, olvdx, olvdx);

	VariantClear( &olvdx );
	VariantClear( &m_datax_var );

	if (ret != 0) 
	{
		addcheck = 1;
		msg12.Format("%s,\nadditional property #%d (%s/%s/%s/%s) could not be read out ! (Status was: \"%s\")", msg12, j+1, m_addprop_context[j], m_addprop_server[j], m_addprop_device[j],m_addprop_property[j],m_CACOPAL.GetStatus());
	}
 }		


 if ((daqcheck == 1) || (addcheck == 1))
 {
    ((CVideoclntDlg *)AfxGetMainWnd())->OwnMessageBox(MB_ICONEXCLAMATION, "While checking%s%s\n\nThis/these properties will not be correctly read out by online DAQ and/or Additional Property readout (for saving files) !", msg11, msg12);
 }

 // check END

 m_CACOPAL.SetAccessMode("POLL");

 // start DAQ TINE properties polling

 for (j=0; j<m_iLoadedDAQProperties; j++)
 {
	m_CACOPAL.SetDeviceContext((LPCTSTR) m_daqprop_context[j]);
	m_CACOPAL.SetDeviceGroup((LPCTSTR) m_daqprop_server[j]);
	m_CACOPAL.SetDeviceName((LPCTSTR) m_daqprop_device[j]);
	m_CACOPAL.SetDeviceProperty((LPCTSTR) m_daqprop_property[j]); 

	VARIANT olvdx, m_datax_var;
	VariantInit( &olvdx );
		
	VariantInit( &m_datax_var );
    V_VT( &m_datax_var ) = VT_R4;
    m_datax_var.fltVal = 0.0;
 
	// call the server
	m_CACOPAL.SetAccessRate("500");
	m_daqprop_linkid[j] = m_CACOPAL.AttachLink(&m_daqprop_var[j], olvdx, olvdx, &m_datax_var, olvdx, olvdx);

	VariantClear( &olvdx );
	VariantClear( &m_datax_var );

	if (m_daqprop_linkid[j] < 0) 
	{
		//CString msg;
		//msg.Format("Attachlink for property #%d (%s/%s/%s/%s) could not be established.\nACOP Status was: \"%s\" .", j+1, m_daqprop_context[j], m_daqprop_server[j], m_daqprop_device[j],m_daqprop_property[j],m_CACOPAL.GetStatus());
		//CCERRC(-300, msg);
	}
 }		

 // start Additional TINE properties polling

 for (j=0; j<m_iLoadedAdditionalProperties; j++)
 {
	m_CACOPAL.SetDeviceContext((LPCTSTR) m_addprop_context[j]);
	m_CACOPAL.SetDeviceGroup((LPCTSTR) m_addprop_server[j]);
	m_CACOPAL.SetDeviceName((LPCTSTR) m_addprop_device[j]);
	m_CACOPAL.SetDeviceProperty((LPCTSTR) m_addprop_property[j]); 

	VARIANT olvdx, m_datax_var;
	VariantInit( &olvdx );
		
	VariantInit( &m_datax_var );
    V_VT( &m_datax_var ) = VT_R4;
    m_datax_var.fltVal = 0.0;
 
	// call the server
	m_CACOPAL.SetAccessRate("500");
	m_addprop_linkid[j] = m_CACOPAL.AttachLink(&m_addprop_var[j], olvdx, olvdx, &m_datax_var, olvdx, olvdx);

	VariantClear( &olvdx );
	VariantClear( &m_datax_var );

	if (m_addprop_linkid[j] < 0) 
	{
		//CString msg;
		//msg.Format("Attachlink for property #%d (%s/%s/%s/%s) could not be established.\nACOP Status was: \"%s\" .", j+1, m_addprop_context[j], m_addprop_server[j], m_addprop_device[j],m_addprop_property[j],m_CACOPAL.GetStatus());
		//CCERRC(-300, msg);
	}
 }		

 m_bSuccessfulInitialized = TRUE;
 return TRUE;

err:

 m_bSuccessfulInitialized = FALSE;

 ((CVideoclntDlg *)AfxGetMainWnd())->OwnMessageBox(MB_ICONEXCLAMATION, "%s (Errorcode=%d)\n\n%s", errormessage, errorcode, finalmsg);

 return FALSE;
}

BOOL CTineALDlg::DeinitializeTine()
{
 if (m_bSuccessfulInitialized == FALSE) return TRUE;

 long link=0;
 CComVariant var(link);

 for (int i=0;i<m_iLoadedDAQProperties;i++)
 {
   var.lVal = m_daqprop_linkid[i];
   if (var.lVal > 0) m_CACOPAL.CloseLink( var );

   VariantClear( &m_daqprop_var[i] );
 }

 for (i=0;i<m_iLoadedAdditionalProperties;i++)
 {
   var.lVal = m_addprop_linkid[i];
   if (var.lVal > 0) m_CACOPAL.CloseLink( var );

   VariantClear( &m_addprop_var[i] );
 }

 m_bSuccessfulInitialized = FALSE;

 return TRUE;
}

BOOL CTineALDlg::returnDAQPropAsDouble( int prop, double &val)
{
	if (prop < 0 || prop >= m_iLoadedDAQProperties) return FALSE;
	if (m_daqprop_var_ro[prop].vt == VT_R4)
	{
		val = m_daqprop_var_ro[prop].fltVal;
	}
	else if (m_daqprop_var_ro[prop].vt == VT_R8)
	{
		val = m_daqprop_var_ro[prop].dblVal;
	}
	else return FALSE;

	return TRUE;
}

BOOL CTineALDlg::returnDAQPropAsInt( int prop, int &val)
{
	if (prop < 0 || prop >= m_iLoadedDAQProperties) return FALSE;
	if (m_daqprop_var_ro[prop].vt == VT_UI1)
	{
		val = (int) m_daqprop_var_ro[prop].bVal;
	}
	else if (m_daqprop_var_ro[prop].vt == VT_I2)
	{
		val = m_daqprop_var_ro[prop].iVal;
	}
	else if (m_daqprop_var_ro[prop].vt == VT_I4)
	{
		val = m_daqprop_var_ro[prop].lVal;
	}
	else return FALSE;

	return TRUE;
}

// up to now: empty !!!
BOOL CTineALDlg::returnDAQPropAsString( int prop, CString &val)
{
 return FALSE;
}

BOOL CTineALDlg::returnDAQPropDescAsString( int prop, CString &val)
{
	if (prop < 0 || prop >= m_iLoadedDAQProperties) return FALSE;

	val = m_daqprop_name_str[prop];

	return TRUE;
}

// complete with unit etc.pp.
BOOL CTineALDlg::returnDAQPropAsInterpretedString( int prop, CString &val)
{
 CString tmp;
 if (prop < 0 || prop >= m_iLoadedDAQProperties) return FALSE;

 if (m_daqprop_read[prop] == FALSE)
 {
	 val = "(read error)";
     return TRUE;
 }
 ////////////////////////////////////////////////////////////////

 if (m_daqprop_var_ro[prop].vt == VT_R4)
 {
	tmp.Format("%.8f", (double) m_daqprop_var_ro[prop].fltVal);
 }
 else if (m_daqprop_var_ro[prop].vt == VT_R8)
 {
	tmp.Format("%.8f", (double) m_daqprop_var_ro[prop].dblVal);
 }
 else if (m_daqprop_var_ro[prop].vt == VT_UI1)
 {
	tmp.Format("%d", (int) m_daqprop_var_ro[prop].bVal );
 }
 else if (m_daqprop_var_ro[prop].vt == VT_I2)
 {
	tmp.Format("%d", (int) m_daqprop_var_ro[prop].iVal );
 }
 else if (m_daqprop_var_ro[prop].vt == VT_I4)
 {
	tmp.Format("%d", (int) m_daqprop_var_ro[prop].lVal );
 }
 else return FALSE;

 //tmp += " " + m_daqprop_unit_str[prop];

 val = tmp;

 return TRUE;
}

BOOL CTineALDlg::returnWholePropertyStringForDAQ( CString &propStr )
{
 propStr = "";
 CString value;

 for (int i=0;i<m_iLoadedDAQProperties;i++)
 {
   if (i != 0) propStr += SEPCHAR;
   BOOL ret = returnDAQPropAsInterpretedString(i, value);
   if (ret == FALSE) return FALSE;
   propStr += value;
 }

 return TRUE;
}

BOOL CTineALDlg::returnWholePropertyDescriptionStringForDAQ( CString &propdescStr )
{
 propdescStr = ""; 
 
 for (int i=0;i<m_iLoadedDAQProperties;i++)
 {
	 if (i != 0) propdescStr += SEPCHAR;
	 if (m_daqprop_unit_str[i] == "")
	 {
		 propdescStr += m_daqprop_name_str[i];
	 }
	 else
	 {
         propdescStr += m_daqprop_name_str[i]+" ["+m_daqprop_unit_str[i]+"]";
	 }
 }

 return TRUE;
}

BOOL CTineALDlg::snapshotAdditionalPropertiesToAdditionalPropertyStructure()
{
	// iterate additional properties, look for the link number and fill in the property value accordingly

	for (int i=0;i<NUM_MAX_ADDITIONAL_PROPERTIES;i++)
	{
		AdditionalProperty *p = &(m_pAdditionalProperties[i]);

		if (p->enabled == TRUE)
		{
			int pos = p->pos_for_ALDlg;

			if (m_addprop_read[pos] == FALSE)
			{
				p->acqerr = 1;
			}
			else
			{
				p->acqerr = 0;
				if (m_daqprop_var_ro[pos].vt == VT_R4)
				{
					p->dblval = (double) m_daqprop_var_ro[pos].fltVal;
					p->intval = (int) m_daqprop_var_ro[pos].fltVal;
				}
				else if (m_daqprop_var_ro[pos].vt == VT_R8)
				{
					p->dblval = (double) m_daqprop_var_ro[pos].dblVal;
					p->intval = (int) m_daqprop_var_ro[pos].dblVal;
				}
				else if (m_daqprop_var_ro[pos].vt == VT_UI1)
				{
					p->dblval = (double) m_daqprop_var_ro[pos].bVal;
					p->intval = (int) m_daqprop_var_ro[pos].bVal;
				}
				else if (m_daqprop_var_ro[pos].vt == VT_I2)
				{
					p->dblval = (double) m_daqprop_var_ro[pos].iVal;
					p->intval = (int) m_daqprop_var_ro[pos].iVal;
				}
				else if (m_daqprop_var_ro[pos].vt == VT_I4)
				{
					p->dblval = (double) m_daqprop_var_ro[pos].lVal;
					p->intval = (int) m_daqprop_var_ro[pos].lVal;
				}
				else p->acqerr = 1;

			}

		}
	}

	return TRUE;
}
		
		


