#ifndef __HEADERS__H__INCLUDED__

#define __HEADERS__H__INCLUDED__

#include <sys\timeb.h>
#include <sys\types.h>

//#undef __FITTING__
#define __FITTING__

// IDs for message posting

#define ID_MSG_SOERR          WM_USER+2
#define ID_MSG_FRAMEARRIVED   WM_USER+3
#define ID_MSG_SOERRGRAB      WM_USER+4
#define ID_MSG_GRABFINISHED   WM_USER+5
#define ID_MSG_FRAMEGRABBED   WM_USER+6
#define ID_MSG_UPDATECAMERA   WM_USER+7

#define WM_TIMER_FLASH		  WM_USER+8

#define FILE_IMM 0
#define FILE_IMC 2
#define FILE_BKC 3
#define FILE_BMP 1

#define DEFAULT_SCALE_FACTOR  1.000

#ifdef __INTEL__
#define MEMALIGNSW(d) __declspec(align(d))
#else
#define MEMALIGNSW(d) 
#endif

#define CCERRC(ecode, msg) { errorcode = ecode; errormessage = msg; goto err; }
#define CCERR(msg) { errormessage = msg; goto err; }

#define CR CString("\n")
//#define SP CString(" ")
//#define TAB CString("\t")
#define SEPCHAR CString(";")

#define NUM_MAX_ADDITIONAL_PROPERTIES 15 //NUM_ADDITIONAL_PROPERTIES
#define NUM_MAX_DAQ_PROPERTIES 15

// for probing server on startup (CVideoclntDlg)
#define ACCMODE "READ.CONNECT"
#define ACCRATE "500"

#define ACCRATEWHB "500" 
// width, height, bpp


#define UINT unsigned int
#define INT int

typedef struct {
  UINT   kennung;      // 0x11223344;
  UINT   compression;  // FOURCC codec name
  UINT   len_total;    // length of data + formatheader + vidhdr
  UINT   len_data;     // length of the data (compressed image) 
  UINT   len_fmthdr;   // length of the format header (needed for decompression on windows side)
  UINT   frameno;      // since starting the grabserver
  _timeb timestamp;    // time in milliseconds since 1970 // _ftime() _timeb structure
  INT    cameraport;   // port of the camera (0..3)
  UINT   widthframe;   // width of the frame in pixels
  UINT   heightframe;  // height of the frame in pixels
  UINT   compressed;   // 1= picture is compressed
                       // 0= picture is not compressed because if it would be compressed it would be too big
  double framerate;    // floating point: average number of frames per second
  double scale;
  UINT   bpp;
  UINT   bpp_effective;	// willbe used as bits per pixel effective (12bpp e.g.), WAS: int seqnum;
  char   reserved[8];
} VIDHDR;


// for compressed files (*.imc, *.bkc)

typedef struct {
  UINT width;
  UINT height;
  UINT bpp;
  UINT num_frames;
} FHDR;

typedef struct {
  double scale;
  UINT len_compressed;
  UINT len_uncompressed;
} IMHDR;


#ifndef DECLARE_ONOKCANCEL_HOOK
#define DECLARE_ONOKCANCEL_HOOK(theClass) \
 protected: \
 class XDlgOuter : public CCommonDialog \
 { \
 public: \
  XDlgOuter() : CCommonDialog(NULL) \
   { \
   } \
  virtual void OnOK() \
   { \
    METHOD_PROLOGUE_(theClass, DlgOuter) \
    pThis->OnOK(); \
    Default(); \
   } \
   virtual void OnCancel() \
   { \
    METHOD_PROLOGUE_(theClass, DlgOuter) \
    pThis->OnCancel(); \
    Default(); \
   } \
 } m_xDlgOuter; \
 virtual void PreInitDialog() \
 { m_xDlgOuter.SubclassWindow(::GetParent(m_hWnd)); } \
 friend class XDlgOuter;
#endif

// ADDITIONAL PROPERTIES HANDLING

struct AdditionalProperty
{
  CString FriendlyName;
  CString FriendlyUnit;

  CString Context;
  CString Server;
  CString Device;
  CString Property;

  int     intval;
  double  dblval;

  int     type; // 1== int, 2== float

  BOOL    enabled;

  int	  acqerr;
 
  int     pos_for_ALDlg;
 
};

// MULTI-MONITOR Handling
// only checked with two (!) screens 
// has to be checked with three or more screens

typedef struct 
{
  unsigned int peRed; 
  unsigned int peGreen; 
  unsigned int peBlue; 
  unsigned int peFlags;
} PALETTEENTRYSW;

typedef struct
{
  unsigned short    pixel16;
} COLORACCESSTABLE16;

typedef struct
{
  unsigned long		pixel32;
} COLORACCESSTABLE32;


// An EnumInfo contains extra enumeration information that is passed
// into the the DDEnumCallbackEx function.
struct EnumInfo
{
    BOOL bMultimonSupported;
    HRESULT hr;
	void *dlg;
};

// A Screen represents one display that images can be drawn to.
struct Screen
{
    GUID guid;
    TCHAR szDesc[200];
    HMONITOR hmon;
    LPDIRECTDRAW7 pdd;
    LPDIRECTDRAWSURFACE7 pddsFront;
    LPDIRECTDRAWSURFACE7 pddsBack;
	LPDIRECTDRAWSURFACE7 pddsDraw;
	LPDIRECTDRAWCLIPPER  pddClipper;

    unsigned long int m_uiRGBBitCount;
    
	unsigned long int m_uiRBitMask;
    unsigned long int m_uiGBitMask;
    unsigned long int m_uiBBitMask;
	
	unsigned long int m_uiRBitCount;
	unsigned long int m_uiGBitCount;
	unsigned long int m_uiBBitCount;

	unsigned long int m_iRBitPos;
	unsigned long int m_iGBitPos;
	unsigned long int m_iBBitPos;
	long destadd;

	COLORACCESSTABLE32 *cat32;
	COLORACCESSTABLE16 *cat16;
    
	Screen* pScreenNext; // For linked list

};


#include "MemoryManagement.h"

extern CMemoryManagement memman;

#endif

