// videoclnt.cpp : Legt das Klassenverhalten fr die Anwendung fest.
//

#include "stdafx.h"
#include "videoclnt.h"
#include "headers.h"
#include <vfw.h>
#include "compression.h"
class CVideoclntDlg;
#include <windows.h>
#include <winsock.h>
#undef fd_set
#include "IniEx.h"
#include "Server.h"
#include "ServerList.h"
#include "SSyncSocket.h"
#include "CATineDlg.h"
#include "TineALDlg.h"
#include "MessagesDlg.h"
#include "Queue.h"
#include "BogusTineDlg.h"
#include "ImageAcquire.h"
#include "ImageSequence.h"
#include "Stat.h"
#include "FourierStat.h"
#include "StatFile.h"
#include "MyVideoFrame.h"
#include "PrinterSettings.h"
#include "MarkedComboBox.h"
#include "InformationDialog.h"
#include "videoclntDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVideoclntApp
//
// This class is the main class of the application. It just initializes some 
// things and start the main dialog. Also it is required for proper translation 
// of the accelerators (keyboard shortcuts).
//
//

HWND    ghDlg;          // handle to main dialog box
HACCEL  ghAccelTable;   // handle to the accelerator table (resource)

/////////////////////////////////////////////////////////////////////////////
// CVideoclntApp

BEGIN_MESSAGE_MAP(CVideoclntApp, CWinApp)
	//{{AFX_MSG_MAP(CVideoclntApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Construction of CVideoclntApp (empty)

CVideoclntApp::CVideoclntApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// CVideoclntApp-Object

CVideoclntApp theApp;

/////////////////////////////////////////////////////////////////////////////
// Initialize CVideoclntApp 

BOOL CVideoclntApp::InitInstance()
{
   	HANDLE m_hSem;
	// initialize sockets 
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	// standard initialization

#ifdef _AFXDLL
	Enable3dControls();			// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
#else
	Enable3dControlsStatic();	// Diese Funktion bei statischen MFC-Anbindungen aufrufen
#endif

    SetRegistryKey("Live Video Client (Videoclnt)");

	// load keyboard shortcuts
	ghAccelTable = LoadAccelerators(AfxGetInstanceHandle(),
        MAKEINTRESOURCE(IDR_ACCELERATOR1));

    // define a global semaphore to see if we are already running an instance
	// SW! May 05, 2006: should not work properly, see grabserver2 how to do it better
    m_hSem = CreateSemaphore(NULL, 0, 1, "VC2_SR1b1_IS_RUNNING");

	// instantiate, initialize and show main dialog
	CVideoclntDlg dlg;
	m_pMainWnd = &dlg;
    dlg.setApp(this);
	
	int nResponse = dlg.DoModal();
	
	if (nResponse == IDOK)
	{
	}
	else if (nResponse == IDCANCEL)
	{
	}

	if (m_hSem != NULL) CloseHandle(m_hSem);
	// return false to close the application
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// 
// This function is needed to process the keyboard shortcuts. It just uses 
// windows functions to process the keystroke (if there is a keystroke) and 
// posts a message with the right ID (e.g. of the Menuitem) to the main message 
// queue. 
//

BOOL CVideoclntApp::ProcessMessageFilter(int code, LPMSG lpMsg) 
{
 if (code < 0) CWinApp::ProcessMessageFilter(code, lpMsg);

 if (ghDlg && ghAccelTable)
 {
  if (::TranslateAccelerator(ghDlg, ghAccelTable, lpMsg)) return(TRUE);
 }

 return CWinApp::ProcessMessageFilter(code, lpMsg);
}
