// videoclntDlg.h : Header-Datei
//
//{{AFX_INCLUDES()
#include "Queue.h"
#include "acop.h"
#include "ServerList.h"	// Added by ClassView
//}}AFX_INCLUDES

#if !defined(AFX_VIDEOCLNTDLG_H__DCC4E95E_292D_4654_918A_00F320518310__INCLUDED_)
#define AFX_VIDEOCLNTDLG_H__DCC4E95E_292D_4654_918A_00F320518310__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/////////////////////////////////////////////////////////////////////////////
// CVideoclntDlg Dialogfeld

class CVideoclntDlg : public CDialog
{
	// construction/destruction and public function declarations

public:
	CString GetExecutableDirectory();
	int  CheckDirectory(CString dir);
	void PutToErrorLog( const char *format, ... );
//	void PutToErrorLog( const char *message );
	void OwnMessageBox(UINT additional_styles, const char *format, ...);

	struct AdditionalProperty *ReturnAdditionalProperties();
	int ReturnNumAdditionalProperties();

    void OnDaqPublic();

	BOOL NormalizeToArea(int &mousexpos, int &mouseypos, BOOL &xvalid, BOOL &yvalid, CStatic *frame, struct Screen* screen);
	CString ReturnLoadedDaqFileName();
	CString ReturnDefaultDaqFileName();
    
	struct Screen* s_pScreenFirst; // Linked list of Screens

    void ConvertImageColorSpace(int width, int height, void *src, int srcadd, void *dest, int destadd, unsigned int rgbbitcount, Screen *scrn);
	
	//void CheckServerSettings( CServer srv);
    /*
	SW! rausgenommen Apr 27, 2006 (wird wohl nicht mehr bentigt)
	BOOL GetBitsPerPixelFromServer(int &bpp, CString context, CString servername);
    BOOL GetHeightFrameFromServer(int &height, CString context, CString servername);
    BOOL GetWidthFrameFromServer( int &width, CString context, CString servername );
	*/

	void GetBackgroundsFromServerCallback();
	BOOL m_bShouldCameraEnabledAfterGrabbing;
	void EnableMenusAfterGrab();
	void DisableMenusForGrab();

	void GrabAndSaveCallback();
	BOOL GrabAndSave( int numframes );

	void PrintServerMessage(CString msg);	

    BOOL GetBackgroundsFromServer( int numframes, BOOL envelope);
	CString m_sDAQString; 
	CString m_sDAQFileName; 
	BOOL m_bDAQRunning;
	// standard construction    
    CVideoclntDlg(CWnd* pParent = NULL);

	// functions to catch mouse events on the video frame
	void OnVideoMouseMove( UINT nFlags, CPoint point);
	void OnVideoLeftButtonUp( UINT nFlags, CPoint point);
	void OnVideoLeftButtonDown( UINT nFlags, CPoint point);
    void OnVideoRightButtonDown(UINT nFlags, CPoint point);
    void OnVideoRightButtonUp(UINT nFlags, CPoint point);

	// to set the flag "no, we can not print on the messages dialog any more", 
	// because the user has closed the messages dialog window
	void SetMessagesWindowStatus();

	// sets the application pointer in the main dialog, so that
	// we can r/w the registry
    void setApp( CVideoclntApp *the_app);

    // Dialogfelddaten
	//{{AFX_DATA(CVideoclntDlg)
	enum { IDD = IDD_VIDEOCLNT_DIALOG };
	CMarkedComboBox	m_CComboCamera;
	CEdit	m_CEditScreen2;
	CButton	m_CButtonTopLeft1;
	CEdit	m_CEditSumPixels;
	CStatic	m_CStaticYRms;
	CStatic	m_CStaticXRms;
	CStatic	m_CStaticYMean;
	CStatic	m_CStaticXMean;
	CEdit	m_CEditFrameNo;
	CButton	m_CButtonDaqdiscard;
	CStatic	m_CFrameYProjection;
	CEdit	m_CEditRealLaserPower;
	CButton	m_CButtonSnap;
	CButton	m_DAQ;
	CStatic	m_CFrameProjection;
	CEdit	m_CEditStatusLine;
	CEdit	m_CEditFramesPolled;
	CMyVideoFrame	m_CMyVideoFrame;
	CEdit	m_CEditScale;
	CEdit	m_CEditYRms;
	CEdit	m_CEditXRms;
	CEdit	m_CEditYMean;
	CEdit	m_CEditXMean;
	CEdit	m_CEditDropped;
	CACOP	m_CACOPCtrl;
	CACOP	m_CACOPCtrlCamUpdate;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CVideoclntDlg)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	BOOL CheckFrameheaderSettings( const VIDHDR &vidH );
	UINT m_nShowType;
	HICON m_hIcon;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CVideoclntDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelchangeCombo1Camera();
	afx_msg LRESULT OnSocketError(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnFrameReceived( WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnSocketErrorGrabbing(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnFinishedGrabbing( WPARAM wParam, LPARAM lParam);
    afx_msg LRESULT OnNotifyFrameGrabbed(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnDisplaySettingsChanged(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnServerSettingChanged(WPARAM wParam, LPARAM lParam);
    afx_msg void OnCloseupCombo1Camera();
	afx_msg void OnDropdownCombo1Camera();
	afx_msg void OnSelendcancelCombo1Camera();
	afx_msg void OnSelendokCombo1Camera();
	virtual void OnCancel();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnApplicationQuit();
	afx_msg void OnApplicationOptions();
	afx_msg void OnApplicationMessages();
	afx_msg void OnMenuImagePoll();
	afx_msg void OnApplicationColormodeFalsecolor();
	afx_msg void OnApplicationColormodeGrayscale();
	afx_msg void OnApplicationStayontop();
	afx_msg void OnMenuBackgroundGrab();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnMenuImageGrab10frames();
	afx_msg void OnMenuImageGrab15frames();
	afx_msg void OnMenuImageGrab1frame();
	afx_msg void OnMenuImageGrab20frames();
	afx_msg void OnMenuImageGrab2frames();
	afx_msg void OnMenuImageGrab30frames();
	afx_msg void OnMenuImageGrab3frames();
	afx_msg void OnMenuImageGrab40frames();
	afx_msg void OnMenuImageGrab4frames();
	afx_msg void OnMenuImageGrab50frames();
	afx_msg void OnMenuImageGrab5frames();
	afx_msg void OnChangeEdit6Scale();
	afx_msg void OnApplicationStatisticsmodeFourier();
	afx_msg void OnApplicationStatisticsmodeStraightforward();
	afx_msg void OnBackgroundShow();
	afx_msg void OnBackgroundClear();
	afx_msg void OnImageAnalyze();
	afx_msg void OnApplicationStatisticsmodeOff();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnCaptureChanged(CWnd *pWnd);
	afx_msg void OnMenuBackgroundLoad();
	afx_msg void OnMenuBackgroundSave();
	afx_msg void OnMenuImageLoad();
	afx_msg void OnMenuImageSave();
	afx_msg void OnTakeSnapshot();
	afx_msg void OnApplicationProjectionmodeOff();
	afx_msg void OnApplicationProjectionmodeXprojection();
	afx_msg void OnApplicationProjectionmodeYprojection();
	afx_msg void OnApplicationXrayfiltering();
	afx_msg void OnBackgroundGetAverage10frames();
	afx_msg void OnBackgroundGetAverage5frames();
	afx_msg void OnBackgroundGetEnvelope10frames();
	afx_msg void OnBackgroundGetEnvelope5frames();
	afx_msg void OnBackgroundAdd();
	afx_msg void OnBackgroundGetAverage30frames();
	afx_msg void OnBackgroundGetAverage40frames();
	afx_msg void OnBackgroundGetAverage50frames();
	afx_msg void OnBackgroundGetAverage20frames();
	afx_msg void OnBackgroundGetEnvelope20frames();
	afx_msg void OnBackgroundGetEnvelope30frames();
	afx_msg void OnBackgroundGetEnvelope40frames();
	afx_msg void OnBackgroundGetEnvelope50frames();
	afx_msg void OnApplicationPrint();
	afx_msg void OnApplicationPrintwholewindow();
	afx_msg void OnDaqdiscard();
	afx_msg void OnHelpAbout();
	afx_msg void OnHelpQuickreference();
	afx_msg void OnApplicationColormodeMatlabfalsecolor();
	afx_msg void OnBackgroundGetAverage100frames();
	afx_msg void OnBackgroundGetAverage200frames();
	afx_msg void OnBackgroundGetEnvelope100frames();
	afx_msg void OnBackgroundGetEnvelope200frames();
	afx_msg void OnImageGrab100frames();
	afx_msg void OnImageGrab200frames();
	afx_msg void OnApplicationNormalisation();
	afx_msg void OnApplicationAreaofinterestRectangular();
	afx_msg void OnApplicationAreaofinterestCircular();
	afx_msg void OnImageGrabandsave100frames();
	afx_msg void OnImageGrabandsave10frames();
	afx_msg void OnImageGrabandsave15frames();
	afx_msg void OnImageGrabandsave20frames();
	afx_msg void OnImageGrabandsave30frames();
	afx_msg void OnImageGrabandsave40frames();
	afx_msg void OnImageGrabandsave50frames();
	afx_msg void OnApplicationStatisticsmodeStreakcamera();
	afx_msg void OnApplicationKeepaspectratio();
	afx_msg void OnDAQStart();
	afx_msg void OnReceiveAcopctrl2Pollcamupdate(long LinkIndex, long StatusCode);
	afx_msg void OnButton4Switchcam();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()


private:

	BOOL m_bTineALInitialized;
	CTineALDlg *m_pTineALDlg;

    //void DownScaleTo8Bit(unsigned char *src, unsigned char *dst, unsigned int width, unsigned int height, unsigned int bpp);
    
    CPrinterSettings m_PrinterSettings;
    void ReinitializeImageSettings();
	void CheckImageSettings( int Width, int Height, int Bpp, int Bpp_eff);
    // prints out server messages and status bar informations

    void GetBackgroundFromServerCallback();
    void AddBackgroundFromServerCallback();
    void GrabFramesFromServerCallback();
    // Intialization/Deinitialization of compression
	BOOL InitializeCompression(int width, int height, int bpp);	
	BOOL DeinitializeCompression();

	// functions needed for loading/saving of images
    int SaveBackgroundBMP( char *filename );
	int SaveBackgroundBKG( char *filename );
	CString ObtainSelectedExtension(CString fname, CString &returnvalue, LPCTSTR filterstr, int nFilterIndex);
	
	/* assembler functions */
	// flips the frame top-down
	void AdjustBitdepthForPrinting(void *dest, void *src, int width, int height, int bpp);
	//void flipframemmx1( char *dest, char *src, int width, int height, int bpp);
	// fast memory copy of lengthsize bytes from src to dst

	// needed for resizing the window
    void RedrawClientArea();
    //BOOL AdjustClientArea( RECT *clientArea, RECT *projectionArea, RECT *videoarea, RECT *statusArea, int projectionmode);
	BOOL AdjustClientArea( RECT *clientArea, RECT *projectionxArea, RECT *projectionyArea, RECT *videoArea, RECT *statusArea, BOOL proj_x, BOOL proj_y, BOOL keepaspectratio );

	/* Functions for drawing the video */
    void DisplayFunction(char *video, int cport, BOOL justredraw);
    BOOL DeinitializeDrawing();
    BOOL InitializeDrawing( BOOL falsecolor );

    /* camera handling functions */
	//void SetScaleFromServer(DWORD server);
	// SW! Apr 27, 2006 taken out

	void UpdateCameraPort(BOOL message, BOOL all);	

    /* statistics handling functions */
	void UpdateStatisticalValues();
	//void MakeStatFile( char *framebuffers, char * outdata, int numframes, BOOL XFilt);
	void MakeStatFile(CImageSequence *seq, char *outdata, BOOL XFilt);
	void UpdateStatisticsMode( int fourier);

	/* frame acquire control functions */
	BOOL GrabFramesFromServer( int numframes );
	BOOL GetBackgroundFromServer( );
	BOOL AddBackgroundFromServer( );
	BOOL StopPollMode();
	BOOL StartPollMode();
	
    // enable/disable menu items
    void SetMenuItemByPos(int topmenuid, int item_pos, BOOL enabled);
	void SetMenuItem( int item_id, BOOL enabled);
    BOOL IsMenuItemEnabled(int item_id);

	// check/uncheck menu items 
    void CheckMenuItem(int item_id, BOOL checked);
	
	// updates the palette handle (TRUE: false colors; FALSE: grayscale)
	BOOL UpdatePalette(int falsecolor);	

	// does cleanup when exiting the application
	void QuitApplication();

	/* misc functions */
    // will be called when the socket is closed abnormally
	// does nothing, overrides OnOK in base class so that the dialog 
	// is not closed if the user presses escape
	void OnOK(); 

	/*
	  Variables
    */
	BOOL m_bXRayFiltering; // TRUE: X-Ray filtering is on
	int m_iFalseColor;    // TRUE: False color mode is on
	//int m_iProjectionMode; // 0=no projections 1=x projection 2=y projection
	BOOL m_bStayOnTop;     // TRUE: Application stays on top
	BOOL m_bPollMode;      // TRUE: Poll mode is switched on
	BOOL m_bMessagesWindowOpen; // TRUE: Messages window is open
	BOOL m_bComboBoxBlocked; // TRUE: Combo box for camera selection is blocked
	BOOL m_bDrawingInitialized; // TRUE: drawing of the picture is initialized

    //UINT m_nTimer; // timer handle (updating the camera port)

	// relatively fast drawing of device independent bitmaps (video data)
	//HDRAWDIB m_hDrawDib;
	
    BOOL m_bPaletteChangeInProgress;

	// Point values and Rectangle for drawing mouse cross and area of interest
	CPoint m_CPointCross;
	CPoint m_CPointLast;
	CPoint m_CPointEnd;
	CPoint m_CPointStart;
	CRect m_newAOI; // soon to be used area of interest
	// user pressed the left mouse button -> draw the area of interest rectangle
	BOOL m_bMakeRectangle;

	char *m_pNormalizedImage; // normalized image temporaily buffer
	char *m_pBackground; // pointer to actual background
	char *m_pLastFrame; // last frame which was displayed
	char *m_pDecompressedFrame; // a decompressed frame

	// variables needed to calculate the dropped frames
	int m_iCountedFrames;
	int m_iFirstFrame;

	// queue for the video data transfer receivethread -> application 
	CQueue *m_video_queue; // poll queue
	CQueue *m_grab_queue; // grab queue

	// messages dialog class pointer
	CMessagesDlg *m_wndMessages;

	// pointer to main application class to access the registry 
	//CVideoclntApp * m_pApp;
	
	/* additional values for drawing the video */
	HPALETTE m_hPalette; // pointer to actual palette (grayscale or false color)


    // width and height in screen pixels of the video frame
	int m_VideoWindowWidth;
	int m_VideoWindowHeight;

	/* Statistical analysis variables */
	CStatFile *m_pStatFile;
	int m_iAnalyzeMode; // 1= fourier 2= stat 3= off 4=fitting

private:
	CString m_sExecutableDirectory;
	double GetCurrentScale();
	double internalScaleFactor;

	BOOL TogglePollMode();
	void SetScaleFactorInGUI( double scalefac );
	void SignalCameraSelectionBox(int mstimelength, int changeseveryms, COLORREF color);
	void ReloadServerSettings( int actualserverpos );
	void ReloadServerSettingsSmall();
	void CleanupServerCheckLink();
	BOOL CreateServerCheckLink( CString context, CString tinecontrolname );
	int m_iNumAdditionalProperties;
	struct AdditionalProperty * m_pAdditionalProperties;
	struct AdditionalProperty m_AdditionalProperties[NUM_MAX_ADDITIONAL_PROPERTIES];
	BOOL InitializeDAQFunction();
	BOOL DeinitializeDAQFunction();
	CString BeautifyCSVString( CString src, CString CSVkomma, CString CSVDelimiter );
    HRESULT EnumerateScreens( VOID );
    BOOL RectIntersectsMonitor( RECT* prcSrc, HMONITOR hmon, RECT* prcScreen );
	BOOL RectIntersectsMonitorWithoutOffset( RECT* prcSrc, HMONITOR hmon, RECT* prcScreen );
	BOOL RectIntersectsMonitorDEBUG( RECT* prcSrc, HMONITOR hmon, RECT* prcScreen );
	BOOL CheckAndConfigurePHISTServer();
	BOOL m_bKeepAspectRatio;
	void OnSize();
	void DoCleanupAbortGrabAndSave( CString abortmessage );
	BOOL GrabAndSaveCheckFiles( CString path, CString middlename );
	BOOL m_bCircularAOI;
	void SetCaption(CString caption, CString path, CString end);
	BOOL m_bNormalization;
	CCATineDlg * m_pCATineDlg;
	CVideoclntApp * m_pApp;
	//int m_iActualPort;
	BOOL m_bYProjectionOn;
	BOOL m_bXProjectionOn;
	BOOL m_bTransferRunning;
	
	int m_iActualBppEffective;
	int m_iActualBpp;
	int m_iActualHeight;
	int m_iActualWidth;
	CString m_sActualCameraID;
    long m_lServerCheckLink;

    CString  m_sNewCameraID;
	VARIANT  m_vNewCameraID;
	char    *m_pTineData;
	
	BOOL m_bEnvelope;
	int m_iGrabDestination;
	CImageAcquire * m_pImageAcquire;
	int m_iActualServerPos;
	CServerList m_ServerList;
	BOOL InitializeServerConnections();
	//SW! Apr 27, 2006 taken out: no longer needed
	//BOOL GetCamportScale( CString context, CString server, CString property, double &scaleval);
    BOOL GetCameraName( CString context, CString server, CString property, CString &camportstring);
	CIniEx *m_pIniFileExeGlobal;
	CIniEx *m_pIniFileExeLocal;
	CIniEx *m_pIniFileProf;
	void DeinitializeIniFiles();
	BOOL InitializeIniFiles();
    /* recycle bin */

	CImageSequence *m_pImageSequence;

    // GrabAndSave...
	int m_iGrabAndSaveNumFrames;
	void SaveGrabbedAndStoredData();

    CString m_sGrabAndSavePath;
	CString m_sGrabAndSaveFilename;

	CImageSequence *m_pGSImageSequence;
    CImageSequence *m_pGSBackgroundSequence;

	int  m_iGrabAndSaveProgress;

	BOOL m_bWasShutterOpen;

	CInformationDialog m_InfoDlg;

    PALETTEENTRYSW *m_pColorTable;
	int m_iFirstRGBBitCount;

	time_t m_tFlashAktTime;
	time_t m_tFlashStartTime;
	time_t m_tFlashDuration;
	UINT   m_nFlashTimer;

	FILE   *m_fpDAQFile;
	CString m_sCurrentOnlineDAQFileName;


};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_VIDEOCLNTDLG_H__DCC4E95E_292D_4654_918A_00F320518310__INCLUDED_)
