// videoclntDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "headers.h"
#include "videoclnt.h"
#include <math.h>
#include <vfw.h>
#include "Queue.h"
#include "BMPFileHelper.h"
#include "compression.h"
//#include "rpcdefs.h"
//#include "rpctypes.h"
#define CF_LONG         515
#include "EnvelopeAverage.h"
class CVideoclntDlg;
#include <windows.h>
#include <winsock.h>
#undef fd_set
#include "IniEx.h"
#include "Server.h"
#include "ServerList.h"
#include "SSyncSocket.h"
#include "configdlg.h"
#include "CATineDlg.h"
#include "TineALDlg.h"
#include "ImageSequence.h"
#include "Stat.h"
#include "BogusTineDlg.h"
#include "ImageAcquire.h"
#include "FourierStat.h"
#include "StatFile.h"
#include "StatEmpty.h"
#include "MessagesDlg.h"
#include "MyVideoFrame.h"
#include "acop.h"
#include "oleauto.h"
#include "AdditionalInformation.h"
#include "PrinterSettings.h"
#include "MarkedComboBox.h"
#include "AboutDialog.h"
#include "CATineDlg.h"
#include "InformationDialog.h"
#include "videoclntDlg.h"
#include "ShutterControl.h"
#include "Shlwapi.h"
#include "FilePreview.h"
#include "FileDialogOpenThumbnail.h"
#include "EnvelopeAverageChoose.h"
#define COMPILE_MULTIMON_STUBS 
#include <multimon.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//#define NEWFILE(filename)  CreateFile(filename,GENERIC_READ| GENERIC_WRITE, (DWORD)0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,(HANDLE) NULL)
//#define OPENFILE(filename) CreateFile(filename,GENERIC_READ,(DWORD)0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL)

inline const unsigned char* GetTimeStr()
{
    static unsigned char StrDch[200];

	time_t ltime;
    _tzset();
	time( &ltime );
    sprintf( (char *) &(StrDch[0]),"%ld", ltime );
	return &(StrDch[0]);
}

inline CString GetTimeStrFormatted()
{
	CTime t = CTime::GetCurrentTime();

	CString s = t.Format( "%B_%d_%Y %H_%M_%S" );

	return s;
}



/////////////////////////////////////////////////////////////////////////////
// CVideoclntDlg - main dialog of the application
//
// This is the main dialog of the Videoclnt application. In principle, this class 
// controls the whole application. All the other classes are just helper classes for
// this main class.
//

////////////////////////////////////////////////////////////////////////////
//
// Construction of the class
//
CVideoclntDlg::CVideoclntDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVideoclntDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVideoclntDlg)
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	/* initialize some member variables */
    m_bDrawingInitialized = FALSE;
	m_bTineALInitialized = FALSE;
	m_lServerCheckLink = -1;
	m_sCurrentOnlineDAQFileName = "";
	    
    for (int i=0;i<NUM_MAX_ADDITIONAL_PROPERTIES;i++)
	{
		m_AdditionalProperties[i].enabled = FALSE;
	}
	
	m_pAdditionalProperties = (struct AdditionalProperty *)&m_AdditionalProperties;

}

////////////////////////////////////////////////////////////////////////////
//
// This function is entirely generated by Visual C++. It handles the data 
// exchange between the wrapper classes and the real controls.
//

void CVideoclntDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVideoclntDlg)
	DDX_Control(pDX, IDC_COMBO1_CAMERA, m_CComboCamera);
	DDX_Control(pDX, IDC_EDIT4, m_CEditScreen2);
	DDX_Control(pDX, IDC_BUTTON_HIDDEN, m_CButtonTopLeft1);
	DDX_Control(pDX, IDC_EDIT2, m_CEditSumPixels);
	DDX_Control(pDX, IDC_STATIC_YRMS, m_CStaticYRms);
	DDX_Control(pDX, IDC_STATIC_XRMS, m_CStaticXRms);
	DDX_Control(pDX, IDC_STATIC_YMEAN, m_CStaticYMean);
	DDX_Control(pDX, IDC_STATIC_XMEAN, m_CStaticXMean);
	DDX_Control(pDX, IDC_EDIT3, m_CEditFrameNo);
	DDX_Control(pDX, IDC_BUTTON4_DAQDISCARD, m_CButtonDaqdiscard);
	DDX_Control(pDX, IDC_FRAME_YPROJECTION, m_CFrameYProjection);
	DDX_Control(pDX, IDC_BUTTON2, m_CButtonSnap);
	DDX_Control(pDX, IDC_BUTTON3, m_DAQ);
	DDX_Control(pDX, IDC_FRAME_PROJECTION, m_CFrameProjection);
	DDX_Control(pDX, IDC_EDIT2_STATUSLINE, m_CEditStatusLine);
	DDX_Control(pDX, IDC_EDIT2_FRMSPOLLED, m_CEditFramesPolled);
	DDX_Control(pDX, IDC_FRAME_VIDEO, m_CMyVideoFrame);
	DDX_Control(pDX, IDC_EDIT6_SCALE, m_CEditScale);
	DDX_Control(pDX, IDC_EDIT5_YRMS, m_CEditYRms);
	DDX_Control(pDX, IDC_EDIT4_XRMS, m_CEditXRms);
	DDX_Control(pDX, IDC_EDIT3_YMEAN, m_CEditYMean);
	DDX_Control(pDX, IDC_EDIT2_XMEAN, m_CEditXMean);
	DDX_Control(pDX, IDC_EDIT1, m_CEditDropped);
	DDX_Control(pDX, IDC_ACOPCTRL1, m_CACOPCtrl);
	DDX_Control(pDX, IDC_ACOPCTRL2_POLLCAMUPDATE, m_CACOPCtrlCamUpdate);
	//}}AFX_DATA_MAP
}

////////////////////////////////////////////////////////////////////////////
//
// This is the message map for the class. This section is entirely generated
// by Visual C++.
//

BEGIN_MESSAGE_MAP(CVideoclntDlg, CDialog)
	//{{AFX_MSG_MAP(CVideoclntDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMBO1_CAMERA, OnSelchangeCombo1Camera)
	ON_MESSAGE(ID_MSG_SOERR, OnSocketError)
    ON_MESSAGE(ID_MSG_FRAMEARRIVED, OnFrameReceived )
	ON_MESSAGE(ID_MSG_SOERRGRAB, OnSocketErrorGrabbing)
    ON_MESSAGE(ID_MSG_GRABFINISHED, OnFinishedGrabbing )
    ON_MESSAGE(ID_MSG_FRAMEGRABBED, OnNotifyFrameGrabbed )
	ON_MESSAGE(WM_DISPLAYCHANGE, OnDisplaySettingsChanged )
	ON_MESSAGE(ID_MSG_UPDATECAMERA, OnServerSettingChanged )
	ON_CBN_CLOSEUP(IDC_COMBO1_CAMERA, OnCloseupCombo1Camera)
	ON_CBN_DROPDOWN(IDC_COMBO1_CAMERA, OnDropdownCombo1Camera)
	ON_CBN_SELENDCANCEL(IDC_COMBO1_CAMERA, OnSelendcancelCombo1Camera)
	ON_CBN_SELENDOK(IDC_COMBO1_CAMERA, OnSelendokCombo1Camera)
	ON_WM_SIZE()
	ON_COMMAND(ID_APPLICATION_QUIT, OnApplicationQuit)
	ON_COMMAND(ID_APPLICATION_OPTIONS, OnApplicationOptions)
	ON_COMMAND(ID_APPLICATION_MESSAGES, OnApplicationMessages)
	ON_COMMAND(ID_IMAGE_POLL, OnMenuImagePoll)
	ON_COMMAND(ID_APPLICATION_COLORMODE_FALSECOLOR, OnApplicationColormodeFalsecolor)
	ON_COMMAND(ID_APPLICATION_COLORMODE_GRAYSCALE, OnApplicationColormodeGrayscale)
	ON_COMMAND(ID_APPLICATION_STAYONTOP, OnApplicationStayontop)
	ON_COMMAND(ID_BACKGROUND_GRAB, OnMenuBackgroundGrab)
	ON_WM_TIMER()
	ON_COMMAND(ID_IMAGE_GRAB_10FRAMES, OnMenuImageGrab10frames)
	ON_COMMAND(ID_IMAGE_GRAB_15FRAMES, OnMenuImageGrab15frames)
	ON_COMMAND(ID_IMAGE_GRAB_1FRAME, OnMenuImageGrab1frame)
	ON_COMMAND(ID_IMAGE_GRAB_20FRAMES, OnMenuImageGrab20frames)
	ON_COMMAND(ID_IMAGE_GRAB_2FRAMES, OnMenuImageGrab2frames)
	ON_COMMAND(ID_IMAGE_GRAB_30FRAMES, OnMenuImageGrab30frames)
	ON_COMMAND(ID_IMAGE_GRAB_3FRAMES, OnMenuImageGrab3frames)
	ON_COMMAND(ID_IMAGE_GRAB_40FRAMES, OnMenuImageGrab40frames)
	ON_COMMAND(ID_IMAGE_GRAB_4FRAMES, OnMenuImageGrab4frames)
	ON_COMMAND(ID_IMAGE_GRAB_50FRAMES, OnMenuImageGrab50frames)
	ON_COMMAND(ID_IMAGE_GRAB_5FRAMES, OnMenuImageGrab5frames)
	ON_EN_CHANGE(IDC_EDIT6_SCALE, OnChangeEdit6Scale)
	ON_COMMAND(ID_APPLICATION_STATISTICSMODE_FOURIER, OnApplicationStatisticsmodeFourier)
	ON_COMMAND(ID_APPLICATION_STATISTICSMODE_STRAIGHTFORWARD, OnApplicationStatisticsmodeStraightforward)
	ON_COMMAND(ID_BACKGROUND_SHOW, OnBackgroundShow)
	ON_COMMAND(ID_BACKGROUND_CLEAR, OnBackgroundClear)
	ON_COMMAND(ID_IMAGE_ANALYZE, OnImageAnalyze)
	ON_COMMAND(ID_APPLICATION_STATISTICSMODE_OFF, OnApplicationStatisticsmodeOff)
	ON_WM_SHOWWINDOW()
	ON_WM_CAPTURECHANGED()
	ON_COMMAND(ID_BACKGROUND_LOAD, OnMenuBackgroundLoad)
	ON_COMMAND(ID_BACKGROUND_SAVE, OnMenuBackgroundSave)
	ON_COMMAND(ID_IMAGE_LOAD, OnMenuImageLoad)
	ON_COMMAND(ID_IMAGE_SAVE, OnMenuImageSave)
	ON_BN_CLICKED(IDC_BUTTON2, OnTakeSnapshot)
	ON_COMMAND(ID_APPLICATION_PROJECTIONMODE_OFF, OnApplicationProjectionmodeOff)
	ON_COMMAND(ID_APPLICATION_PROJECTIONMODE_XPROJECTION, OnApplicationProjectionmodeXprojection)
	ON_COMMAND(ID_APPLICATION_PROJECTIONMODE_YPROJECTION, OnApplicationProjectionmodeYprojection)
	ON_COMMAND(ID_APPLICATION_XRAYFILTERING, OnApplicationXrayfiltering)
	ON_COMMAND(ID_BACKGROUND_GET_AVERAGE_10FRAMES, OnBackgroundGetAverage10frames)
	ON_COMMAND(ID_BACKGROUND_GET_AVERAGE_5FRAMES, OnBackgroundGetAverage5frames)
	ON_COMMAND(ID_BACKGROUND_GET_ENVELOPE_10FRAMES, OnBackgroundGetEnvelope10frames)
	ON_COMMAND(ID_BACKGROUND_GET_ENVELOPE_5FRAMES, OnBackgroundGetEnvelope5frames)
	ON_COMMAND(ID_BACKGROUND_ADD, OnBackgroundAdd)
	ON_COMMAND(ID_BACKGROUND_GET_AVERAGE_30FRAMES, OnBackgroundGetAverage30frames)
	ON_COMMAND(ID_BACKGROUND_GET_AVERAGE_40FRAMES, OnBackgroundGetAverage40frames)
	ON_COMMAND(ID_BACKGROUND_GET_AVERAGE_50FRAMES, OnBackgroundGetAverage50frames)
	ON_COMMAND(ID_BACKGROUND_GET_AVERAGE_20FRAMES, OnBackgroundGetAverage20frames)
	ON_COMMAND(ID_BACKGROUND_GET_ENVELOPE_20FRAMES, OnBackgroundGetEnvelope20frames)
	ON_COMMAND(ID_BACKGROUND_GET_ENVELOPE_30FRAMES, OnBackgroundGetEnvelope30frames)
	ON_COMMAND(ID_BACKGROUND_GET_ENVELOPE_40FRAMES, OnBackgroundGetEnvelope40frames)
	ON_COMMAND(ID_BACKGROUND_GET_ENVELOPE_50FRAMES, OnBackgroundGetEnvelope50frames)
	ON_COMMAND(ID_APPLICATION_PRINT, OnApplicationPrint)
	ON_COMMAND(ID_APPLICATION_PRINTWHOLEWINDOW, OnApplicationPrintwholewindow)
	ON_BN_CLICKED(IDC_BUTTON4_DAQDISCARD, OnDaqdiscard)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(ID_HELP_QUICKREFERENCE, OnHelpQuickreference)
	ON_COMMAND(ID_APPLICATION_COLORMODE_MATLABFALSECOLOR, OnApplicationColormodeMatlabfalsecolor)
	ON_COMMAND(ID_BACKGROUND_GET_AVERAGE_100FRAMES, OnBackgroundGetAverage100frames)
	ON_COMMAND(ID_BACKGROUND_GET_AVERAGE_200FRAMES, OnBackgroundGetAverage200frames)
	ON_COMMAND(ID_BACKGROUND_GET_ENVELOPE_100FRAMES, OnBackgroundGetEnvelope100frames)
	ON_COMMAND(ID_BACKGROUND_GET_ENVELOPE_200FRAMES, OnBackgroundGetEnvelope200frames)
	ON_COMMAND(ID_IMAGE_GRAB_100FRAMES, OnImageGrab100frames)
	ON_COMMAND(ID_IMAGE_GRAB_200FRAMES, OnImageGrab200frames)
	ON_COMMAND(ID_APPLICATION_NORMALISATION, OnApplicationNormalisation)
	ON_COMMAND(ID_APPLICATION_AREAOFINTEREST_RECTANGULAR, OnApplicationAreaofinterestRectangular)
	ON_COMMAND(ID_APPLICATION_AREAOFINTEREST_CIRCULAR, OnApplicationAreaofinterestCircular)
	ON_COMMAND(ID_IMAGE_GRABANDSAVE_100FRAMES, OnImageGrabandsave100frames)
	ON_COMMAND(ID_IMAGE_GRABANDSAVE_10FRAMES, OnImageGrabandsave10frames)
	ON_COMMAND(ID_IMAGE_GRABANDSAVE_15FRAMES, OnImageGrabandsave15frames)
	ON_COMMAND(ID_IMAGE_GRABANDSAVE_20FRAMES, OnImageGrabandsave20frames)
	ON_COMMAND(ID_IMAGE_GRABANDSAVE_30FRAMES, OnImageGrabandsave30frames)
	ON_COMMAND(ID_IMAGE_GRABANDSAVE_40FRAMES, OnImageGrabandsave40frames)
	ON_COMMAND(ID_IMAGE_GRABANDSAVE_50FRAMES, OnImageGrabandsave50frames)
	ON_COMMAND(ID_APPLICATION_STATISTICSMODE_STREAKCAMERA, OnApplicationStatisticsmodeStreakcamera)
	ON_COMMAND(ID_APPLICATION_KEEPASPECTRATIO, OnApplicationKeepaspectratio)
	ON_BN_CLICKED(IDC_BUTTON3, OnDAQStart)
	ON_BN_CLICKED(IDC_BUTTON4_SWITCHCAM, OnButton4Switchcam)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideoclntDlg Nachrichten-Handler


/////////////////////////////////////////////////////////////////////////////
//
// The OnInitDialog function is called when the WM_INITDIALOG message is received by the
// message queue. It is called after the class is instantiated and before the dialog is shown.
// 
// This function is mostly used for initialization of some members of this class.
//

BOOL CVideoclntDlg::OnInitDialog()
{
	CInformationDialog dlg;
	CString errormessage;
	BOOL retmem = TRUE;
	BOOL ret3, ret4, ret5, ret6, ret7, ret8, ret9, ret10;
	char *oneblackframe;
	BOOL bTineEnabled;
	//DWORD act_port;
	CServer srv;
	CString tmp;

	dlg.Show("Starting up Video Client 2...");

	s_pScreenFirst = NULL;
	CDialog::OnInitDialog();

    // attach symbol tso dialog
	SetIcon(m_hIcon, TRUE);			// big symbol
	SetIcon(m_hIcon, FALSE);		// small symbol
	
	ghDlg = m_hWnd; // global variable (needed for keyboard shortcuts)

	m_pColorTable = NULL;
	// SW! Jnue 29, 2006
	//
	// as the executable directory is used as a reference to find config and/or program files, it is
	// read out (found out) here and will be stored in a variable for subsequent access

	// find path to executed program	
	CString tmpFilePath=__argv[0];
	int nPlace=tmpFilePath.ReverseFind('\\');
    
	if (nPlace!=-1)
	{
		m_sExecutableDirectory = tmpFilePath.Left(nPlace);
	}
	else
	{
		char curDir[MAX_PATH];
		GetCurrentDirectory(MAX_PATH,curDir);
		m_sExecutableDirectory = curDir;
	}

	m_nFlashTimer = 0;
    m_nShowType = SIZE_RESTORED;

	// no message window per default
	m_wndMessages = NULL;
	m_bMessagesWindowOpen = FALSE;
	m_bTransferRunning = FALSE;
	m_bKeepAspectRatio = FALSE;

	// variables needed to set up tine data transfer
	SAFEARRAY *psa;
	SAFEARRAYBOUND rgsabound[1];

	// initialize a safe array width the maximum size of a 
	// camera id string
	rgsabound[0].lLbound = 0;
	rgsabound[0].cElements = 48;

	if ((psa=SafeArrayCreate(VT_I1,1,rgsabound)) == NULL)
	{
		OwnMessageBox(MB_ICONSTOP, "Memory allocation failed.");
		CDialog::OnCancel();
	}

	// initialize tine data block variant
	VariantInit( &m_vNewCameraID );
	V_VT( &m_vNewCameraID ) = VT_I1 | VT_ARRAY;
	V_ARRAY( &m_vNewCameraID ) = psa;
	m_pTineData = (char *) psa->pvData;
    m_sNewCameraID = "";

	m_fpDAQFile = NULL;

	m_iActualServerPos = -1;
	m_bPollMode = FALSE; // poll mode is off when starting application

    m_pLastFrame = NULL; // lastframe is empty
	m_bDAQRunning = FALSE; // DAQ off by default
	
	m_bXProjectionOn = TRUE;
	m_bYProjectionOn = TRUE;
	m_iFalseColor = 1; // grayscale mode

	CheckMenuItem(ID_APPLICATION_COLORMODE_FALSECOLOR, TRUE);
	CheckMenuItem(ID_APPLICATION_COLORMODE_GRAYSCALE, FALSE);
	CheckMenuItem(ID_APPLICATION_COLORMODE_MATLABFALSECOLOR, FALSE);
    CheckMenuItem(ID_APPLICATION_PROJECTIONMODE_OFF, FALSE);
    CheckMenuItem(ID_APPLICATION_PROJECTIONMODE_XPROJECTION, TRUE);
    CheckMenuItem(ID_APPLICATION_PROJECTIONMODE_YPROJECTION, TRUE);

	//m_hDrawDib = NULL; // no drawdib object at initialization
	m_bXRayFiltering = FALSE; // no x-ray filtering per default
    //m_nTimer = 0;

	m_pImageSequence = NULL;
	m_grab_queue = NULL;
	m_pBackground = NULL;
	m_pNormalizedImage = NULL;
	m_pIniFileProf = NULL;
	m_pTineALDlg = NULL;
	
	m_pIniFileExeGlobal = NULL;
	m_pIniFileExeLocal = NULL;

	m_pImageAcquire = NULL;
    m_pCATineDlg = NULL;
    m_pDecompressedFrame = NULL;
	m_pImageSequence = NULL;
	
	// initialize camera combo box 
	m_CComboCamera.EnableWindow(FALSE);
	m_CButtonDaqdiscard.EnableWindow(FALSE);
    m_DAQ.EnableWindow(FALSE);
	m_bComboBoxBlocked = FALSE;
	m_bTineALInitialized = FALSE;

    m_pGSImageSequence = NULL;
    m_pGSBackgroundSequence = NULL;

	// no palette change is in progress
    m_bPaletteChangeInProgress = FALSE; 

	// no video queue
	m_video_queue = NULL;
	
	// no statistical classes per default
	m_pStatFile = NULL;

	// no rectangle select at the moment
	m_bMakeRectangle = FALSE;

    // no normalization when starting up
	m_bNormalization = FALSE;

    m_bCircularAOI = FALSE;
    CheckMenuItem(ID_APPLICATION_AREAOFINTEREST_CIRCULAR, FALSE);
    CheckMenuItem(ID_APPLICATION_AREAOFINTEREST_RECTANGULAR, TRUE);

	// initialize points needed for selecing area of interest
	m_CPointLast.x = 0;
	m_CPointLast.y = 0;

	m_CPointCross.x = 0;
    m_CPointCross.y = 0;

	// attach main dialog to video frame class (needed for callback)
	m_CMyVideoFrame.SetMainDlg(this);

	// initialze frames polled counter to zero
	m_CEditFramesPolled.SetWindowText("0");

    ret3 = InitializeIniFiles(); // reads in additional properties, too.
	if (ret3 == FALSE) CCERR("");

    ret6 = InitializeServerConnections();
	// put new title bar string to indicate on which server we are operating

    // get server name from ini file and set up TINE properties
    m_ServerList.getServer( m_iActualServerPos, srv );

    SetCaption( "Video Client 2 - empty image", "", "" );
	m_pIniFileExeLocal->SetValue("MAIN", "DefaultServer", srv.getNickname() );

	// set default area of interest to whole picture
	m_newAOI.SetRect(0,0, m_iActualWidth-1, m_iActualHeight-1 );

	m_iAnalyzeMode = 2; /* straightforward statistics on */
	UpdateStatisticsMode( m_iAnalyzeMode );

    m_pCATineDlg = new CCATineDlg();
	if (m_pCATineDlg != NULL)
	{
     ret9 = m_pCATineDlg->Create(IDD_DIALOG2_CATINE, GetDesktopWindow() );
	}
	 else ret9 = FALSE;
    if (ret9 == FALSE) CCERR("Could not initialize TINE for reading out properties. Program must quit.");

	ret10 = TRUE;
	ret8 = InitializeDAQFunction();

    if (ret8 == FALSE) CCERR("Could not create control system access class.\nThis is a severe error. Program must quit.");

    m_pImageSequence = new CImageSequence( m_pCATineDlg, m_bTineALInitialized, m_pTineALDlg, this );
	if (m_pImageSequence == NULL) retmem = FALSE;
    
	// allocate memory location needed for decompressed frame 
	m_pDecompressedFrame = (char *) memman.sw_malloc( m_iActualWidth*m_iActualHeight*m_iActualBpp/8 );
	if (m_pDecompressedFrame == NULL) retmem = FALSE;

	// allocate and clear memory location needed for background
	m_pBackground = (char *) memman.sw_malloc( m_iActualWidth*m_iActualHeight*m_iActualBpp/8 );
    if (m_pBackground == NULL) retmem = FALSE;
	if (retmem == TRUE) memset((void *) m_pBackground, 0, m_iActualWidth*m_iActualHeight*m_iActualBpp/8 );

	// allocate and clear memory for last frame buffer
	m_pLastFrame = (char *) memman.sw_malloc( (m_iActualWidth*m_iActualHeight*m_iActualBpp)/8 ); 
    if (m_pLastFrame == NULL) retmem = FALSE;
	if (retmem == TRUE) memset((void *) m_pLastFrame, 0, (m_iActualWidth*m_iActualHeight*m_iActualBpp)/8 );

	// allocate and clear memory for normalized image buffer
	m_pNormalizedImage = (char *) memman.sw_malloc( (m_iActualWidth*m_iActualHeight*m_iActualBpp)/8 );
    if (m_pNormalizedImage == NULL) retmem = FALSE;
	if (retmem == TRUE) memset((void *) m_pNormalizedImage, 0, (m_iActualWidth*m_iActualHeight*m_iActualBpp)/8 );

    oneblackframe = (char *) memman.sw_malloc( (m_iActualWidth*m_iActualHeight*m_iActualBpp/8)+sizeof(VIDHDR) );
	if (oneblackframe == NULL) retmem = FALSE;
	if (retmem == TRUE) memset( (void *) oneblackframe, 0, (m_iActualWidth*m_iActualHeight*m_iActualBpp/8)+sizeof(VIDHDR) );

	if (retmem == FALSE) CCERR("Out of memory.\nThis is a severe error. Program must quit.");

	// put in a default video header inside the grab buffer
	VIDHDR vidH;
	vidH.cameraport = -2;
	vidH.widthframe = m_iActualWidth;
	vidH.heightframe = m_iActualHeight;
	vidH.bpp = m_iActualBpp;
	vidH.bpp_effective = m_iActualBppEffective;
	vidH.scale = DEFAULT_SCALE_FACTOR;
    memman.memcpysw((char *) oneblackframe, (char *) &vidH, sizeof(VIDHDR));
    m_pImageSequence->Add( (unsigned char *) oneblackframe );

	{
		CString Snapshotdir = m_pIniFileProf->GetValue("MAIN", "SnapshotDir", "h:\\");
		int retvalchkdir = CheckDirectory(Snapshotdir);
	
		if ( retvalchkdir != 1)
		{
			// are all non-fatal
			CString message;

			if (retvalchkdir == -1)
			{
				OwnMessageBox(MB_ICONINFORMATION, "Snapshot directory does not exist. Taking snapshots ('Snap') will generate an error !");
			}
			else if (retvalchkdir == -2)
			{
				OwnMessageBox(MB_ICONINFORMATION, "Snapshot directory is not writable. Taking snapshots ('Snap') will generate an error !");
			}
			else
			{
				PrintServerMessage("Unknown error in CheckDirectory() when checking Snapshotdir on startup.");
			}
		}
	}

	// initialize (de-)compression class
	ret4 = InitializeCompression( m_iActualWidth, m_iActualHeight, m_iActualBpp );
    if (ret4 != TRUE) CCERR("Could not initialize decompression class.\nThis is a severe error. Program must quit.");

	// initialize drawing objects so that the video and the projection can be drawed
	ret5 = InitializeDrawing(m_iFalseColor);  
	ret7 = FALSE;
	if (ret5 == TRUE) 
	{
		m_bStayOnTop = TRUE; // will be set to false by next line (single call to OnApplicationStayontop
		OnApplicationStayontop(); // initialize application so that it does not stay on top

		CString tine_poll = m_pIniFileExeLocal->GetValue("MAIN", "TinePollMode", "POLL.NETWORK");
		CString tine_enab = m_pIniFileExeLocal->GetValue("MAIN", "TineFramesEnabled", "TRUE");

		bTineEnabled = FALSE;
		if (tine_enab == "TRUE") bTineEnabled = TRUE;

		m_pImageAcquire = new CImageAcquire( m_pIniFileExeGlobal, m_pCATineDlg );
		if (m_pImageAcquire != NULL)
		{
			ret7 = m_pImageAcquire->Init( bTineEnabled, tine_poll ); // TRUE = try to use tine
		}
		if (ret7 == FALSE) CCERR("Failed to initialize Image Acquire class ! Program must quit.");
    }

    // quit application if it could not be initialized properly
	if (retmem == FALSE || ret4 == FALSE || ret5 == FALSE || ret6 == FALSE || ret7 == FALSE || ret8 == FALSE || ret9 == FALSE || ret10 == FALSE) CCERR("");

	dlg.Hide();

	// print ready on status line
    PrintServerMessage("Ready");

	return TRUE;  

err:
	dlg.Hide();

	if (errormessage != "")
	{
		OwnMessageBox( MB_ICONEXCLAMATION, errormessage );
	}
	
    OnApplicationQuit();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
//
// The OnPaint function is generated by Visual C++. It is called automatically.
//
void CVideoclntDlg::OnPaint() 
{
	Screen *pScreen;
	HRESULT hres;

	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
        for (pScreen = s_pScreenFirst; pScreen != NULL; pScreen = pScreen->pScreenNext)
        {
           // Handle lost surfaces
           if (pScreen->pddsFront->IsLost() == DDERR_SURFACELOST)
           {
               hres = pScreen->pdd->RestoreAllSurfaces();
           }

        
	       DDBLTFX bltfx;
	       memset( &bltfx, 0, sizeof(bltfx) );
	       bltfx.dwSize = sizeof(bltfx);
	        
		   RECT clientArea;
		   RECT button;
		   RECT statusline;
		   RECT rcScreen;
		
		   m_CEditStatusLine.GetWindowRect( &statusline );
		   m_CButtonTopLeft1.GetWindowRect( &button );
		   clientArea.top = button.top;
		   clientArea.left = button.left;
		   clientArea.right = statusline.right;
		   clientArea.bottom = statusline.top-1;

		   int width, height;
 
		   // SW! !!! 15.08.2005
		   //width = clientArea.right - clientArea.left + 1;
		   //height = clientArea.bottom - clientArea.top + 1;
		   // SW! !!! 15.08.2005

		   width = clientArea.right - clientArea.left;
		   height = clientArea.bottom - clientArea.top;

		   if ((width > 0) && (height > 0))
		   {
         
   		     if (RectIntersectsMonitor(&clientArea, pScreen->hmon, &rcScreen))
             {
          	    hres = pScreen->pddsFront->Blt( &rcScreen, pScreen->pddsBack, &rcScreen, DDBLT_WAIT, &bltfx);
		        if (hres == DDERR_SURFACELOST) 
				{ 
					pScreen->pdd->RestoreAllSurfaces(); 
					//PrintServerMessage("SurfaceLost on blit to prim");
				}
				if (hres != DD_OK)
				{
				}
             }
           }
		}

		CDialog::OnPaint();
	}

}

/////////////////////////////////////////////////////////////////////////////
//
// This function is generated by Visual C++. It is called automatically by 
// system calls.
//
HCURSOR CVideoclntDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/////////////////////////////////////////////////////////////////////////////
//
// This function closes the application after properly cleaning up through 
// the QuitApplication() functions. This function is called by either clicking
// on the 'X' in the title bar or by selecing Quit from the menu or by pressing 
// ALT-F4.
//
void CVideoclntDlg::OnCancel()
{
    QuitApplication();

    CDialog::OnCancel();
}

/////////////////////////////////////////////////////////////////////////////
//
// This function prints the parameter message on the status bar. If the message
// window is open, it is also printed there.
//
void CVideoclntDlg::PrintServerMessage(CString message)
{
	// get current time
	CTime time3;  
	time3 = CTime::GetCurrentTime();

	// build a string out of the current time
	CString timestr = time3.Format("%d.%m.%Y %H:%M:%S: ");

	CString local_message;

	local_message = timestr + message;
 
	if (m_bMessagesWindowOpen == TRUE)
	{
		m_wndMessages->PrintServerMessage(local_message);
	}
  
	m_CEditStatusLine.SetWindowText((LPCTSTR) local_message);
	PutToErrorLog(local_message);
	m_CEditStatusLine.UpdateWindow();
}


/////////////////////////////////////////////////////////////////////////////
//
// This function is called by the CVideoclntApp class to tell this class the 
// application pointer. Using this app pointer, the dialog can read/write the
// registry.
//
void CVideoclntDlg::setApp(CVideoclntApp *the_app)
{
 m_pApp = the_app;
}

BEGIN_EVENTSINK_MAP(CVideoclntDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CVideoclntDlg)
	ON_EVENT(CVideoclntDlg, IDC_ACOPCTRL2_POLLCAMUPDATE, 1 /* Receive */, OnReceiveAcopctrl2Pollcamupdate, VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

/////////////////////////////////////////////////////////////////////////////
//
// This function initializes the (de-)compression class. Using this class, 
// the compressed images which come from the socket can be decompressed.
//
BOOL CVideoclntDlg::InitializeCompression(int width, int height, int bpp)
{
  // everything went fine
  return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
//
// This function deinitializes the part of the code that is used for decompression 
// of the compressed frames. Mainly the memory is freed.
//
BOOL CVideoclntDlg::DeinitializeCompression()
{
 // return always true
 return TRUE;
}

///////////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever a new camera port is selected from the 
// combo box. The new port is obtained and sent to the server using tine protocol. 
// The server then changes the camera port to the newly selected value.
//
// When the new camera port is selected succesfully, the background is cleared and 
// the scale control is set to the default value for this camera port.
//
void CVideoclntDlg::OnSelchangeCombo1Camera() 
{
    // obtain the host name of the default server  

	int oldActualServerPos = m_iActualServerPos;

    int pos = m_CComboCamera.GetCurSel();
	m_iActualServerPos = pos+1; 


	CServer srv1;
	m_ServerList.getServer( m_iActualServerPos, srv1 );

    m_pIniFileExeLocal->SetValue("MAIN", "DefaultServer", srv1.getNickname() );

    BOOL waspollon = m_bPollMode;

	if (m_iActualServerPos != oldActualServerPos)
	{
		CleanupServerCheckLink();
	}

    if (waspollon == TRUE)
	{
		StopPollMode();
    }

	/*// SW! Apr 26, 2006 taken out
    SetScaleFromServer( m_iActualServerPos ); // set the proper scale for the new port
    CheckServerSettings( srv1 );
    */

	OnBackgroundClear(); // clear the background when switching (!)

	m_sActualCameraID = srv1.getCamID();
    
	if (m_iActualServerPos != oldActualServerPos)
	{
		CreateServerCheckLink( srv1.getTineContext(), srv1.getTineControlName() );
	}

	// configure for a possible change of the camera name and settings
    UpdateCameraPort(FALSE, FALSE);

    if (waspollon == TRUE)
    {
		StartPollMode();
    }
}


LRESULT CVideoclntDlg::OnSocketErrorGrabbing(WPARAM wParam, LPARAM lParam)
{
 int error = (int) wParam;
 int what = (int) lParam;

 m_pImageAcquire->GrabFramesCleanup();
 SetCaption( "Video Client 2", "", "" );
 
 m_grab_queue->EmptyQueue();
 delete m_grab_queue;
 m_grab_queue = NULL;

 CString msg;
 
 switch( what )
 {
  case 0: msg.Format("Error during grabbing frames. Socket Error.");
          break;
  
  case 1: msg.Format("Error during grabbing frames. Tine error=%d.", error);
          break;

  case 2: msg.Format("Error during grabbing frames. Timeout.");
          break;

  default: break;
 } 

 if (m_iGrabDestination == 5) // GrabAndSave...
 {
   msg = msg + CString("\nThis is a severe error. No images were grabbed and saved.");
   DoCleanupAbortGrabAndSave(msg);
 }
 else
 {
   OwnMessageBox(MB_ICONEXCLAMATION, (LPCTSTR) msg);
 }

 EnableMenusAfterGrab();

 m_bTransferRunning = FALSE;
 
 return( 0 );
}

LRESULT CVideoclntDlg::OnNotifyFrameGrabbed(WPARAM wParam, LPARAM lParam)
{
 int akt = (int) wParam;
 int max = (int) lParam;

 CString msg;
 msg.Format("Got Frame %d out of %d", akt, max);
 PrintServerMessage(msg);

 return( 0 );
}


LRESULT CVideoclntDlg::OnFinishedGrabbing(WPARAM wParam, LPARAM lParam)
{
 m_pImageAcquire->GrabFramesCleanup();
 SetCaption( "Video Client 2", "", "" );

 switch( m_iGrabDestination )
 {
  case 1: GetBackgroundFromServerCallback();
          break;

  case 2: GetBackgroundsFromServerCallback();
          break;

  case 3: GrabFramesFromServerCallback();
          break;

  case 4: AddBackgroundFromServerCallback();
          break;

  case 5: EnableMenusAfterGrab();
          m_bTransferRunning = FALSE;
          GrabAndSaveCallback();
          break;

  default: break;
 }

 if (m_iGrabDestination != 5)
 {
	 m_grab_queue->EmptyQueue();
	 delete m_grab_queue;
  	 m_grab_queue = NULL;
 
	 EnableMenusAfterGrab();

	 m_bTransferRunning = FALSE;
 }
 
 return( 0 );
}

/////////////////////////////////////////////////////////////////////////////
//
// This is a callback function. When something happens to the socket in the
// receive thread (poll mode), a message is posted to the main message queue.
// Through the main message queue, this function is called to deal with the 
// error.
//
LRESULT CVideoclntDlg::OnSocketError(WPARAM wParam, LPARAM lParam)
{
 int sockerr = (int) wParam; // obtain socket error from parameter
 int what = (int) lParam;

 /* CString msg;
 msg.Format("soerr=%d", sockerr);
 PrintServerMessage(msg);
 */
 
 BOOL tmpPoll = m_bPollMode;

 StopPollMode();

 if (tmpPoll == TRUE) // poll mode was on -> set back menu entries
 {
  SetMenuItem(ID_APPLICATION_PRINT, TRUE);
  SetMenuItem(ID_APPLICATION_PRINTWHOLEWINDOW, TRUE );
  SetMenuItem(ID_IMAGE_LOAD, TRUE);
  SetMenuItem(ID_IMAGE_SAVE, TRUE);
  SetMenuItem(ID_IMAGE_ANALYZE, TRUE);
  CheckMenuItem( ID_IMAGE_POLL, FALSE);
  SetMenuItem(ID_BACKGROUND_GRAB, TRUE);
  SetMenuItem(ID_BACKGROUND_SHOW, TRUE);
  SetMenuItem(ID_APPLICATION_OPTIONS, TRUE);
  SetMenuItemByPos(1, 2, TRUE);
  SetMenuItemByPos(1, 3, TRUE);
  SetMenuItemByPos(2, 3, TRUE);
  m_CEditScale.SetReadOnly(FALSE);

 }
 m_bPollMode = FALSE;

 // print warning
 OwnMessageBox(MB_ICONINFORMATION, "Server disconnected ! \n I have reset poll mode.");
 PrintServerMessage("Disconnected from server.");

 CString msg;
 msg.Format("Socketerror=%d what=%d", sockerr, what);
 PrintServerMessage(msg);

 return( 0 );
}

/////////////////////////////////////////////////////////////////////////////
//
// This is a callback function. When a new frame is acquired by the receive 
// thread (poll mode), a message is posted to the main message queue.
// Through the main message queue, this function is called to deal with the 
// new frame.
//
// The function gets any (mostly 1) frame from the frame queue, decompress
// them if necessary, do statistical analysis if necessary, displays the 
// newly arrived frames and updates the dropped frames and the frame number 
// control on the toolbar.
//
LRESULT CVideoclntDlg::OnFrameReceived(WPARAM wParam, LPARAM lParam)
{
 int size;
 unsigned int dropped;

 //double droppedd;

 // if there is no video queue, exit immediately
 if (m_video_queue == NULL) return( 0 ); // for safety

 // how many pictures are in the queue ? 
 size = m_video_queue->GetSize();

 // less than one picture -> exit
 if (size < 1) return( 0 );

 //AcquireAdditionalProperties();

 // loop over all pictures
 for (int i=0;i<size;i++)
 {
   // obtain pointer to picture from queue 
   char *tmpptr = (char *) m_video_queue->RemoveHead();

   if (tmpptr != NULL) // for safety
   {
    VIDHDR vidH;

	// copy the video header part into the vidH variable
    memman.memcpysw( (char *) &vidH, (char *) tmpptr, sizeof(VIDHDR) );

	CImageSequence *imseq = new CImageSequence( m_pCATineDlg, m_bTineALInitialized, m_pTineALDlg, this );
    if (imseq == NULL)
	{
     memman.sw_free( (void *) tmpptr );
	 return 0;
	}

    BOOL ret = imseq->Add( (unsigned char *) tmpptr );
    if (ret == TRUE)
	{
	 delete m_pImageSequence;
	 m_pImageSequence = imseq;
	}


	CheckImageSettings( m_pImageSequence->GetImageWidth(), m_pImageSequence->GetImageHeight(), m_pImageSequence->GetBpp(), m_pImageSequence->GetBppEffective());

	if (m_bDAQRunning) m_pImageSequence->AcquireDoocsProperties();

    SetScaleFactorInGUI( m_pImageSequence->GetScale() );

	// SW! Apr 26, 2006 shouldn't it be enough to update this on server change ? 
    //CServer srv5;
    //m_ServerList.getServer( m_iActualServerPos, srv5 );
    //CString tmp = srv5.getNickname();
    //SetCaption( "Video Client 2 on", "", tmp );

    // initialize proper analyse class (empty, straightforward, fourier)	
	MakeStatFile( m_pImageSequence, m_pNormalizedImage, m_bXRayFiltering);
	
	// do statistical analysis, subtract background, normalize image etc.
	if (m_pStatFile != NULL) m_pStatFile->START();

    // update the statistical variables
	UpdateStatisticalValues();

	// display the normalized image
	DisplayFunction( m_pNormalizedImage, vidH.cameraport, FALSE);

	// calculate dopped and polled frames and put in GUI

	if (((int)vidH.frameno) <= m_iFirstFrame) m_iFirstFrame = -1;

	// update variables
    m_iCountedFrames++;
    if (m_iFirstFrame == -1) { m_iFirstFrame = vidH.frameno; m_iCountedFrames = 1;}
 
	// calculate dropped frames 
    dropped = (vidH.frameno - m_iFirstFrame) - m_iCountedFrames+1;
    //droppedd = dropped*1.0 / m_iCountedFrames*1.0;
 
	// print out dropped frames on the control
    
	CString msg;
    msg.Format("%d", dropped);
	m_CEditDropped.SetWindowText((LPCTSTR) msg);

	//msg.Format("%d", vidH.frameno);
	//m_CEditFrameNo.SetWindowText((LPCTSTR) msg);

	// print out counted frames on the control
    msg.Format("%d", m_iCountedFrames);
	m_CEditFramesPolled.SetWindowText((LPCTSTR) msg);




   }
 }
 return( 0 );
}


/////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the Closeup-Message is posted. It is needed
// to let the User switch the camera port properly when using the keyboard.
// If the variable m_bComboBoxBlocked is set to true, the user does something using
// the keyboard on the camera port combo box. It indicates that the selected item
// of the combo box should not change as long as the user is selecting it using 
// the keyboard.
//
void CVideoclntDlg::OnCloseupCombo1Camera() 
{
	m_bComboBoxBlocked = FALSE;
}

/////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the Dropdown-Message is posted. It is needed
// to let the User switch the camera port properly when using the keyboard.
// If the variable m_bComboBoxBlocked is set to true, the user does something using
// the keyboard on the camera port combo box. It indicates that the selected item
// of the combo box should not change as long as the user is selecting it using 
// the keyboard.
// CComboBox
void CVideoclntDlg::OnDropdownCombo1Camera() 
{
	m_bComboBoxBlocked = TRUE;
    //PrintServerMessage("Downloading new camera names...");
	UpdateCameraPort(FALSE, TRUE);
}

/////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the Selendcancel-Message is posted. It is needed
// to let the User switch the camera port properly when using the keyboard.
// If the variable m_bComboBoxBlocked is set to true, the user does something using
// the keyboard on the camera port combo box. It indicates that the selected item
// of the combo box should not change as long as the user is selecting it using 
// the keyboard.
//
void CVideoclntDlg::OnSelendcancelCombo1Camera() 
{
    m_bComboBoxBlocked = FALSE;
}

/////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the Selendok-Message is posted. It is needed
// to let the User switch the camera port properly when using the keyboard.
// If the variable m_bComboBoxBlocked is set to true, the user does something using
// the keyboard on the camera port combo box. It indicates that the selected item
// of the combo box should not change as long as the user is selecting it using 
// the keyboard.
//
void CVideoclntDlg::OnSelendokCombo1Camera() 
{
	m_bComboBoxBlocked = FALSE;
}


///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the WM_SIZE message is posted. It is needed
// for proper redrawing and rearranging the main dialog window whenever the user
// resizes it. The parameters come directly from the message. 
//
void CVideoclntDlg::OnSize(UINT nType, int cx, int cy) 
{
    CDialog::OnSize(nType, cx, cy); // call base class

	// drawing is not yet initialized, then go immediately out here
	if (m_bDrawingInitialized == FALSE) return;

	RECT r;

	GetClientRect( &r );

	//CString msg;
	//msg.Format("ntype=%d, cx=%d, cy=%d, max=%d, min=%d rest=%d, Rleft=%d, Rright=%d, Rtop=%d, Rbottom=%d", nType, cx, cy, SIZE_MAXIMIZED, SIZE_MINIMIZED, SIZE_RESTORED, r.left, r.right, r.top, r.bottom);
    //PrintServerMessage(msg);

    m_nShowType = nType;

    //if (nType == SIZE_MAXIMIZED) Debug
	//{
	// int akdglasgd = 1;
	//}

	// indicate that other functions should not draw at the moment
	m_bDrawingInitialized = FALSE;

	RECT clientArea, videoArea, statusArea, projectionxArea, projectionyArea;

	// obtain client area coordinates and transform them to screen coordinates
    this->GetClientRect( &clientArea);
    this->ClientToScreen( &clientArea );

	// adjust the client area
	clientArea.right = clientArea.left + cx;
	clientArea.bottom = clientArea.top + cy;

	// do proper adjustment to the new size, modify positions of all elements that reside in the client area
    AdjustClientArea( &clientArea, &projectionxArea, &projectionyArea, &videoArea, &statusArea, m_bXProjectionOn, m_bYProjectionOn, m_bKeepAspectRatio);

	// transform screen coordinates back to client-relative coordinates
    this->ScreenToClient( &videoArea );
    this->ScreenToClient( &statusArea );
	this->ScreenToClient( &projectionxArea );
	this->ScreenToClient( &projectionyArea );

	// move the controls that are attached to the main dialog window
    m_CMyVideoFrame.MoveWindow( videoArea.left, videoArea.top, videoArea.right - videoArea.left + 1, videoArea.bottom - videoArea.top + 1, TRUE);
    m_CEditStatusLine.MoveWindow( statusArea.left, statusArea.top, statusArea.right - statusArea.left + 1, statusArea.bottom - statusArea.top + 1, TRUE);
	m_CFrameProjection.MoveWindow( projectionxArea.left, projectionxArea.top, projectionxArea.right - projectionxArea.left + 1, projectionxArea.bottom - projectionxArea.top + 1, TRUE);
	m_CFrameYProjection.MoveWindow( projectionyArea.left, projectionyArea.top, projectionyArea.right - projectionyArea.left + 1, projectionyArea.bottom - projectionyArea.top + 1, TRUE);

	// calculate new video window size
    m_VideoWindowWidth = videoArea.right - videoArea.left + 1;
    m_VideoWindowHeight = videoArea.bottom - videoArea.top + 1;

	// for safety set virtual mouse coordinates to upper left corner of the video window
	m_CPointCross.x = 1;
    m_CPointCross.y = 1;

	// drawing is up again
	m_bDrawingInitialized = TRUE;

	// cal displayfunction to display the last frame
	DisplayFunction(0, 0, TRUE);

	// call OnPaint function to redraw the rest of the dialog window
	OnPaint();
}

void CVideoclntDlg::OnSize()
{
 RECT r;

 GetClientRect( &r ); 

 UINT nType = SIZE_RESTORED;
 
 LPARAM p;

 p = (((r.bottom-r.top)<<16)&0xffff0000) + ((r.right-r.left)&0xffff);

 if (IsIconic() == TRUE) nType = SIZE_MINIMIZED;
 if (IsZoomed() == TRUE) nType = SIZE_MAXIMIZED;

 PostMessage( WM_SIZE, (LPARAM) nType, p);

 //CString msg;
 //msg.Format("ONS() ntype=%d, cx=%d, cy=%d, max=%d, min=%d rest=%d, Rleft=%d, Rright=%d, Rtop=%d, Rbottom=%d", nType, r.right-r.left, r.bottom-r.top, SIZE_MAXIMIZED, SIZE_MINIMIZED, SIZE_RESTORED, r.left, r.right, r.top, r.bottom);
 //PrintServerMessage(msg);

 //OnSize( nType, r.right-r.left, );
 
}

///////////////////////////////////////////////////////////////////////////////
//
// This is a helper function for OnSize. It recalculates size and position of the
// frames and controls inside the client area according to the new size of the 
// dialog frame. The last parameter is an input parameter. The first parameter 
// is an In/Out parameter. ProjectionArea, videoArea and statusArea are output 
// parameters. All RECT parameters are in screen-coordinates. To make resizing 
// even simpler I have added a hidden button on the dialog window. It marks the 
// first available position where the projection or video frame (if there is no 
// projection) can be moved to.
//
BOOL CVideoclntDlg::AdjustClientArea( RECT *clientArea, RECT *projectionxArea, RECT *projectionyArea, RECT *videoArea, RECT *statusArea, BOOL proj_x, BOOL proj_y, BOOL keepaspectratio /*int projectionmode */)
{
 // all Areas are in screen(!) coordinates

 // obtain hidden button coordinates
 RECT buttonArea;
 GetDlgItem(IDC_BUTTON_HIDDEN)->GetWindowRect(&buttonArea); 

 clientArea->top = buttonArea.top;

 int clientheight = clientArea->bottom - clientArea->top + 1;

 // client area height without height of the status bar
 int clientheightwostatusbar = clientheight-22;
 int clientwidth = clientArea->right - clientArea->left + 1;

 int projectionxheight = 0;
 int projectionywidth = 0;

 if (proj_x == TRUE) // x-projection activated ? 
 {
	 // make the projection height at least 1/8 of the height of the client area 
	 // without the status bar plus 15 pixels
	 projectionxheight = (clientheightwostatusbar / 8) + 15;
 }

 if (proj_y == TRUE)
 {
    projectionywidth = (int) ((1.0*clientwidth) / 7.5);
 }

 // make video height to height of full client area minus status bar height
 int videoheight = clientheightwostatusbar-6;
 int videowidth = clientwidth-6;

 if (proj_x == TRUE ) // projection activated ? 
 {
	 // subtract the projectionheight from the video height
	 videoheight -= projectionxheight;
 }
 
 if (proj_y == TRUE)
 {
    videowidth -= projectionywidth;
 }

 // update videowidth und videoheight based on aspect ratio if needed

 int origh = videoheight;
 int origw = videowidth;


 if (keepaspectratio == TRUE)
 {
    double whratiovideo = 1.0;
	if (videoheight != 0) whratiovideo = ((double)m_iActualWidth)/((double)m_iActualHeight);

	double whratioclient = ((double)clientwidth)/((double)clientheight);

here:
	videoheight = (int) (((double)videowidth)/whratiovideo);
	if (videoheight > origh) { videowidth--; goto here; }
 }

 // write output parameters

 // adjust projection area
 projectionxArea->top = clientArea->top + 3;
 projectionxArea->bottom = clientArea->top + 3 + projectionxheight - 3;
 projectionxArea->left = clientArea->left + 3 + projectionywidth; 
 projectionxArea->right = projectionxArea->left + videowidth - 3;

 projectionyArea->top = clientArea->top + 3 + projectionxheight;
 projectionyArea->bottom = projectionyArea->top+videoheight - 5;
 projectionyArea->left = clientArea->left + 3;
 projectionyArea->right = clientArea->left + projectionywidth - 3;

 // adjust video area
 videoArea->top = clientArea->top + 3 + projectionxheight;
 videoArea->bottom = videoArea->top + videoheight - 5;
 videoArea->left = clientArea->left+ 3 + projectionywidth;
 videoArea->right = videoArea->left + videowidth - 3;

 // adjust status bar area
 statusArea->top = clientArea->bottom - 25;
 statusArea->bottom = statusArea->top + 21;
 statusArea->left = clientArea->left+3;
 statusArea->right = clientArea->right-3;

 return TRUE; // successful
}

DWORD GetNumberOfBits( DWORD dwMask )
{
    DWORD dwBits = 0;
    while( dwMask )
    {
        dwMask = dwMask & ( dwMask - 1 );  
        dwBits++;
    }
    return dwBits;
}

DWORD GetBitPos( DWORD dwMask )
{
    DWORD dwBits = 0;
    while( dwMask )
    {
	    if (dwMask & 1) break;
        dwMask >>= 1;  
        dwBits++;
    }
    return dwBits;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

//static HRESULT EnumerateScreens( VOID );
static BOOL WINAPI DDEnumCallback( GUID* pGuid, LPTSTR pszDesc, LPTSTR pszDriverName, VOID* pContext );
static BOOL WINAPI DDEnumCallbackEx( GUID* pGuid, LPTSTR pszDesc, LPTSTR pszDriverName, VOID* pContext, HMONITOR hmon );

//-----------------------------------------------------------------------------
// Name: EnumerateScreens()
// Desc: Creates a Screen structure for every appropriate screen in the user's
//       computer.  This function is written in such a way that it will work on
//       systems that do not necessarily have DX6 (and thus DirectDrawEnumerateEx)
//       installed.  If your application has already ensured that DX6 is present,
//       you won't need to handle calling DirectDrawEnumerate and providing a
//       DDEnumCallback function.  If your application has already ensured that
//       DX7 is present, you don't even need to use LoadLibrary and 
//       GetProcAddress.  Just call DirectDrawEnumerateEx directly.
//
//-----------------------------------------------------------------------------
HRESULT CVideoclntDlg::EnumerateScreens( VOID )
{
    HRESULT hr;
    HMODULE hModule = NULL;
    LPDIRECTDRAWENUMERATEEX pDDEnumEx = NULL;
    EnumInfo enumInfo;

    ZeroMemory(&enumInfo, sizeof(enumInfo));

    hModule = LoadLibrary( TEXT("ddraw.dll") );
    // If ddraw.dll doesn't exist in the search path,
    // then DirectX probably isn't installed, so fail.
    if (hModule == NULL)
        return E_FAIL;
    
    pDDEnumEx = (LPDIRECTDRAWENUMERATEEX) GetProcAddress(hModule, 
#ifdef UNICODE
        "DirectDrawEnumerateExW"
#else
        "DirectDrawEnumerateExA"
#endif
        );

    if (pDDEnumEx == NULL)
    {
        // We must be running on an old version of DirectDraw.
        // Therefore MultiMon isn't supported. Fall back on
        // DirectDrawEnumerate to enumerate standard devices on a 
        // single-monitor system.
        enumInfo.bMultimonSupported = FALSE;
		enumInfo.dlg = (void *) this;
        hr = DirectDrawEnumerate(DDEnumCallback, &enumInfo);
    }
    else
    {
        enumInfo.bMultimonSupported = TRUE;
		enumInfo.dlg = (void *) this;
        hr = pDDEnumEx(DDEnumCallbackEx, &enumInfo, DDENUM_ATTACHEDSECONDARYDEVICES);
    }

    // If something failed inside the enumeration, be sure to return that HRESULT
    if (SUCCEEDED(hr) && FAILED(enumInfo.hr))
        hr = enumInfo.hr;

    FreeLibrary(hModule);
    return hr;
}


//-----------------------------------------------------------------------------
// Name: DDEnumCallback()
// Desc: This callback function is called by DirectDrawEnumerate when 
//       DirectDrawEnumerateEx is not available.  It simply calls 
//       DDEnumCallbackEx.
//-----------------------------------------------------------------------------
BOOL WINAPI DDEnumCallback( GUID* pGuid, LPTSTR pszDesc, LPTSTR pszDriverName, 
                            VOID* pContext )
{
    DDEnumCallbackEx(pGuid, pszDesc, pszDriverName, pContext, NULL);
    return FALSE; // Stop enumerating -- For this sample, we don't want any non-display devices
}


//-----------------------------------------------------------------------------
// Name: DDEnumCallbackEx()
// Desc: This callback function is called by DirectDraw once for each 
//       available DirectDraw device.  In this implementation, it saves the
//       GUID, device description, and hmon in a Screen structure for later use.
//-----------------------------------------------------------------------------
BOOL WINAPI DDEnumCallbackEx( GUID* pGuid, LPTSTR pszDesc, LPTSTR pszDriverName,
                              VOID* pContext, HMONITOR hmon )
{
    Screen* pScreenNew;
    EnumInfo* pEnumInfo = (EnumInfo*)pContext;
    GUID guidNull;
    ZeroMemory(&guidNull, sizeof(GUID));

    CVideoclntDlg *dlg = (CVideoclntDlg *) pEnumInfo->dlg;

    if (dlg->s_pScreenFirst != NULL && dlg->s_pScreenFirst->guid == guidNull)
    {
        // We must be running on a multimon system, so get rid of the 
        // guidNull Screen -- we want Screens with specific GUIDs.
        delete dlg->s_pScreenFirst;
        dlg->s_pScreenFirst = NULL;
    }

    // Store all the info in a Screen structure
    pScreenNew = new Screen;
    if (pScreenNew == NULL)
    {
        pEnumInfo->hr = E_OUTOFMEMORY;
        return FALSE; // fatal error, stop enumerating
    }
    ZeroMemory(pScreenNew, sizeof(Screen));
    if (pGuid == NULL)
        pScreenNew->guid = guidNull;
    else
        pScreenNew->guid = *pGuid;
    lstrcpy(pScreenNew->szDesc, pszDesc);
    pScreenNew->hmon = hmon;

    // Insert Screen into global linked list
    if (dlg->s_pScreenFirst == NULL)
        dlg->s_pScreenFirst = pScreenNew;
    else
    {
        // Insert at end of list
        Screen* pScreen = dlg->s_pScreenFirst; 
        while (pScreen->pScreenNext != NULL)
            pScreen = pScreen->pScreenNext;
        pScreen->pScreenNext = pScreenNew;
    }

    return TRUE; // Keep enumerating
}

//-----------------------------------------------------------------------------
// Name: RectIntersectsMonitor()
// Desc: Returns TRUE if prcSrc intersects the monitor hmon, and uses prcScreen
//       to store prcSrc in that monitor's local coordinate system.
//-----------------------------------------------------------------------------
BOOL CVideoclntDlg::RectIntersectsMonitor( RECT* prcSrc, HMONITOR hmon, RECT* prcScreen )
{
    MONITORINFO mi;
    RECT rcIntersection;
    BOOL bIntersects;
    ZeroMemory(&mi, sizeof(mi));
    mi.cbSize = sizeof(mi);
    if (hmon == NULL)
    {
        SetRect(&mi.rcMonitor, 0, 0, GetSystemMetrics(SM_CXSCREEN), 
            GetSystemMetrics(SM_CYSCREEN));
    }
    else
    {
        GetMonitorInfo(hmon, &mi);
    }
    bIntersects = IntersectRect(&rcIntersection, prcSrc, &mi.rcMonitor);
    if (!bIntersects)
        return FALSE;
    *prcScreen = rcIntersection;
	//if (prcScreen->left < mi.rcMonitor.left) prcScreen->left = mi.rcMonitor.left;
	//if (prcScreen->top < mi.rcMonitor.top) prcScreen->top = mi.rcMonitor.top;
    OffsetRect(prcScreen, -mi.rcMonitor.left, -mi.rcMonitor.top); // - - 
    return TRUE;
}


BOOL CVideoclntDlg::RectIntersectsMonitorDEBUG( RECT* prcSrc, HMONITOR hmon, RECT* prcScreen )
{
    MONITORINFO mi;
    RECT rcIntersection;
    BOOL bIntersects;
    ZeroMemory(&mi, sizeof(mi));
    mi.cbSize = sizeof(mi);
    if (hmon == NULL)
    {
        SetRect(&mi.rcMonitor, 0, 0, GetSystemMetrics(SM_CXSCREEN), 
            GetSystemMetrics(SM_CYSCREEN));
    }
    else
    {
        GetMonitorInfo(hmon, &mi);
    }
    
	//CString msg;
	//msg.Format("hmon=%x src l=%d t=%d r=%d b=%d\n", hmon, prcSrc->left, prcSrc->top, prcSrc->right, prcSrc->bottom );
	//PrintServerMessage(msg);

	//msg.Format("hmon=%x mon l=%d t=%d r=%d b=%d\n", hmon, mi.rcMonitor.left, mi.rcMonitor.top, mi.rcMonitor.right, mi.rcMonitor.bottom );
	//PrintServerMessage(msg);
	
	bIntersects = IntersectRect(&rcIntersection, prcSrc, &mi.rcMonitor);
    
	//msg.Format("hmon=%x IS=%d\n", hmon, bIntersects );
    //PrintServerMessage(msg);
	
	if (!bIntersects)
        return FALSE;


    *prcScreen = rcIntersection;
	//if (prcScreen->left < mi.rcMonitor.left) prcScreen->left = mi.rcMonitor.left;
	//if (prcScreen->top < mi.rcMonitor.top) prcScreen->top = mi.rcMonitor.top;
    OffsetRect(prcScreen, -mi.rcMonitor.left, -mi.rcMonitor.top); // - - 
    return TRUE;
}


BOOL CVideoclntDlg::RectIntersectsMonitorWithoutOffset( RECT* prcSrc, HMONITOR hmon, RECT* prcScreen )
{
    MONITORINFO mi;
    RECT rcIntersection;
    BOOL bIntersects;
    ZeroMemory(&mi, sizeof(mi));
    mi.cbSize = sizeof(mi);
    if (hmon == NULL)
    {
        SetRect(&mi.rcMonitor, 0, 0, GetSystemMetrics(SM_CXSCREEN), 
            GetSystemMetrics(SM_CYSCREEN));
    }
    else
    {
        GetMonitorInfo(hmon, &mi);
    }
    bIntersects = IntersectRect(&rcIntersection, prcSrc, &mi.rcMonitor);
    if (!bIntersects)
        return FALSE;
    *prcScreen = rcIntersection;
    return TRUE;
}


///////////////////////////////////////////////////////////////////////////////
//
// This function initializes everything that is needed for proper drawing on the
// client area. It 
// - arranges the frames and controls of the dialog window according to the initial size
// - initializes all objects needed for gdi drawing (video and projections) 
//
BOOL CVideoclntDlg::InitializeDrawing( BOOL falsecolor )
{
 HRESULT ddrval;
 DDSURFACEDESC2			ddsd;
 DDSURFACEDESC2			ddsd2;
 int errorcode;
 CString errormessage;
 CString msg222;
 int iFirstRGBBitCount=-1;

 if (m_bDrawingInitialized == TRUE) return TRUE;
 
 m_bDrawingInitialized = FALSE;

 // wnd has to be initialized
 RECT clientArea, videoArea, statusArea, projectionxArea, projectionyArea;

 // obtain client area dimensions
 this->GetClientRect( &clientArea);
 this->ClientToScreen( &clientArea );

 // adjust frames and controls to the right size
 AdjustClientArea( &clientArea, &projectionxArea, &projectionyArea, &videoArea, &statusArea, m_bXProjectionOn, m_bYProjectionOn, m_bKeepAspectRatio);

 // convert screen to client coordinates (relative to upper left of client area)
 this->ScreenToClient( &videoArea );
 this->ScreenToClient( &statusArea );
 this->ScreenToClient( &projectionxArea );
 this->ScreenToClient( &projectionyArea );

 // resposition the controls and frames
 m_CMyVideoFrame.MoveWindow( videoArea.left, videoArea.top, videoArea.right - videoArea.left + 1, videoArea.bottom - videoArea.top + 1, TRUE);
 m_CEditStatusLine.MoveWindow( statusArea.left, statusArea.top, statusArea.right - statusArea.left + 1, statusArea.bottom - statusArea.top + 1, TRUE);
 m_CFrameProjection.MoveWindow( projectionxArea.left, projectionxArea.top, projectionxArea.right - projectionxArea.left + 1, projectionxArea.bottom - projectionxArea.top + 1, TRUE);
 m_CFrameYProjection.MoveWindow( projectionyArea.left, projectionyArea.top, projectionyArea.right - projectionyArea.left + 1, projectionyArea.bottom - projectionyArea.top + 1, TRUE);
 
 // calculate video window width and height
 m_VideoWindowWidth = videoArea.right - videoArea.left + 1;
 m_VideoWindowHeight = videoArea.bottom - videoArea.top + 1;

 Screen* pScreen2=NULL;
 Screen* pScreenNext2;
 Screen* pScreen1;

 pScreen2 = s_pScreenFirst;

 if (pScreen2 != NULL)
 {
   s_pScreenFirst = NULL;
   while (pScreen2 != NULL)
   {
        pScreenNext2 = pScreen2->pScreenNext;

		if (pScreen2->cat16 != NULL) memman.sw_free( (void *) pScreen2->cat16 );
		if (pScreen2->cat32 != NULL) memman.sw_free( (void *) pScreen2->cat32 );

        if (pScreen2->pddsBack != NULL) pScreen2->pddsBack->Release();
        if (pScreen2->pddsFront != NULL) pScreen2->pddsFront->Release();
        if (pScreen2->pddsDraw != NULL) pScreen2->pddsDraw->Release();
        if (pScreen2->pddClipper != NULL) pScreen2->pddClipper->Release();

        //pScreen1->pdd->RestoreDisplayMode();
        if (pScreen2->pdd != NULL) pScreen2->pdd->SetCooperativeLevel( AfxGetMainWnd()->GetSafeHwnd(), DDSCL_NORMAL);
        if (pScreen2->pdd != NULL) pScreen2->pdd->Release();

        delete pScreen2;
        pScreen2 = pScreenNext2;
   }
 }

 Screen* pScreen;
 GUID* pGuid;
 DWORD dwFlags;
 GUID guidNull;
 ZeroMemory(&guidNull, sizeof(GUID));

 EnumerateScreens();

 for (pScreen = s_pScreenFirst; pScreen != NULL; pScreen = pScreen->pScreenNext)
 {
	    pScreen->m_iBBitPos = 0;
		pScreen->m_iGBitPos = 0;
		pScreen->m_iRBitPos = 0;
		pScreen->m_uiBBitCount = 0;
		pScreen->m_uiBBitMask = 0;
		pScreen->m_uiGBitCount = 0;
		pScreen->m_uiGBitMask = 0;
		pScreen->m_uiRBitCount = 0;
		pScreen->m_uiRBitMask = 0;

		pScreen->m_uiRGBBitCount = 0;
		pScreen->pdd = NULL;
		pScreen->pddClipper = NULL;
		pScreen->pddsBack = NULL;
		pScreen->pddsDraw = NULL;
		pScreen->pddsFront = NULL;
		
		pScreen->cat16 = NULL;
		pScreen->cat32 = NULL;

        if (pScreen->guid == guidNull)
            pGuid = NULL;
        else
            pGuid = &pScreen->guid;
        if (FAILED(ddrval = DirectDrawCreateEx(pGuid, (VOID**)&(pScreen->pdd), IID_IDirectDraw7, NULL)))
        {
            CCERRC(ddrval, "DDCreateEx");
        }

        if (pScreen == s_pScreenFirst)
        {
            dwFlags = DDSCL_SETFOCUSWINDOW;
            if (FAILED(ddrval = pScreen->pdd->SetCooperativeLevel(AfxGetMainWnd()->GetSafeHwnd(), dwFlags)))
                CCERRC(ddrval, "SetCoopLevel11");

            dwFlags = DDSCL_ALLOWREBOOT | DDSCL_NORMAL;
            if (FAILED(ddrval = pScreen->pdd->SetCooperativeLevel(AfxGetMainWnd()->GetSafeHwnd(), dwFlags)))
                CCERRC(ddrval, "SetCoopLevel12");
        }
        else
        {
            dwFlags = DDSCL_ALLOWREBOOT | DDSCL_NORMAL;
			//dwFlags = DDSCL_SETFOCUSWINDOW | DDSCL_CREATEDEVICEWINDOW | DDSCL_ALLOWREBOOT | DDSCL_NORMAL;
            if (FAILED(ddrval = pScreen->pdd->SetCooperativeLevel(AfxGetMainWnd()->GetSafeHwnd(), dwFlags)))
                CCERRC(ddrval, "SetCoopLevel21");
        }
 }

 for (pScreen = s_pScreenFirst; pScreen != NULL; pScreen = pScreen->pScreenNext)
 {
	    ZeroMemory(&ddsd, sizeof(ddsd));
        ddsd.dwSize = sizeof(ddsd);
        ddsd.dwFlags = DDSD_CAPS;
        ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
        if (FAILED(ddrval = pScreen->pdd->CreateSurface(&ddsd, &pScreen->pddsFront, NULL)))
            CCERRC(ddrval, "CreateSurface Frontbuffer");

        ZeroMemory(&ddsd, sizeof(ddsd));
        ddsd.dwSize = sizeof(ddsd);
        if (FAILED(ddrval = pScreen->pddsFront->GetSurfaceDesc(&ddsd))) CCERRC(ddrval, "GetSurfDesc Frontbuffer");

        memset( &ddsd, 0, sizeof(ddsd) );
        ddsd.dwSize = sizeof(ddsd);
        ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
        ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_SYSTEMMEMORY; 

        ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
        pScreen->pddsFront->GetPixelFormat( &ddsd.ddpfPixelFormat );
        if (ddrval != DD_OK) CCERRC(ddrval, "GetPixelFormat(primary) for Backbuffer Surface");

        memset( &ddsd2, 0, sizeof(ddsd2) );
        ddsd2.dwSize = sizeof(ddsd2);
        ddrval = pScreen->pddsFront->GetSurfaceDesc(&ddsd2);
        if (ddrval != DD_OK) CCERRC(ddrval, "GetSurfaceDesc(primary) for Backbuffer");

        ddsd.dwWidth = ddsd2.dwWidth;
        ddsd.dwHeight = ddsd2.dwHeight;

        ddrval = pScreen->pdd->CreateSurface (&ddsd, &pScreen->pddsBack, NULL);
		if (ddrval != DD_OK) CCERRC(ddrval, "CreateBackbufferSurface");

		memset( &ddsd, 0, sizeof(ddsd) );
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
		ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_SYSTEMMEMORY;
		ddsd.dwWidth = m_iActualWidth;
		ddsd.dwHeight = m_iActualHeight;

		ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
		ddrval = pScreen->pddsFront->GetPixelFormat( &ddsd.ddpfPixelFormat );
		if (ddrval != DD_OK) CCERRC(ddrval, "GetPixelFormat(primary) for Video Drawing Surface");

        if (iFirstRGBBitCount == -1) iFirstRGBBitCount = ddsd.ddpfPixelFormat.dwRGBBitCount;

		if (((ddsd.ddpfPixelFormat.dwRGBBitCount != 16) && (ddsd.ddpfPixelFormat.dwRGBBitCount != 32)) || (ddsd.ddpfPixelFormat.dwRGBBitCount != (unsigned) iFirstRGBBitCount)) CCERRC(ddsd.ddpfPixelFormat.dwRGBBitCount, "Bits per pixel setting on screen is not supported.");

        m_iFirstRGBBitCount = iFirstRGBBitCount;

		//pScreen->destadd = ddsd.lPitch;

		pScreen->m_uiRGBBitCount = ddsd.ddpfPixelFormat.dwRGBBitCount;
		pScreen->m_uiRBitMask = ddsd.ddpfPixelFormat.dwRBitMask;
		pScreen->m_uiGBitMask = ddsd.ddpfPixelFormat.dwGBitMask;
		pScreen->m_uiBBitMask = ddsd.ddpfPixelFormat.dwBBitMask;

		pScreen->m_uiRBitCount = GetNumberOfBits( ddsd.ddpfPixelFormat.dwRBitMask );
		pScreen->m_uiGBitCount = GetNumberOfBits( ddsd.ddpfPixelFormat.dwGBitMask );
		pScreen->m_uiBBitCount = GetNumberOfBits( ddsd.ddpfPixelFormat.dwBBitMask );

		pScreen->m_iRBitPos = GetBitPos( ddsd.ddpfPixelFormat.dwRBitMask );
		pScreen->m_iGBitPos = GetBitPos( ddsd.ddpfPixelFormat.dwGBitMask );
		pScreen->m_iBBitPos = GetBitPos( ddsd.ddpfPixelFormat.dwBBitMask );

		//msg222.Format(" R %d (%xh) ||| G %d (%xh) ||| B %d (%xh)", ddsd.ddpfPixelFormat.dwRBitMask, ddsd.ddpfPixelFormat.dwRBitMask,ddsd.ddpfPixelFormat.dwGBitMask,ddsd.ddpfPixelFormat.dwGBitMask,ddsd.ddpfPixelFormat.dwBBitMask,ddsd.ddpfPixelFormat.dwBBitMask);
		//AfxMessageBox(msg222, MB_OK | MB_ICONINFORMATION );

        //SetRect(&rc, 0, 0, ddsd2.dwWidth, ddsd2.dwHeight);
        //hrgn = CreateRectRgn(0, 0, ddsd2.dwWidth, ddsd2.dwHeight);
        //GetRegionData(hrgn, sizeof(rgnDataBuffer), (RGNDATA*)rgnDataBuffer);
        if (FAILED(ddrval = pScreen->pdd->CreateClipper(0, &pScreen->pddClipper, 0))) CCERRC(ddrval, "Clipper could not be created.");
        //if (FAILED(hr = pclip->SetClipList((RGNDATA*)rgnDataBuffer, 0)))
        //{
        //    pclip->Release();
        //    return hr;
        //}

	    ddrval = pScreen->pddClipper->SetHWnd( 0, AfxGetMainWnd()->GetSafeHwnd() );
        if (ddrval != DD_OK) CCERRC(ddrval, "Clipper->SetHWnd");

        ddrval = pScreen->pddsFront->SetClipper( pScreen->pddClipper );
		if (ddrval != DD_OK) CCERRC(ddrval, "Primary->SetClipper");

        memset( &ddsd, 0, sizeof(ddsd) );
        ddsd.dwSize = sizeof(ddsd);
        ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
        ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_SYSTEMMEMORY;
        ddsd.dwWidth = m_iActualWidth;
        ddsd.dwHeight = m_iActualHeight;

        ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
        ddrval = pScreen->pddsFront->GetPixelFormat( &ddsd.ddpfPixelFormat );
        if (ddrval != DD_OK) CCERRC(ddrval, "GetPixelFormat(primary) for Video Drawing Surface");

        ddrval = pScreen->pdd->CreateSurface (&ddsd, &pScreen->pddsDraw, NULL);
        if (ddrval != DD_OK) CCERRC(ddrval, "VideoDrawingSurface");

		// SW! Sept 19, 2006 !!! (huge colortables will not work. find workaround!)

		unsigned long total_bpp_colors = 1 << m_iActualBpp;

		pScreen->cat16 = (COLORACCESSTABLE16 *) memman.sw_malloc( total_bpp_colors*2 );
	    pScreen->cat32 = (COLORACCESSTABLE32 *) memman.sw_malloc( total_bpp_colors*4 );

		if (pScreen->cat16 == NULL) CCERRC( -1, "Unable to allocate 16 bit color table"); 
		if (pScreen->cat32 == NULL) CCERRC( -1, "Unable to allocate 32 bit color table"); 

 }

 // initialize the palette needed for drawing the video
 UpdatePalette(falsecolor);

 // set flag to indicate that drawing has been initialized succesfully
 m_bDrawingInitialized = TRUE;

 return( TRUE );

err:

 Screen* pScreenNext1;

 pScreen1 = s_pScreenFirst;
 s_pScreenFirst = NULL;
 while (pScreen1 != NULL)
 {
        pScreenNext1 = pScreen1->pScreenNext;

		if (pScreen1->cat16 != NULL) memman.sw_free( (void *) pScreen1->cat16 );
		if (pScreen1->cat32 != NULL) memman.sw_free( (void *) pScreen1->cat32 );

        if (pScreen1->pddsBack != NULL) pScreen1->pddsBack->Release();
        if (pScreen1->pddsFront != NULL) pScreen1->pddsFront->Release();
        if (pScreen1->pddsDraw != NULL) pScreen1->pddsDraw->Release();
        if (pScreen1->pddClipper != NULL) pScreen1->pddClipper->Release();

        //pScreen1->pdd->RestoreDisplayMode();
        if (pScreen1->pdd != NULL) pScreen1->pdd->SetCooperativeLevel( AfxGetMainWnd()->GetSafeHwnd(), DDSCL_NORMAL);
        if (pScreen1->pdd != NULL) pScreen1->pdd->Release();

        delete pScreen1;
        pScreen1 = pScreenNext1;
 }

 const CString msg1("Failed to (re-)initialize drawing. This is a severe error. Program must quit.");
 OwnMessageBox(MB_ICONEXCLAMATION, "Error: \"%s\". Errorcode was %xh (%d).\n %s", errormessage, errorcode, errorcode, msg1 );

 //OnApplicationQuit();		
 return FALSE;
}

///////////////////////////////////////////////////////////////////////////////
//
// Everything that is initialized through InitializeDrawing can be deinitialized 
// by calling this function.
//
BOOL CVideoclntDlg::DeinitializeDrawing()
{
	// is drawing is not initialized, do not deinitialize it
	if (m_bDrawingInitialized == FALSE) return( TRUE );

    Screen* pScreen1;
    Screen* pScreenNext1;

    pScreen1 = s_pScreenFirst;
    s_pScreenFirst = NULL;
    while (pScreen1 != NULL)
    {
        pScreenNext1 = pScreen1->pScreenNext;

		if (pScreen1->cat16 != NULL) memman.sw_free( (void *) pScreen1->cat16 );
		if (pScreen1->cat32 != NULL) memman.sw_free( (void *) pScreen1->cat32 );

        if (pScreen1->pddsBack != NULL) pScreen1->pddsBack->Release();
        if (pScreen1->pddsFront != NULL) pScreen1->pddsFront->Release();
        if (pScreen1->pddsDraw != NULL) pScreen1->pddsDraw->Release();
        if (pScreen1->pddClipper != NULL) pScreen1->pddClipper->Release();

        //pScreen1->pdd->RestoreDisplayMode();
        pScreen1->pdd->SetCooperativeLevel( AfxGetMainWnd()->GetSafeHwnd(), DDSCL_NORMAL);
        pScreen1->pdd->Release();

        delete pScreen1;
        pScreen1 = pScreenNext1;
    }

	// clear flag to indicate that drawing is not initialized
	m_bDrawingInitialized = FALSE;

	return( TRUE );	// succssful
}



void CTsrcBitTONBitRGB(int width, int height, void *src, int srcadd, void *dest, int dstadd, int bpp, CVideoclntDlg *dlg, void *coloraccesstable, unsigned int sourcebpp)
{
	/*unsigned int wdiv4 = width >> 2;
	unsigned int wdiv8 = width >> 3;
	unsigned int wand3 = width&3;
	unsigned int wand7 = width&7;
	unsigned int srcrest = (width+srcadd)*height-(width*height);
	unsigned int destrest = (width+dstadd)*height-(width*height);*/

	//add esi, [srcadd]
	//add edi, [dstadd]
	// SW! Sept 21, 2006 gestern verschlimmbesserung, es wird x und y loop bentigt, denn nach jeder zeile muss srcadd
	//und dstadd hinzugefgt werden!!!


	if (srcadd != 0 || dstadd != 0 || width <= 0 || height <= 0 || src == NULL || dest == NULL || dlg == NULL || sourcebpp > 16)
	{
		int abc = 1;
	}

	if ((sourcebpp == 8) && (bpp == 16))
	{
		__asm
		{
			mov esi, [src]
			mov edi, [dest]
			mov edx, [height]
			mov eax, [coloraccesstable]

		   myloop1_y:

			push edx
			mov ecx, [width]
			
		   myloop1_x:
			xor ebx, ebx 
			mov bl, [esi]
			mov dx, [eax+ebx*2]

			mov [edi], dx

			add esi,1
			add edi,2

			sub ecx, 1
			jnz myloop1_x

			add esi, [srcadd]
			add edi, [dstadd]

			pop edx
			sub edx, 1
			jnz myloop1_y
		}
	}
	else if ((sourcebpp == 8) && (bpp == 32))
	{
		__asm
		{
			mov esi, [src]
			mov edi, [dest]
			mov eax, [coloraccesstable]
			mov edx, [height]

		   myloop2_y:
			push edx
			mov ecx, [width]

		   myloop2_x:
			xor ebx, ebx 
			mov bl, [esi]
			mov edx, [eax+ebx*4]

			mov [edi], edx

			add esi,1
			add edi,4

			sub ecx, 1
			jnz myloop2_x

			add esi, [srcadd]
			add edi, [dstadd]

			pop edx
			sub edx, 1
			jnz myloop2_y
		}
	}
	else if ((sourcebpp == 16) && (bpp == 16))
	{
		__asm
		{
			mov esi, [src]
			mov edi, [dest]
			mov eax, [coloraccesstable]
			mov edx, [height]

		   myloop3_y:
			push edx
			mov ecx, [width]

		   myloop3_x:
			xor ebx, ebx 
			mov bx, [esi]
			mov dx, [eax+ebx*2]

			mov [edi], dx

			add esi,2
			add edi,2

			sub ecx, 1
			jnz myloop3_x

			add esi, [srcadd]
			add edi, [dstadd]

			pop edx
			sub edx,1
			jnz myloop3_y
		}
	}
	else if ((sourcebpp == 16) && (bpp == 32))
	{
		__asm
		{
			mov esi, [src]
			mov edi, [dest]
			mov eax, [coloraccesstable]
			mov edx, [height]

 		   myloop4_y:
			push edx
			mov ecx, [width]

		   myloop4_x:
			xor ebx, ebx 
			mov bx, [esi]
			mov edx, [eax+ebx*4]

			mov [edi], edx

			add esi,2
			add edi,4

			sub ecx, 1
			jnz myloop4_x
			
			add esi, [srcadd]
			add edi, [dstadd]

			pop edx
			sub edx,1
			jnz myloop4_y
		}
	}
	else
	{
		dlg->PrintServerMessage("Video BPP not supported!");
	}
}

void CVideoclntDlg::ConvertImageColorSpace(int width, int height, void *src, int srcadd, void *dest, int destadd, unsigned int rgbbitcount, Screen *scrn)
{
	void *colortable;
	if (rgbbitcount == 32) colortable = scrn->cat32; else colortable = scrn->cat16;

	CTsrcBitTONBitRGB(width, height, src, srcadd, dest, destadd, rgbbitcount, this, colortable, m_iActualBpp);
}

///////////////////////////////////////////////////////////////////////////////
//
// This function draws the actual image (or redraws the last one). The first 
// parameter is a pointer to the memory location where the to-be-drawn frame 
// is stored. The second parameter identifies the camera port the image is from.
// The third parameter is a flag which indicates whether the last frame should be
// redrawn.
//
// The function also displays/updates a projection, if any projection is switched on.
// In addition to this, the mouse cross, the area of interest and the cross where 
// the spot is located is drawn.
//
// Parameters
//   video    - pointer to the to-be-drawn image, can be NULL when justredraw is set 
//              to TRUE (VIDEO must match current m_iActualBpp !!! )
//   cport    - camera port the frame was taken from (0..3)
//              Other values are also valid. These are:
//              -1 - the to-be-drawn image is a background image 
//              -2 - the buffer contains no real data (empty frame)
//              -3 - the buffer contains a loaded image
//
// justredraw - TRUE  : just redraw the last drawn frame
//              FALSE : draw the new frame located at 'video'
//
void CVideoclntDlg::DisplayFunction(char *video, int cport, BOOL justredraw)
{ 
  double valuexm,valueym, valuexrms, valueyrms, scale;

  // drawing is not initialized, better not draw
  if (m_bDrawingInitialized == FALSE) return;

  // changing the palette - better not draw
  if (m_bPaletteChangeInProgress == TRUE) return;

  // exit if no statfile present
  if (m_pStatFile == NULL) return;

  // obtain video window width and height
  int destw = m_VideoWindowWidth;
  int desth = m_VideoWindowHeight;

  // clear backbuffer
  	
  DDBLTFX ddbltfxc;
  RECT clientArea;
  RECT button;
  RECT videoArea;
  RECT statusline;
  CString msg;
  Screen *pScreen;
  static int lcport;

  if (justredraw == FALSE) lcport = cport;

  m_CEditStatusLine.GetWindowRect( &statusline );
  m_CButtonTopLeft1.GetWindowRect( &button );
  clientArea.top = button.top;
  clientArea.left = button.left;
  clientArea.right = statusline.right;
  clientArea.bottom = statusline.bottom;
 
  int cawidth, caheight;

  // SW! !!! 15.08.2005
  // cawidth = clientArea.right - clientArea.left + 1;
  // caheight = clientArea.bottom - clientArea.top + 1;
  // SW! !!! 15.08.2005

  cawidth = clientArea.right - clientArea.left;
  caheight = clientArea.bottom - clientArea.top;

  ddbltfxc.dwSize = sizeof(DDBLTFX);
  ddbltfxc.dwFillColor = RGB(0, 0, 0);

  HRESULT hres1=DD_OK;
  RECT rcScreen;

  if ((cawidth > 0) && (caheight > 0)) 
  {
    for (pScreen = s_pScreenFirst; pScreen != NULL; pScreen = pScreen->pScreenNext)
    {
        // Handle lost surfaces
        if (pScreen->pddsFront->IsLost() == DDERR_SURFACELOST)
        {
            hres1 = pScreen->pdd->RestoreAllSurfaces();
			//PrintServerMessage("SurfaceLost on blit to back");
        }

        if (RectIntersectsMonitor(&clientArea, pScreen->hmon, &rcScreen))
        {
          hres1 = pScreen->pddsBack->Blt(&rcScreen, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfxc);
        }
    }
  }

  if (m_pLastFrame == NULL) // no lastframe memory buffer allocated yet ? 
  {
    //m_pLastFrame = (char *) memman.sw_malloc( (m_iActualWidth*m_iActualHeight)+(3*m_iActualHeight) ); // allocate it
    m_pLastFrame = (char *) memman.sw_malloc( (m_iActualWidth*m_iActualHeight*m_iActualBpp)/8 ); // allocate it
	if (m_pLastFrame == NULL) return;
  }

  if (justredraw == FALSE) // just redrawing ? 
  {
      if (video != NULL) memman.memcpysw( (char *) m_pLastFrame, (char *) video, (m_iActualWidth*m_iActualHeight*m_iActualBpp)/8 );
  }
   else video = m_pLastFrame;
   
  if (video != NULL)
  {
      HRESULT hres;
      DDSURFACEDESC2 ddsd;
	  DDBLTFX bltfx;
	  #define NULLSAME1 NULL

      for (pScreen = s_pScreenFirst; pScreen != NULL; pScreen = pScreen->pScreenNext)
      {
        // Handle lost surfaces
        if (pScreen->pddsDraw->IsLost() == DDERR_SURFACELOST)
        {
            hres1 = pScreen->pdd->RestoreAllSurfaces();
			//PrintServerMessage("SurfaceLost on copy to video");
        }

        memset( &bltfx, 0, sizeof(bltfx) );
  	    memset( &ddsd, 0, sizeof(ddsd) );

	    bltfx.dwSize = sizeof(bltfx);
	    ddsd.dwSize = sizeof(ddsd);

        hres = pScreen->pddsDraw->Lock( NULLSAME1, &ddsd, DDLOCK_WAIT | DDLOCK_WRITEONLY, NULL );
        if (hres == DD_OK) 
	    {
			pScreen->destadd = ddsd.lPitch - (ddsd.dwWidth*(pScreen->m_uiRGBBitCount / 8));
			if (pScreen->destadd < 0) pScreen->destadd = 0;
			ConvertImageColorSpace(m_iActualWidth, m_iActualHeight, video, 0, ddsd.lpSurface, pScreen->destadd, pScreen->m_uiRGBBitCount, pScreen );
	        hres = pScreen->pddsDraw->Unlock( NULLSAME1 );
	    }
      }

      m_CMyVideoFrame.GetWindowRect( &videoArea );

	  int vawidth, vaheight;
  	  
	  // SW! !!! 15.08.2005
	  //vawidth = videoArea.right - videoArea.left + 1;
	  //vaheight = videoArea.bottom - videoArea.top + 1;
	  // SW! !!! 15.08.2005

	  vawidth = videoArea.right - videoArea.left;
	  vaheight = videoArea.bottom - videoArea.top;

	  if ((vawidth > 0) && (vaheight > 0)) 
	  {

        for (pScreen = s_pScreenFirst; pScreen != NULL; pScreen = pScreen->pScreenNext)
        {
            // Handle lost surfaces
            if (pScreen->pddsFront->IsLost() == DDERR_SURFACELOST)
            {
               hres = pScreen->pdd->RestoreAllSurfaces();
			   //PrintServerMessage("SurfaceLost on blit video to back");
            }

            RECT rcsrc;
			
			rcsrc.top = 0;
			rcsrc.left = 0;
			rcsrc.right = m_iActualWidth;
			rcsrc.bottom = m_iActualHeight;
			///CString msg666;

			double sxfac = (m_iActualWidth*1.0) / (vawidth*1.0);
			double syfac = (m_iActualHeight*1.0) / (vaheight*1.0);

		    //CString msg1;
		    //msg1.Format("SRC hmon=%xh va.l=%d va.t=%d va.r=%d va.b=%d\n", pScreen->hmon, videoArea.left, videoArea.top, videoArea.right, videoArea.bottom);
            //PrintServerMessage( msg1 );
            
			if (RectIntersectsMonitorWithoutOffset(&videoArea, pScreen->hmon, &rcScreen))
            {

		        //CString msg1;
		        //msg1.Format("Tscrn hmon=%xh sc.l=%d sc.t=%d sc.r=%d sc.b=%d\n", pScreen->hmon, rcScreen.left, rcScreen.top, rcScreen.right, rcScreen.bottom);
                //PrintServerMessage( msg1 );

                if (rcScreen.left != videoArea.left)
				{
					int fac = (int) ((rcScreen.left - videoArea.left)*sxfac);
					if (rcScreen.left > videoArea.left) rcsrc.left += fac; else rcsrc.left -= fac;
				}
				if (rcScreen.right != videoArea.right)
				{
					int fac = (int) ((rcScreen.right - videoArea.right)*sxfac);
					if (rcScreen.right > videoArea.right) rcsrc.right -= fac; else rcsrc.right += fac;

				}
				if (rcScreen.top != videoArea.top) 
				{
					int fac = (int) ((rcScreen.top - videoArea.top)*syfac);
					if (rcScreen.top > videoArea.top) rcsrc.top += fac; else rcsrc.top -= fac;

				}
				if (rcScreen.bottom != videoArea.bottom) 
				{
					int fac = (int) ((rcScreen.bottom - videoArea.bottom)*syfac);
					//if (fac < 0) fac = fac*-1.0;
				    //msg1.Format("BOTTOM fac=%d scrn.bottom=%d va.bottom=%d syfac=%f\n", fac, rcScreen.bottom, videoArea.bottom, syfac);
					//PrintServerMessage(msg1);
					if (rcScreen.bottom > videoArea.bottom) rcsrc.bottom -= fac; else rcsrc.bottom += fac;

				}
					
				RECT rcScreen1;
				RectIntersectsMonitor(&videoArea, pScreen->hmon, &rcScreen1);

		        //msg1.Format("Tscrn1 hmon=%xh sc1.l=%d sc1.t=%d sc1.r=%d sc1.b=%d\n", pScreen->hmon, rcScreen1.left, rcScreen1.top, rcScreen1.right, rcScreen1.bottom);
                //PrintServerMessage( msg1 );

		        //msg1.Format("Tsrc hmon=%xh sr.l=%d sr.t=%d sr.r=%d sr.b=%d\n", pScreen->hmon, rcsrc.left, rcsrc.top, rcsrc.right, rcsrc.bottom);
                //PrintServerMessage( msg1 );

				hres = pScreen->pddsBack->Blt(&rcScreen1, pScreen->pddsDraw, &rcsrc, DDBLT_WAIT, &bltfx);
            }
      }
 }

/* if (justredraw == FALSE)
 {
	// print the camera port information in the CEdit control where the camera port string is drawn
	if (cport == -1) msg.Format("BCKGND"); else msg.Format("%d", cport);
	if (cport == -2) msg.Format("EMPTY");
	if (cport == -3) msg.Format("LOADED");
	//m_CEditCameraPort.SetWindowText((LPCTSTR) msg); // SW! !!! Oct 20, 2005, replacement must be found!!!
 }*/

 HDC hdc=NULL;

 for (pScreen = s_pScreenFirst; pScreen != NULL; pScreen = pScreen->pScreenNext)
 {
    // Handle lost surfaces
    if (pScreen->pddsFront->IsLost() == DDERR_SURFACELOST || pScreen->pddsBack->IsLost() == DDERR_SURFACELOST)
    {
               hres1 = pScreen->pdd->RestoreAllSurfaces();
			   //PrintServerMessage("SurfaceLost on getDC");
    }

    hres1 = pScreen->pddsBack->GetDC( &hdc );

    CDC *destDC=NULL;

    if (hdc != NULL) destDC = CDC::FromHandle( hdc );

    if (hdc == NULL || destDC == NULL) 
	{ 
	  OnPaint(); 
	  return; 
	}

	MONITORINFO mi;
  
	ZeroMemory(&mi, sizeof(mi));
	mi.cbSize = sizeof(mi);
	GetMonitorInfo(pScreen->hmon, &mi);

    m_CEditStatusLine.GetWindowRect( &statusline );
    m_CButtonTopLeft1.GetWindowRect( &button );
    clientArea.top = button.top;
    clientArea.left = button.left;
    clientArea.right = statusline.right;
    clientArea.bottom = statusline.bottom;
	RectIntersectsMonitor( &clientArea, pScreen->hmon, &clientArea );

    // obtain video window width and height
    int w=m_VideoWindowWidth;
    int h=m_VideoWindowHeight;

    // calculate the ratios between frame width and height and video window width and height
    double ratX=(m_iActualWidth*1.0)/(w*1.0);
    double ratY=(m_iActualHeight*1.0)/(h*1.0);

	scale = GetCurrentScale();

	/* SW! Apr 27, 2006 taken out
    // SW! Apr 26, 2006 warum wird das ANZEIGEFELD auskopiert ? 
    // obtain the scale from the CEdit control
	m_CEditScale.GetWindowText(msg);
    scale = atof( (const char *) (LPCTSTR) msg);
	// SW! Apr 26, 2006 warum wird das ANZEIGEFELD auskopiert END ? 
	*/

	RECT rec, destrec;
    RECT clientAreaWhole1;

	if (lcport == -1) msg.Format("BCKGND"); 
	else if (lcport == -2) msg.Format("EMPTY");
	else if (lcport == -3) msg.Format("FILE");
	else msg.Format("SRV");
	
	destDC->SetBkColor(RGB(0,0,0));
	destDC->SetTextColor(RGB(255,255,0));
	
    m_CMyVideoFrame.GetWindowRect(&clientAreaWhole1);
		   
    rec.left = clientAreaWhole1.left+10;
    rec.top = clientAreaWhole1.top+10;
    rec.right = rec.left+destDC->GetTextExtent(msg).cx;
    rec.bottom = rec.top+destDC->GetTextExtent(msg).cy;

    if (RectIntersectsMonitor(&rec, pScreen->hmon, &destrec ) == TRUE)
    {
		   destDC->TextOut(destrec.left,destrec.top, msg); // print value in _scaled_ pixels
    }

    int xcrosspos;
	BOOL xvalid;
	int ycrosspos;
	BOOL yvalid;

    // variables needed for projections
    double *distarr;
    double *distarr_fit;
    int distlength = 0;

    if ((m_bXProjectionOn == TRUE) && (w>0) && (h>0))
    {
      distlength = m_iActualWidth; // items in distarr
      distarr = m_pStatFile->X_DIST(); // get distarr pointer
      distarr_fit = m_pStatFile->X_DIST_FIT();
      
      RECT projArea;
	  RECT projAreaAdj;
      m_CFrameProjection.GetWindowRect( &projArea );
      RectIntersectsMonitor( &projArea, pScreen->hmon, &projAreaAdj );

      BOOL ret = NormalizeToArea(xcrosspos, ycrosspos, xvalid, yvalid, &m_CFrameProjection, pScreen);

      if (ret == TRUE)
	  {

		// calculate needed variables
		int projHeight = projArea.bottom - projArea.top + 1;
		int projHeightDraw = projHeight - 18;
		int projWidth = projArea.right - projArea.left + 1;
		
		int projHeightAdj = projAreaAdj.bottom - projAreaAdj.top + 1;
		int projHeightDrawAdj = projHeightAdj - 18;
		int projWidthAdj = projAreaAdj.right - projAreaAdj.left + 1;

		int pixel_x, pixel_y;
		//int projYWidth = yprojArea.right - yprojArea.left + 1;

		// obtain maximum (biggest) value of distarr
		double maxval = 0.0;
		for (int i=0;i<distlength;i++)
		{  
			if (distarr[i] > maxval) maxval = distarr[i];
		}
      
		if (m_iAnalyzeMode == 4)
		{
	        double maxval_fit = 0;
			for (int i=0;i<distlength;i++)
			{  
 				if (distarr_fit[i] > maxval_fit) maxval_fit = distarr_fit[i];
			}

			if (maxval_fit > maxval) maxval = maxval_fit;
      
		}

		// if the maximum value is around zero, then make it a bit bigger to avoid division by zero
		if (maxval > -0.0001 && maxval < 0.0001) maxval = 0.1;

		// calculate factors needed for proper drawing the projection area 
		// factor = factor by which the actual projection y-position is stretched
		double factor = ((double)projHeightDraw-2) / maxval;  // drw -2
		// xfactor = factor by which the projection array is streched in x, e.g.
		// the projection area could be bigger (in pixels) than the number of values that 
		// are stored in the distarr array
		double xfactor = ((double)projWidth) / ((double)distlength);
     
		// create yellow pen and attach it to the projection device context
		CPen p(PS_SOLID,1, RGB(255,255,0));
		//m_destDCProj->SelectObject(&p);

		// clear the projection area by filling it with black                            // -2
		destDC->FillSolidRect( projAreaAdj.left, projAreaAdj.top, projWidthAdj, projHeightAdj, RGB(0,0,0) );
		// make a white 2 pixel border at the bottom of the projection area
      
		//int startxpos = 0;
		//if (m_bYProjectonOn == TRUE) startxpos += projYWidth;
      
		destDC->FillSolidRect( projAreaAdj.left, projAreaAdj.bottom-1, projWidthAdj-2, 1, RGB(255,255,255) );

		// draw 5 orientation lines inside the projection area (green)
		CPen p2(PS_SOLID, 1, RGB(0,130,0));
		destDC->SelectObject(&p2);

		int lines = 5; // 5 lines
		double step = projHeightDraw / 5.0; // step between the 5 lines
     
		// start position (some space is reserved for proper displaying some values) 
		double akt = (double) (projHeight - projHeightDraw);

		// draw the 5 lines
		for (int k=0;k<5;k++)
		{
			RECT rec, destrec;

			rec.left = projArea.left;
			rec.right = projArea.right;
			rec.top = projArea.top+(int)akt;
			rec.bottom = rec.top+1;

			if (RectIntersectsMonitor( &rec, pScreen->hmon, &destrec) == TRUE)
			{
 				destDC->MoveTo( destrec.left, destrec.top ); 
				destDC->LineTo( destrec.right, destrec.top );
            }
			
			akt += step;
		}

		// attach yellow pen to projection device context 
		destDC->SelectObject(&p);

		// draw the projection         
		int last_pixel_y = (projHeightDraw-2) - ((int) (distarr[0] * factor));
		int last_pixel_x = 0;
		for (i=1;i<distlength;i++)
		{                         
			pixel_y = (projHeightDraw-2) - ((int) (distarr[i] * factor));
			pixel_x = (int) (((double)i)*xfactor);

			RECT lrect1, lrect2, lrect1adj, lrect2adj;

			lrect1.left = projArea.left+last_pixel_x;
			lrect1.right = lrect1.left + 1;
			lrect1.top = projArea.top+18+last_pixel_y;
			lrect1.bottom = lrect1.top + 1;
         
			lrect2.right = projArea.left+pixel_x;
			lrect2.left = lrect2.right - 1;
			lrect2.bottom = projArea.top+18+pixel_y;
			lrect2.top = lrect2.bottom - 1;
			
            if ((RectIntersectsMonitor( &lrect1, pScreen->hmon, &lrect1adj ) == TRUE) && 
				(RectIntersectsMonitor( &lrect2, pScreen->hmon, &lrect2adj ) == TRUE))
			{
				destDC->MoveTo(lrect1adj.left,lrect1adj.top);
				destDC->LineTo(lrect2adj.right,lrect2adj.bottom);
			}

			last_pixel_x = pixel_x;
			last_pixel_y = pixel_y;
		}

		if (m_iAnalyzeMode == 4)
		{

			CPen p5(PS_SOLID, 1, RGB(255,0,0) );
			destDC->SelectObject( &p5 );

			// draw the projection         
			int last_pixel_y = (projHeightDraw-2) - ((int) (distarr_fit[0] * factor));
			int last_pixel_x = 0;
			for (i=1;i<distlength;i++)
			{                         
				pixel_y = (projHeightDraw-2) - ((int) (distarr_fit[i] * factor));
				pixel_x = (int) (((double)i)*xfactor);

				RECT lrect1, lrect2, lrect1adj, lrect2adj;

				lrect1.left = projArea.left+last_pixel_x;
				lrect1.right = lrect1.left + 1;
				lrect1.top = projArea.top+18+last_pixel_y;
				lrect1.bottom = lrect1.top + 1;
         
				lrect2.right = projArea.left+pixel_x;
				lrect2.left = lrect2.right - 1;
				lrect2.bottom = projArea.top+18+pixel_y;
				lrect2.top = lrect2.bottom - 1;
			
				if ((RectIntersectsMonitor( &lrect1, pScreen->hmon, &lrect1adj ) == TRUE) && 
					(RectIntersectsMonitor( &lrect2, pScreen->hmon, &lrect2adj ) == TRUE))
				{
					destDC->MoveTo(lrect1adj.left,lrect1adj.top);
					destDC->LineTo(lrect2adj.right,lrect2adj.bottom);
				}

				last_pixel_x = pixel_x;
				last_pixel_y = pixel_y;
			}
		}

		if (xvalid == TRUE)
		{
  		  // lengthen x cross line from video frame into projection
		  CPen p1(PS_SOLID, 1, RGB(0,255,0)); // green pen
		  destDC->SelectObject(&p1);

		  destDC->MoveTo(projAreaAdj.left+xcrosspos,projAreaAdj.top+0);
		  destDC->LineTo(projAreaAdj.left+xcrosspos,projAreaAdj.top+projHeightAdj-1);

		  // set background color to black, set text color to pure red
		  destDC->SetBkColor(RGB(0,0,0));
		  destDC->SetTextColor(RGB(255,0,0));

		  // obtain the right value out of the projection array
		  double index;
		  double pixel_value;
		  // calculate the proper index based on the mouse's x position and the video window width
		  index = (((double)m_CPointCross.x) * (m_iActualWidth*1.0) / ((double)m_VideoWindowWidth));
		  pixel_value = distarr[(int)index] / maxval;

		  // build up actual projection value string 
		  CString msg;
		  msg.Format("%.2f", pixel_value);

		  // adjust string drawing coordinates so that the string never goes out of the projection area frame
		  double diffX=m_CPointCross.x*destDC->GetTextExtent(msg).cx;
		  diffX /= (double) ((projAreaAdj.right - projAreaAdj.left) + 1);;

		  RECT rec, destrec;

		  rec.left = projArea.left+(int) (m_CPointCross.x-diffX);
		  rec.top = projArea.top+0;
		  rec.right = rec.left+destDC->GetTextExtent(msg).cx;
		  rec.bottom = rec.top+destDC->GetTextExtent(msg).cy;

		  //OffsetRect(&rec, mi.rcMonitor.left, mi.rcMonitor.top); // - - 

		  if (RectIntersectsMonitor(&rec, pScreen->hmon, &destrec ) == TRUE)
		  {
			destDC->TextOut(destrec.left,destrec.top, msg); // print value in _scaled_ pixels
		  }
		}
	  }
	}

    if ((m_bYProjectionOn == TRUE) && (w>0) && (h>0))
    {
      // Y-projection  
      distlength = m_iActualHeight; // items in distarr
      distarr = m_pStatFile->Y_DIST(); // get distarr pointer
      distarr_fit = m_pStatFile->Y_DIST_FIT();
      double yrmsstreak = m_pStatFile->Y_RMS();

      // redraw projection area 

      // obtain coordinates of projection area
      RECT projArea, projAreaAdj;
      m_CFrameYProjection.GetWindowRect( &projArea );
      RectIntersectsMonitor( &projArea, pScreen->hmon, &projAreaAdj );

      BOOL ret = NormalizeToArea(xcrosspos, ycrosspos, xvalid, yvalid, &m_CFrameYProjection, pScreen);

      if (ret == TRUE)
	  {
		// calculate needed variables
		int pixels_for_text_value = 30;

		int projHeight = projArea.bottom - projArea.top + 1;
		int projWidth = (projArea.right - projArea.left) + 1;
		int projWidthDraw = projWidth - (pixels_for_text_value) - 2;
		int projAdjWidth = (projAreaAdj.right - projAreaAdj.left) + 1;
		int projAdjHeight = (projAreaAdj.bottom - projAreaAdj.top) + 1;
		int projAdjWidthDraw = projAdjWidth - (pixels_for_text_value); 
		
		int pixel_x, pixel_y;

		// obtain maximum (biggest) value of distarr
		double maxval = 0;
		for (int i=0;i<distlength;i++)
		{ 
			if (distarr[i] > maxval) maxval = distarr[i];
		}

		if (m_iAnalyzeMode == 4)
		{
			double maxval_fit = 0;
			for (int i=0;i<distlength;i++)
			{  
			if (distarr_fit[i] > maxval_fit) maxval_fit = distarr_fit[i];
			}

			if (maxval_fit > maxval) maxval = maxval_fit;
		}

		// if the maximum value is arounnd zero, then make it a bit bigger to avoid division by zero
		if (maxval > -0.0001 && maxval < 0.0001) maxval = 0.1;

		// calculate factors needed for proper drawing the projection area 
		// factor = factor by which the actual projection y-position is stretched
		double factor = ((double) projWidthDraw ) / maxval;
		// xfactor = factor by which the projection array is streched in x, e.g.
		// the projection area could be bigger (in pixels) than the number of values that 
		// are stored in the distarr array
		double xfactor = ((double)projHeight) / ((double)distlength);
     
		// create yellow pen and attach it to the projection device context
		CPen p(PS_SOLID,1, RGB(255,255,0));

		// clear the projection area by filling it with black
		destDC->FillSolidRect( projAreaAdj.left,projAreaAdj.top, projAdjWidth, projAdjHeight-1, RGB(0,0,0) );
		// make a white 2 pixel border at the bottom of the projection area
		destDC->FillSolidRect( projAreaAdj.right-1, projAreaAdj.top, 1, projAdjHeight-1, RGB(255,255,255) );
		
    		/// draw 5 orientation lines inside the projection area (green)
		CPen p2(PS_SOLID, 1, RGB(0,130,0));
		destDC->SelectObject(&p2);

		int lines = 5; // 5 lines
		double step = projWidthDraw / 5.0; // step between the 5 lines
     
		// start position (some space in pixels is reserved for proper displaying some values) 
		double akt = (double) pixels_for_text_value; // 18 pixels were reserved for text, see above code
									//Height - projHeightDraw);
		// draw the 5 lines
		for (int k=0;k<5;k++)
		{

			RECT rec, destrec;
			
			rec.left = projArea.left + ((int)akt);
			rec.right = rec.left + 1;
			rec.top = projArea.top;
			rec.bottom = projArea.bottom-1;

			if (RectIntersectsMonitor(&rec, pScreen->hmon, &destrec ) == TRUE)
			{
				destDC->MoveTo( destrec.left, destrec.top );
				destDC->LineTo( destrec.left, destrec.bottom );
            }
			akt += step;
		}

		// attach yellow pen to projection device context 
		destDC->SelectObject(&p);

		// draw the Y projection
		int last_pixel_y = 0;
		int last_pixel_x = projWidthDraw - ((int) (distarr[0] * factor));
		

		for (i=1;i<distlength;i++)
		{
			pixel_y = (int) (((double)(i))*xfactor);
			pixel_x = (projWidthDraw - ((int) (distarr[i] * factor)));
			
			RECT lrect1, lrect2, lrect1adj, lrect2adj;

			lrect1.left = projArea.left+(pixels_for_text_value)+last_pixel_x; // -1
			lrect1.right = lrect1.left + 1;
			lrect1.top = projArea.top+last_pixel_y;
			lrect1.bottom = lrect1.top + 1;
         
			lrect2.right = projArea.left+(pixels_for_text_value)+pixel_x; // -1
			lrect2.left = lrect2.right - 1;
			lrect2.bottom = projArea.top+pixel_y;
			lrect2.top = lrect2.bottom - 1;

	        if ((RectIntersectsMonitor( &lrect1, pScreen->hmon, &lrect1adj ) == TRUE) && 
				(RectIntersectsMonitor( &lrect2, pScreen->hmon, &lrect2adj ) == TRUE))
			{
				destDC->MoveTo(lrect1adj.left,lrect1adj.top);
				destDC->LineTo(lrect2adj.right,lrect2adj.bottom);
			}

		
			last_pixel_x = pixel_x;
			last_pixel_y = pixel_y;
		}

		if (m_iAnalyzeMode == 4)
		{

			CPen p5(PS_SOLID, 1, RGB(255,0,0) );
			destDC->SelectObject( &p5 );

			// draw the projection
			int last_pixel_y = 0;
			int last_pixel_x = projWidthDraw - ((int) (distarr_fit[0] * factor));
			for (i=1;i<distlength;i++)
			{
				pixel_y = (int) (((double)i)*xfactor);
				pixel_x = (projWidthDraw - ((int) (distarr_fit[i] * factor)));

				RECT lrect1, lrect2, lrect1adj, lrect2adj;

				lrect1.left = projArea.left+(pixels_for_text_value)+last_pixel_x; // -1
				lrect1.right = lrect1.left + 1;
				lrect1.top = projArea.top+last_pixel_y;
				lrect1.bottom = lrect1.top + 1;
         
				lrect2.right = projArea.left+(pixels_for_text_value)+pixel_x; // -1
				lrect2.left = lrect2.right - 1;
				lrect2.bottom = projArea.top+pixel_y;
				lrect2.top = lrect2.bottom - 1;

				if ((RectIntersectsMonitor( &lrect1, pScreen->hmon, &lrect1adj ) == TRUE) && 
					(RectIntersectsMonitor( &lrect2, pScreen->hmon, &lrect2adj ) == TRUE))
				{
					destDC->MoveTo(lrect1adj.left,lrect1adj.top);
					destDC->LineTo(lrect2adj.right,lrect2adj.bottom);
				}

		
				last_pixel_x = pixel_x;
				last_pixel_y = pixel_y;
			}

		}

		if (yvalid == TRUE)
		{
			// lengthen x cross line from video frame into projection
			CPen p1(PS_SOLID, 1, RGB(0,255,0)); // green pen
			destDC->SelectObject(&p1);
			
			destDC->MoveTo(projAreaAdj.left+0, projAreaAdj.top+ycrosspos);
			destDC->LineTo(projAreaAdj.left+projAdjWidth-1, projAreaAdj.top+ycrosspos);

			// set background color to black, set text color to pure red
			destDC->SetBkColor(RGB(0,0,0));
			destDC->SetTextColor(RGB(255,0,0));

			// obtain the right value out of the projection array
			double index;
			double pixel_value;
			// calculate the proper index based on the mouse's y position and the video window height
			index = (((double)m_CPointCross.y) * (m_iActualHeight*1.0) / ((double)m_VideoWindowHeight));
			pixel_value = distarr[(int)index] / maxval;

			// build up actual projection value string 
			CString msg;
			msg.Format("%.2f", pixel_value );

			// adjust string drawing coordinates so that the string never goes out of the projection area frame
			double diffY=m_CPointCross.y*destDC->GetTextExtent(msg).cy;
			diffY /= (double) ((projAreaAdj.bottom - projAreaAdj.top) + 1);

			RECT rec, destrec;

		    rec.left = projArea.left+2;
		    rec.top = projArea.top+(int) (m_CPointCross.y-diffY);
		    rec.right = rec.left+destDC->GetTextExtent(msg).cx;
		    rec.bottom = rec.top+destDC->GetTextExtent(msg).cy;

		    if (RectIntersectsMonitor(&rec, pScreen->hmon, &destrec ) == TRUE)
			{
				destDC->TextOut(destrec.left,destrec.top, msg); // print value in _scaled_ pixels
			}

			//output the text
			//destDC->TextOut(projAreaAdj.left+15, projAreaAdj.top+(int) (ycrosspos-diffY), msg);

			if (m_iAnalyzeMode == 5)
			{
				msg.Format("%.3f ps", yrmsstreak*2.0*scale);
				
				rec.top = projArea.top - 20;
				rec.right = projArea.right-5;
				rec.left = rec.right - destDC->GetTextExtent(msg).cx;
				rec.bottom = rec.top + destDC->GetTextExtent(msg).cy;

				if (RectIntersectsMonitor(&rec, pScreen->hmon, &destrec ) == TRUE)
				{
					destDC->SetBkColor(RGB(0,0,0));
					destDC->SetTextColor(RGB(0,210,0));
					destDC->TextOut(destrec.left, destrec.top, msg);
				}
			}
		}
	  }
    }

    BOOL ret2 = NormalizeToArea(xcrosspos, ycrosspos, xvalid, yvalid, &m_CMyVideoFrame, pScreen);

    // statistical analysis or fourier analysis?
    if ((m_iAnalyzeMode == 1 || m_iAnalyzeMode == 2 || m_iAnalyzeMode == 4 || m_iAnalyzeMode == 5) && (ret2 == TRUE))
    {
      // obtain the suggested position and size of the spot
      valuexm = m_pStatFile->XM();// * scale;
      valueym = m_pStatFile->YM();// * scale;
      valuexrms = m_pStatFile->X_RMS();// * scale;
      valueyrms = m_pStatFile->Y_RMS();// * scale;
    
      // red pen
      CPen p(PS_SOLID,1,RGB(255,255,0));

      // draw the spot-cross onto the spot
      destDC->SelectObject(&p);

      double dw = m_iActualWidth*1.0;
      double dh = m_iActualHeight*1.0;

      m_CMyVideoFrame.GetWindowRect( &videoArea );

	  int hlxstart = videoArea.left+(int)(((valuexm-valuexrms)*w/dw)+0.5);
	  int hlxend   = videoArea.left+(int)(((valuexm+valuexrms)*w/dw)+0.5);
	  int hly      = videoArea.top+(int)((valueym*h/dh)+0.5);

	  int vlystart = videoArea.top+(int)(((valueym-valueyrms)*h/dh)+0.5);
	  int vlyend   = videoArea.top+(int)(((valueym+valueyrms)*h/dh)+0.5);
	  int vlx      = videoArea.left+(int)((valuexm*w/dw)+0.5);

	  RECT xline, xlineresult;

	  xline.left = hlxstart;
	  xline.right = hlxend;
	  xline.top = hly;
	  xline.bottom = hly+1;

	  if (RectIntersectsMonitor( &xline, pScreen->hmon, &xlineresult ) == TRUE)
	  {
        destDC->MoveTo(xlineresult.left,xlineresult.top);
        destDC->LineTo(xlineresult.right,xlineresult.top);
	  }

	  RECT yline, ylineresult;

	  yline.left = vlx;
	  yline.right = vlx+1;
	  yline.top = vlystart;
	  yline.bottom = vlyend;

	  if (RectIntersectsMonitor( &yline, pScreen->hmon, &ylineresult ) == TRUE)
	  {
        destDC->MoveTo(ylineresult.left,ylineresult.top);
        destDC->LineTo(ylineresult.left,ylineresult.bottom);
	  }
	}

    
	RECT videoAreaAdj;
	m_CMyVideoFrame.GetWindowRect( &videoArea );
	RectIntersectsMonitor( &videoArea, pScreen->hmon, &videoAreaAdj );

    if (m_bCircularAOI == TRUE)
    {
       int _x1, _y1, _x2, _y2;

	   _x1 = (int)(m_newAOI.left/ratX - m_newAOI.right/ratX);
	   _y1 = (int)(m_newAOI.top/ratY - m_newAOI.right/ratY);

	   _x2 = (int)(m_newAOI.left/ratX + m_newAOI.right/ratX);
	   _y2 = (int)(m_newAOI.top/ratY + m_newAOI.right/ratY);

       MONITORINFO mi;
       RECT rcIntersection;
	   RECT prcSrc;
       BOOL bIntersects;
       ZeroMemory(&mi, sizeof(mi));
       mi.cbSize = sizeof(mi);

	   prcSrc.left = _x1;
	   prcSrc.right = _x2;
	   prcSrc.top = _y1;
	   prcSrc.bottom = _y2;

	   m_CMyVideoFrame.ClientToScreen( &prcSrc );

	   BOOL ret = GetMonitorInfo(pScreen->hmon, &mi);
    
       if (ret != FALSE) bIntersects = IntersectRect(&rcIntersection, &prcSrc, &mi.rcMonitor); else bIntersects = TRUE;
	   rcIntersection = prcSrc;
	   OffsetRect(&rcIntersection, -mi.rcMonitor.left, -mi.rcMonitor.top);

	   //CString msg;
	   //msg.Format("isects=%d _x1=%d _x2 = %d _y1 = %d _y2 = %d mleft=%d, mtop=%d mright=%d, mbottom=%d", bIntersects, rcIntersection.left, rcIntersection.right, rcIntersection.top, rcIntersection.bottom, mi.rcMonitor.left, mi.rcMonitor.top, mi.rcMonitor.right,mi.rcMonitor.bottom );
	   //PrintServerMessage(msg);

	   if (bIntersects)
	   {
		   _x1 = rcIntersection.left;
		   _x2 = rcIntersection.right;
		   _y1 = rcIntersection.top;
		   _y2 = rcIntersection.bottom;

           // draw the currently selected area of interest
           CPen pe(PS_DASHDOT,1,RGB(255,255,0));
           destDC->SetBkColor(RGB(0,0,0));
           destDC->SetTextColor(RGB(255,255,0));

           destDC->SelectObject(&pe);

           HBRUSH nullbr1 = (HBRUSH) GetStockObject( HOLLOW_BRUSH );
	       CBrush *nullbr = CBrush::FromHandle( nullbr1 );

	       destDC->SelectObject( nullbr );
	       BOOL ret = destDC->Ellipse( _x1, _y1, _x2, _y2 );
		   //msg.Format("ret ellip=%d\n", ret);
		   //PrintServerMessage(msg);
	   }

    }
    else
    {
       // draw the currently selected area of interest

       CPen pe(PS_DASHDOT,1,RGB(255,255,0));
       destDC->SetBkColor(RGB(0,0,0));
       destDC->SetTextColor(RGB(255,255,0));

       destDC->SelectObject(&pe);

       m_CMyVideoFrame.GetWindowRect( &videoArea );

  	   int hlxstart = videoArea.left+(int)((m_newAOI.left/ratX));
	   int hlxend   = videoArea.left+(int)((m_newAOI.right/ratX));
	   int hly1     = videoArea.top+(int)((m_newAOI.top/ratY));
	   int hly2     = videoArea.top+(int)((m_newAOI.bottom/ratY)); 

	   int vlystart = videoArea.top+(int)((m_newAOI.top/ratY));
	   int vlyend   = videoArea.top+(int)((m_newAOI.bottom/ratY));
	   int vlx1     = videoArea.left+(int)((m_newAOI.left/ratX));
	   int vlx2     = videoArea.left+(int)((m_newAOI.right/ratX));

	   RECT xline1, xline2, xlineresult;

	   xline1.left = hlxstart;
	   xline1.right = hlxend;
	   xline1.top = hly1;
	   xline1.bottom = hly1+1;

   	   xline2.left = hlxstart;
	   xline2.right = hlxend;
	   xline2.top = hly2;
	   xline2.bottom = hly2+1;

	   if (RectIntersectsMonitor( &xline1, pScreen->hmon, &xlineresult ) == TRUE)
	   {
	    destDC->MoveTo(xlineresult.left,xlineresult.top);
        destDC->LineTo(xlineresult.right,xlineresult.top);
	   }

	   if (RectIntersectsMonitor( &xline2, pScreen->hmon, &xlineresult ) == TRUE)
	   {
	    destDC->MoveTo(xlineresult.left,xlineresult.top);
        destDC->LineTo(xlineresult.right,xlineresult.top);
	   }

	   RECT yline1, yline2, ylineresult;

	   yline1.left = vlx1;
	   yline1.right = vlx1+1;
	   yline1.top = vlystart;
	   yline1.bottom = vlyend;

   	   yline2.left = vlx2;
	   yline2.right = vlx2+1;
	   yline2.top = vlystart;
	   yline2.bottom = vlyend;

	   if (RectIntersectsMonitor( &yline1, pScreen->hmon, &ylineresult ) == TRUE)
	   {
	    destDC->MoveTo(ylineresult.left,ylineresult.top);
        destDC->LineTo(ylineresult.left,ylineresult.bottom);
	   }

	   if (RectIntersectsMonitor( &yline2, pScreen->hmon, &ylineresult ) == TRUE)
	   {
	    destDC->MoveTo(ylineresult.left,ylineresult.top);
        destDC->LineTo(ylineresult.left,ylineresult.bottom);
	   }

    }

     // draw cross ( 2 lines, which indicate the mouse position )

     // draw mouse cross
     CPen pe1(PS_DASHDOT,1,RGB(255,255,0));
     destDC->SelectObject(&pe1);

     destDC->SetBkColor(RGB(0,0,0));
     destDC->SetTextColor(RGB(255,255,0));
	
     //int x = m_CPointCross.x;
     //int y = m_CPointCross.y;

     //ret = NormalizeToArea(xcrosspos, ycrosspos, xvalid, yvalid, &m_CMyVideoFrame, pScreen);
	 NormalizeToArea(xcrosspos, ycrosspos, xvalid, yvalid, &m_CMyVideoFrame, pScreen);

     RECT clientAreaAdj;
     RECT clientAreaWhole;

     m_CMyVideoFrame.GetWindowRect(&clientAreaWhole);

     //if (ret == TRUE)
	 //{
       if (RectIntersectsMonitor( &clientAreaWhole, pScreen->hmon, &clientAreaAdj ) == TRUE)
	   {
		   //x = xcrosspos;
		   //y = ycrosspos;
     	 
           // calculate width and height of the video frame
           //int width_window = clientAreaWhole.right - clientAreaWhole.left + 1;
           //int height_window = clientAreaWhole.bottom - clientAreaWhole.top + 1;

		   // obtain video window width and height
           //w= (clientAreaWhole.right - clientAreaWhole.left) + 1;
		   //h= (clientAreaWhole.bottom - clientAreaWhole.top) + 1;

		   // calculate the ratios between frame width and height and video window width and height
		   ratX=(m_iActualWidth*1.0)/(((clientAreaWhole.right - clientAreaWhole.left) + 1)*1.0);
		   ratY=(m_iActualHeight*1.0)/(((clientAreaWhole.bottom - clientAreaWhole.top) + 1)*1.0);

           // caluclate base test position
           double TextY=h-(m_CPointCross.y)-1;
           TextY*=ratY*scale;

           double TextX=m_CPointCross.x;
           TextX*=ratX*scale;

           // calculate delta for absolute test position
           double diffY=m_CPointCross.y*destDC->GetTextExtent("1").cy;
           diffY /= (double) (((clientAreaWhole.bottom - clientAreaWhole.top) + 1)*1.0);

           int diffYABS=destDC->GetTextExtent("1").cy;

           msg.Format("%.3f", TextX);
           double diffX=m_CPointCross.x*destDC->GetTextExtent(msg).cx;
           diffX /= (double) (((clientAreaWhole.right - clientAreaWhole.left) + 1)*1.0);

		   RECT rec, destrec;
			
		   rec.left = clientAreaWhole.left;
		   rec.top = clientAreaWhole.top+m_CPointCross.y; 
		   rec.right = clientAreaWhole.right;
		   rec.bottom = rec.top+1;

		   /*CString msg2;
		   msg2.Format("Awe: h=%xh, r.l=%d, r.t=%d, r.r=%d, r.b=%d y=%d W.t=%d", pScreen->hmon, rec.left, rec.top, rec.right, rec.bottom, y, clientAreaWhole.top);
		   PrintServerMessage(msg2);*/

		   if (RectIntersectsMonitor(&rec, pScreen->hmon, &destrec) == TRUE)
		   {
			   destDC->MoveTo( destrec.left, destrec.top );
			   destDC->LineTo( destrec.right, destrec.top );

			   /*CString msg1;
			   //msg1.Format("SRC x=%d y=%d rec.left=%d rec.right=%d rec.top=%d rec.bottom=%d", x,y,rec.left, rec.right, rec.top, rec.bottom);
		       msg1.Format("d DR: left=%d, top=%d, right=%d, bottom=%d",destrec.left, destrec.top, destrec.right, destrec.bottom);
               PrintServerMessage( msg1 );*/
		   }
		   else
		   {
			   /*CString msg1;
			   //msg1.Format("SRC x=%d y=%d rec.left=%d rec.right=%d rec.top=%d rec.bottom=%d", x,y,rec.left, rec.right, rec.top, rec.bottom);
			   msg1.Format("ND !");
			   PrintServerMessage( msg1 );*/
		   }

		   /*CString msg1;
		   //msg1.Format("SRC x=%d y=%d rec.left=%d rec.right=%d rec.top=%d rec.bottom=%d", x,y,rec.left, rec.right, rec.top, rec.bottom);
		   msg1.Format("SRC hm=%xh x=%d y=%d left=%d, top=%d, right=%d, bottom=%d", pScreen->hmon, x, y, destrec.left, destrec.top, destrec.right, destrec.bottom);
           PrintServerMessage( msg1 );*/
		   //msg1.Format(
		       //PrintServerMessage( msg1 );

       	   msg.Format("%.3f", TextY);
						
		   rec.left = clientAreaWhole.left+3;
		   rec.top = clientAreaWhole.top+(int)(m_CPointCross.y-diffY);
		   rec.right = rec.left+destDC->GetTextExtent(msg).cx;
		   rec.bottom = rec.top+destDC->GetTextExtent(msg).cy;


		   if (RectIntersectsMonitor(&rec, pScreen->hmon, &destrec ) == TRUE)
		   {
			   //msg1.Format("left=%d, top=%d\n", destrec.left, destrec.top);
		       //PrintServerMessage( msg1 );
			   
			   destDC->TextOut(destrec.left,destrec.top, msg); // print value in _scaled_ pixels
		   }
		   
		   rec.left = clientAreaWhole.left+m_CPointCross.x;
		   rec.top = clientAreaWhole.top;
		   rec.right = rec.left+1;
		   rec.bottom = clientAreaWhole.bottom;

		   if (RectIntersectsMonitor(&rec, pScreen->hmon, &destrec ) == TRUE)
		   {
			   destDC->MoveTo( destrec.left, destrec.top );
			   destDC->LineTo( destrec.left, destrec.bottom );
		   }

		   /*
		   CString msg1;
		   //msg1.Format("SRC x=%d y=%d rec.left=%d rec.right=%d rec.top=%d rec.bottom=%d", x,y,rec.left, rec.right, rec.top, rec.bottom);
		   msg1.Format("SRC x=%d y=%d left=%d, top=%d, right=%d, bottom=%d", x, y, destrec.left, destrec.top, destrec.right, destrec.bottom);
           PrintServerMessage( msg1 );
		   //msg1.Format(
		       //PrintServerMessage( msg1 );
			*/

           msg.Format("%.3f", TextX);
		   
		   rec.left = clientAreaWhole.left+(int)(m_CPointCross.x-diffX);
		   rec.top = clientAreaWhole.top+(int)(h-diffYABS);
		   rec.right = rec.left+destDC->GetTextExtent(msg).cx;
		   rec.bottom = rec.top+destDC->GetTextExtent(msg).cy;

		   if (RectIntersectsMonitor(&rec, pScreen->hmon, &destrec ) == TRUE)
		   {
			   destDC->TextOut(destrec.left,destrec.top, msg); // print value in _scaled_ pixels
		   }
	   } 
	 //}

     // finished drawing mouse cross 
     hres1 = pScreen->pddsBack->ReleaseDC( hdc );  
     if (hres1 == DDERR_SURFACELOST) 
	 { 
		 pScreen->pdd->RestoreAllSurfaces();
		 //PrintServerMessage("SurfaceLost on releaseDC");
	 }
   }
  }  
  // blit the entire video bitmap buffer onto the main dialog 

  OnPaint();

}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user presses ALT-F4 or selects 
// Application->Close from the menu. It just calls the QuitApplication() 
// procedure which deinitializes and cleans up. After this, OnOK from the
// base class is called to quit the application.
//
void CVideoclntDlg::OnApplicationQuit() 
{
    QuitApplication(); // do clean up if necessary

	CDialog::OnOK(); // quit!
}

///////////////////////////////////////////////////////////////////////////////
//
// This procedure opens the options dialog where the user can make some changes, 
// e.g. change the server name and port etc. For specific information on what 
// can be changed please look into the class CConfigDlg.
// 
void CVideoclntDlg::OnApplicationOptions() 
{
    CConfigDlg *dlg = new CConfigDlg( this ); // instantiate dynamic dialog
	if (dlg == NULL) 
	{
		OwnMessageBox(MB_ICONEXCLAMATION, "Failed to create config dialog.");
		return;
	}

    dlg->SetIniFile( m_pIniFileExeGlobal,m_pIniFileExeLocal, m_pIniFileProf ); // set ini file reference pointer (needed to r/w the ini file)
    dlg->SetTineProperties( m_pImageAcquire->IsTineEnabled(), m_pImageAcquire->CanTineBeEnabled() );

    int ret = dlg->DoModal(); // call dialog

    if (ret == IDOK)
	{
		DeinitializeDAQFunction();

		BOOL ret = InitializeDAQFunction();
		
		if (m_pImageAcquire != NULL)
		{
			m_pImageAcquire->Done();
			CString tinepoll = m_pIniFileExeLocal->GetValue("MAIN", "TinePollMode", "POLL.NETWORK");
			m_pImageAcquire->Init( dlg->ReturnTransferMode(), tinepoll );
		}
	
		if (dlg->ReturnServerReInititialisation() == TRUE)
		{

			m_bDrawingInitialized = FALSE;
			CleanupServerCheckLink();

			InitializeServerConnections();
			
			m_bDrawingInitialized = TRUE;
			ReinitializeImageSettings(); // reinitialisation
			
		}      

		if (ret == FALSE)
		{
			OnApplicationQuit();
		}

	}

 	delete dlg; // after the user has closed the dialog, free up memory and call the destructor

}

///////////////////////////////////////////////////////////////////////////////
//
// This procedure is called whenever the user selects 'Messages' from
// the 'Application' menu. It toggles the messages window. The messages window is 
// in principle the history of the status line plus some additional messages.
//  
void CVideoclntDlg::OnApplicationMessages() 
{
	if (m_bMessagesWindowOpen == TRUE)// it's open
	{
		m_bMessagesWindowOpen = FALSE; // set flag so that no one wants to write on it

        // close messages window
		m_wndMessages->ShowWindow(SW_HIDE); //hide it
		m_wndMessages->DestroyWindow(); // destroy it 
		
		CheckMenuItem(ID_APPLICATION_MESSAGES, FALSE); // uncheck menu item
	}
	else
	{
		// open messages window
		if (m_wndMessages == NULL) // not yet instantiated
		{
			m_wndMessages = new CMessagesDlg(); // create it 
			if (m_wndMessages == NULL)
			{
				OwnMessageBox(MB_ICONEXCLAMATION, "Failed to create messages dialog.");
				return; 
			}
			m_wndMessages->SetMainDlg(this); // set main dialog pointer
		}
		// create the dialog
		m_wndMessages->Create(IDD_DIALOG2_MESSAGES, GetDesktopWindow() );
		// make it topmost (set on top)
		m_wndMessages->SetWindowPos( &wndTopMost, 0,0,0,0,SWP_NOMOVE | SWP_NOSIZE );
		// show it
		m_wndMessages->ShowWindow(SW_SHOW);

		// set flag to indicate that window is open
		m_bMessagesWindowOpen = TRUE;

		// check menu item 'Messages'
		CheckMenuItem(ID_APPLICATION_MESSAGES, TRUE);
	}
} 

///////////////////////////////////////////////////////////////////////////////
//
// This procedure will be called by the messages window to tell the main 
// application dialog that the messages window will be closed. After this 
// function call has finished, we can not print any more in the messages window.
//
void CVideoclntDlg::SetMessagesWindowStatus()
{
 // clear flag to indicate that we can not print on the messages dialog any more
 m_bMessagesWindowOpen = FALSE;

 // destroy window
 m_wndMessages->DestroyWindow();
 
 // uncheck menuitem 'Messages'
 CheckMenuItem(ID_APPLICATION_MESSAGES, FALSE);
}

///////////////////////////////////////////////////////////////////////////////
//
// This function will enable or disable a menuitem which is specified through its 
// id. The menu item will be grayed.
//
// Parameters:
//  item_id   - id of the item to enable or disable
//  enabled   - TRUE: enable menu item   FALSE: disable and gray menu item
//
void CVideoclntDlg::SetMenuItem(int item_id, BOOL enabled)
{
  CMenu* pMenu = this->GetMenu(); // obtain temporary menu object

  // build up action parameter
  UINT action = MF_BYCOMMAND;
  if (enabled == TRUE) action |= MF_ENABLED; else action |= MF_DISABLED | MF_GRAYED;

  if (pMenu != NULL) // menu could be obtained
  {
      pMenu->EnableMenuItem( (UINT) item_id, action ); // enable/disable menu item
	  this->DrawMenuBar(); // redraw menu bar
  }
}

BOOL CVideoclntDlg::IsMenuItemEnabled(int item_id)
{
  CMenu* pMenu = this->GetMenu(); // obtain temporary menu object

  // build up action parameter
  UINT action = MF_BYCOMMAND;
  
  if (pMenu != NULL) // menu could be obtained
  {
      UINT ret = pMenu->GetMenuState( (UINT) item_id, action ); // get menu item state
      if ((ret&MF_ENABLED) == MF_ENABLED) return TRUE;
  }
  return FALSE;
}


///////////////////////////////////////////////////////////////////////////////
//
// This function will enable or disable a menuitem which is specified through its 
// position in its topmenu. The menu item will be grayed when it is disabled.
//
// Parameters:
//  topmenuid  - id of the top menu in which the item is located
//  item_pos   - item position inside top menu
//  enabled    - TRUE: enable menu item   FALSE: disable and gray menu item
//
// Remarks:
//  Let's say you want to disable the Grab menuitem in the Image topmenu.
//  The function call would be 'SetMenuItemByPos(1, 2, FALSE); The first 
//  parameter is set to 1 because the Images Menu is the second menu in 
//  the menu bar (zero-based). The second parameter is also zero based. As 
//  the menu item 'Grab' is the third item its tem_pos must be set to 2. 
//
void CVideoclntDlg::SetMenuItemByPos(int topmenuid, int item_pos, BOOL enabled)
{
  CMenu* pMenu = this->GetMenu(); // get main menu
  CMenu* pMenu1 = pMenu->GetSubMenu( topmenuid ); // get submenu with id 'topmenuid'

  // build up action parameter
  UINT action = MF_BYPOSITION;
  if (enabled == TRUE) action |= MF_ENABLED; else action |= MF_DISABLED | MF_GRAYED;

  if (pMenu1 != NULL) // topmenu could be obtained
  {
      pMenu1->EnableMenuItem( (UINT) item_pos, action ); // enable/disable menu item
	  this->DrawMenuBar(); // redraw menu bar
  }
}

///////////////////////////////////////////////////////////////////////////////
//
// This function will check or uncheck a menuitem which is specified through its 
// id. 
//
// Parameters:
//  item_id   - id of the item to check or uncheck 
//  checked   - TRUE: check menu item   FALSE: uncheck menu item
//
void CVideoclntDlg::CheckMenuItem(int item_id, BOOL checked)
{
  CMenu* pMenu = this->GetMenu(); // get main menu

  // build up the action command
  UINT action = MF_BYCOMMAND;
  if (checked == TRUE) action |= MF_CHECKED; else action |= MF_UNCHECKED;

  if (pMenu != NULL) // menu could be instantiated
  {
      pMenu->CheckMenuItem( (UINT) item_id, action ); //check or uncheck
	  this->DrawMenuBar(); // redraw the menu bar
  }
}


///////////////////////////////////////////////////////////////////////////////
//
// This function is called every time the user selects 'Poll' from the 'Image' 
// menu. Poll-mode is either enabled or disabled. This function can also be 
// invoked through the hotkey 'ALT-P'.
// 
void CVideoclntDlg::OnMenuImagePoll() 
{
	TogglePollMode();
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called every time the user selects 'False color' from the 
// 'Application->Color mode' menu. False color mode is enabled by calling this 
// function. This function can also be invoked through the hotkey 'F6'.
// 
void CVideoclntDlg::OnApplicationColormodeFalsecolor() 
{
	m_iFalseColor = 1; // set falsecolor flag to true (false color mode=on)

	// check falsecolor and uncheck grayscale
	CheckMenuItem(ID_APPLICATION_COLORMODE_FALSECOLOR, TRUE);
	CheckMenuItem(ID_APPLICATION_COLORMODE_GRAYSCALE, FALSE);
	CheckMenuItem(ID_APPLICATION_COLORMODE_MATLABFALSECOLOR, FALSE);

	/* update color tables etc. */
    UpdatePalette(m_iFalseColor);

	DisplayFunction(NULL, 0, TRUE); // redraw
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called every time the user selects 'Grayscale' from the 
// 'Application->Color mode' menu. Grayscale mode is enabled by calling this 
// function. This function can also be invoked through the hotkey 'F5'.
// 
void CVideoclntDlg::OnApplicationColormodeGrayscale() 
{
	m_iFalseColor = 0; // grayscale mode

	// uncheck falsecolor and check grayscale
	CheckMenuItem(ID_APPLICATION_COLORMODE_FALSECOLOR, FALSE);
	CheckMenuItem(ID_APPLICATION_COLORMODE_GRAYSCALE, TRUE);
	CheckMenuItem(ID_APPLICATION_COLORMODE_MATLABFALSECOLOR, FALSE);

//	CheckMenuItem(ID_APPLICATION_COLORMODE_COLORCUBEFALSECOLOR, FALSE);
//	CheckMenuItem(ID_APPLICATION_COLORMODE_LINESFALSECOLOR, FALSE);
//	CheckMenuItem(ID_APPLICATION_COLORMODE_PRISMFALSECOLOR, FALSE);

	/* update color tables etc. */
	UpdatePalette(m_iFalseColor);

	DisplayFunction(NULL, 0, TRUE); // redraw
}

void CVideoclntDlg::OnApplicationColormodeMatlabfalsecolor() 
{
	m_iFalseColor = 2; // MATLAB false color (JET)

	// uncheck falsecolor and check grayscale
	CheckMenuItem(ID_APPLICATION_COLORMODE_FALSECOLOR, FALSE);
	CheckMenuItem(ID_APPLICATION_COLORMODE_GRAYSCALE, FALSE);
	CheckMenuItem(ID_APPLICATION_COLORMODE_MATLABFALSECOLOR, TRUE);
//	CheckMenuItem(ID_APPLICATION_COLORMODE_COLORCUBEFALSECOLOR, FALSE);
//	CheckMenuItem(ID_APPLICATION_COLORMODE_LINESFALSECOLOR, FALSE);
//	CheckMenuItem(ID_APPLICATION_COLORMODE_PRISMFALSECOLOR, FALSE);


	/* update color tables etc. */
	UpdatePalette(m_iFalseColor);

	DisplayFunction(NULL, 0, TRUE); // redraw
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called every time the user selects 'Stay on top' from the 
// 'Application' menu. This function toggles the m_bStayOnTop flag and sets 
// the window properties accordingly. If the window stayed on top before the 
// function call, the window will not stay on top any more. 
// Otherwise 'TopMost'-mode is set.
// 
void CVideoclntDlg::OnApplicationStayontop() 
{
	if (m_bStayOnTop == FALSE) // actually not staying on top?
	{
        // make the window topmost
		SetWindowPos( &wndTopMost, 0,0,0,0, SWP_NOSIZE | SWP_NOMOVE );
		// check menu item 'Stay on top' to indicate it
		CheckMenuItem( ID_APPLICATION_STAYONTOP, TRUE);
		// adjust flag
		m_bStayOnTop = TRUE;
	}
	else
	{
        // make the window not topmost
		SetWindowPos( &wndNoTopMost, 0,0,0,0, SWP_NOSIZE | SWP_NOMOVE );
		// uncheck menu item 'Stay on top' to indicate it
		CheckMenuItem( ID_APPLICATION_STAYONTOP, FALSE);
		// adjust flag
		m_bStayOnTop = FALSE;
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// This function does all cleanup that is necessary to proper quit the 
// application. For example it could be that poll mode is still on, so it has
// to be switched off.
// 
void CVideoclntDlg::QuitApplication()
{
    if (m_bPollMode == TRUE) // poll mode on ? 
    {
      StopPollMode(); // then shut down poll mode
    }

	// kill the camera port update timer
	//if (m_nTimer != 0) KillTimer( m_nTimer );

	// delete memory structures where frames were stored
	if (m_pLastFrame != NULL) memman.sw_free( (void *) m_pLastFrame );
	if (m_pBackground != NULL) memman.sw_free( (void *) m_pBackground );
	//if (m_pGrabBuffer != NULL) memman.sw_free( (void *) m_pGrabBuffer );
	if (m_pNormalizedImage != NULL) memman.sw_free( (void *) m_pNormalizedImage );

	CleanupServerCheckLink();
	VariantClear( &m_vNewCameraID );

	// deinitialize drawing
	DeinitializeDrawing();

	// deinitialize compression
    DeinitializeCompression();

	if (m_pColorTable != NULL) memman.sw_free( (void *) m_pColorTable );

	if (m_pImageAcquire != NULL)
	{
     m_pImageAcquire->Done();
  	 delete m_pImageAcquire;
	 m_pImageAcquire = NULL;
	}

    if (m_pCATineDlg != NULL) 
	{
	 m_pCATineDlg->DestroyWindow();
	 delete m_pCATineDlg;
     m_pCATineDlg = NULL;
	}

	DeinitializeDAQFunction();

	// delete the memory location to store the decompressed frame
    if (m_pDecompressedFrame != NULL) memman.sw_free( (void *) m_pDecompressedFrame );

    if (m_pImageSequence != NULL) delete m_pImageSequence;

    if (m_pStatFile != NULL)
    {
	  delete m_pStatFile; // then destruct it and free memory
	  m_pStatFile = NULL;
    }

	DeinitializeIniFiles();
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is there to ecapsulate the calculation of palettes needed to display
// the grayscaled video frames. If the input parameter is set to true, the function
// generates a false color palette. If the input parameter is set to false, the function
// generates a grayscale palette where 0 is pure black and 255 is pure white.
// 
BOOL CVideoclntDlg::UpdatePalette(int falsecolor)
{
	// indicate other parts of the program that there is a palette change in progress
	m_bPaletteChangeInProgress = TRUE;
 
	PALETTEENTRYSW *rgb_entries;
	int i;
	Screen *pScreen;

	int different_colorvalues = 1 << m_iActualBpp;
	int different_effective_colorvalues = 1 << m_iActualBppEffective;

	rgb_entries = (PALETTEENTRYSW *) memman.sw_malloc( sizeof( PALETTEENTRYSW ) * different_colorvalues );

	if (rgb_entries == NULL) // fatal error;
  		return FALSE;

	for (i=0;i<different_colorvalues;i++)
	{
		// make non-available entries 'magenta' color
		rgb_entries[i].peRed = 255;
		rgb_entries[i].peGreen = 0;
		rgb_entries[i].peBlue = 255;
		rgb_entries[i].peFlags = 0;
	}

	// now build real palette:

	switch( falsecolor )
	{
		case 1:
			{
			// fill in PITZ false colors

			double dec = (double) different_effective_colorvalues;
			rgb_entries[0].peRed      = 0;
			rgb_entries[0].peGreen    = 0;
			rgb_entries[0].peBlue     = 0;

			rgb_entries[different_effective_colorvalues-1].peRed      = 255;
			rgb_entries[different_effective_colorvalues-1].peGreen    = 255;
			rgb_entries[different_effective_colorvalues-1].peBlue     = 255;

			int step1min = 1;
			int step1max = (different_effective_colorvalues/3);
			
			int step2min = step1max + 1;
			int step2max = ((different_effective_colorvalues*293)/500);
			
			int step3min = step2max + 1;
			int step3max = ((different_effective_colorvalues*2)/3);
			
			int step4min = step3max + 1;
			int step4max = different_effective_colorvalues-1;

			for (i=step1min;i<step2min;i++)
			{
				double m = -0.5608 / (dec/3-1.0);
				double n = 1.0 - m*1.0;
				
				rgb_entries[i].peRed      = 0;
				rgb_entries[i].peGreen    = 0;
				rgb_entries[i].peBlue     = (unsigned int) ((m*i+n)*255.0);
			}

			for (i=step2min;i<step3min;i++)
			{
				double m1= 0.561 / ( (dec*293/500)-(dec/3));
				double n1 = 0.263 - (m1 * (dec/3));
			
				double m2= -0.4314 / ( (dec*293/500)-(dec/3));
				double n2 = 0 - (m2 * (dec*293/500));

				rgb_entries[i].peRed      = 0;
				rgb_entries[i].peGreen    = (unsigned int) ((m1*i+n1)*255.0);
				rgb_entries[i].peBlue     = (unsigned int) ((m2*i+n2)*255.0);
			}

			for (i=step3min;i<step4min;i++)
			{
				double m1= 0.176 / ( (dec*2/3)-(dec*293/500));
				double n1 = 1 - (m1 * (dec*2/3));
				
				rgb_entries[i].peRed      = 0;
				rgb_entries[i].peGreen    = (unsigned int) ((m1*i+n1)*255.0);
				rgb_entries[i].peBlue     = 0;
			}
			
			for (i=step4min;i<step4max;i++)
			{
				double m1= 0.737 / (dec-(dec*2/3));
				double n1 = 1 - (m1 * dec);
			
				rgb_entries[i].peRed      = (unsigned int) ((m1*i+n1)*255.0);
				rgb_entries[i].peGreen    = 0;
				rgb_entries[i].peBlue     = 0; 
			}
			}
		    break;

		case 2: // MATLAB JET false color
			{
			int step1min = 0;
			int step1max = (different_effective_colorvalues/8)-1;
			
			int step2min = step1max + 1;
			int step2max = ((different_effective_colorvalues*3)/8)-1;
			
			int step3min = step2max + 1;
			int step3max = ((different_effective_colorvalues*5)/8)-1;
			
			int step4min = step3max + 1;
			int step4max = ((different_effective_colorvalues*7)/8)-1;
			
			int step5min = step4max + 1;
			int step5max = different_effective_colorvalues-1;

			rgb_entries[different_effective_colorvalues-1].peRed      = (unsigned int) (1.0*255.0);
			rgb_entries[different_effective_colorvalues-1].peGreen    = (unsigned int) (1.0*255.0);
			rgb_entries[different_effective_colorvalues-1].peBlue     = (unsigned int) (1.0*255.0);


			for (i=step1min;i<step2min;i++)
			{
				rgb_entries[i].peRed      = 0;
				rgb_entries[i].peGreen    = 0;
				rgb_entries[i].peBlue     = (unsigned int) ((((i/2.0)/step2min)+0.5)*255.0);
			}

			for (i=step2min;i<step3min;i++)
			{
				rgb_entries[i].peRed      = 0;
				rgb_entries[i].peGreen    = (unsigned int) (((i/(step2min*2.0))-0.5) *255.0);
				rgb_entries[i].peBlue     = (unsigned int) (1*255.0);
			}

			for (i=step3min;i<step4min;i++)
			{
				rgb_entries[i].peRed      = (unsigned int) (((i/(step2min*2.0))-1.5) *255.0);
				rgb_entries[i].peGreen    = (unsigned int) (1*255.0);
				rgb_entries[i].peBlue     = (unsigned int) ((1.0-((i/(step2min*2.0))-1.5))*255.0);
			}
			
			for (i=step4min;i<step5min;i++)
			{
				rgb_entries[i].peRed      = (unsigned int) (1*255.0);
				rgb_entries[i].peGreen    = (unsigned int) (((i/(-(step2min*2.0)))+3.5) *255.0);
				rgb_entries[i].peBlue     = 0; 
			}

			for (i=step5min;i<step5max;i++)
			{
				rgb_entries[i].peRed      = (unsigned int) (((i/(-(step2min*2.0)))+4.5) *255.0);
				rgb_entries[i].peGreen    = 0;
				rgb_entries[i].peBlue     = 0; 
			}
			}
		    break;

		default: // grayscale mode
			{
			double dec = (double) different_effective_colorvalues;
	 
			for (i=0; i<different_effective_colorvalues; i++)
			{
				rgb_entries[i].peRed      = (unsigned int) ((i*255.0)/(dec-1));
				rgb_entries[i].peGreen    = (unsigned int) ((i*255.0)/(dec-1));
				rgb_entries[i].peBlue     = (unsigned int) ((i*255.0)/(dec-1));
			}
			}
			break;
	}
	if (m_pColorTable != NULL) memman.sw_free( (void *) m_pColorTable );

	m_pColorTable = rgb_entries;
	//was: memcpy( &m_ColorTable, &palentries, sizeof(palentries) );

	for (pScreen = s_pScreenFirst; pScreen != NULL; pScreen = pScreen->pScreenNext)
	{
		int bpp = pScreen->m_uiRGBBitCount;

		for (int k=0;k<different_colorvalues;k++)
		{
			unsigned short int fred = (unsigned short int) m_pColorTable[k].peRed;
			unsigned short int fgrn = (unsigned short int) m_pColorTable[k].peGreen;
			unsigned short int fblu = (unsigned short int) m_pColorTable[k].peBlue;

			unsigned short first16;

			if (pScreen->m_uiRBitCount > 8) { fred <<= (pScreen->m_uiRBitCount-8);  }
			if (pScreen->m_uiRBitCount < 8) { fred >>= (8-pScreen->m_uiRBitCount);  }

			if (pScreen->m_uiGBitCount > 8) { fgrn <<= (pScreen->m_uiGBitCount-8);  }
			if (pScreen->m_uiGBitCount < 8) { fgrn >>= (8-pScreen->m_uiGBitCount);  }

			if (pScreen->m_uiBBitCount > 8) { fblu <<= (pScreen->m_uiBBitCount-8);  }
			if (pScreen->m_uiBBitCount < 8) { fblu >>= (8-pScreen->m_uiBBitCount);  }

			if (pScreen->m_iRBitPos > 0) { fred <<= pScreen->m_iRBitPos;  }
			if (pScreen->m_iGBitPos > 0) { fgrn <<= pScreen->m_iGBitPos;  }
			if (pScreen->m_iBBitPos > 0) { fblu <<= pScreen->m_iBBitPos;  }

			first16  = fred + fgrn + fblu;

			pScreen->cat16[k].pixel16 = first16;

			unsigned long first32;

			unsigned long int fred32 = (unsigned long int) m_pColorTable[k].peRed;
			unsigned long int fgrn32 = (unsigned long int) m_pColorTable[k].peGreen;
			unsigned long int fblu32 = (unsigned long int) m_pColorTable[k].peBlue;

			if (pScreen->m_uiRBitCount > 8) { fred32 <<= (pScreen->m_uiRBitCount-8); }
			if (pScreen->m_uiRBitCount < 8) { fred32 >>= (8-pScreen->m_uiRBitCount); }

			if (pScreen->m_uiGBitCount > 8) { fgrn32 <<= (pScreen->m_uiGBitCount-8); }
			if (pScreen->m_uiGBitCount < 8) { fgrn32 >>= (8-pScreen->m_uiGBitCount); }

			if (pScreen->m_uiBBitCount > 8) { fblu32 <<= (pScreen->m_uiBBitCount-8); }
			if (pScreen->m_uiBBitCount < 8) { fblu32 >>= (8-pScreen->m_uiBBitCount); }

			if (pScreen->m_iRBitPos > 0) { fred32 <<= pScreen->m_iRBitPos; }
			if (pScreen->m_iGBitPos > 0) { fgrn32 <<= pScreen->m_iGBitPos; }
			if (pScreen->m_iBBitPos > 0) { fblu32 <<= pScreen->m_iBBitPos; }

			first32  = fred32 + fgrn32 + fblu32;

			pScreen->cat32[k].pixel32 = first32;
			
		}
	}

	// tell other program pieces that we are finished changing the palette 
	m_bPaletteChangeInProgress = FALSE;

	//DisplayFunction(NULL, 0, TRUE); // redraw

	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//
// This function does all initialization that is needed to go into poll mode.
// It mainly connects to the proper server using the SSyncSocket socket class and
// starts the receive thread which grabs the frames. If everything went fine, 
// the function returns TRUE, otherwise it returns FALSE.
//
BOOL CVideoclntDlg::StartPollMode()
{
	  // initialize variables needed for measuring the dropped frames
	  m_iFirstFrame = -1;
	  m_iCountedFrames = 0;

	  // instantiate video queue (transfer queue from receive thread to the main thread)
	  m_video_queue = new CQueue();
	  if (m_video_queue == NULL) return FALSE;

	  
      CServer srv;
	  m_ServerList.getServer( m_iActualServerPos, srv );

	  /* SW! Apr 26, 2006 commented out, should not be necessary
      CheckServerSettings( srv );
	  */

	  CString msg1;
	  msg1.Format("Connecting to %s...", srv.getNickname() );
	  PrintServerMessage( msg1 );

      BOOL ret = m_pImageAcquire->StartPollMode( srv, m_video_queue );

	  if (ret == TRUE) 		  
	  {
	      // initialize frames polled
		  m_CEditFramesPolled.SetWindowText("0");
		  m_bTransferRunning = TRUE;
		  CString msg;
		  msg.Format("Connected to %s - Poll mode started.", srv.getNickname() );
		  PrintServerMessage( msg );

		  SetCaption( "Video Client 2 on", "", srv.getNickname() );
      }

      return( ret );

}

///////////////////////////////////////////////////////////////////////////////
//
// This function does all deinitialization that is needed to leave poll mode.
// It mainly closes the socket (disconnects from the server) to tell the receive
// thread that it should stop. Then it waits for the receive thread to come down 
// and frees up some memory (video queue).
//
BOOL CVideoclntDlg::StopPollMode()
{
   PrintServerMessage("Disconnecting...");	

   m_pImageAcquire->StopPollMode();
   
   m_pImageSequence->AcquireDoocsProperties();
   
   m_video_queue->EmptyQueue();
   // destruct video queue (because it is no longer needed)
   delete m_video_queue;
   m_video_queue = NULL;

   // print success message
   PrintServerMessage("Disconnected.");	

   SetCaption( "Video Client 2 ", "", "" );

   m_bTransferRunning = FALSE;

   return TRUE;
}


///////////////////////////////////////////////////////////////////////////////
//
// This function connects to the server, acquires a background image, decompresses
// it if necessary and stores it in the proper background memory location. The 
// parameters specify the width and the height of the background image in pixels.
// Width and height should be set to 768 and 574. The function returns TRUE if every-
// thing went fine or FALSE if there was an error.
//

void CVideoclntDlg::GetBackgroundFromServerCallback()
{
	// read in grabbed frames

	int size = m_grab_queue->GetSize();

	if (size != 1)
	{
		PrintServerMessage("Could not grab background. Maybe the server is not grabbing.");
		OwnMessageBox(MB_ICONEXCLAMATION, "Could not grab background. Maybe the server is not grabbing.");
  
		if (size != 0)
		{
			for (int i=0;i<size;i++)
			{
				void *tmpptr = m_grab_queue->RemoveHead();
				if (tmpptr != NULL) memman.sw_free( tmpptr );
			}
		}
		return;

	}//if size != 1

	// if we are here everything went fine with acquiring the background image

	VIDHDR vidH;
	char *tmpptr = (char *) m_grab_queue->RemoveHead();
	if (tmpptr != NULL)
	{
		char *moveptr = (char *) tmpptr;

		// extract video header out of the grab buffer
		memman.memcpysw( (char *) &vidH, moveptr, sizeof(VIDHDR));

		if (CheckFrameheaderSettings( vidH ) == FALSE)
		{
			OwnMessageBox(MB_ICONEXCLAMATION, "Grabbed image (get background) is not compatible to current video resolution and bitdepth setting !\nImage was discarded. Old background was kept.");
		}
		else
		{
			// extract the background image out of the grab buffer
			memman.memcpysw( m_pBackground, moveptr + sizeof(VIDHDR), vidH.heightframe*vidH.widthframe*vidH.bpp/8 );
  
			// display the background (-1 = background image)
			DisplayFunction((char *) m_pBackground, -1, FALSE);
		}

		memman.sw_free( (void *) tmpptr ); 
	}
	else
	{
		OwnMessageBox(MB_ICONEXCLAMATION, "Queue empty. Could not grab background.");
	}

}

BOOL CVideoclntDlg::GetBackgroundFromServer()
{
  // get server name and port number from ini file
  CString msg;

  // get server name from ini file and set up TINE properties
  
  
  CServer srv;
  m_ServerList.getServer( m_iActualServerPos, srv );
  
  /* SW! Apr 26, 2006 commented out, should not be necessary
  CheckServerSettings( srv );
  */

  m_iGrabDestination = 1; 
  m_grab_queue = new CQueue();
  if (m_grab_queue == NULL) return FALSE;

  BOOL ret = m_pImageAcquire->GrabFrames( srv, m_grab_queue, 1, 1);
  if (ret == TRUE)
  {
   DisableMenusForGrab();
   m_bTransferRunning = TRUE;
  }

  return ret;
}


///////////////////////////////////////////////////////////////////////////////
//
// This function connects to the server, acquires a background image, decompresses
// it if necessary and stores it in the proper background memory location. The 
// parameters specify the width and the height of the background image in pixels.
// Width and height should be set to 768 and 574. The function returns TRUE if every-
// thing went fine or FALSE if there was an error.
//
//
//
// Envelop=True envelope =FALSE average
BOOL CVideoclntDlg::GetBackgroundsFromServer( int numframes, BOOL envelope)
{
  // get server name and port number from ini file
  CString msg;

  // get server name from ini file and set up TINE properties
  
  
  CServer srv;
  m_ServerList.getServer( m_iActualServerPos, srv );

  /* SW! Apr 26, 2006 commented out, should not be necessary
  CheckServerSettings( srv );
  */

  m_iGrabDestination = 2; 
  m_bEnvelope = envelope;

  int framerate = m_pIniFileExeLocal->GetValueInt("MAIN", "Framerate", 0);  
  int framerateoverride = m_pIniFileExeGlobal->GetValueInt(srv.getNickname(), "OverrideFramerate", 0 );
  if (framerateoverride != 0) framerate = framerateoverride;

  m_grab_queue = new CQueue();
  if (m_grab_queue == NULL) return FALSE;

  BOOL ret = m_pImageAcquire->GrabFrames( srv, m_grab_queue, numframes, framerate);
  if (ret == TRUE)
  {
   DisableMenusForGrab();
   m_bTransferRunning = TRUE;
  }

  return ret;
}


BOOL CVideoclntDlg::AddBackgroundFromServer()
{
  // get server name and port number from ini file
  CString msg;

  // get server name from ini file and set up TINE properties


  CServer srv;
  m_ServerList.getServer( m_iActualServerPos, srv );

  /* SW! Apr 26, 2006 commented out, should not be necessary  
  CheckServerSettings( srv );
  */

  m_iGrabDestination = 4; 
  m_grab_queue = new CQueue();
  if (m_grab_queue == NULL) return FALSE;

  BOOL ret = m_pImageAcquire->GrabFrames( srv, m_grab_queue, 1, 1);
  if (ret == TRUE)
  {
   DisableMenusForGrab();
   m_bTransferRunning = TRUE;
  }

  return ret;
}


void CVideoclntDlg::AddBackgroundFromServerCallback()
{
 // read in grabbed frames

 int size = m_grab_queue->GetSize();

 if (size != 1)
 {
  PrintServerMessage("Could not grab background. Maybe the server is not grabbing.");
  OwnMessageBox(MB_ICONEXCLAMATION, "Could not grab background. Maybe the server is not grabbing.");
  
  if (size != 0)
  {
   for (int i=0;i<size;i++)
   {
    void *tmpptr = m_grab_queue->RemoveHead();
	if (tmpptr != NULL) memman.sw_free( tmpptr );
   }
  }
  return;

 }//if size != 1

  // if we are here everything went fine with the acquiration of the background image

  VIDHDR vidH;
  char *tmpptr = (char *) m_grab_queue->RemoveHead();
  if (tmpptr != NULL)
  {
   char *moveptr = (char *) tmpptr;

   // extract video header out of the grab buffer
   memman.memcpysw( (char *) &vidH, moveptr, sizeof(VIDHDR));

   if (CheckFrameheaderSettings( vidH ) == FALSE)
   {
	   OwnMessageBox(MB_ICONEXCLAMATION, "Grabbed image (add background) is not compatible to current video resolution and bitdepth setting !\nImage was discarded. Old background was kept.");
   }
   else
   {
     if (vidH.bpp == 8)
	 {
	   unsigned char *bckgnd = (unsigned char *) m_pBackground;
       unsigned char *data = (unsigned char *) (moveptr + sizeof(VIDHDR));
   
       for (unsigned int i=0;i<vidH.heightframe*vidH.widthframe;i++)
       {
         unsigned int b = (unsigned int) bckgnd[i];
	     unsigned int d = (unsigned int) data[i];

	     b += d;
	     if (b > 255) b= 255;

	     bckgnd[i] = b;
	   }
	 }
	 else if (vidH.bpp == 16)
	 {
	   unsigned short *bckgnd = (unsigned short *) m_pBackground;
       unsigned short *data = (unsigned short *) (moveptr + sizeof(VIDHDR));
   
       for (unsigned int i=0;i<vidH.heightframe*vidH.widthframe;i++)
       {
         unsigned int b = (unsigned int) bckgnd[i];
	     unsigned int d = (unsigned int) data[i];

	     b += d;
	     if (b > 65535) b= 65535;

	     bckgnd[i] = b;
	   }
	 }
	 else // bpp == 32
	 {
	   unsigned long *bckgnd = (unsigned long *) m_pBackground;
       unsigned long *data = (unsigned long *) (moveptr + sizeof(VIDHDR));
   
       for (unsigned int i=0;i<vidH.heightframe*vidH.widthframe;i++)
       {
         double b = (double) bckgnd[i];
	     double d = (double) data[i];

	     b += d;
	     if (b > 4294967295) b= 4294967295;

	     bckgnd[i] = (unsigned long) b;
	   }
	 }

	 // display the background (-1 = background image)
     DisplayFunction( (char *) m_pBackground, -1, FALSE);
   
	 PrintServerMessage("Background added.");
   }

   memman.sw_free( (void *) tmpptr ); 
  }
  else
  {
	  OwnMessageBox(MB_ICONEXCLAMATION, "Queue empty. Could not grab background.");
  }

}


///////////////////////////////////////////////////////////////////////////////
//
// This function connects to the server, acquires a background image, decompresses
// it if necessary and stores it in the proper background memory location. The 
// parameters specify the width and the height of the background image in pixels.
// Width and height should be set to 768 and 574. The function returns TRUE if every-
// thing went fine or FALSE if there was an error.
//
//
//
// Envelop=True envelope =FALSE average

void CVideoclntDlg::GetBackgroundsFromServerCallback()
{
  // initialize variables for checking
  int port = -1;
  int lastframe = -1;
  BOOL portchange = FALSE;
  BOOL framesmissed = FALSE;
  BOOL resolutionfine = TRUE;
  int width;
  int height;
  int bpp;
  VIDHDR vidH;

  int size = m_grab_queue->GetSize();

  // loop over all grabbed frames
  for (int a=0;a<size;a++)
  {
   // extract 'a'# video header out of the grab buffer
   
   char *aktpos = (char *) m_grab_queue->GetElem( a );
   memman.memcpysw( (char *) &vidH, aktpos, sizeof(VIDHDR));

   width = vidH.widthframe; height = vidH.heightframe;
   bpp = vidH.bpp;

   if (CheckFrameheaderSettings( vidH ) == FALSE) resolutionfine = FALSE;
   
   // no port value set'ed
   if (port == -1)
   {
    lastframe = (unsigned) vidH.frameno; // set frame number to number of first frame
	port = vidH.cameraport; // set port number to port number of first frame
   }
   else
   {
	// if last port is not equal to camera port of actual frame 
    // then we have detected a port change
	if (port != (signed) vidH.cameraport) portchange = TRUE;
	// framenumber if not equal last_framenumber+1 the we have missed at least one frame
    if (vidH.frameno != (unsigned)(lastframe+1)) framesmissed = TRUE;
	// set last frame number to number of actual frame
	lastframe = vidH.frameno;
   }
  }

  // if there was a port change, print out warning message
  if (portchange == TRUE)
  {
   OwnMessageBox(MB_ICONEXCLAMATION, "Attention: Not all grabbed frames came from the same cameraport !\nThis is a severe error. Frames have been discarded and old background was not changed.");

   // delete the grabbed frames
   for (a=0;a<size;a++)
   {
    void *tmpptr = m_grab_queue->RemoveHead();
    if (tmpptr != NULL) memman.sw_free( tmpptr );
   } 

   return;
  }

  // if there were some frames missed, print out warning message
  if (resolutionfine == FALSE) 
  {
	  OwnMessageBox(MB_ICONEXCLAMATION, "At least one of the grabbed background images is not compatible to current video resolution and bitdepth setting !\nImages were discarded. Old background was not changed.");

	  // delete the grabbed frames
	  for (a=0;a<size;a++)
	  {
		  void *tmpptr = m_grab_queue->RemoveHead();
		  if (tmpptr != NULL) memman.sw_free( tmpptr );
	  } 

	  return;
  }

  
  // if there were some frames missed, print out warning message
  if (framesmissed == TRUE) 
  {
   OwnMessageBox(MB_ICONINFORMATION, "Attention: Some frames were missed while grabbing backgrounds!");
  }

  // if we are here everything went fine with the acquiration of the background image(s)

  // apply algorithm (envelop / average)
  // copy background

  BOOL success_process = TRUE;  
  BOOL retval;
  
  CEnvelopeAverage phelp;

  retval = phelp.Init(bpp, vidH, m_bEnvelope, m_bXRayFiltering );
  if (retval == FALSE) success_process = FALSE;
  if (retval == TRUE)
  {
     // loop over all grabbed frames
     for (int a=0;a<size;a++)
     {
      VIDHDR vidH1;
	  // extract 'a'# video header out of the grab buffer
      unsigned char *aktpos = (unsigned char *) m_grab_queue->GetElem( a );

	  memman.memcpysw( (char *) &vidH1, (char *) aktpos, sizeof(VIDHDR) );
      aktpos += sizeof(VIDHDR);

	  retval = phelp.AddFrame(aktpos, vidH1 );
	  if (retval == FALSE) success_process = FALSE;
     }

	 if (success_process == TRUE) phelp.ReturnBuffer( (unsigned char *) m_pBackground, NULL );
  }


  // delete the grabbed frames
  for (a=0;a<size;a++)
  {
   void *tmpptr = m_grab_queue->RemoveHead();
   if (tmpptr != NULL) memman.sw_free( tmpptr );
  } 

  if (success_process == TRUE)
  {  
      DisplayFunction( (char *) m_pBackground, -1, FALSE);
  }
   else
  {
	   CString msg("Error while processing backgrounds. Background was not changed!");
	   
	   PrintServerMessage(msg);
	   OwnMessageBox(MB_ICONEXCLAMATION, (LPCTSTR) msg );
  }
}

///////////////////////////////////////////////////////////////////////////////
//
// This function connects to the server, acquires exactly numframes images, 
// decompresses them if necessary and stores them in the grab buffer memory location.
// The grab buffer location is dynamically allocated. You don't have to make sure 
// that there are enough bytes allocated, this function reallocates it if necessary.
// The other parameters specify the width and the height of a single image in pixels.
// Width and height should be set to 768 and 574. The function returns TRUE if every-
// thing went fine or FALSE if there was an error.
//
BOOL CVideoclntDlg::GrabFramesFromServer( int numframes )
{
  // get server name and port number from ini file
  CString msg;

  // get server name from ini file and set up TINE properties

  CServer srv;
  m_ServerList.getServer( m_iActualServerPos, srv );

  /* SW! Apr 26, 2006 commented out, should not be necessary
  CheckServerSettings( srv );*/

  m_iGrabDestination = 3; 
  
  int framerate = m_pIniFileExeLocal->GetValueInt("MAIN", "Framerate", 0);  
  int framerateoverride = m_pIniFileExeGlobal->GetValueInt(srv.getNickname(), "OverrideFramerate", 0 );
  if (framerateoverride != 0) framerate = framerateoverride;

  m_grab_queue = new CQueue();
  if (m_grab_queue == NULL) return FALSE;

  BOOL ret = m_pImageAcquire->GrabFrames( srv, m_grab_queue, numframes, framerate);
  if (ret == TRUE)
  {
   DisableMenusForGrab();
   m_bTransferRunning = TRUE;
   SetCaption( "Video Client 2 on", "", srv.getNickname() );
  }

  return ret;
}

void CVideoclntDlg::GrabFramesFromServerCallback()
{
  VIDHDR vidH;
  char *tmpptr;
  int width;
  int height;
  int bpp;
  unsigned int bpp_eff;

  int numframes = m_grab_queue->GetSize();
  tmpptr = (char *) m_grab_queue->GetHead();
  memman.memcpysw((char *) &vidH, tmpptr, sizeof(VIDHDR) );

  width = vidH.widthframe;
  height = vidH.heightframe;
  bpp = vidH.bpp;
  bpp_eff = vidH.bpp_effective;

  // save old grab buffer, so if something happens
  // with the new one, we are able to restore the old one,
  // which may contain valuable data
  //unsigned char *pGrabBuffer_old;
  //int  iGrabBufferWidth_old;
  //int  iGrabBufferHeight_old;
  //int  iGrabBufferNumImages_old;

  //m_pImageSequence->AcquireDoocsProperties();
  CImageSequence *newseq;
  newseq = new CImageSequence( m_pCATineDlg, m_bTineALInitialized, m_pTineALDlg, this );
  if (newseq == NULL)
  {
    // print error message
	PrintServerMessage("Could not allocate buffer space needed for image storage!");

    OwnMessageBox(MB_ICONEXCLAMATION, "Could not allocate required memory while grabbing.");

	// return error code
	return;
  } 

  // the next block of code checks for two things: first we have to be sure that all frames 
  // were acquired from the same camera port (another client could have changed the camera port)
  // and whether not a single frame was dropped during the grabbing

  // initialize variables for checking
  int port = -1;
  int lastframe = -1;
  BOOL portchange = FALSE;
  BOOL framesmissed = FALSE;
  
  // loop over all grabbed frames
  for (int a=0;a<numframes;a++)
  {
   // extract 'a'# video header out of the grab buffer
   char *aktpos = (char *) m_grab_queue->GetElem(a);
   memman.memcpysw( (char *) &vidH, aktpos, sizeof(VIDHDR));

   // no port value set'ed
   if (port == -1)
   {
    lastframe = (unsigned) vidH.frameno; // set frame number to number of first frame
	port = vidH.cameraport; // set port number to port number of first frame
   }
   else
   {
	// if last port is not equal to camera port of actual frame 
    // then we have detected a port change
	if (port != (signed) vidH.cameraport) portchange = TRUE;
	// framenumber if not equal last_framenumber+1 the we have missed at least one frame
    if (vidH.frameno != (unsigned)(lastframe+1)) framesmissed = TRUE;
	// set last frame number to number of actual frame
	lastframe = vidH.frameno;
   }
  }

  // if there was a port change, print out severe error message
  if (portchange == TRUE)
  {
   OwnMessageBox(0,"Attention: Not all grabbed frames came from the same camera !\nThis is a severe error. Frames have been discarded.\nPlease try again.");

   // delete the grabbed frames
   for (a=0;a<numframes;a++)
   {
    void *tmpptr = m_grab_queue->RemoveHead();
    if (tmpptr != NULL) memman.sw_free( tmpptr );
   } 

   delete newseq;

   return;
  }
  
  // if there were some frames missed, print out warning message
  if (framesmissed == TRUE) 
  {
	  OwnMessageBox(MB_ICONINFORMATION, "Attention: Some frames were missed while grabbing !");
  }

  CheckImageSettings( width, height, bpp, bpp_eff );

  BOOL copysuccessful=TRUE;

  // copy frames into grabbuffer and free the queue memory
  for (a=0;a<numframes;a++)
  {
   char *src = (char *) m_grab_queue->RemoveHead();
   
   if (src != NULL)
   {
    BOOL ret = newseq->Add( (unsigned char *) src );
	if (ret == FALSE) copysuccessful = FALSE;
   }
  }
 
  if (copysuccessful == FALSE)
  {
   delete newseq;

   CString msg;
   msg.Format("Error while grabbing frames. Could not copy the buffer.");
   PrintServerMessage(msg);
   OwnMessageBox(MB_ICONEXCLAMATION, (LPCTSTR) msg);

   return;
  }

  delete m_pImageSequence;
  m_pImageSequence = newseq;

  if (m_bDAQRunning) m_pImageSequence->AcquireDoocsProperties();

  SetScaleFactorInGUI( m_pImageSequence->GetScale() );
  
  /* SW! Apr 27, 2006 taken out
  SetScaleFromServer( m_iActualServerPos );

  // SW! Apr 26, 2006 warum wird das ANZEIGEFELD auskopiert ? 
  CString msg89;
  m_CEditScale.GetWindowText(msg89);
  double sc = atof( (const char *) (LPCTSTR) msg89 );
  m_pImageSequence->SetScale( sc );
  // SW! Apr 26, 2006 warum wird das ANZEIGEFELD auskopiert END ? 
  */

  CInformationDialog dlg;

  // make statistical analysis of the grabbed images if necessary
  MakeStatFile(m_pImageSequence, m_pNormalizedImage, m_bXRayFiltering);
  dlg.Show("Calculating...");
  
  if (m_pStatFile != NULL) m_pStatFile->START(); // start statistical analysis

  UpdateStatisticalValues(); // update the statistical values (mean, rms, etc.)
     
  dlg.Hide();

  // extract the video header out of the last frame in the grab buffer
  char *moveptr;
  m_pImageSequence->GetFrame( m_pImageSequence->Count()-1, (const char **) &moveptr);
  memman.memcpysw( (char *) &vidH, moveptr, sizeof(VIDHDR));
  
  // display the averaged and normalized and background subtracted image on the video frame
  DisplayFunction(m_pNormalizedImage, vidH.cameraport, FALSE);

  // now we can analyze an image (sequence maybe), so enable it
  SetMenuItem(ID_IMAGE_ANALYZE, TRUE);

  // now we can save an image (sequence maybe), so enable it
  SetMenuItem(ID_IMAGE_SAVE, TRUE);
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab a background. It is 
// called either by the menuitem in the background menu or via the hotkey 
// CTRL-G.
//
void CVideoclntDlg::OnMenuBackgroundGrab() 
{
    // call procedure which grabs background
	BOOL ret = GetBackgroundFromServer();

	if (ret == FALSE) // error while grabbing background?
	{
		// print error message
		CString msg("Unable to get background from Server.");

		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
	
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever a 'timeout' on the timer occurs. This function
// is called once per second to check whether the actual camera port is valid. It 
// just calls the UpdateCameraPort() function.
//
void CVideoclntDlg::OnTimer(UINT nIDEvent) 
{
	switch( nIDEvent )
	{
		case WM_TIMER_FLASH:

			m_tFlashAktTime = time(NULL);
			if (m_tFlashAktTime > (m_tFlashStartTime + m_tFlashDuration))
			{
				m_CComboCamera.Flash( FALSE, RGB(255,0,0) );
				KillTimer(m_nFlashTimer);
				m_nFlashTimer = 0;
			}
			else 
			{
				m_CComboCamera.Flash( TRUE, RGB(255,0,0) );
				//PrintServerMessage("FlashTimer");
			}
			break;
		
	
		default: //PrintServerMessage("Unsupported TimerID");
		      break;
	
	}

	// call base class
	CDialog::OnTimer(nIDEvent);
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab one frame from the 
// Image->Grab menu. It grabs one frame, checks for errors and returns.
//
void CVideoclntDlg::OnMenuImageGrab1frame() 
{
	// grab exactly one frame from the server
	BOOL ret = GrabFramesFromServer(1);

	if (ret == FALSE) // error ? 
	{
		// print out error message
		CString msg("Unable to get frame from Server.");

		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}
///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab two frames from the 
// Image->Grab menu. It grabs two frames, checks for errors and returns.
//
void CVideoclntDlg::OnMenuImageGrab2frames() 
{
	// grab exactly two frames
	BOOL ret = GrabFramesFromServer(2);

	if (ret == FALSE) // error ? 
	{
		// print out error message
		CString msg("Unable to get frames from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 3 frames from the 
// Image->Grab menu. It grabs 3 frames, checks for errors and returns.
//
void CVideoclntDlg::OnMenuImageGrab3frames() 
{
	// grab exactly 3 frames
	BOOL ret = GrabFramesFromServer(3);

	if (ret == FALSE) // error ? 
	{
		// print out error messages
		CString msg("Unable to get frames from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 4 frames from the 
// Image->Grab menu. It grabs 4 frames, checks for errors and returns.
//
void CVideoclntDlg::OnMenuImageGrab4frames() 
{
	// grab exactly 4 frames
	BOOL ret = GrabFramesFromServer(4);

	if (ret == FALSE) // error ? 
	{
		// print out error messages
		CString msg("Unable to get frames from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 5 frames from the 
// Image->Grab menu. It grabs 5 frames, checks for errors and returns.
//
void CVideoclntDlg::OnMenuImageGrab5frames() 
{
	// grab exactly 5 frames
	BOOL ret = GrabFramesFromServer(5);

	if (ret == FALSE) // error ? 
	{
		// print out error messages
		CString msg("Unable to get frames from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 10 frames from the 
// Image->Grab menu. It grabs 10 frames, checks for errors and returns.
//
void CVideoclntDlg::OnMenuImageGrab10frames() 
{
	// grab exactly 10 frames
	BOOL ret = GrabFramesFromServer(10);

	if (ret == FALSE) // error ? 
	{
		// print out error messages
		CString msg("Unable to get frames from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 15 frames from the 
// Image->Grab menu. It grabs 15 frames, checks for errors and returns.
//
void CVideoclntDlg::OnMenuImageGrab15frames() 
{
	// grab exactly 15 frames
	BOOL ret = GrabFramesFromServer(15);

	if (ret == FALSE) // error ? 
	{
		// print out error messages
		CString msg("Unable to get frames from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 20 frames from the 
// Image->Grab menu. It grabs 20 frames, checks for errors and returns.
//
void CVideoclntDlg::OnMenuImageGrab20frames() 
{
	// grab exactly 20 frames
	BOOL ret = GrabFramesFromServer(20);

	if (ret == FALSE) // error ? 
	{
		// print out error messages
		CString msg("Unable to get frames from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 30 frames from the 
// Image->Grab menu. It grabs 30 frames, checks for errors and returns.
//
void CVideoclntDlg::OnMenuImageGrab30frames() 
{
	// grab exactly 30 frames
	BOOL ret = GrabFramesFromServer(30);

	if (ret == FALSE) // error ? 
	{
		// print out error messages
		CString msg("Unable to get frames from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 40 frames from the 
// Image->Grab menu. It grabs 40 frames, checks for errors and returns.
//
void CVideoclntDlg::OnMenuImageGrab40frames() 
{
	// grab exactly 40 frames
	BOOL ret = GrabFramesFromServer(40);

	if (ret == FALSE) // error ? 
	{
		// print out error messages
		CString msg("Unable to get frames from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 50 frames from the 
// Image->Grab menu. It grabs 50 frames, checks for errors and returns.
//
void CVideoclntDlg::OnMenuImageGrab50frames() 
{
	// grab exactly 50 frames
	BOOL ret = GrabFramesFromServer(50);

	if (ret == FALSE) // error ? 
	{
		// print out error messages
		CString msg("Unable to get frames from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

void CVideoclntDlg::OnImageGrab100frames() 
{
	// grab exactly 50 frames
	BOOL ret = GrabFramesFromServer(100);

	if (ret == FALSE) // error ? 
	{
		// print out error messages
		CString msg("Unable to get frames from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

void CVideoclntDlg::OnImageGrab200frames() 
{
	// grab exactly 50 frames
	BOOL ret = GrabFramesFromServer(200);

	if (ret == FALSE) // error ? 
	{
		// print out error messages
		CString msg("Unable to get frames from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}


///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user enters a new scale into the scale field 
// on the toolbar. In the program logic, there is a scale value for each camera port
// remembered, so all four cameras can have independent scale values. The scale value
// is changed automatically whenever the user selects a new camera port by hand. On 
// automatic camera port changes (e.g. another client changes it) the scale value remains.
//
void CVideoclntDlg::OnChangeEdit6Scale() 
{
	//static BOOL inside = FALSE;

	//if (inside == TRUE) return;
	//inside = TRUE;

 // SW! Apr 26, 2006 warum wird das ANZEIGEFELD auskopiert ? 
 // warum nicht ANZEIGEFELD nur editierbar bei geladenen Bildern ? 
 // SW! apr 27, 2006 scale nur editierbar wenn poll mode aus
 // SW! Apr 26, 2006 warum wird das ANZEIGEFELD auskopiert END ? 

	double sc;
	CString msg99;
	m_CEditScale.GetWindowText(msg99);
 
	sc = atof( (const char *) (LPCTSTR) msg99 );

	if (sc > 0.0000)
	{
		if (m_pImageSequence != NULL) m_pImageSequence->SetScale( sc );
		internalScaleFactor = sc;
	}

	// SW! Apr 27, 2006 commented out endless recursion!
	//SetScaleFactorInGUI(sc);

	//inside = FALSE;
}


///////////////////////////////////////////////////////////////////////////////
//
// This function updates the right check mark in front of the menuitem when the 
// statistics mode is changed.
//
// The fourier parameter can have 3 values:
// 1: fourier mode
// 2: straightforward mode
// 3: off (no statistics)
//
void CVideoclntDlg::UpdateStatisticsMode(int analyzemode)
{
	switch( analyzemode )
	{
	case 1: // fourier
     PrintServerMessage("Switched on fourier calculations.");
	 
	 // place the right check mark and uncheck the two other statistic modes
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_FITTING, FALSE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_FOURIER, TRUE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_STRAIGHTFORWARD, FALSE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_OFF, FALSE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_STREAKCAMERA, FALSE);

	 m_CStaticXRms.SetWindowText("x RMS");
	 m_CStaticYRms.SetWindowText("y RMS");
	 m_CStaticXMean.SetWindowText("<x> mm");
	 m_CStaticYMean.SetWindowText("<y> mm");

     break;

	case 2: // straightforward
     PrintServerMessage("Switched on straightforward calculations.");
     
	 // place the right check mark and uncheck the two other statistic modes
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_FITTING, FALSE );
     CheckMenuItem( ID_APPLICATION_STATISTICSMODE_FOURIER, FALSE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_STRAIGHTFORWARD, TRUE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_OFF, FALSE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_STREAKCAMERA, FALSE);

	 m_CStaticXRms.SetWindowText("x RMS");
	 m_CStaticYRms.SetWindowText("y RMS");
	 m_CStaticXMean.SetWindowText("<x> mm");
	 m_CStaticYMean.SetWindowText("<y> mm");

     break;

	case 3: // no calculations
     PrintServerMessage("Switched off calculations.");
     
	 // place the right check mark and uncheck the two other statistic modes
     CheckMenuItem( ID_APPLICATION_STATISTICSMODE_FITTING, FALSE );
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_FOURIER, FALSE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_STRAIGHTFORWARD, FALSE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_OFF, TRUE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_STREAKCAMERA, FALSE);

	 m_CStaticXRms.SetWindowText("x RMS");
	 m_CStaticYRms.SetWindowText("y RMS");
	 m_CStaticXMean.SetWindowText("<x> mm");
	 m_CStaticYMean.SetWindowText("<y> mm");

	 break;

	case 4:
     PrintServerMessage("Switched on fitting mode.");
     
	 // place the right check mark and uncheck the two other statistic modes
     CheckMenuItem( ID_APPLICATION_STATISTICSMODE_FITTING, TRUE );
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_FOURIER, FALSE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_STRAIGHTFORWARD, FALSE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_OFF, FALSE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_STREAKCAMERA, FALSE);

	 m_CStaticXRms.SetWindowText("x RMS");
	 m_CStaticYRms.SetWindowText("y RMS");
	 m_CStaticXMean.SetWindowText("<x> mm");
	 m_CStaticYMean.SetWindowText("<y> mm");
     
	 break;

    case 5:
	 PrintServerMessage("Switched on streakcamera statistics.");
     CheckMenuItem( ID_APPLICATION_STATISTICSMODE_FITTING, FALSE );
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_FOURIER, FALSE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_STRAIGHTFORWARD, FALSE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_OFF, FALSE);
	 CheckMenuItem( ID_APPLICATION_STATISTICSMODE_STREAKCAMERA, TRUE);

	 m_CStaticXRms.SetWindowText("x ps");
	 m_CStaticYRms.SetWindowText("y ps");
	 m_CStaticXMean.SetWindowText("<x> ---");
	 m_CStaticYMean.SetWindowText("<y> ---");

     break;
	default: break;
	}
}


///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user selects the statistics mode 'fourier'
// either from the 'Application->Statistics mode' menu or via the hotkey F2.
//
void CVideoclntDlg::OnApplicationStatisticsmodeFourier() 
{
	// set analyze mode to fourier 
	m_iAnalyzeMode = 1;
	// update check marks
	UpdateStatisticsMode( m_iAnalyzeMode );
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user selects the statistics mode 
// 'straightforward' either from the 'Application->Statistics mode' menu or via 
// the hotkey F3.
//
void CVideoclntDlg::OnApplicationStatisticsmodeStraightforward() 
{
	// set analyze mode to straightforward
	m_iAnalyzeMode = 2;
	// update check marks
	UpdateStatisticsMode( m_iAnalyzeMode );
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user selects 'no statistics' mode 
// either from the 'Application->Statistics mode' menu or via the hotkey F4.
//
void CVideoclntDlg::OnApplicationStatisticsmodeOff() 
{
	// set analyze mode to off (no calculations)
	m_iAnalyzeMode = 3;
	// update check marks
	UpdateStatisticsMode( m_iAnalyzeMode );
}

/*
void CVideoclntDlg::OnApplicationStatisticsmodeFitting() 
{
    int fit = m_pIniFileExe->GetValueInt("MAIN", "Fitting", 0);

	if (fit != 0)
	{
  	 // set analyze mode to fourier 
	 m_iAnalyzeMode = 4;
	 // update check marks
	 UpdateStatisticsMode( m_iAnalyzeMode );
    }
	else
	{
     AfxMessageBox("Fitting is not supported on this computer!", MB_ICONEXCLAMATION | MB_OK);
	}
}
*/

void CVideoclntDlg::OnApplicationStatisticsmodeStreakcamera() 
{
	// set analyze mode to straightforward
	m_iAnalyzeMode = 5;
	// update check marks
	UpdateStatisticsMode( m_iAnalyzeMode );
	
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to show the background image,
// either by selecting 'Show' from the background menu or by pression the hotkey
// CTRL-S. 
//
void CVideoclntDlg::OnBackgroundShow() 
{
    // display the background buffer with cameraport set to background and no redraw
	// of the last frame

	// display the background (-1 = background image)
    DisplayFunction( (char *) m_pBackground, -1, FALSE);

}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called for every new frame / sequence of frames that come in via
// poll or grab mode. It instantiates the proper CStatFile class needed for statistical 
// analysis. Even if the statistics is in 'off'-mode, this function is called.
//
// Parameters:
//  framebuffers - pointer to the grab buffer
//  outdata      - pointer to a memory location big enough to store a single frame (must match m_iActualBpp now!!!)
//  numframes    - number of frames in the grab buffer 'framebuffers'
//  XFilt        - TRUE: apply x-ray filtering on each frame, FALSE: no not apply x-ray filtering
//void CVideoclntDlg::MakeStatFile(char *framebuffers, char *outdata, int numframes, BOOL XFilt)
void CVideoclntDlg::MakeStatFile(CImageSequence *seq, char *outdata, BOOL XFilt)
{
  //static BOOL first = TRUE;
  //static BOOL circularfirst = TRUE;
  //static CRect tmpAOI;
  //static CRect tmpAOIcirc;

  CRect l_AOI;

  // we have a statfile class instantiated ? 
  if (m_pStatFile != NULL)
  {
	  delete m_pStatFile; // then destruct it and free memory
	  m_pStatFile = NULL;
  }
  
  // very first call, so initialize the local variable 'tmpAOI'
  //if (first == TRUE)
  //{
  // tmpAOI.CopyRect( (LPCRECT) m_newAOI );
  // first = FALSE;
  //}

  // if the user is actually selecting a new area of interest, do not use it but use the 
  // area of interest stored inside tmpAOI 
  if (m_bMakeRectangle == FALSE) 
  {
    l_AOI.CopyRect( (LPCRECT) m_newAOI ); 
  } 
  else 
  {
   if (m_bCircularAOI == TRUE)
   {
    l_AOI.left = m_iActualWidth/2;
	l_AOI.top = m_iActualHeight/2;
	if (m_iActualWidth > m_iActualHeight) l_AOI.right = (m_iActualHeight/2)-1; else l_AOI.right = (m_iActualWidth/2)-1;
	l_AOI.bottom = 0;
   }
   else
   {
    l_AOI.left = 0;
	l_AOI.top =0 ;
	l_AOI.right = m_iActualWidth-1;
	l_AOI.bottom = m_iActualHeight-1;
   }
  } 
  
  CServer srv;
  m_ServerList.getServer( m_iActualServerPos, srv );

  unsigned int framerate = (unsigned int) m_pImageAcquire->AutoDetectFramerateFIT(m_pIniFileExeLocal->GetValueInt("MAIN", "Framerate", 0));
  unsigned int framerateoverride = (unsigned int) m_pIniFileExeGlobal->GetValueInt(srv.getNickname(), "OverrideFramerate", 0 );
  if (framerateoverride != 0) framerate = framerateoverride;

  // instantiate StatFile class
  // numframes, framebuffers, ...
  //!!!CheckCircular( l_AOI );
  
  int tmpanalyzemode = m_iAnalyzeMode;

  if ((m_iAnalyzeMode == 4) && (seq->Count() > 1))
  {
   CString msg;
   msg.Format("You have selected to calculate the fitting of %d images.\nThis could take up to 10 seconds per video image.\nShall I revert to fourier mode only for this measurement?\nIt will be a lot faster.", seq->Count() );
   int ret = AfxMessageBox(msg, MB_ICONQUESTION | MB_YESNO);
   if (ret == IDYES) tmpanalyzemode = 1;
  }
  
  m_pStatFile = new CStatFile(m_pImageSequence, (unsigned char *) m_pBackground, (unsigned char *) outdata, l_AOI, XFilt, m_bCircularAOI, m_bNormalization, tmpanalyzemode, m_iActualWidth, m_iActualHeight, m_iActualBpp, m_iActualBppEffective, framerate);

}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called for every new frame / sequence of frames that come in via
// either grab or poll mode. In addition, everytime the user selects Image->Analyze,
// this function is called, too. It just obtains the statistical values from the 
// statfile class and displays them in the proper CEdit controls.
// The four values that are displayed are spot center position (xm, ym) and spot 
// size( xrms, yrms). Also DAQ string is created and added to here.
//
void CVideoclntDlg::UpdateStatisticalValues()
{
 // no statfile class -> then out of here
 if (m_pStatFile == NULL) return;

 CString msg;
 double valuexm, valueym, valuexrms, valueyrms;
 double scale;

 // get proper scale value
 // SW! Apr 26, 2006 warum wird das ANZEIGEFELD auskopiert ? 
 // und nicht aus einer variable / imagesequence geholt ? 
 //m_CEditScale.GetWindowText(msg);
 // SW! Apr 27, 2006 wird jetzt aus variablen geholt
 
 scale = GetCurrentScale();
 
 //	 atof( (const char *) (LPCTSTR) msg);
 // SW! Apr 26, 2006 warum wird das ANZEIGEFELD auskopiert ? 

 // calculate the right xm value based on the scale
 valuexm = m_pStatFile->XM() * scale;
 msg.Format("%f", valuexm);
 // put it into the CEdit field
 m_CEditXMean.SetWindowText((LPCTSTR) msg);
					if (m_bDAQRunning) m_sDAQString+=msg+SEPCHAR;

 // calculate the right ym value based on the scale
 valueym = ((m_iActualHeight-1) - m_pStatFile->YM()) * scale;
 msg.Format("%f", valueym);
 // put it into the CEdit field
 m_CEditYMean.SetWindowText((LPCTSTR) msg);
					if (m_bDAQRunning) m_sDAQString+=msg+SEPCHAR; /*+CString(GetTimeStr())+CR; */

 // calculate the right xrms value based on the scale
 valuexrms = m_pStatFile->X_RMS() * scale;
 if (m_iAnalyzeMode == 5) valuexrms*=2;
 msg.Format("%f", valuexrms);
 // put it into the CEdit field
 m_CEditXRms.SetWindowText((LPCTSTR) msg);
					if (m_bDAQRunning) m_sDAQString+=msg+SEPCHAR;

 // calculate the right yrms value based on the scale
 valueyrms = m_pStatFile->Y_RMS() * scale;
 if (m_iAnalyzeMode == 5) valueyrms*=2;
 msg.Format("%f", valueyrms);
 // put it into the CEdit field
 m_CEditYRms.SetWindowText((LPCTSTR) msg);
					if (m_bDAQRunning) m_sDAQString+=msg+SEPCHAR+CString( (const unsigned char *) GetTimeStr() )+SEPCHAR+GetTimeStrFormatted()+SEPCHAR;

 msg.Format("%f", m_pStatFile->SUM_PIXELS() );
 m_CEditSumPixels.SetWindowText( (const char *) (LPCTSTR) msg );

 if (m_bDAQRunning) m_sDAQString+=msg+SEPCHAR;

 if (m_bDAQRunning)
 {
	 CString PropStr;
	 BOOL ret = m_pImageSequence->returnDoocsProperties( PropStr );
	 if (ret == TRUE) m_sDAQString += PropStr;

	 m_sDAQString += CR;
 }

 if (m_sDAQString.GetLength() > 10000) 
 {
	 m_sDAQString = BeautifyCSVString( m_sDAQString, m_pIniFileExeLocal->GetValue("MAIN", "CSVComma", ","), m_pIniFileExeLocal->GetValue("MAIN", "CSVDelimiter", ";") );

	 if (m_fpDAQFile != NULL) fputs( (const char *) (LPCTSTR) m_sDAQString, m_fpDAQFile );

	 m_sDAQString.Empty();
 }

}

///////////////////////////////////////////////////////////////////////////////
//
// This function clears the background memory location. After this, the background
// is empty. If this empty background is subtracted from an image, the image 
// remains the same. This function is called whenever the user selects 'Clear' 
// from the background menu or presses the hotkey CTRL-C .
//
void CVideoclntDlg::OnBackgroundClear() 
{
    // clear background
	memset( m_pBackground, 0, m_iActualWidth*m_iActualHeight*m_iActualBpp/8 );
	PrintServerMessage("Background cleared.");
    //OnBackgroundShow();
}  

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user selects Image->Analyze from the menu 
// or the user presses the hotkey 'ALT-A'. It creates a new statfile class 
// ( MakeStatFile() ), recalculates the statistical values and displays them.
// Then the proper camera port is extracted out of the videoheader and displayed 
// together with the last image from the grab buffer.
// 
void CVideoclntDlg::OnImageAnalyze() 
{
    CInformationDialog dlg;

	dlg.Show("Calculating...");

	// make CStatFile class
    MakeStatFile(m_pImageSequence, m_pNormalizedImage, m_bXRayFiltering);
    // calculate
	if (m_pStatFile != NULL) m_pStatFile->START();
    // update statistical values
	UpdateStatisticalValues();

	dlg.Hide();

	// extract video header
    char *vidhptr;
	m_pImageSequence->GetFrame(m_pImageSequence->Count()-1, (const char **) &vidhptr);
	VIDHDR vidH;
    memman.memcpysw((char *) &vidH, vidhptr, sizeof(VIDHDR));

	// display analyzed frame together with camera port
	DisplayFunction(m_pNormalizedImage, vidH.cameraport, FALSE);
}

void CVideoclntDlg::OnVideoRightButtonDown(UINT nFlags, CPoint point)
{
}

void CVideoclntDlg::OnVideoRightButtonUp(UINT nFlags, CPoint point)
{
	TogglePollMode();
}


///////////////////////////////////////////////////////////////////////////////
//
// This function is needed for the selection of the area of interest. If the left 
// mouse button goes down, we are starting a 'make rectangle' algorithm, which is
// implemented in this function, 'OnVideoLeftButtonUp()' and 'OnVideoMouseMove()'.
//
void CVideoclntDlg::OnVideoLeftButtonDown(UINT nFlags, CPoint point)
{
 // we are actually making a rectangle -> immediately out of here
 if (m_bMakeRectangle != FALSE) return;

 // set proper initial ratios
 double ratX=m_iActualWidth;	
 double ratY=m_iActualHeight;

 // calculate real ratios between frame size and videoframe size 
 ratX /= (double) m_VideoWindowWidth;
 ratY /= (double) m_VideoWindowHeight;

 // create starting point inside grabbed frame
 CPoint p1( (int)((point.x*ratX)), (int)((point.y*ratY)));

 // exclusive mouse cursor access
 m_CMyVideoFrame.SetCapture();

 // set starting point 
 m_CPointStart = p1;

 // from now on we are selecting a rectangle
 m_bMakeRectangle = TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is needed for the selection of the area of interest. If the left 
// mouse button goes up, we are stopping a 'make rectangle' algorithm, which is
// implemented in this function, 'OnVideoLeftButtonDown()' and 'OnVideoMouseMove()'.
//
void CVideoclntDlg::OnVideoLeftButtonUp(UINT nFlags, CPoint point)
{
	// we are not selecting a rectangle? -> then out of here
	if (m_bMakeRectangle != TRUE) return;
 
	// we are not selecting an rectangle any more
	m_bMakeRectangle = FALSE;

	//PrintServerMessage("LeftButtonUp");

	// release exclusive mouse cursor 
	ReleaseCapture();
 
	// calulate ratio between frame size and videoframe size 
	double ratX=m_iActualWidth;	
	double ratY=m_iActualHeight;
	ratX /= (double) m_VideoWindowWidth;
	ratY /= (double) m_VideoWindowHeight;

	// calculate end point
	CPoint m_CPointEnd((int)((point.x*ratX)), (int)((point.y*ratY)) );

	if (m_CPointEnd.x < 0) m_CPointEnd.x = 0;
	if (m_CPointEnd.x > m_iActualWidth-1) m_CPointEnd.x = m_iActualWidth-1;

	if (m_CPointEnd.y <0) m_CPointEnd.y = 0;
	if (m_CPointEnd.y > m_iActualHeight-1) m_CPointEnd.y = m_iActualHeight-1;


	if (m_bCircularAOI == TRUE)
	{
         double length = sqrt(pow(m_CPointStart.x - m_CPointEnd.x, 2)+pow(m_CPointStart.y - m_CPointEnd.y, 2)); 
         CPoint a;
		 CPoint b;
		 a.x = m_CPointStart.x;
		 a.y = m_CPointStart.y;
		 b.x = ((int) length);
		 b.y = 0;

		 if ((a.x - b.x) < 0) b.x = b.x + (a.x-b.x);
		 if ((a.x + b.x) >= m_iActualWidth) b.x = m_iActualWidth-a.x-1;
		 if ((a.y + b.x) >= m_iActualHeight) b.x = m_iActualHeight-a.y-1;
		 if ((a.y - b.x) < 0) b.x = b.x + (a.y-b.x);

         CRect rect( a, b);
		 m_newAOI.CopyRect( (LPCRECT) rect );

		 if (length < 4)
		 {
			m_newAOI.left = m_iActualWidth/2;
			m_newAOI.top = m_iActualHeight/2;
	
			if (m_iActualWidth < m_iActualHeight) m_newAOI.right = m_iActualWidth/2; else m_newAOI.right = m_iActualHeight/2;
			m_newAOI.bottom = 0;
		 }
	}
	else
	{
		// build up rectangle out of the two points and normalize it 
		CRect rect( m_CPointStart, m_CPointEnd );
		rect.NormalizeRect();

		// if any of the values is not in range -> set a default area of interest
		if ((rect.right > m_iActualWidth-1) || (rect.bottom > m_iActualHeight-1) || rect.Width() < 2 || rect.Height() < 2 || rect.left < 0 || rect.top < 0)
		{
			m_newAOI.SetRect(0,0,m_iActualWidth-1,m_iActualHeight-1);
		}
		else // everything okay
		{ // just copy the rectangle into the area of interest variable
			m_newAOI.CopyRect( (LPCRECT) rect);
		}
	}
 
	if (m_bPollMode == FALSE) // we are not in poll mode ? 
	{
		CInformationDialog dlg;

		dlg.Show("Calculating...");
		// reanalyze actual frame  
		// make CStatFile class
		MakeStatFile(m_pImageSequence, m_pNormalizedImage, m_bXRayFiltering);
		// calculate
		if (m_pStatFile != NULL) m_pStatFile->START();
		// update statistical values
		UpdateStatisticalValues();

		dlg.Hide();

		// extract video header
		char *vidhptr;
		m_pImageSequence->GetFrame(m_pImageSequence->Count()-1, (const char **) &vidhptr);
		VIDHDR vidH;
		memman.memcpysw((char *) &vidH, vidhptr, sizeof(VIDHDR));

		// display analyzed frame together with camera port
		DisplayFunction(m_pNormalizedImage, vidH.cameraport, FALSE);
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is needed for the selection of the area of interest. If the mouse 
// is moved and the m_bMakeRectangle is TRUE, we are selecting the area of interest.
// This is implemented in this function.
//
void CVideoclntDlg::OnVideoMouseMove(UINT nFlags, CPoint point)
{
	// This if needs to be done, because OnMouseMove is not just called when the mouse 
	// is moved, but also called via Timer (once a second). If the mousepointer didn't 
	//	change its position: do nothing
	if (m_CPointLast == point)
	{
		m_CPointLast = point;
		return;
	}
	else
	{
		m_CPointLast = point;
	}

	// we are selecting a rectangle ? 
	if (m_bMakeRectangle == TRUE)
	{
		// draw actual rectangle
		double ratX=m_iActualWidth*1.0;	
		double ratY=m_iActualHeight*1.0;
		ratX /= (double) m_VideoWindowWidth;
		ratY /= (double) m_VideoWindowHeight;

		CPoint end((int)((point.x*ratX)), (int)((point.y*ratY)));
		if (end.x < 0) end.x = 0;
		if (end.x > m_iActualWidth-1) end.x = m_iActualWidth-1;

		if (end.y <0) end.y = 0;
		if (end.y > m_iActualHeight-1) end.y = m_iActualHeight-1;


        if (m_bCircularAOI == TRUE)
		{
			double length = sqrt(pow(m_CPointStart.x - end.x, 2)+pow(m_CPointStart.y - end.y, 2)); 
			CPoint a;
			CPoint b;
			a.x = m_CPointStart.x;
			a.y = m_CPointStart.y;
			b.x = ((int) length);
			b.y = 0;

			if ((a.x - b.x) < 0) b.x = b.x + (a.x-b.x);
			if ((a.x + b.x) >= m_iActualWidth) b.x = m_iActualWidth-a.x-1;
			if ((a.y + b.x) >= m_iActualHeight) b.x = m_iActualHeight-a.y-1;
			if ((a.y - b.x) < 0) b.x = b.x + (a.y-b.x);

			CRect rect( a, b);
			m_newAOI.CopyRect( (LPCRECT) rect );

			/*         
			int brup;
			int brleft;
			int brdown;
			int brright;

			brup = a.y - b.x;
			brdown = a.y + b.x;
			brleft = a.x - b.x;
			brright = a.x + b.x;

			CString msg;
			msg.Format("rect(%d,%d,%d,%d)", brleft, brup, brright, brdown);
			PrintServerMessage(msg);
			*/

			if (m_bPollMode == FALSE) DisplayFunction(0,0, TRUE);
		}
		else
		{
 			// make rectangle
			CRect rect( m_CPointStart, end);
			rect.NormalizeRect();

			// copy rectangle into area of interest
			m_newAOI.CopyRect( (LPCRECT) rect);

			// force the new area of interest to be drawn if we are not 
			// in poll mode; if poll mode is enabled, we are only drawing
			// when a new frame comes in because of the high cpu load we
			// are producing
			if (m_bPollMode == FALSE) DisplayFunction(0, 0, TRUE);
		}
	}
	else // we are not selecting an area of interest 
	{ // draw two lines (mouse cross)
		m_CPointCross.x = point.x;
		m_CPointCross.y = point.y;

		/*
		int x = m_CPointCross.x;
		int y = m_CPointCross.y;
		ClientToScreen(&m_CPointCross);


		CString msg666;
		msg666.Format("Mx=%d My=%d", x, y);
		m_CEditFrameNo.SetWindowText( msg666 );
		*/		 

		// draw only if we are not in poll mode
		if (m_bPollMode == FALSE) DisplayFunction(0, 0, TRUE);
	}

}

///////////////////////////////////////////////////////////////////////////////
//
// This function is just needed for convenience. Otherwise if the user presses
// Enter key, an ID_OK is issued which results in closing a dialog based application.
// Because we do not want this, we just do nothing in this function and are not calling
// the base class.
//
void CVideoclntDlg::OnOK()
{
 // do nothing
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is just needed for convenience. When the application window is  
// shown, the video frame is not redrawn properly. So I have overridden the base
// class function to redraw the video frame every time this function is called.
//
void CVideoclntDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	static BOOL first = TRUE;

	// call base class
	CDialog::OnShowWindow(bShow, nStatus);
	
	// very first time ?
	if (first)
	{
		// make statistical class, calculate values and show them
		MakeStatFile( m_pImageSequence, m_pNormalizedImage, FALSE);
		if (m_pStatFile != NULL) m_pStatFile->START();
	    UpdateStatisticalValues();
		
		// display the video frame buffer
		DisplayFunction( m_pNormalizedImage, -2, FALSE);
		first = FALSE;
	}

	// every time we show the window, redraw the last frame
	if (bShow == TRUE)
	{
      DisplayFunction(0, 0, TRUE);
	  this->UpdateWindow();
	}

}

///////////////////////////////////////////////////////////////////////////////
//
// This function is needed because if someone steals the exclusive mouse cursor 
// access, this function notifies us. We can then stop the selection of the area 
// of interest in a safe manner.
//
void CVideoclntDlg::OnCaptureChanged(CWnd *pWnd) 
{
	//PrintServerMessage("CaptureChanged");

	// we are selecting an area of interest at the moment ? 
	if (m_bMakeRectangle == TRUE)
	{
	 // get actual point of the mouse cursor 
	 CPoint p;
	 GetCursorPos(&p);
     // call the proper function which stops selecting the area of interest
	 OnVideoLeftButtonUp(0, p);

	 // call base class
	 CDialog::OnCaptureChanged(pWnd);
    }
}

///////////////////////////////////////////////////////////////////////////////
//
// In the function OnMenuBackgroundLoad() a background image is loaded from disk.
// At first, a file-open dialog is presented where the user can choose its preferred
// filename and file format. After this, the file is loaded into the background 
// memory location. One can load BMP (Windows Bitmap file) or BKG (own file format) files.
// 
// Please note: Only BMP files with a width of 768, a height of 574 and 8-bit 
// color resolution can be loaded.
//
void CVideoclntDlg::OnMenuBackgroundLoad() 
{
 // build file filter string for CFileDialog
 CString filefilter = "All Background Files (*.bkg, *.bkc, *.bmp)|*.bkg;*.bkc;*.bmp|Background Files (*.bkg, *.bkc)|*.bkg;*.bkc|BMP Files (*.bmp)|*.bmp||";

 CString sdisabled = m_pIniFileProf->GetValue("MAIN","LoadPreviewDialogDisabled", "FALSE");
 BOOL bdisabled = FALSE;

 if (sdisabled == "TRUE") bdisabled = TRUE;

 // instantiate a file dialog (load files, no default extension, no default filename, 
 // path and file must exist, no read only checkbox and the definded filter string 
 CFileDialogOpenThumbnail fileDlg(bdisabled, NULL,NULL, OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, filefilter);
 
 // if the user pressed cancel then get out of here
 
 int ret = fileDlg.DoModal();

 if (fileDlg.ReturnDisableGlobal() == TRUE) m_pIniFileProf->SetValue("MAIN", "LoadPreviewDialogDisabled", "TRUE");

 if(ret ==IDCANCEL)
	return;


 // get file name and file extension
 CString CurrentFileName = fileDlg.GetPathName();
 CString CurrentExtension = fileDlg.GetFileExt();

 // get the actually selected extension, because if the user has omitted it we append it to the filename
 CString SelectedExtension;
 SelectedExtension = ObtainSelectedExtension( CurrentFileName, SelectedExtension, fileDlg.m_ofn.lpstrFilter, fileDlg.m_ofn.nFilterIndex);

 // file has no extension, then append the selected extension
 if (CurrentExtension == "") 
 {
	 CurrentExtension = SelectedExtension;
	 CurrentFileName += "." + SelectedExtension;
 }

 // make both extensions upper case
 CurrentExtension.MakeUpper();
 SelectedExtension.MakeUpper();

 if (SelectedExtension == "BKG") // we want to load a bkg file
 {
  FILE *fp;

  fp = fopen((LPCTSTR) CurrentFileName, "rb");
  
  if (fp != NULL) // file could be opened
  {
   unsigned int w, h, bpp, bpp_eff;

   // read width and height of the image
   fread(&w, 1, 4, fp);
   fread(&h, 1, 4, fp);
   
   bpp = (w&0xff0000)>>16;
   w = w&0xffff;
   if (bpp == 0) bpp = 8;

   bpp_eff = (h&0xff0000)>>16;
   if (bpp_eff == 0) bpp_eff = bpp;
   h = h&0xffff;
   
   //w=768;
   //h=574;

   if (w != ((unsigned)m_iActualWidth) || h != ((unsigned)m_iActualHeight) || (bpp != ((unsigned) m_iActualBpp)) || (bpp_eff != ((unsigned) m_iActualBppEffective)) ) // not the right width and height:
   {
    /*CString msg;
	msg.Format("w=%d h=%d");
	AfxMessageBox((LPCTSTR)msg);*/

	// print out error message
	OwnMessageBox(MB_ICONEXCLAMATION, "The BKG File you are trying to load has a wrong size (must be %dx%dx%dbpp for the current setting) !", m_iActualWidth, m_iActualHeight, m_iActualBpp);
   }
   else
   {
    // create temporary memory location and read in frame data
	char *temp = (char *) memman.sw_malloc( w*h*bpp/8 );
	if (temp != NULL)
	{
	  unsigned int ret = fread( temp, 1, w*h*bpp/8, fp);

	  if (ret != (w*h*bpp/8)) // could not read frame data if this is true
	  {
	    // print error message (file too short)
	    OwnMessageBox(MB_ICONEXCLAMATION, "Error while reading from file. Maybe the file is corrupted.");
	  }
	  else
	  { // everything went fine:
         // copy temp memory location into background memory location
  	     memman.memcpysw(m_pBackground, temp, w*h*bpp/8 );
	     // show background
	     OnBackgroundShow();
	  }
	  // free temporary allocated memory
	  memman.sw_free( (void *) temp);
	}
	else
	{
     OwnMessageBox(MB_ICONEXCLAMATION, "Out of memory loading BKG background.");
 	}
   }

  }
  else // fp == NULL
  {
	OwnMessageBox(MB_ICONINFORMATION, "Could not open BKG file.");
  }
  // close file 
  fclose(fp);

 }
 else if ( SelectedExtension == "BMP") // okay, we want to load a BMP file
 {
  // here: load bmp file

  CBitmap bmp;

  CBMPFileHelper help;

  // load bitmap out of file 'CurrentFileName' using helper function
  HBITMAP hBmp = help.LoadDIBSectionFromFile((LPCTSTR) CurrentFileName, NULL, NULL, 0);
  
  if (hBmp == NULL) // error while loading file
  {
	  // print error message
	  OwnMessageBox(0, "Error loading bmp file.");
	  // get out of this function
	  return;
  }

  // attach HBITMAP handle to CBitmap class
  BOOL ret = bmp.Attach( hBmp );

  // acquire width and height from image
  BITMAP Bitmap;
  GetObject(hBmp, sizeof(BITMAP), &Bitmap);
  LONG cx = Bitmap.bmWidth;
  LONG cy = Bitmap.bmHeight;

  if (cx != m_iActualWidth && cy != m_iActualHeight) // wrong width or wrong height
  {
   // print warning message   
   OwnMessageBox(0, "Background image has wrong size. It must be exactly %d x %d pixels.\n", m_iActualWidth, m_iActualHeight);

   // detach bitmap and delete it
   HBITMAP del = (HBITMAP) bmp.Detach();
   if (del != NULL) ::DeleteObject( (HGDIOBJ) del );
   
   // get out of this function
   return;
  }

  // check for wrong color depth
  if (Bitmap.bmBitsPixel != 8)
  {
   // print error message  
   OwnMessageBox(0, "Image has wrong color depth. It must be of 8 bit color depth.\nPlease load the picture into your favourite picture editor and modify it to meet the requirements (%dx%d pixel, 8 bit color depth (256 colors)).", m_iActualWidth, m_iActualHeight);

   // detach bitmap
   HBITMAP del = (HBITMAP) bmp.Detach();

   // free BITMAP handle and attached memory
   if (del != NULL) ::DeleteObject( (HGDIOBJ) del );
   
   return;
  }
  // obtain the real bits from the image attached to CBitmap class
  // and store them in the background memory location
  
  if (m_iActualBpp != 8)
  {

    unsigned char *tempbuffer = (unsigned char *) memman.sw_malloc( cx*cy );
    if (tempbuffer != NULL)
	{
	    bmp.GetBitmapBits( cx*cy, (LPVOID) tempbuffer );//(LPVOID) m_pBackground );
    
	    if (m_iActualBpp == 16)
		{
          unsigned short *bkg = (unsigned short *) m_pBackground;

		  for (int i=0;i<cx*cy;i++)
		  {
			  bkg[i] = (unsigned short) (((unsigned short)tempbuffer[i]) << 8);
		  }
        }
		else // bpp = 32
		{
          unsigned long *bkg = (unsigned long *) m_pBackground;

		  for (int i=0;i<cx*cy;i++)
		  {
			  bkg[i] = (unsigned long) (((unsigned long)tempbuffer[i]) << 24);
		  }
		}

	    memman.sw_free( (void *) tempbuffer );
    	// show background
    
	    OnBackgroundShow();
	}
    else
	{
      OwnMessageBox(MB_ICONEXCLAMATION, "Out of memory loading BMP background file.");
	}


    // we no longer need the CBitmap class and HBitmap object
  }
  else
  {
    bmp.GetBitmapBits( cx*cy, (LPVOID) m_pBackground );

	// show background
    
	OnBackgroundShow();
  }

  // detach HBITMAP handle 
  HBITMAP del = (HBITMAP) bmp.Detach();

  // free memory and resources
  if (del != NULL) ::DeleteObject( (HGDIOBJ) del );
 }
 else if (SelectedExtension == "BKC")
 {
	 CImageSequence help( m_pCATineDlg, m_bTineALInitialized, m_pTineALDlg, this);

	 BOOL ret = help.LoadFromFile( FILE_BKC, CurrentFileName );

	 if (ret == TRUE)
	 {
		 if (help.GetImageWidth() != (m_iActualWidth) || help.GetImageHeight() != (m_iActualHeight) || (help.GetBpp() != ( m_iActualBpp))) // not the right width and height:
		 {
			/*CString msg;
			msg.Format("w=%d h=%d");
			AfxMessageBox((LPCTSTR)msg);*/

			// print out error message
			OwnMessageBox(MB_ICONEXCLAMATION, "The BKC File you are trying to load has a wrong size (must be %dx%dx%dbpp for the current setting) !\nIt was not loaded !", m_iActualWidth, m_iActualHeight, m_iActualBpp );
		 }
		 else
		 {
			 CEnvelopeAverageChoose choose(this);

		     choose.DoModal();

			 int env = choose.ReturnChoiceEnvelope();

			 CEnvelopeAverage envavg;

			 VIDHDR vidH;
			 vidH.kennung = 0x11223344;
			 vidH.widthframe = help.GetImageWidth();
			 vidH.heightframe = help.GetImageHeight();

			 envavg.Init( help.GetBpp(), vidH, env, FALSE ); // SW! Sept 21, 2006 not yet done!!! bpp_eff!

			 for (int i=0;i<help.Count();i++)
			 {
				VIDHDR vidH1;

				char *pFrame;

 				help.GetFrame(i, (const char **) &pFrame);
				memman.memcpysw( (char *) &vidH1, pFrame, sizeof(VIDHDR) );
				pFrame += (vidH1.len_total - vidH1.len_data);

				 envavg.AddFrame((unsigned char *) pFrame, vidH1 );

			 }

			 unsigned int size;

			 envavg.ReturnBuffer((unsigned char *) m_pBackground, &size);

			 OnBackgroundShow();
		 }
	 }
	 else
	 {
		 OwnMessageBox(MB_ICONEXCLAMATION, "The file \"%s\" could not be loaded.\nThe Background was not updated.", CurrentFileName );
	 }
 }
 else // no known file extension
 {
   // print error message
   OwnMessageBox(0, "No suitable file extension. I can only load BMP, BKG and BKC files.");
 }
	
}

///////////////////////////////////////////////////////////////////////////////
//
// In the function OnMenuBackgroundSave() a background image is saved to disk.
// At first, a file-save dialog is presented where the user can choose its preferred
// filename and file format. After this, the file is saved from the  background 
// memory location. One can save BMP (Windows Bitmap file) or BKG (own file format) files.
// 
//
void CVideoclntDlg::OnMenuBackgroundSave() 
{
 // create file filter string needed for CFileDialog
 CString filefilter = "BKG Files (*.bkg)|*.bkg|BMP Files (*.bmp)|*.bmp||";

 // instantiate Save As dialog
 CFileDialog fileDlg(FALSE,NULL,NULL, OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY, filefilter);
 
 // user pressed cancel button? -> then get out of here
 if(fileDlg.DoModal()==IDCANCEL)
	return;

 // get file name and path 
 CString CurrentFileName = fileDlg.GetPathName();
 // get extension of file
 CString CurrentExtension = fileDlg.GetFileExt();

 // obtain the selected extension from the dialog if the user has omitted the file extension
 CString SelectedExtension;
 SelectedExtension = ObtainSelectedExtension( CurrentFileName, SelectedExtension, fileDlg.m_ofn.lpstrFilter, fileDlg.m_ofn.nFilterIndex);


 if (CurrentExtension == "") // no current file extension? 
 {
	 // append our selected extension
	 CurrentExtension = SelectedExtension;
	 CurrentFileName += "." + SelectedExtension;
 }

 // make the extensions upper case
 CurrentExtension.MakeUpper();
 SelectedExtension.MakeUpper();

 /* construct proper filename string for additional textfile */
 /* and call proper function to ask, query and store the information if necessary */
 CString filenamepath = fileDlg.GetPathName();
 CString filename = fileDlg.GetFileName();
 CString path = filenamepath.Left( filenamepath.GetLength() - filename.GetLength() );
 // format name string of textfile

 if (SelectedExtension == "BKG") // we want to save a BKG file
 {
  FILE *fp;

  // open the file for writing
  fp = fopen((LPCTSTR) CurrentFileName, "wb");
  
  if (fp != NULL) // file could be opened
  {
   unsigned int w=m_iActualWidth, h=m_iActualHeight, bpp = m_iActualBpp, bpp_eff=m_iActualBppEffective;
   unsigned int codedbpp = bpp;
   if (codedbpp == 8) codedbpp = 0;
   // write out width and height
   w = + ((codedbpp&0xff)<<16)+(w&0xffff);
   unsigned int ret = fwrite(&w, 1, 4, fp);

   if (bpp_eff == 8) bpp_eff = 0;
   h = ((bpp_eff<<16)&0xff0000) + (h&0xffff);
   ret += fwrite(&h, 1, 4, fp);

   // write out background bits
   ret += fwrite( m_pBackground, 1, m_iActualWidth*m_iActualHeight*m_iActualBpp/8, fp);

   // check whether all bytes have been written
   if (((int)ret) != (m_iActualWidth*m_iActualHeight*m_iActualBpp/8)+8)
   {
     // print error if not all bytes have been written
	 OwnMessageBox(0, "Error while writing to file.");
   }
   else
   {
    // print okay message (status line)
	PrintServerMessage("File saved.");
   }

  }
  // close file
  fclose(fp);

 }
 else if ( SelectedExtension == "BMP") // we want to save a BMP file
 {
  if (m_iActualBpp != 8)
  {
	 int ret = AfxMessageBox("Background will be converted to 8 bits before written to a BMP file. This is lossy.\nDo you really want to do this ?", MB_ICONQUESTION | MB_YESNO );

	 if (ret == IDNO)
	 {
		 OwnMessageBox(MB_ICONINFORMATION, "Nothing was saved.");
		 return;
	 }
  }
  
  int ret = SaveBackgroundBMP( (char *) (LPCTSTR) CurrentFileName);
  
  if (ret == 0) // error while writing ? 
  {
	OwnMessageBox(0, "Error while writing file.");
  }
  else // everything went fine
  {
    PrintServerMessage("File saved."); 
  }
 }
 else // no suitable file extension
 {
  OwnMessageBox(0, "No suitable file extension. I can only save BMP and BKG files.");
 }
}

///////////////////////////////////////////////////////////////////////////////
//
// In the function OnMenuImageLoad() a normal image (frame) is loaded from disk.
// At first, a file-open dialog is presented where the user can choose its preferred
// filename and file format. After this, the file is loaded into the grab buffer, 
// processed and displayed on screen. One can load BMP (Windows Bitmap file) or 
// IMM (own file format) files.
// 
// Please note: Only BMP files with a width of 768, a height of 574 and 8-bit 
// color resolution can be loaded. In addition, a IMM file can have more than one
// frame in it. A BMP file has only a single frame in it.
//
void CVideoclntDlg::OnMenuImageLoad() 
{
 // create file filter string
 CString filefilter = "All Image Files (*.imm, *.imc, *.bmp)|*.imm;*.imc;*.bmp|Image Files (*.imm, *.imc)|*.imm;*.imc|BMP Files (*.bmp)|*.bmp||";

 CString sdisabled = m_pIniFileProf->GetValue("MAIN","LoadPreviewDialogDisabled", "FALSE");
 BOOL bdisabled = FALSE;

 if (sdisabled == "TRUE") bdisabled = TRUE;

 // instantiate file open dialog
 CFileDialogOpenThumbnail fileDlg(bdisabled, NULL,NULL, OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, filefilter);
 
 // if the user pressed cancel then get out of here
 
 int ret = fileDlg.DoModal();

 if (fileDlg.ReturnDisableGlobal() == TRUE) m_pIniFileProf->SetValue("MAIN", "LoadPreviewDialogDisabled", "TRUE");

 if(ret ==IDCANCEL)
	return;

 // make extensions upper case
 CString CurrentFileName = fileDlg.GetPathName();
 CString CurrentExtension = fileDlg.GetFileExt();
 CString filename = CurrentFileName;

 // obtain selected extension (needed if user has omitted a extension to the filename)
 CString SelectedExtension;
 SelectedExtension = ObtainSelectedExtension( CurrentFileName, SelectedExtension, fileDlg.m_ofn.lpstrFilter, fileDlg.m_ofn.nFilterIndex);

 // no extension supplied -> append selected extension
 if (CurrentExtension == "") 
 {
	 CurrentExtension = SelectedExtension;
	 CurrentFileName += "." + SelectedExtension;
 }

 // make extensions upper case
 CurrentExtension.MakeUpper();
 SelectedExtension.MakeUpper();

 CImageSequence *newseq;
 newseq = new CImageSequence( m_pCATineDlg, m_bTineALInitialized, m_pTineALDlg, this );
 if (newseq == NULL)
 {
	 OwnMessageBox(MB_ICONEXCLAMATION, "Unable to create Image Sequence. File was not loaded.");
	 return;
 }

 if ((SelectedExtension == "IMM") || (SelectedExtension == "IMC")) // we want to load a IMM file
 {
  int type = FILE_IMM;
  if (SelectedExtension == "IMC") type = FILE_IMC;

  BOOL ret = newseq->LoadFromFile( type, CurrentFileName );
  if (ret == TRUE)
  {
    BOOL canbeloaded = TRUE;
	if (newseq->GetImageWidth() != m_iActualWidth || newseq->GetImageHeight() != m_iActualHeight )
	{
	 int a = newseq->GetImageWidth();
	 int b = newseq->GetImageHeight();
	 
	 if ((a*b) % 8 != 0)
	 {
	  canbeloaded = FALSE;
	 }
	}

    if (canbeloaded == TRUE) 
	{
	 CheckImageSettings( newseq->GetImageWidth(), newseq->GetImageHeight(), newseq->GetBpp(), newseq->GetBppEffective() );

	 delete m_pImageSequence;
     m_pImageSequence = newseq;
	
	 SetScaleFactorInGUI( m_pImageSequence->GetScale() );

     // do statistical calculations and update the statistical values
     // MakeStatFile( (char *) m_pGrabBuffer, m_pNormalizedImage, m_iGrabBufferNumImages, m_bXRayFiltering);
     
	 CInformationDialog dlg;

     CString tmp;
	 tmp.Format("(%u frame(s))", m_pImageSequence->Count());
     SetCaption( "Video Client 2 -", filename, tmp );

	 dlg.Show("Calculating,..");

	 MakeStatFile( m_pImageSequence, m_pNormalizedImage, m_bXRayFiltering);
	 if (m_pStatFile != NULL) m_pStatFile->START();
     UpdateStatisticalValues();

     dlg.Hide();

     VIDHDR vidH;
	 char *tmpptr;
	 m_pImageSequence->GetFrame( m_pImageSequence->Count()-1, (const char **) &tmpptr );
     memman.memcpysw( (char *) &vidH, tmpptr, sizeof(VIDHDR) );

     // display the analyzed frame
	 DisplayFunction( m_pNormalizedImage, vidH.cameraport, FALSE);

     // from now on we can analyze and save a image, because buffer is initialized properly
     SetMenuItem(ID_IMAGE_ANALYZE, TRUE);	
     SetMenuItem(ID_IMAGE_SAVE, TRUE);
	}
	else
	{
     OwnMessageBox(0, "Can not load in image because width and height are not a multiple of four.");
	 // SW! Apr 26, 2006 is the above line (and the check itself) really necessary ? 
     delete newseq;
	}
  }
  else
  {
   OwnMessageBox(MB_ICONEXCLAMATION, "Could not load in the file.");
   delete newseq;
  }
 }
 else if( SelectedExtension == "BMP")
 {
  BOOL ret = newseq->LoadFromFile( FILE_BMP, CurrentFileName );
  if (ret == TRUE)
  {
    BOOL canbeloaded = TRUE;
	if (newseq->GetImageWidth() != m_iActualWidth || newseq->GetImageHeight() != m_iActualHeight)
	{
	 int a = newseq->GetImageWidth();
	 int b = newseq->GetImageHeight();
	 
	 if ((a*b) % 8 != 0)
	 {
	  canbeloaded = FALSE;
	 }
	}

    if (canbeloaded == TRUE) 
	{
	 CheckImageSettings( newseq->GetImageWidth(), newseq->GetImageHeight(), 8, 8 );
     delete m_pImageSequence;
     m_pImageSequence = newseq;

	 m_pImageSequence->SetScale( DEFAULT_SCALE_FACTOR ); // it is a BMP file and NO scale is encoded, so use default
	 SetScaleFactorInGUI( m_pImageSequence->GetScale() );

     // do statistical calculations and update the statistical values
     //MakeStatFile( (char *) m_pGrabBuffer, m_pNormalizedImage, m_iGrabBufferNumImages, m_bXRayFiltering);

   	 CInformationDialog dlg;

	 dlg.Show("Calculating,..");

	 MakeStatFile( m_pImageSequence, m_pNormalizedImage, m_bXRayFiltering);
	 if (m_pStatFile != NULL) m_pStatFile->START();
     UpdateStatisticalValues();

     dlg.Hide();

     VIDHDR vidH;
	 char *tmpptr;
	 m_pImageSequence->GetFrame( m_pImageSequence->Count()-1, (const char **) &tmpptr );
     memman.memcpysw( (char *) &vidH, tmpptr, sizeof(VIDHDR) );

     CString tmp;
	 tmp.Format("(%u frame(s))", m_pImageSequence->Count());
     SetCaption( "Video Client 2 -", filename, tmp );

     // display the analyzed frame
	 DisplayFunction( m_pNormalizedImage, vidH.cameraport, FALSE);

     // from now on we can analyze and save a image, because buffer is initialized properly
     SetMenuItem(ID_IMAGE_ANALYZE, TRUE);	
     SetMenuItem(ID_IMAGE_SAVE, TRUE);
	}
	else
	{
     OwnMessageBox(0, "Can not load in image because width and height are not a multiple of four.");
     delete newseq;
	}

  }
  else
  {
   OwnMessageBox(MB_ICONEXCLAMATION, "Could not load in the file.");
   delete newseq;
  }
 }
 else // no suitable file extension
 {
  OwnMessageBox(0, "No suitable file extension. I can only load BMP, IMC and IMM files.");
 }
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is needed to save a background image to disk. It is required 
// as a helper function for saving an image, because if an image is saved, the 
// background is saved, too. This function writes out a BMP file.
//
// Parameter:
//  filename - full name and path of file to be saved
//
// Return value:
//    0      -  error while writing file
//    1      -  everything went fine, file is saved
//
int CVideoclntDlg::SaveBackgroundBMP( char *filename )
{
	return 0;

	/*
  BOOL ret;
  // create CPalette

  CBMPFileHelper help;

  if (m_iActualBpp == 8)
  {
    // write out BMP file
    ret = help.WriteBMP( filename , m_pBackground, (PALETTEENTRYSW *) &m_ColorTable, m_iActualWidth, m_iActualHeight, FALSE );
  }
  else 
  {
	  unsigned char *bitsbuffer8 = (unsigned char *) memman.sw_malloc( m_iActualWidth*m_iActualHeight );
	  if (bitsbuffer8 != NULL)
	  {
    	DownScaleTo8Bit((unsigned char *) m_pBackground, bitsbuffer8, m_iActualWidth, m_iActualHeight, m_iActualBpp);
        // write out BMP file
        ret = help.WriteBMP( filename , (char *) bitsbuffer8, (PALETTEENTRYSW *)  &m_ColorTable, m_iActualWidth, m_iActualHeight, FALSE );

		memman.sw_free( (void *) bitsbuffer8 );
	  }
	  else
	  {
       OwnMessageBox(MB_ICONEXCLAMATION, "Out of memory saving background BMP file ! File was not saved.");
	   ret = FALSE;
	  }
  }

  if (ret == FALSE) // error ? 
  {
   return( 0 ); // return error code
  }
  
  
  return( 1 ); // everything went fine*/
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is needed to save a background image to disk. It is required 
// as a helper function for saving an image, because if an image is saved, the 
// background is saved, too. This function writes out a BKG file.
//
// Parameter:
//  filename - full name and path of file to be saved
//
// Return value:
//    0      -  error while writing file
//    1      -  everything went fine, file is saved
//
int CVideoclntDlg::SaveBackgroundBKG( char *filename )
{
  FILE *fp;

  // open file for writing
  fp = fopen( filename, "wb");
  
  if (fp != NULL) // file could be opened ? 
  {
   unsigned int w=m_iActualWidth, h=m_iActualHeight, bpp=m_iActualBpp, bpp_eff = m_iActualBppEffective;
   
   unsigned int codedbpp = bpp;
   if (codedbpp == 8) codedbpp = 0;

   unsigned int w_write = ((codedbpp&0xff)<<16) + (w&0xffff);

   // write out width and height
   unsigned int ret = fwrite(&w_write, 1, 4, fp);
   
   if (bpp_eff == 8) bpp_eff = 0;

   unsigned int h_write = ((bpp_eff<<16)&0xff0000) + (h&0xffff);

   ret += fwrite( &h_write, 1, 4, fp);
   
   // write out background bits
   ret += fwrite( m_pBackground, 1, w*h*m_iActualBpp/8, fp);

   if (ret != (w*h*m_iActualBpp/8)+8) // error [not all bytes written] ? 
   {
    fclose(fp);
	return( 0 ); // return error
   }
  }
  fclose(fp);
  return( 1 ); // return success
}


///////////////////////////////////////////////////////////////////////////////
//
// In the function OnMenuImageSave() a image (frame) is saved to disk.
// At first, a file-save dialog is presented where the user can choose its preferred
// filename and file format. After this, the file is saved from the grab buffer 
// memory location. One can save BMP (Windows Bitmap file) or IMM (own file format) files.
// A IMM file can have multiple frames inside. For example a IMM file has 20 frames if you 
// grabbed 20 frames (Image->>Grab->20 frames) before.
//
void CVideoclntDlg::OnMenuImageSave() 
{
 int savetofileerror;

 // create file filter
 CString filefilter = "IMC Files (*.imc)|*.imc|IMM Files (*.imm)|*.imm|BMP Files (*.bmp)|*.bmp||";

 // instantiate "Save as" dialog
 CFileDialog fileDlg(FALSE,NULL,NULL, OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY, filefilter);
 
 // execute and check for return value
 if(fileDlg.DoModal()==IDCANCEL)
	return; // Cancel pressed ? -> get out of here

 // get filename and full path
 CString CurrentFileName = fileDlg.GetPathName();
 // get extension
 CString CurrentExtension = fileDlg.GetFileExt();

  // obtain selected file extension (needed to append to filename if the user omitted a extension)
 CString SelectedExtension;
 SelectedExtension = ObtainSelectedExtension( CurrentFileName, SelectedExtension, fileDlg.m_ofn.lpstrFilter, fileDlg.m_ofn.nFilterIndex);

 CString filename1 = CurrentFileName;

 if (CurrentExtension == "") // no extension appended ? 
 {
	 // append the selected extension from the file dialog
	 CurrentExtension = SelectedExtension;
	 CurrentFileName += "." + SelectedExtension;
 }

 // make the extension variables upper case
 CurrentExtension.MakeUpper();
 SelectedExtension.MakeUpper();

 /* construct proper filename string for additional textfile */
 /* and call proper function to ask, query and store the information if necessary */
 CString filenamepath = fileDlg.GetPathName();
 CString filename = fileDlg.GetFileName();
 CString path = filenamepath.Left( filenamepath.GetLength() - filename.GetLength() );
 // format name string of textfile
 CString textfilename;
 textfilename.Format("%s%s.%s", path, fileDlg.GetFileTitle(), "txt");
 
 CString basefilename;
 basefilename.Format("%s%s", path, fileDlg.GetFileTitle() );

 if ((SelectedExtension == "BMP") && (m_iActualBpp != 8))
 {
	 int ret = AfxMessageBox("Image and background will be converted to 8 bits before written to BMP files. This is lossy.\nDo you really want to do this ?", MB_ICONQUESTION | MB_YESNO );

	 if (ret == IDNO)
	 {
		 OwnMessageBox(MB_ICONINFORMATION, "Nothing was saved.");
		 return;
	 }
 }

 int ret = AfxMessageBox("Do you want to save additional information?", MB_YESNO);
 BOOL savetext = TRUE;
 if (ret == IDNO) savetext = FALSE;
 
 if ((SelectedExtension == "IMM") || (SelectedExtension == "IMC")) // we want to save an IMM file
 {

  int type = FILE_IMM;
  if (SelectedExtension == "IMC") type = FILE_IMC;

  BOOL ret = m_pImageSequence->SaveToFile( type, savetext, FALSE, basefilename, textfilename, 0,  (PALETTEENTRYSW *) m_pColorTable, NULL, NULL, &savetofileerror);

  if (ret == TRUE)
  {

   // save background using same file name but extension set to bkg
   CString filenamepath = fileDlg.GetPathName();
   CString filename = fileDlg.GetFileName();
   CString path = filenamepath.Left( filenamepath.GetLength() - filename.GetLength() );

   // format name string of background
   CString backgroundname;
   backgroundname.Format("%s%s.%s", path, fileDlg.GetFileTitle(), "bkg");
   
   // save background as bkg file
   int retb = SaveBackgroundBKG( (char *) (LPCTSTR) backgroundname );
   if (retb != 1) // error ? 
   {
     OwnMessageBox(0, "Could not save attached background file\n%s", backgroundname);
   }
   else // everything went fine
   {
     CString tmp;
	 tmp.Format("(%u frame(s))", m_pImageSequence->Count());
     SetCaption( "Video Client 2 -", filename1, tmp );

	 CString msg;
	 if (savetext == 1) msg.Format("Image, background and textual information were saved.");
	 if (savetext == 0) msg.Format("Image and background were saved.");
     OwnMessageBox(0, (LPCTSTR) msg);
   }
  
  }
   else
  {
   if (savetofileerror == 1)
   {
     OwnMessageBox(MB_ICONEXCLAMATION, "Error saving image file.");
   }
   else if (savetofileerror == 2)
   {
     OwnMessageBox(MB_ICONEXCLAMATION, "Error saving additional text file.");
   }
  }
 }
 else if ( SelectedExtension == "BMP") // save BMP file 
 {
  // save pictures from grab-buffer as bmp images 
  // if there is more than one picture inside the grab buffer then
  // the images are written out as a sequence.
  // The actual background is saved accordingly.

  BOOL ret = m_pImageSequence->SaveToFile( FILE_BMP, savetext, FALSE, basefilename, textfilename, 0,  (PALETTEENTRYSW *) m_pColorTable, NULL, NULL, &savetofileerror);

  if (ret == TRUE)
  {

     // format background string
     CString backgroundname;
     backgroundname.Format("%s%s_bkg.%s", path, fileDlg.GetFileTitle(), SelectedExtension);
  
     // save background
     int retb = SaveBackgroundBMP( (char *) (LPCTSTR) backgroundname );
     if (retb != 1) // error ? 
     {
       OwnMessageBox(0, "Could not save attached background file\n%s", backgroundname);
     }
     else // everything went fine
     { 
       CString tmp;
  	   tmp.Format("(%u frame(s))", m_pImageSequence->Count());
       SetCaption( "Video Client 2 -", filename1, tmp );

  	   CString msg;
	   if (savetext == 1) msg.Format("Image, background and textual information were saved.");
	   if (savetext == 0) msg.Format("Image and background were saved.");

       OwnMessageBox(0, msg);
     }
  }
   else
  {
   if (savetofileerror == 1)
   {
     OwnMessageBox(MB_ICONEXCLAMATION, "Error saving image file.");
   }
   else if (savetofileerror == 2)
   {
     OwnMessageBox( MB_ICONEXCLAMATION, "Error saving additional text file.");
   }
  }
 }
 else // no suitable file extension
 {
	OwnMessageBox(0, "No suitable file extension. I can only save BMP, IMC and IMM files.");
 }
	
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user presses the snapshot button located
// on the toolbar or presses the hotkey F10. When this function is called the 
// actual displayed frame is saved to disk. The file is saved as a BMP file.
// The filename is constructed out of "snap", the actual date and time and the 
// extension BMP. A valid filename would be: snap26_06_2002_11_09_22.bmp .
// The file was saved on the 26th of June 2002 at 11:09am and 22 seconds.
//
// All pictures are saved in the snapshot directory which can be set in 
// Application->Preferences.
//
void CVideoclntDlg::OnTakeSnapshot() 
{
  // get snapshot directory from ini file
  CString Snapshotdir = m_pIniFileProf->GetValue("MAIN", "SnapshotDir", "h:\\");

  // get current time and date and create time string 
  CTime time3;  
  time3 = CTime::GetCurrentTime();
  CString timestr = time3.Format("%d_%m_%Y__%H_%M_%S");

  // append filename at snapshot dir
  Snapshotdir += "snap" + timestr + ".bmp";

 
  CBMPFileHelper help;

  // write out BMP file
  BOOL ret = help.WriteBMP( ( char *) (LPCTSTR) Snapshotdir, m_pLastFrame, m_pColorTable, m_iActualWidth, m_iActualHeight, m_iActualBpp, m_iActualBppEffective, FALSE );

  // print message on status bar
  CString snapname = "Picture \"snap" + timestr + ".bmp\" snapped.";

  if (ret == FALSE) 
  {
	  snapname = "Error writing snapshot file. No Image could be snapped.";

	  OwnMessageBox(MB_ICONEXCLAMATION, snapname );
  
  }

  PrintServerMessage( snapname );
  
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called via a Timer to check once a second whether the camera
// port has changed on the server. If the port has changed, the camera port
// combo box will be updated to show the actual port.
//
// updating does not take place when a transfer is running and 
// override_transfer is set to FALSE
void CVideoclntDlg::UpdateCameraPort( BOOL message, BOOL all )
{
	static int running = 0;
	if (running == 1) return;
	running = 1;
	
    if (m_ServerList.Count() == 0)
	{
	 running = 0;
	 return;
	}

	CServer srv;
	CString camIDStr;
	
	if (all == TRUE)
	{
		ReloadServerSettingsSmall();

		// SW! July 13, 2006 negative dropped fixed.
		m_iFirstFrame = -1;
		m_iCountedFrames = 0;
		// SW! July 13, 2006 END

		
		//m_ServerList.getServer(m_iActualServerPos, srv);
		//CheckServerSettings( srv );

	}
	else
	{
		m_ServerList.getServer(m_iActualServerPos, srv);
		
		BOOL ret = GetCameraName(srv.getTineContext(), srv.getTineControlName(), "C_CAMID", camIDStr);
		if (ret == TRUE)
		{
			//CString msgtemp;
			//msgtemp.Format("%s != %s ?", camIDStr, m_sActualCameraID);
			//PrintServerMessage(msgtemp);

			if (camIDStr != m_sActualCameraID)
			{
				if (message == TRUE) PrintServerMessage("Attention: camera change!");
				SignalCameraSelectionBox(10000, 100, RGB(255,0,0));
		  		
				// SW! July 13, 2006 negative dropped fixed.
				m_iFirstFrame = -1;
				m_iCountedFrames = 0;
				// SW! July 13, 2006 END

			
				ReloadServerSettings( m_iActualServerPos );
			
				//m_ServerList.getServer(m_iActualServerPos, srv);
				//CheckServerSettings( srv );
			}

		}


	}
	running = 0;

}

///////////////////////////////////////////////////////////////////////////////
//
// In this function all calculations take place that happen when the user resizes 
// the window. The status line, the video frame and maybe the propjection frame
// are resized accordingly.
//
void CVideoclntDlg::RedrawClientArea()
{
 RECT clientArea, videoArea, statusArea, projectionxArea, projectionyArea;

 // get client rectangle after resizing took place
 this->GetClientRect( &clientArea);
 this->ClientToScreen( &clientArea );

 // recalculate the projectionArea, videoArea and statusArea
 AdjustClientArea( &clientArea, &projectionxArea, &projectionyArea, &videoArea, &statusArea, m_bXProjectionOn, m_bYProjectionOn, m_bKeepAspectRatio);

 // convert the screen coordinates after the AdjustClientArea call back to client coordinates
 this->ScreenToClient( &videoArea );
 this->ScreenToClient( &statusArea );
 this->ScreenToClient( &projectionxArea );
 this->ScreenToClient( &projectionyArea );

 // move and resize the frames accordingly
 m_CMyVideoFrame.MoveWindow( videoArea.left, videoArea.top, videoArea.right - videoArea.left + 1, videoArea.bottom - videoArea.top + 1, TRUE);
 m_CEditStatusLine.MoveWindow( statusArea.left, statusArea.top, statusArea.right - statusArea.left + 1, statusArea.bottom - statusArea.top + 1, TRUE);
 m_CFrameProjection.MoveWindow( projectionxArea.left, projectionxArea.top, projectionxArea.right - projectionxArea.left + 1, projectionxArea.bottom - projectionxArea.top + 1, TRUE);
 m_CFrameYProjection.MoveWindow( projectionyArea.left, projectionyArea.top, projectionyArea.right - projectionyArea.left + 1, projectionyArea.bottom - projectionyArea.top + 1, TRUE);

 // calculate new width and height of the video window
 m_VideoWindowWidth = videoArea.right - videoArea.left + 1;
 m_VideoWindowHeight = videoArea.bottom - videoArea.top + 1;
 
 // temporary disable any drawing to the window by other threads
 m_bDrawingInitialized = FALSE;

 // drawing is up and running again
 m_bDrawingInitialized = TRUE;
 
 // display last frame again
 DisplayFunction(0, 0, TRUE);

 // call OnPaint function
 OnPaint();
}

///////////////////////////////////////////////////////////////////////////////
//
// In this function the projection mode is switched to off. It is only swtched off
// if it was not already in this state. It is called via the menu 
// Application->Projection mode->Off.
//
void CVideoclntDlg::OnApplicationProjectionmodeOff() 
{
    if (m_bXProjectionOn == TRUE || m_bYProjectionOn == TRUE) // do we have to switch ? 
	{
	  // print message
	  PrintServerMessage("Projection switched off.");

	  // put check mark accordingly
      CheckMenuItem(ID_APPLICATION_PROJECTIONMODE_OFF, TRUE);
	  CheckMenuItem(ID_APPLICATION_PROJECTIONMODE_XPROJECTION, FALSE);
      CheckMenuItem(ID_APPLICATION_PROJECTIONMODE_YPROJECTION, FALSE);
	  
	  m_bXProjectionOn = FALSE;
	  m_bYProjectionOn = FALSE;
	  //m_iProjectionMode = 0; // no projection

      // redraw the client area
      RedrawClientArea();
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// In this function the projection mode is switched to X-projection. It is only 
// switched to X-projection if it was not already in this state. It is called via 
// the menu Application->Projection mode->X projection.
//
void CVideoclntDlg::OnApplicationProjectionmodeXprojection() 
{
    if (m_bXProjectionOn != TRUE) // do we have to switch ? 
	{
  	  // print message
	  PrintServerMessage("Switched on X-Projection.");
      
	  // put check mark accordingly
	  CheckMenuItem(ID_APPLICATION_PROJECTIONMODE_OFF, FALSE);
	  CheckMenuItem(ID_APPLICATION_PROJECTIONMODE_XPROJECTION, TRUE);
      
	  //m_iProjectionMode = 1; // x projection
	  m_bXProjectionOn = TRUE;
	
      // redraw the client area
	  RedrawClientArea();
	}
	 else
	{
  	  // print message
	  PrintServerMessage("Switched off X-Projection.");
      
	  // put check mark accordingly
	  CheckMenuItem(ID_APPLICATION_PROJECTIONMODE_XPROJECTION, FALSE);
      
	  //m_iProjectionMode = 1; // x projection
	  m_bXProjectionOn = FALSE;
	
      // redraw the client area
	  RedrawClientArea();
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// In this function the projection mode is switched to Y-projection. It is only 
// switched to Y-projection if it was not already in this state. It is called via 
// the menu Application->Projection mode->Y projection.
//
void CVideoclntDlg::OnApplicationProjectionmodeYprojection() 
{
    if (m_bYProjectionOn != TRUE) // do we have to switch ? 
	{
     // print message
	 PrintServerMessage("Switched on Y-Projection.");
     
	  // put check mark accordingly
	 CheckMenuItem(ID_APPLICATION_PROJECTIONMODE_OFF, FALSE);
	 CheckMenuItem(ID_APPLICATION_PROJECTIONMODE_YPROJECTION, TRUE);

	 //m_iProjectionMode = 2; // y projection
	 m_bYProjectionOn = TRUE;

     // redraw the client area
     RedrawClientArea();
	}
    else
	{
     // print message
	 PrintServerMessage("Switched off Y-Projection.");
     
	  // put check mark accordingly
	 CheckMenuItem(ID_APPLICATION_PROJECTIONMODE_YPROJECTION, FALSE);

	 //m_iProjectionMode = 2; // y projection
	 m_bYProjectionOn = FALSE;

     // redraw the client area
     RedrawClientArea();
	}

}

/* SW! Apr 27, 2006 taken out
///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user switches the camera port. There can be
// one unique scale value for each of the 4 camera ports. The CEdit control 'scale'
// is updated accordingly to the new camera port.
//
void CVideoclntDlg::SetScaleFromServer(DWORD server)
{
    int lserver = (int) server;

	CServer srv;
	m_ServerList.getServer( lserver, srv );

	double scale = srv.getCamScale( );

	CString msg;
	msg.Format("%f", scale);
    m_CEditScale.SetWindowText( (LPCTSTR) msg);
}
*/

///////////////////////////////////////////////////////////////////////////////
//
// This function examines the filterstr and nFilterIndex which are returned by 
// the CFileDialog class. This function returns the selected file extension from
// the dialog. It is required for adding the selected extension to a filename
// where the user omitted a extension.
//
CString CVideoclntDlg::ObtainSelectedExtension(CString fname, CString &returnvalue, LPCTSTR filterstr, int nFilterIndex)
{
 // each filterindex has 2 fields in the filterstr, so the actual position in strings (not in filters) 
 // must be exactly the double
 nFilterIndex *= 2;
 char *stringaktpos = (char *) filterstr;
 char *default1;

 // seek through the string
 for (int i=1;i<nFilterIndex;i++)
 {
  stringaktpos += strlen( (const char *) stringaktpos )+1;
 }

 default1 = stringaktpos;

 // now we have the filterstring for the selected extension

 char *token = strtok( stringaktpos, ";" );
 while( token != NULL )
 {

    // deliver all characters after the last point in the extension
    stringaktpos = (strrchr( (const char *) token, '.')) + 1;

    int len = strlen(stringaktpos);

    CString extfn = fname.Right(len);

    extfn.MakeUpper();

    CString str2(stringaktpos);
    str2.MakeUpper();

    if (str2 == extfn)
	{
      break;
	}

    /* Get next token: */
    token = strtok( NULL, ";" );
 }

 //if (token == NULL) stringaktpos = default1;
 
 // make CString out of it
 returnvalue = CString(stringaktpos);

 return( returnvalue ); // return the selected extension
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user selects Application->X ray filtering
// from the menu. It either switches on or off x-ray filtering. X-ray filtering
// is only applied in grab mode. In poll mode, it has no function.
//
void CVideoclntDlg::OnApplicationXrayfiltering() 
{
 if (m_bXRayFiltering == TRUE) // X-ray filtering is on: switch it off
 {
    // print message
	PrintServerMessage("Switched X-Ray filtering off.");

    // uncheck menu item	
	CheckMenuItem(ID_APPLICATION_XRAYFILTERING, FALSE);
    
	// set x-ray filtering flag to FALSE
	m_bXRayFiltering = FALSE;
 }
 else // Y-ray filtering is off: switch it on
 {
    // print message
	PrintServerMessage("Switched X-Ray filtering on.");

	// check menu item
	CheckMenuItem(ID_APPLICATION_XRAYFILTERING, TRUE);
    
	// set x-ray filtering flag to TRUE
	m_bXRayFiltering = TRUE;
 }
}

////////////////////////////////////////////////////////////////////////////////////
//
// This function loads up the configuration file when starting up the application. 
// It loads the file into memory, or creates a default file if there is no file on disk.
// Some variables of the CVideoclntDlg are also initializes, mainly the default scales
// for the camera ports.
//
BOOL CVideoclntDlg::InitializeIniFiles()
{
 CString filepath;
 BOOL atExe = TRUE;
 LPITEMIDLIST lpID = NULL;
 char   folder[MAX_PATH];
 LPMALLOC  lpMalloc = NULL;

 // initialize ini file at user's profile directory

 if (SHGetSpecialFolderLocation(NULL, CSIDL_APPDATA, &lpID) == NOERROR)
 {
      if (SHGetPathFromIDList (lpID, folder) == TRUE)
      {
            filepath = CString(folder) + CString("\\videoclnt2_user.cfg");
			atExe = FALSE;
      }

      // free the ITEMIDLIST
      if (SHGetMalloc (&lpMalloc) == NOERROR)
      {
       lpMalloc->Free(lpID);
      }
 }

 // instantiate profile ini file
 m_pIniFileProf = new CIniEx();
 if (m_pIniFileProf == NULL)
 {
  OwnMessageBox(MB_ICONEXCLAMATION, "Unable to create initialization file class. This is a severe error. Program must quit.");
  return FALSE;
 }
 
 if (atExe == TRUE)
 {
   m_pIniFileProf->OpenAtExeDirectory( "videoclnt2_user.cfg" );
 }
  else
 {
  m_pIniFileProf->Open( (LPCSTR) filepath, TRUE, TRUE, TRUE, FALSE );
 }

 // try to retrieve a value that must not exist in order to know
 // whether we have created a empty file 
 CString maintest = m_pIniFileProf->GetValue("MAIN", "SnapshotDir", "<empty>");

 if (maintest == "<empty>")
 {
  m_pIniFileProf->SetValue("MAIN", "SnapshotDir", "h:\\");
  m_pIniFileProf->WriteFile();
 }

 // initialize ini file that is located at the executables directory
 // instantiate ini file
 m_pIniFileExeGlobal = new CIniEx();
 if (m_pIniFileExeGlobal == NULL)
 {
	OwnMessageBox(MB_ICONEXCLAMATION, "Unable to create global initialization file class. This is a severe error. Program must quit.");
	return FALSE;
 }
 
 BOOL reti1 = m_pIniFileExeGlobal->OpenAtExeDirectory( "videoclnt2_global.cfg", FALSE, FALSE, TRUE, FALSE); /* open at the executable's directory */

 // initialize ini file that is located at the executables directory
 // instantiate ini file
 m_pIniFileExeLocal = new CIniEx();
 if (m_pIniFileExeLocal == NULL)
 {
	OwnMessageBox(MB_ICONEXCLAMATION, "Unable to create local initialization file class. This is a severe error. Program must quit.");
	return FALSE;
 }
 
 BOOL reti2 = m_pIniFileExeLocal->OpenAtExeDirectory( "videoclnt2_local.cfg" ); /* open at the executable's directory */

 if (reti1 == FALSE || reti2 == FALSE)
 {
	 CString msg1;
	 msg1.Format("");
	 
	 if (reti1 == FALSE && reti2 == FALSE)
	 {
		 msg1.Format("Could not open neither global nor local initialization file.");
	 }
	 else if (reti1 == FALSE)
	 {
		 msg1.Format("Could not open global initialization file.");
	 }
	 else if (reti2 == FALSE)
	 {
         msg1.Format("Could not open local initialization file.");
	 }

	 OwnMessageBox(MB_ICONEXCLAMATION, "There was an error opening the initialization files.\n %s \n\n This is a severe error! Program must quit.", msg1 );
	 return FALSE;
 }

 maintest = m_pIniFileExeLocal->GetValue( "MAIN", "Servers", "<empty>");

 if (maintest == "<empty>") // aha, no values in the file yet, so fill the file with
 {                          // default values 
	 OwnMessageBox( MB_ICONEXCLAMATION, "There was an error reading contents of the local initialization file.\n This is a severe error! Program must quit." );

	 return FALSE;
 }

 // initialize additional properties

 int cnt=0;

 for (int k=0;k<NUM_MAX_ADDITIONAL_PROPERTIES;k++)
 {
	 CString propSect;

	 if ((k+1)<10) propSect.Format("Additional0%d", k+1); else propSect.Format("Additional%d", k+1);
	 
	 CString ena = m_pIniFileExeGlobal->GetValue(propSect, "Enabled", "FALSE");

	 if (ena == "TRUE")
	 {
		 CString cont = m_pIniFileExeGlobal->GetValue(propSect, "Context", "");
		 CString serv = m_pIniFileExeGlobal->GetValue(propSect, "Server", "");
		 CString devi = m_pIniFileExeGlobal->GetValue(propSect, "Device", "");
		 CString prop = m_pIniFileExeGlobal->GetValue(propSect, "Property", "");
		 CString dtyp = m_pIniFileExeGlobal->GetValue(propSect, "Datatype", "");
		 CString fnam = m_pIniFileExeGlobal->GetValue(propSect, "FriendlyName", "");
		 CString funi = m_pIniFileExeGlobal->GetValue(propSect, "FriendlyUnit", "");
		 dtyp.MakeUpper();

		 CString funiU = funi;
		 funiU.MakeUpper();
		 if (funiU == "NONE") funi = "";

		 if ((cont != "") && (serv != "") && (devi != "") && (prop != "") && (dtyp != "") && (fnam != ""))
		 {
			 m_AdditionalProperties[cnt].Context = cont;
			 m_AdditionalProperties[cnt].Server = serv;
			 m_AdditionalProperties[cnt].Device = devi;
			 m_AdditionalProperties[cnt].Property = prop;
			 m_AdditionalProperties[cnt].FriendlyUnit = funi;
			 m_AdditionalProperties[cnt].FriendlyName = fnam;
			 m_AdditionalProperties[cnt].intval = 0;
			 m_AdditionalProperties[cnt].dblval = 0;
			 m_AdditionalProperties[cnt].acqerr = 1;
			 
			 
			 if (dtyp == "INT")
			 {
				 m_AdditionalProperties[cnt].type = 1; // integer
				 m_AdditionalProperties[cnt].enabled = TRUE;
				 cnt++;
			 }
			 else if (dtyp == "FLOAT")
			 {
				 m_AdditionalProperties[cnt].type = 2; // floating point
				 m_AdditionalProperties[cnt].enabled = TRUE;
				 cnt++;
			 }
		 }
             

	 }
 }
 m_iNumAdditionalProperties = cnt;


 return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////
//
// This function deinitializes the configuration file's memory structures. It saves 
// the memory mapped file to disk and frees up all memory structures. This procedure 
// is called when leaving the application.
//
void CVideoclntDlg::DeinitializeIniFiles()
{
 if (m_pIniFileProf != NULL) 
 {
  // flush the profile file to disk
  m_pIniFileProf->WriteFile();
 
  // delete the profile initialization file class instance
  delete m_pIniFileProf;
  m_pIniFileProf = NULL;
 }

 if (m_pIniFileExeGlobal != NULL)
 {
  // delete the atExe initialization file class instance
  delete m_pIniFileExeGlobal;
  m_pIniFileExeGlobal = NULL;
 }

 if (m_pIniFileExeLocal != NULL)
 {
  // flush the atExe file to disk
  m_pIniFileExeLocal->WriteFile();

  // delete the atExe initialization file class instance
  delete m_pIniFileExeLocal;
  m_pIniFileExeLocal = NULL;
 }

}


void CVideoclntDlg::OnBackgroundGetAverage10frames() 
{
    // call procedure which grabs backgrounds
	BOOL ret = GetBackgroundsFromServer(10, FALSE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
	
}

void CVideoclntDlg::OnBackgroundGetAverage5frames() 
{
    // call procedure which grabs backgrounds
	BOOL ret = GetBackgroundsFromServer(5, FALSE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
	
}

void CVideoclntDlg::OnBackgroundGetEnvelope10frames() 
{
    // call procedure which grabs backgrounds
	BOOL ret = GetBackgroundsFromServer(10, TRUE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}	


void CVideoclntDlg::OnBackgroundGetEnvelope5frames() 
{
    // call procedure which grabs backgrounds
	BOOL ret = GetBackgroundsFromServer(5, TRUE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}


BOOL CVideoclntDlg::GetCameraName(CString context, CString server, CString property, CString &camportstring)
{

	 // set tine properties
	 // Device Context: "PITZ"
	 // Device Group:   server name
	 // Device Name:    "device_0"
	 // Device Property: e.g. "GRAB_CAM.0" (read camera string of camera port 0) 

	 m_CACOPCtrl.SetDeviceContext(context);
	 m_CACOPCtrl.SetDeviceGroup((LPCTSTR) server);
	 m_CACOPCtrl.SetDeviceName("GRABSRV");
     m_CACOPCtrl.SetDeviceProperty((LPCTSTR) property);

	 // set proper access mode and rate 
	 m_CACOPCtrl.SetAccessRate("1000");
	 m_CACOPCtrl.SetAccessMode("READ");
	 
	 VARIANT camdata, camsize, camtype, camport, camportsize, camportdatatype;

	 // set up string variant in which the camera string will be returned
	 CString str3 = "                                                                ";
	 VariantInit( &camdata );
	 V_VT( &camdata ) = VT_BSTR;
	 V_BSTR( &camdata ) = str3.AllocSysString();

	 // set size (1 string)
	 VariantInit( &camsize );
	 V_VT( &camsize ) = VT_I4;
	 camsize.lVal = 1;

	 // set proper type name variant
	 CString str2 = "NAME48";
	 VariantInit( &camtype );
	 V_VT( &camtype ) = VT_BSTR;
     V_BSTR( &camtype ) = str2.AllocSysString();

	 // set up char variant defining the port we want the name from
	 VariantInit( &camport );
	 V_VT( &camport ) = VT_I1;
	 camport.cVal = 0;

	 // size of the char variant (1 byte)
     VariantInit( &camportsize );
	 V_VT( &camportsize ) = VT_I4;
	 camportsize.lVal = 1;

	 // set up proper type
	 CString str1="BYTE";
	 VariantInit( &camportdatatype );
	 V_VT( &camportdatatype ) = VT_BSTR;
	 V_BSTR( &camportdatatype ) = str1.AllocSysString();

     long ret = m_CACOPCtrl.Execute( &camdata, camsize, camtype, &camport, camportsize, camportdatatype);
	 if (ret == 0) 
	 {
	  camportstring = CString(camdata.bstrVal);
	 }

	 if (ret != 0)
	 {
		 CString msgx;
		 msgx.Format("GetCameraName: %s", m_CACOPCtrl.GetStatus() );
		 PrintServerMessage(msgx);
	 }

	 VariantClear( &camdata );
     VariantClear( &camsize );
     VariantClear( &camtype );
     VariantClear( &camport );
     VariantClear( &camportsize );
     VariantClear( &camportdatatype );

  	 if (ret != 0) return FALSE;
	
	 return TRUE;
}


BOOL CVideoclntDlg::InitializeServerConnections()
{
	int pos = 1;
	int haveputin = 0;

    // remove information
    m_ServerList.deleteAllServers();
	
	m_CComboCamera.ResetContent();

    m_iActualServerPos = 1;

	// kill the camera port update timer
	//if (m_nTimer != 0) KillTimer( m_nTimer );

    // obtain default server id
	CString defaultserver = m_pIniFileExeLocal->GetValue("MAIN", "DefaultServer", "ZNPPITZFG1");

	int servers = m_pIniFileExeLocal->GetValueInt("MAIN", "Servers", 0);

	if (servers == 0) return( FALSE );

	for (int i=0;i<servers;i++) // iterate the servers
	{
	 CString key;
	 
	 // build up proper key value to look for server #i
	 
	 if (i<9)
	 {
      key.Format("Server00%d", i+1);
	 }
	 else if (i>=9 && i<99)
	 {
      key.Format("Server0%d", i+1);
	 }
	 else // i >= 100
	 {
      key.Format("Server%d", i+1);
	 }

     // get server section name of server #i

	 CString srvnameSection = m_pIniFileExeLocal->GetValue("MAIN", key, "");

	 if (srvnameSection != "") // server found ? 
	 {
	   // get proper hostname out of the server section
	   
	   CString srvnameHost = m_pIniFileExeGlobal->GetValue(srvnameSection, "Servername", "znppitzfg1");
       CString tinename = m_pIniFileExeGlobal->GetValue(srvnameSection, "TineControlEqpName", "ZNPPITZFG1");
	   CString tinecontext = m_pIniFileExeGlobal->GetValue(srvnameSection, "TineContext", "PITZ");

	   // access server
	   // download settings
	   // add cam name to box

	   CString	camName;
	   CString  camID;


	   BOOL retval1;
	   BOOL notasingleerror=TRUE;

       if (notasingleerror==TRUE) retval1 = GetCameraName( tinecontext, tinename, "C_CAMNAME", camName );
	   if (retval1 == FALSE) { camName = ""; notasingleerror = FALSE;}

       if (notasingleerror==TRUE) retval1 = GetCameraName( tinecontext, tinename, "C_CAMID", camID );
	   if (retval1 == FALSE) { camID = ""; notasingleerror = FALSE;}

	   int listenport = m_pIniFileExeGlobal->GetValueInt( srvnameSection, "Portnumber", 31777);
	   CString tineFrameEqp = m_pIniFileExeGlobal->GetValue( srvnameSection, "TineEqpName", "ZNPPITZFG1F");

       if (notasingleerror == TRUE)
	   {

	    CServer srv( pos, srvnameSection, srvnameHost, listenport, tineFrameEqp, camName, camID, tinename, tinecontext );
        m_ServerList.addServer( srv );

        if (srvnameSection == defaultserver) 
 	    {
 	     m_iActualServerPos = pos;
	    }
       
        haveputin = 1;
	    int lpos;
		DWORD val;

		CString tmp;
		tmp.Format("%s: %s", srvnameSection, camName);
		lpos = m_CComboCamera.AddString((LPCTSTR) tmp);
        val = pos;
		m_CComboCamera.SetItemData( lpos, val ); 
		pos++;

	   }
     }
     //pos++;
    }
 
    if (haveputin == 0)
	{
	 // switch off camera changing if not a single server could be added to the camera port list
	 m_CComboCamera.EnableWindow(FALSE);

     m_iActualWidth = 768;
	 m_iActualHeight = 574;
	 m_iActualBpp = 8;
	 m_iActualBppEffective = 8;

	 //m_nTimer = 0;

	 CServer srv( 1, "dummysect", "dummy", 31777, "dummyfrmeqp", "N/Aport0", "-nix-", "dtinename", "DEFAULT" );
     m_ServerList.addServer( srv );
     //m_iActualPort = 0;

 	 SetScaleFactorInGUI(DEFAULT_SCALE_FACTOR);

     OwnMessageBox(MB_ICONEXCLAMATION, "The program was unable to connect to any of the %d installed servers. \nPlease check the servers and local network / TINE protocol.\nYou can not grab or poll video frames.", servers);
    }
	 else
	{
	 if (m_iActualServerPos == -1) m_iActualServerPos = 1;

	 CServer srv;
	 m_ServerList.getServer( m_iActualServerPos, srv);

	 // create default setup;
     m_iActualWidth = 768;
	 m_iActualHeight = 574;
	 m_iActualBpp = 8;
	 m_iActualBppEffective = 8;
	 
	 m_sActualCameraID = srv.getCamID();

	 CreateServerCheckLink( srv.getTineContext(), srv.getTineControlName() );

	 m_CComboCamera.EnableWindow(TRUE);
	 m_CComboCamera.SetCurSel( m_iActualServerPos-1 );
	 m_CComboCamera.RedrawWindow();
	 
	 UpdateCameraPort(FALSE, FALSE);
	 
	 DWORD server = (m_CComboCamera.GetItemData( m_CComboCamera.GetCurSel() ));

	 SetScaleFactorInGUI(DEFAULT_SCALE_FACTOR);

 	}

    if ((haveputin != 0) && (m_ServerList.Count() != servers))
	{
		int unableto = servers - m_ServerList.Count();

		OwnMessageBox(MB_ICONEXCLAMATION, "The program was unable to connect to %d of the %d installed servers.\nPlease check the video server computers.\n", unableto, servers);
	}

    return( TRUE );
}

void CVideoclntDlg::DisableMenusForGrab()
{
   SetMenuItem(ID_APPLICATION_PRINT, FALSE);
   SetMenuItem(ID_APPLICATION_PRINTWHOLEWINDOW, FALSE );
   SetMenuItem(ID_IMAGE_LOAD, FALSE);
   SetMenuItem(ID_IMAGE_SAVE, FALSE);
   SetMenuItem(ID_IMAGE_ANALYZE, FALSE);
   SetMenuItem(ID_BACKGROUND_GRAB, FALSE);
   SetMenuItem(ID_BACKGROUND_ADD, FALSE);
   SetMenuItem(ID_BACKGROUND_SHOW, FALSE);
   SetMenuItem(ID_APPLICATION_OPTIONS, FALSE);
   SetMenuItemByPos(1, 2, FALSE); /* Grab... */
   SetMenuItemByPos(1, 3, FALSE); // Grab and Save
   SetMenuItemByPos(2, 4, FALSE); /* Background Get Envelope/Average */
   SetMenuItemByPos(0, 0, FALSE); /* stat mode */
   SetMenuItemByPos(0, 1, FALSE); /* color mode */
   SetMenuItemByPos(0, 2, FALSE); /* projection mode */
   SetMenuItemByPos(0, 3, FALSE); /* area of interest mode */

   SetMenuItem(ID_APPLICATION_QUIT, FALSE);
   SetMenuItem(ID_APPLICATION_NORMALISATION, FALSE);
   SetMenuItem(ID_IMAGE_POLL, FALSE );

   SetMenuItem(ID_BACKGROUND_LOAD, FALSE);
   SetMenuItem(ID_BACKGROUND_SAVE, FALSE);
   SetMenuItem(ID_APPLICATION_MESSAGES, FALSE);
   SetMenuItem(ID_APPLICATION_STAYONTOP, FALSE);
   SetMenuItem(ID_BACKGROUND_CLEAR, FALSE);
   SetMenuItem(ID_APPLICATION_XRAYFILTERING, FALSE);
   SetMenuItem(ID_DAQ_GETPATH, FALSE);

   m_bShouldCameraEnabledAfterGrabbing = m_CComboCamera.IsWindowEnabled();

   m_CComboCamera.EnableWindow(FALSE);
   m_CButtonSnap.EnableWindow(FALSE);
   m_DAQ.EnableWindow(FALSE);
}

void CVideoclntDlg::EnableMenusAfterGrab()
{
   SetMenuItem(ID_APPLICATION_PRINT, TRUE);
   SetMenuItem(ID_APPLICATION_PRINTWHOLEWINDOW, TRUE );
   SetMenuItem(ID_IMAGE_LOAD, TRUE);
   SetMenuItem(ID_IMAGE_SAVE, TRUE);
   SetMenuItem(ID_IMAGE_ANALYZE, TRUE);
   SetMenuItem(ID_BACKGROUND_GRAB, TRUE);
   SetMenuItem(ID_BACKGROUND_ADD, TRUE);
   SetMenuItem(ID_BACKGROUND_SHOW, TRUE);
   SetMenuItem(ID_APPLICATION_OPTIONS, TRUE);
   SetMenuItemByPos(1, 2, TRUE); /* Grab... */
   SetMenuItemByPos(1, 3, TRUE); /* Grab and Save */
   SetMenuItemByPos(2, 4, TRUE); /* Background Get Envelope/Average */
   SetMenuItemByPos(0, 0, TRUE); /* stat mode */
   SetMenuItemByPos(0, 1, TRUE); /* color mode */
   SetMenuItemByPos(0, 2, TRUE); /* projection mode */
   SetMenuItemByPos(0, 3, TRUE); /* area of interest */

   SetMenuItem(ID_APPLICATION_QUIT, TRUE);
   SetMenuItem(ID_APPLICATION_NORMALISATION, TRUE);
   SetMenuItem(ID_IMAGE_POLL, TRUE );

   SetMenuItem(ID_BACKGROUND_LOAD, TRUE);
   SetMenuItem(ID_BACKGROUND_SAVE, TRUE);
   SetMenuItem(ID_APPLICATION_MESSAGES, TRUE);
   SetMenuItem(ID_APPLICATION_STAYONTOP, TRUE);
   SetMenuItem(ID_BACKGROUND_CLEAR, TRUE);
   SetMenuItem(ID_APPLICATION_XRAYFILTERING, TRUE);
   SetMenuItem(ID_DAQ_GETPATH, TRUE);

   if (m_bShouldCameraEnabledAfterGrabbing == TRUE) m_CComboCamera.EnableWindow(TRUE);
   m_CButtonSnap.EnableWindow(TRUE);
   m_DAQ.EnableWindow(TRUE);

}


void CVideoclntDlg::OnBackgroundAdd() 
{
	BOOL ret = AddBackgroundFromServer();

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get background from Server.");
		// print error message
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg );
	}
}

void CVideoclntDlg::ReinitializeImageSettings()
{
	CheckImageSettings(-1, 0, 0, 0);
	SetCaption( "Video Client 2 - empty image", "", "" );
}

// if Width set to -1 on call: invalid settings passed, force reinitialisation
// of image analysis and drawing subsystem
//
//
void CVideoclntDlg::CheckImageSettings( int Width, int Height, int Bpp, int Bpp_eff)
{
 BOOL retmem;
 
 if (Width != -1)
 {
	if ((Width == m_iActualWidth) && (Height == m_iActualHeight) && (Bpp == m_iActualBpp) && (Bpp_eff == m_iActualBppEffective)) 
	{
		return;
	}
 }
 
 // when we are here we do not have proper settings, so set up everything properly

 if (m_pLastFrame != NULL) memman.sw_free( (void *) m_pLastFrame );
 if (m_pBackground != NULL) memman.sw_free( (void *) m_pBackground );
 if (m_pNormalizedImage != NULL) memman.sw_free( (void *) m_pNormalizedImage );

 // deinitialize drawing
 DeinitializeDrawing();

 // deinitialize compression
 DeinitializeCompression();

 // delete the memory location to store the decompressed frame
 if (m_pDecompressedFrame != NULL) memman.sw_free( (void *) m_pDecompressedFrame );

 if (m_pImageSequence != NULL) delete m_pImageSequence;
 m_pImageSequence = NULL;


 // after deinitializing everything we can reinitialize 

 if (Width != -1)
 {
	m_iActualWidth = Width;
	m_iActualHeight = Height;
	m_iActualBpp = Bpp;
	m_iActualBppEffective = Bpp_eff;
 }
 else
 {
	 Width = m_iActualWidth;
 	 Height = m_iActualHeight;
	 Bpp = m_iActualBpp;
 }

 // set default area of interest to whole picture

 if (m_bCircularAOI == TRUE)
 {
	m_newAOI.left = m_iActualWidth/2;
	m_newAOI.top = m_iActualHeight/2;
	
	if (m_iActualWidth < m_iActualHeight) m_newAOI.right = m_iActualWidth/2; else m_newAOI.right = m_iActualHeight/2;
	m_newAOI.bottom = 0;
 }
 else
 {
	m_newAOI.SetRect(0,0, m_iActualWidth-1, m_iActualHeight-1 );
 }
 

 retmem = TRUE;
   
 // allocate memory location needed for decompressed frame 
 m_pDecompressedFrame = (char *) memman.sw_malloc( Width*Height*Bpp/8 );
 if (m_pDecompressedFrame == NULL) retmem = FALSE;

 // allocate and clear memory location needed for background
 m_pBackground = (char *) memman.sw_malloc( Width*Height*Bpp/8 );
 if (m_pBackground == NULL) retmem = FALSE;
 if (retmem == TRUE) memset((void *) m_pBackground, 0, Width*Height*Bpp/8 );

 // allocate and clear memory for last frame buffer
 m_pLastFrame = (char *) memman.sw_malloc( Width*Height*Bpp/8 ); 
 if (m_pLastFrame == NULL) retmem = FALSE;
 if (retmem == TRUE) memset((void *) m_pLastFrame, 0, Width*Height*Bpp/8 );

 // allocate and clear memory for normalized image buffer
 m_pNormalizedImage = (char *) memman.sw_malloc( Width*Height*Bpp/8 );
 if (m_pNormalizedImage == NULL) retmem = FALSE;
 if (retmem == TRUE) memset((void *) m_pNormalizedImage, 0, Width*Height*Bpp/8 );

 m_pImageSequence = new CImageSequence( m_pCATineDlg, m_bTineALInitialized, m_pTineALDlg, this );
 if (m_pImageSequence == NULL) retmem = FALSE;

 // allocate and clear default grab buffer (1 picture)
 char *oneblackframe = (char *) memman.sw_malloc( (Width*Height*Bpp/8)+sizeof(VIDHDR) );
 if (oneblackframe == NULL) retmem = FALSE;
 if (retmem == TRUE) memset( (void *) oneblackframe, 0, (Width*Height*Bpp/8)+sizeof(VIDHDR) );

 // put in a default video header inside the grab buffer
 if (retmem == TRUE) 
 {
     VIDHDR vidH;
	 vidH.cameraport = -2;
	 vidH.widthframe = Width;
	 vidH.heightframe = Height;
	 vidH.bpp = Bpp;
	 vidH.bpp_effective = Bpp;
	 vidH.scale = DEFAULT_SCALE_FACTOR;
	 vidH.kennung = 0x11223344;
     memman.memcpysw((char *) oneblackframe, (char *) &vidH, sizeof(VIDHDR));
 }
 m_pImageSequence->Add( (unsigned char *) oneblackframe ); // scale should be now in the sequence!
 
 SetScaleFactorInGUI( m_pImageSequence->GetScale() );
 
 // initialize (de-)compression class
 BOOL ret4 = InitializeCompression( Width, Height, Bpp);
 if (ret4 != TRUE) OwnMessageBox(0, "Could not initialize decompression class.");

 // initialize drawing objects so that the video and the projection can be drawed
 BOOL ret5 = InitializeDrawing(m_iFalseColor);  
 //if (ret5 != TRUE) AfxMessageBox("Could not initialize video frame (gdi).", MB_ICONINFORMATION | MB_OK );

 // quit application if it could not be initialized properly
 if (retmem == FALSE || ret4 == FALSE || ret5 == FALSE) 
 {
  if (ret5 == TRUE) OwnMessageBox(MB_ICONEXCLAMATION, "Image properties changed, but reinitialize failed.\n This is a fatal error. Application must quit.");
  OnApplicationQuit();
 }
 else
 {
	 // put success (and info) message
	 PrintServerMessage("Attention: Image properties changed (width, height or bpp). Reinitialization of VC2 was done.");
 }

 // initialize proper analyse class (empty, straightforward, fourier)	
 MakeStatFile( m_pImageSequence, m_pNormalizedImage, m_bXRayFiltering);
 // do statistical analysis, subtract background, normalize image etc.

 if (m_pStatFile != NULL) m_pStatFile->START();
 // update the statistical variables
 UpdateStatisticalValues();

 // display the normalized image
 DisplayFunction( m_pNormalizedImage, -2, FALSE);

 RECT vr;
 m_CMyVideoFrame.GetWindowRect( &vr );

 INT32 xval = (vr.right - vr.left)/2;
 INT32 yval = (vr.bottom - vr.top)/2;

 OnVideoMouseMove(0, CPoint(xval,yval) );

}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 20 background images 
// and creating the real background out of the 20 backgrounds by averaging the 
// images.
//
void CVideoclntDlg::OnBackgroundGetAverage20frames() 
{
    // call procedure which grabs backgrounds, 20 images, average method
	BOOL ret = GetBackgroundsFromServer(20, FALSE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 30 background images 
// and creating the real background out of the 30 backgrounds by averaging the 
// images.
//
void CVideoclntDlg::OnBackgroundGetAverage30frames() 
{
    // call procedure which grabs backgrounds, 30 images, average method
	BOOL ret = GetBackgroundsFromServer(30, FALSE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 40 background images 
// and creating the real background out of the 40 backgrounds by averaging the 
// images.
//
void CVideoclntDlg::OnBackgroundGetAverage40frames() 
{
    // call procedure which grabs backgrounds, 40 images, average method
	BOOL ret = GetBackgroundsFromServer(40, FALSE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 50 background images 
// and creating the real background out of the 50 backgrounds by averaging the 
// images.
//
void CVideoclntDlg::OnBackgroundGetAverage50frames() 
{
    // call procedure which grabs backgrounds, 50 images, average method
	BOOL ret = GetBackgroundsFromServer(50, FALSE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

void CVideoclntDlg::OnBackgroundGetAverage100frames() 
{
    // call procedure which grabs backgrounds, 50 images, average method
	BOOL ret = GetBackgroundsFromServer(100, FALSE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

void CVideoclntDlg::OnBackgroundGetAverage200frames() 
{
    // call procedure which grabs backgrounds, 50 images, average method
	BOOL ret = GetBackgroundsFromServer(200, FALSE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}



/////////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 20 background images 
// and creating the real background out of the 20 backgrounds by envelope method.
//
void CVideoclntDlg::OnBackgroundGetEnvelope20frames() 
{
    // call procedure which grabs backgrounds, 20 images, envelope method
	BOOL ret = GetBackgroundsFromServer(20, TRUE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

/////////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 30 background images 
// and creating the real background out of the 30 backgrounds by envelope method.
//
void CVideoclntDlg::OnBackgroundGetEnvelope30frames() 
{
    // call procedure which grabs backgrounds, 30 images, envelope method
	BOOL ret = GetBackgroundsFromServer(30, TRUE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

/////////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 40 background images 
// and creating the real background out of the 40 backgrounds by envelope method.
//
void CVideoclntDlg::OnBackgroundGetEnvelope40frames() 
{
    // call procedure which grabs backgrounds, 40 images, envelope method
	BOOL ret = GetBackgroundsFromServer(40, TRUE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

/////////////////////////////////////////////////////////////////////////////////
//
// This function is called whenever the user wants to grab 50 background images 
// and creating the real background out of the 50 backgrounds by envelope method.
//
void CVideoclntDlg::OnBackgroundGetEnvelope50frames() 
{
    // call procedure which grabs backgrounds, 50 images, envelope method
	BOOL ret = GetBackgroundsFromServer(50, TRUE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
	
}

void CVideoclntDlg::OnBackgroundGetEnvelope100frames() 
{
    // call procedure which grabs backgrounds, 50 images, envelope method
	BOOL ret = GetBackgroundsFromServer(100, TRUE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

void CVideoclntDlg::OnBackgroundGetEnvelope200frames() 
{
    // call procedure which grabs backgrounds, 50 images, envelope method
	BOOL ret = GetBackgroundsFromServer(200, TRUE);

	if (ret == FALSE) // error while grabbing background?
	{
		CString msg("Unable to get backgrounds from Server.");
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}


// dest always w*h*32bpp
// source bpp only 8 and 16
// flips the image top-down, too
void CVideoclntDlg::AdjustBitdepthForPrinting(void *dest, void *src, int width, int height, int bpp)
{
	unsigned int *destlong = (unsigned int *) dest;
	if (bpp==8)
	{
		unsigned char *src_char;
		for (int y=height-1;y>=0;y--)
		{
			src_char = (unsigned char *) src;
			src_char += y*width;

			for (int x=0;x<width;x++)
			{
				*destlong++ = ((m_pColorTable[*src_char].peRed&0xFF)<<16) + 
							  ((m_pColorTable[*src_char].peGreen&0xFF)<<8) + 
							  ((m_pColorTable[*src_char].peBlue&0xFF));
				src_char++;
			}
		}
	}
	else if (bpp == 16)
	{
		unsigned short *src_short;
		for (int y=height-1;y>=0;y--)
		{
			src_short = (unsigned short *) src;
			src_short += y*width;

			for (int x=0;x<width;x++)
			{
				*destlong++ = ((m_pColorTable[*src_short].peRed&0xFF)<<16) + 
							  ((m_pColorTable[*src_short].peGreen&0xFF)<<8) + 
							  ((m_pColorTable[*src_short].peBlue&0xFF));
				src_short++;
			}

		}
	}
}

//DEL void CVideoclntDlg::flipframemmx(char *dest, char *src, int width, int height, int bpp)
//DEL {
//DEL  char *srcptr = src;
//DEL  char *destptr = dest;
//DEL  int lastline = (width*height*bpp/8)-(width*bpp/8);
//DEL  int adddst = width%4;
//DEL  int widthdiv8 = width / 8;
//DEL  int subtract = width*2;
//DEL  
//DEL  BOOL mmxdetected = FALSE;
//DEL 
//DEL  __asm
//DEL  {
//DEL      mov EAX, 1 
//DEL      CPUID 
//DEL      test EDX, 00800000h 
//DEL  
//DEL      jz MMX_Technology_Not_Found
//DEL      mov mmxdetected, 1
//DEL      MMX_Technology_Not_Found:
//DEL  }
//DEL 
//DEL  if (mmxdetected == TRUE)
//DEL  {
//DEL    __asm
//DEL    {
//DEL      emms
//DEL      mov esi, srcptr
//DEL      add esi, lastline
//DEL      mov edi, destptr
//DEL      mov edx, height
//DEL 	 mov eax, width
//DEL 	 and eax, 7
//DEL     yloop:
//DEL      mov ecx, widthdiv8
//DEL     xloop:
//DEL      movq mm1, [esi]
//DEL      add  esi,8
//DEL      movq [edi], mm1
//DEL      add edi,8
//DEL 
//DEL      dec ecx
//DEL      jnz xloop
//DEL 
//DEL      push eax
//DEL      cmp eax,0
//DEL 	 jg  dosmallloop
//DEL     backhere:
//DEL 	 pop eax
//DEL 
//DEL      sub esi, subtract
//DEL 	 add edi, adddst
//DEL 
//DEL      dec edx
//DEL      jnz yloop
//DEL 
//DEL      emms
//DEL 	 jmp outofhere
//DEL 
//DEL     dosmallloop:
//DEL 	 mov bl, [esi]
//DEL 	 add esi, 1
//DEL 	 mov [edi], bl
//DEL 	 add edi, 1
//DEL 	 dec eax
//DEL 	 jnz dosmallloop
//DEL 	 jmp backhere
//DEL 
//DEL     outofhere:
//DEL    }
//DEL  }
//DEL   else
//DEL  {
//DEL     int add = (width*bpp/8)%4;
//DEL 
//DEL     srcptr += lastline;
//DEL 
//DEL     int addsrc = (width*bpp/8);
//DEL     int adddst1 = addsrc + add;
//DEL 
//DEL     for (int i=0;i<height;i++)
//DEL     {
//DEL      memman.memcpysw( (char *) destptr, (char *) srcptr, width);
//DEL      destptr += adddst1;
//DEL      srcptr -= addsrc; 
//DEL     }
//DEL  }
//DEL }


/////////////////////////////////////////////////////////////////////////////////
// OnApplicationPrint() - prints the video image
// 
void CVideoclntDlg::OnApplicationPrint() 
{
	//OwnMessageBox(MB_ICONINFORMATION, "Printing image disabled in this version.");
	
	// load default (last selected or windows default) printer from printer settings class
	HDC hdc;
	LPBITMAPINFO lpbi=NULL; // bitmapinfoheader of video data 
	m_PrinterSettings.PrinterSetup(this, hdc);

	char *videotemp=NULL;


	if (hdc != NULL) // check whether a valid printer handle was returned 
	{
		// create a printer CDC class
		CDC dcPrinter;
		dcPrinter.Attach(hdc);

		// create bitmapinfo structure
		lpbi = (LPBITMAPINFO) memman.sw_malloc( sizeof(BITMAPINFOHEADER) );
		if (lpbi == NULL) 
		{
		 OwnMessageBox(MB_ICONEXCLAMATION, "Printing failed !");
		 dcPrinter.DeleteDC();
		 return;
		}
		
		// fill in proper bitmpapinfoheader values
		lpbi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
		lpbi->bmiHeader.biWidth = m_iActualWidth;
		lpbi->bmiHeader.biHeight = m_iActualHeight; //-574
		lpbi->bmiHeader.biPlanes = 1;
		lpbi->bmiHeader.biBitCount = 32; // 8
		lpbi->bmiHeader.biCompression = BI_RGB;
		lpbi->bmiHeader.biSizeImage = 0;
		lpbi->bmiHeader.biXPelsPerMeter = 0;
		lpbi->bmiHeader.biYPelsPerMeter = 0;
		lpbi->bmiHeader.biClrUsed = 0;
		lpbi->bmiHeader.biClrImportant = 0;

		// prepare DOCINFO structure
		DOCINFO docinfo;
		memset(&docinfo, 0, sizeof(docinfo));
		docinfo.cbSize = sizeof(docinfo);
		docinfo.lpszDocName = _T("Image from Video Client");

		dcPrinter.SetMapMode(MM_ISOTROPIC);          // map mode that allows scaling

		// get window rect (size, position) information 
		CSize sz(m_iActualWidth, m_iActualHeight);

		dcPrinter.SetWindowExt(sz.cx, sz.cy );

		// LOGICAL_WIDTH & LOGICAL_HEIGHT define the size of my logical
		// drawing page

		dcPrinter.SetViewportExt(dcPrinter.GetDeviceCaps(HORZRES), dcPrinter.GetDeviceCaps(VERTRES));
   
		// set the physical printer page size. Windows will scale the logical
		// page defined in SetWindowExt to match this physical page

		dcPrinter.SetWindowOrg(0,0); 

		// if it fails, complain and exit gracefully
		if (dcPrinter.StartDoc(&docinfo) < 0)
		{
			OwnMessageBox(0, "Printer wouldn't initalize");
		}
		else
		{
			// start a page
			if (dcPrinter.StartPage() < 0)
			{
				OwnMessageBox(0, "Could not start page.");
				dcPrinter.AbortDoc();
			}
			else
			{
				videotemp = (char *) memman.sw_malloc( m_iActualWidth*m_iActualHeight*4 );
				if (videotemp != NULL)
				{
					// create a memDC that is compatible with the video frame DC m_destDC
					CDC memDC;
					memDC.CreateCompatibleDC(&dcPrinter);

					BOOL tmpb;

					// create a compatible bitmap and select it into the memDC
					CBitmap bm;
					tmpb = bm.CreateCompatibleBitmap(&dcPrinter, sz.cx, sz.cy);

					CBitmap *oldbm = memDC.SelectObject(&bm);
         
					// call OnPaint to redraw window
					OnPaint();

					AdjustBitdepthForPrinting((void *) videotemp, (void *) m_pLastFrame, m_iActualWidth, m_iActualHeight, m_iActualBpp);
					//flipframemmx(videotemp, (char *) m_pLastFrame, m_iActualWidth, m_iActualHeight, m_iActualBpp);

					// draw video frame into memDC 
					HDRAWDIB hDrawDib;
					hDrawDib = DrawDibOpen();

					DrawDibBegin(hDrawDib, memDC.m_hDC, sz.cx, sz.cy, &lpbi->bmiHeader, m_iActualWidth, m_iActualHeight, DDF_JUSTDRAWIT); 

					DrawDibSetPalette( hDrawDib, (HPALETTE) m_hPalette);

					DrawDibRealize(hDrawDib, memDC.m_hDC, FALSE);

					// draw and stretch the last frame (m_pLastFrame) into the memDC
					DrawDibDraw(hDrawDib, memDC.m_hDC, 0, 0, sz.cx, sz.cy, &lpbi->bmiHeader, (LPVOID) videotemp, 
						0, 0, -1, -1, 0); 

					DrawDibClose(hDrawDib);

					// bitblt to printer
					dcPrinter.BitBlt(0,0,sz.cx, sz.cy, &memDC, 0, 0, SRCCOPY);

					// finish printer page and document
					dcPrinter.EndPage();

					dcPrinter.EndDoc();

					memDC.SelectObject(oldbm);

					if (videotemp != NULL) memman.sw_free( (void *) videotemp);
				}
				else
				{
					OwnMessageBox(0, "Out of memory printing image.");
					dcPrinter.AbortDoc();
				}
         		     
			}
		}

		if (lpbi != NULL) 
		{
			memman.sw_free( (void *) lpbi );
		}

		// Clean up.  
		dcPrinter.DeleteDC();
		PrintServerMessage("Printing done.");

	}
  
}

/////////////////////////////////////////////////////////////////////////////////
// OnApplicationPrintwholewindow() - prints the whole application window
// 
void CVideoclntDlg::OnApplicationPrintwholewindow() 
{

  HDC hdc;
  m_PrinterSettings.PrinterSetup(this, hdc);

  if (hdc != NULL)
  {
   
   CDC dcPrinter;
   dcPrinter.Attach(hdc);

   DOCINFO docinfo;
   memset(&docinfo, 0, sizeof(docinfo));
   docinfo.cbSize = sizeof(docinfo);
   docinfo.lpszDocName = _T("Image from Video Client");

   dcPrinter.SetMapMode(MM_ISOTROPIC);          // map mode that allows scaling

   // get window rect (size, position) information 
   CRect r;
   this->GetWindowRect(&r);
   CSize sz(r.Width(), r.Height());

   dcPrinter.SetWindowExt(sz.cx, sz.cy );

   // LOGICAL_WIDTH & LOGICAL_HEIGHT define the size of my logical
   // drawing page

   dcPrinter.SetViewportExt(dcPrinter.GetDeviceCaps(HORZRES), dcPrinter.GetDeviceCaps(VERTRES));
   
   // set the physical printer page size. Windows will scale the logical
   // page defined in SetWindowExt to match this physical page

   dcPrinter.SetWindowOrg(0,0); 

   // if it fails, complain and exit gracefully
   if (dcPrinter.StartDoc(&docinfo) < 0)
   {
      OwnMessageBox(0, "Printer wouldn't initalize");
   }
   else
   {  // start a page
      if (dcPrinter.StartPage() < 0)
      {
         OwnMessageBox(0, "Could not start page");
         dcPrinter.AbortDoc();
      }
      else
      {
         CString msg;
		 BOOL ret;

         // make window topmost so that we are able to grab it properly
         this->SetWindowPos( &wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE );
         this->RedrawWindow( NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW );
		 this->UpdateWindow();

         // make sure that SetWindowPos is processed...
         CWnd::Default();
		 CWnd::Default();
		 CWnd::Default();
         CWnd::Default();
      	 
		 // redraw the whole client area

		 // extract video header
         char *vidhptr;
	     m_pImageSequence->GetFrame(m_pImageSequence->Count()-1, (const char **) &vidhptr);
	     VIDHDR vidH;
         memman.memcpysw((char *) &vidH, vidhptr, sizeof(VIDHDR));

	     // display analyzed frame together with camera port
	     DisplayFunction(m_pNormalizedImage, vidH.cameraport, FALSE);
         
         // for safety
         CWnd::Default();
		 CWnd::Default();
		 CWnd::Default();
         CWnd::Default();

         // create memory DC compatible to window DC
         CDC memDC;
         memDC.CreateCompatibleDC(&dcPrinter);

         CBitmap bm;
         
         // create a compatible bitmap
         ret = bm.CreateCompatibleBitmap(&dcPrinter, sz.cx, sz.cy);

         // select the compatible bitmap into the memDC
         CBitmap *oldbm = memDC.SelectObject(&bm);
         
		 CDC *window = this->GetWindowDC();

		 // stretch the window into the memDC Csize
		 ret = memDC.StretchBlt(0, 0, sz.cx, sz.cy, window, 0, 0, sz.cx, sz.cy, SRCCOPY);
         
		 // bitblt memDC to printer
         ret = dcPrinter.BitBlt(0,0, sz.cx, sz.cy, &memDC, 0, 0, SRCCOPY);

         // finish printer page and document
         dcPrinter.EndPage();
         dcPrinter.EndDoc();

         memDC.SelectObject(oldbm);
         
		 // release the DC of the window
		 this->ReleaseDC(window);

         // set window to no top most 
		 this->SetWindowPos( &wndNoTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE );
      }
   }

   // Clean up.  
   dcPrinter.DeleteDC();
   PrintServerMessage("Printing done.");

  }

}

/////////////////////////////////////////////////////////////////////////////////
// OnDaqdiscard() - discards the recorded DAQ 
// 
void CVideoclntDlg::OnDaqdiscard() 
{
    
	if(m_bDAQRunning==TRUE) // daq was running ?
	{   
		// DAQ was running -> reset it
		m_DAQ.SetWindowText("DAQstart");
		m_sDAQString.Empty();
		m_CButtonDaqdiscard.EnableWindow(FALSE);
		m_bDAQRunning = FALSE;

        fclose( m_fpDAQFile );
		m_fpDAQFile = NULL;

		if (remove( (const char *) (LPCTSTR) m_sCurrentOnlineDAQFileName) == -1) PrintServerMessage("DaqDiscard: Temporary DAQ file could not be removed from disk !"); 

		m_bDAQRunning = FALSE;
	}
	
}

/////////////////////////////////////////////////////////////////////////////////
// OnHelpAbout() - shows about dialog of the application
// 
void CVideoclntDlg::OnHelpAbout() 
{
	CAboutDialog dlg;
	dlg.DoModal();
}


/////////////////////////////////////////////////////////////////////////////////
// OnHelpQuickreference() - shows the quick reference html help using default
//                          windows browser
// 
void CVideoclntDlg::OnHelpQuickreference() 
{
    CString filePath;
    CString tmpFilePath;
	int nPlace=0;
	
    // find path to executed program	
	tmpFilePath=__argv[0];
	nPlace=tmpFilePath.ReverseFind('\\');
    
	if (nPlace!=-1)
	{
		filePath=tmpFilePath.Left(nPlace);
	}
	else
	{
		char curDir[MAX_PATH];
		GetCurrentDirectory(MAX_PATH,curDir);
		filePath=curDir;
	}
	
	// append the html file
	filePath+="\\";
    filePath+="videoclnt2.html";

    // open up default browser and display html file
    ::ShellExecute( this->m_hWnd, "open", (LPCTSTR) filePath, NULL, "", SW_SHOWDEFAULT );	
}




void CVideoclntDlg::OnApplicationNormalisation() 
{
	if (m_bNormalization == FALSE)
	{
     CheckMenuItem(ID_APPLICATION_NORMALISATION, TRUE);
     m_bNormalization = TRUE;
	}
	else
	{
     CheckMenuItem(ID_APPLICATION_NORMALISATION, FALSE);
     m_bNormalization = FALSE;
	}
}

void CVideoclntDlg::SetCaption(CString caption, CString path, CString end)
{
 static CString current("");
 char buffer_1[1000];
 char *bufptr;

 bufptr = &buffer_1[0];
 
 CString msg;
 msg.Format("%s %s %s", caption, path, end);
 
 if (current != msg)
 {
    if (path != "")
	{
  	  HDC hdc;

	  CRect rect;

	  char buffer_2[MAX_PATH];
	  char *bufptr2;

	  bufptr2 = buffer_2;

	  hdc = this->GetDC()->m_hDC;

	  this->GetWindowRect( &rect );

	  int length = rect.right - rect.left;
	  length -= 200;

      sprintf( buffer_2, "%s", (const char *)  (LPCTSTR) path );

      PathCompactPath(hdc,bufptr2,length);	

	  sprintf( buffer_1, "%s %s %s", (const char *)  (LPCTSTR) caption, bufptr2, (const char *) (LPCTSTR) end); 
    }
    else
	{
	 sprintf( buffer_1, "%s %s", (const char *)  (LPCTSTR) caption, (const char *)  (LPCTSTR) end);
	}

    this->SetWindowText( bufptr );  
    current = CString(bufptr);
 }
}


void CVideoclntDlg::OnApplicationAreaofinterestRectangular() 
{
    m_bCircularAOI = FALSE;
    CheckMenuItem(ID_APPLICATION_AREAOFINTEREST_CIRCULAR, FALSE);
    CheckMenuItem(ID_APPLICATION_AREAOFINTEREST_RECTANGULAR, TRUE);

    m_newAOI.left = 0;
	m_newAOI.top = 0;
	m_newAOI.right = m_iActualWidth-1;
	m_newAOI.bottom = m_iActualHeight-1;

	if (m_bPollMode == FALSE) DisplayFunction(0, 0, TRUE);
}

void CVideoclntDlg::OnApplicationAreaofinterestCircular() 
{
    m_bCircularAOI = TRUE;
    CheckMenuItem(ID_APPLICATION_AREAOFINTEREST_CIRCULAR, TRUE);
    CheckMenuItem(ID_APPLICATION_AREAOFINTEREST_RECTANGULAR, FALSE);

    m_newAOI.left = m_iActualWidth/2;
	m_newAOI.top = m_iActualHeight/2;
	
	if (m_iActualWidth < m_iActualHeight) m_newAOI.right = m_iActualWidth/2; else m_newAOI.right = m_iActualHeight/2;
	m_newAOI.bottom = 0;
		
    if (m_bPollMode == FALSE) DisplayFunction(0, 0, TRUE);

}


void CVideoclntDlg::OnImageGrabandsave10frames() 
{
	GrabAndSave( 10 );
}

void CVideoclntDlg::OnImageGrabandsave15frames() 
{
	GrabAndSave( 15 );
}

void CVideoclntDlg::OnImageGrabandsave20frames() 
{
	GrabAndSave( 20 );
}

void CVideoclntDlg::OnImageGrabandsave30frames() 
{
    GrabAndSave( 30 );
}

void CVideoclntDlg::OnImageGrabandsave40frames() 
{
	GrabAndSave( 40 );
}

void CVideoclntDlg::OnImageGrabandsave50frames() 
{
	GrabAndSave( 50 );
}

void CVideoclntDlg::OnImageGrabandsave100frames() 
{
	GrabAndSave( 100 );
}

BOOL CVideoclntDlg::GrabAndSave(int numframes)
{
 CShutterControl ctrl( m_pIniFileExeGlobal, m_pCATineDlg) ;

 // initialize variables for proper cleanup afterwards
 m_pGSImageSequence = NULL;
 m_pGSBackgroundSequence = NULL;
 m_grab_queue = NULL;
 
 // create file filter
 CString filefilter = "IMC Files (*.imc)|*.imc||";

 // instantiate "Save as" dialog
 CFileDialog fileDlg(FALSE,NULL,NULL, OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY, filefilter);
 
 // execute and check for return value
 if(fileDlg.DoModal()==IDCANCEL)
 	return FALSE; // Cancel pressed ? -> get out of here

 /* construct proper filename string for additional textfile */
 /* and call proper function to ask, query and store the information if necessary */
 CString filenamepath = fileDlg.GetPathName();
 CString filename = fileDlg.GetFileName();

 CString path = filenamepath.Left( filenamepath.GetLength() - filename.GetLength() );
 
 CString basefilename;
 m_sGrabAndSavePath = path;
 m_sGrabAndSaveFilename = fileDlg.GetFileTitle();

 //CString check = m_sGrabAndSaveFilename.Left(4);
 //check.MakeUpper();
/*
 if ((check == CString("ENV_")) || (check == CString("AVG_")) )
 {
  AfxMessageBox("The filename you entered is invalid. It must not start with \"ENV_\" or \"AVG_\".", MB_ICONEXCLAMATION | MB_OK);
  return FALSE;
 }
*/
 BOOL ret7 = GrabAndSaveCheckFiles( path, m_sGrabAndSaveFilename );
 if (ret7 == FALSE)
 {
	 OwnMessageBox(MB_ICONINFORMATION, "Grab and Save was aborted.");
	 return FALSE;
 }


 BOOL bSuccess;
 BOOL bError;

 m_bWasShutterOpen = ctrl.IsShutterOpen( &bError );

 if (bError == TRUE)
 {
  OwnMessageBox(MB_ICONEXCLAMATION, "Error: Could not query shutter status. No images were grabbed and saved.");
  return FALSE;
 }

 m_InfoDlg.Show("Closing shutter");

 bSuccess = ctrl.CloseShutter();

 if (bSuccess == FALSE)
 {
  if (m_bWasShutterOpen == TRUE) ctrl.OpenShutter(); else ctrl.CloseShutter();
  m_InfoDlg.Hide();
  OwnMessageBox(MB_ICONEXCLAMATION, "Error: Could not close laser shutter in order to take background sequence.\n" \
                "No images were grabbed and saved.");
  return FALSE;
 }
 
 // get server name from ini file and set up TINE properties

 
 CServer srv;
 m_ServerList.getServer( m_iActualServerPos, srv );

 /* SW! Apr 26, 2006 commented out, should not be necessary
 CheckServerSettings( srv );
 */

  
 m_iGrabDestination = 5; 
 m_bEnvelope = FALSE;
 m_iGrabAndSaveProgress = 1; 
 m_iGrabAndSaveNumFrames = numframes;

 int framerate = m_pIniFileExeLocal->GetValueInt("MAIN", "Framerate", 0);  
 int framerateoverride = m_pIniFileExeGlobal->GetValueInt(srv.getNickname(), "OverrideFramerate", 0 );
 if (framerateoverride != 0) framerate = framerateoverride;

 m_grab_queue = new CQueue();
 if (m_grab_queue == NULL) 
 {
   if (m_bWasShutterOpen == TRUE) ctrl.OpenShutter(); else ctrl.CloseShutter();
   m_InfoDlg.Hide();
   OwnMessageBox(MB_ICONEXCLAMATION, "Could not create queue. This is a severe error.\nNo images were grabbed and saved.");
   return FALSE;
 }

 m_InfoDlg.UpdateText("Taking background sequence...");

 BOOL ret = m_pImageAcquire->GrabFrames( srv, m_grab_queue, numframes, framerate);
 if (ret == TRUE)
 {
   DisableMenusForGrab();
   m_bTransferRunning = TRUE;
   SetCaption( "Video Client 2 on", "", srv.getNickname() );
 }
  else
 {
  delete m_grab_queue;
  m_grab_queue = NULL;

  if (m_bWasShutterOpen == TRUE) ctrl.OpenShutter(); else ctrl.CloseShutter();
  m_InfoDlg.Hide();
  
  OwnMessageBox(MB_ICONEXCLAMATION, "Could not grab background. This is a severe error. No images were grabbed and saved.");
  return FALSE;
 }

 return TRUE;
}



void CVideoclntDlg::GrabAndSaveCallback()
{
 // initialize variables for checking
 int port = -1;
 int lastframe = -1;
 BOOL portchange = FALSE;
 BOOL framesmissed = FALSE;
 int width;
 int bpp;
 int height;
 VIDHDR vidH;
 char *tmpptr;
 BOOL success_process=FALSE;

 CShutterControl ctrl(m_pIniFileExeGlobal, m_pCATineDlg);
 CString errormessage;

 switch( m_iGrabAndSaveProgress )
 {
	case 1:{ 
	      VIDHDR vidH;
/*
          if (m_iGrabAndSaveProgress == 1)
		  {
            m_InfoDlg.UpdateText("Processing average background.");
			// 1 means process average background (was taken before) and continue with taking average frames 
		  }
		  else
		  {
            m_InfoDlg.UpdateText("Processing envelope background.");
			// 3 means
			// (1) average background was taken and processed before
			// (2) average frames were taken and processed before
			// (3) envelope background was taken just before 
			// (4) continue processing envelope background and start taking envelope frames
		  }
  */
          int size = m_grab_queue->GetSize();

          // loop over all grabbed frames
          for (int a=0;a<size;a++)
          {
           // extract 'a'# video header out of the grab buffer
           
           char *aktpos = (char *) m_grab_queue->GetElem( a );
           memman.memcpysw( (char *) &vidH, aktpos, sizeof(VIDHDR));

           width = vidH.widthframe; height = vidH.heightframe;
		   bpp = vidH.bpp;

           // no port value set'ed
           if (port == -1)
           {
            lastframe = (unsigned) vidH.frameno; // set frame number to number of first frame
	        port = vidH.cameraport; // set port number to port number of first frame
           }
           else
           {
	        // if last port is not equal to camera port of actual frame 
            // then we have detected a port change
	        if (port != (signed) vidH.cameraport) portchange = TRUE;
	        // framenumber if not equal last_framenumber+1 the we have missed at least one frame
            if (vidH.frameno != (unsigned)(lastframe+1)) framesmissed = TRUE;
	        // set last frame number to number of actual frame
	        lastframe = vidH.frameno;
           }
          }

          // if there was a port change, print out warning message
          if (portchange == TRUE) CCERR("Attention: Not all grabbed frames came from the same camera port !\nThis is a severe error. Frames have been discarded. No images were grabbed and saved.");
          // if there were some frames missed, print out warning message
          if (framesmissed == TRUE) CCERR("Attention: Some frames were missed while grabbing background sequence. This is a severe error.\nFrames have been discarded! No images were grabbed and saved.");

          // if we are here everything went fine with the acquiration of the background image(s)

          // apply algorithm (envelop / average)
          // copy background

          m_pGSBackgroundSequence = new CImageSequence( m_pCATineDlg, m_bTineALInitialized, m_pTineALDlg, this );
		  if (m_pGSBackgroundSequence == NULL) CCERR("Could not allocate memory for background sequence.\nThis is a severe error.\nFrames have been discarded. No images were grabbed and saved.");

          BOOL success_process = TRUE;  
          BOOL retval;

          CEnvelopeAverage phelp;

          retval = phelp.Init(bpp, vidH, m_bEnvelope, m_bXRayFiltering );
          if (retval == FALSE) CCERR("Unable to process background.\nThis is a severe error. No frames were grabbed and saved.");

	
				// copy frames into grabbuffer and free the queue memory
                BOOL copysuccessful = TRUE;
				for (a=0;a<size;a++)
                {
                        char *src = (char *) m_grab_queue->GetElem(a);
   
						if (src != NULL)
						{
							BOOL ret = m_pGSBackgroundSequence->Add( (unsigned char *) src );
							if (ret == FALSE) copysuccessful = FALSE;
						}
						else copysuccessful = FALSE;
				}
				if (copysuccessful == FALSE)
				{
						for (a=0;a<size;a++)
						{
						    m_pGSBackgroundSequence->RemoveFrame(0);
						}

						CCERR( "Could not copy frames to background sequence.\nThis is a severe error.\nFrames have been discarded. No images were grabbed and saved.");
				}
           
          // delete the grabbed frames
          // SW!!! 9.3.04 had to be removed for envelope/average sequence background
		  //for (a=0;a<size;a++)
          //{
          // void *tmpptr = m_grab_queue->RemoveHead();
          // if (tmpptr != NULL) memman.sw_free( tmpptr );
          //} 

          delete m_grab_queue;
          m_grab_queue = NULL;

          m_InfoDlg.UpdateText("Opening shutter for taking frames...");

		  BOOL bSuccess = ctrl.OpenShutter();
		  if (bSuccess == FALSE) CCERR("Could not open laser shutter. This is a severe error.\nNo images were grabbed and saved.");

          // get server name from ini file and set up TINE properties
          CServer srv;
          m_ServerList.getServer( m_iActualServerPos, srv );
          m_iGrabDestination = 5; 

          // SW! taken out Apr 26, 2006
		  // CheckServerSettings( srv );
  
          int framerate = m_pIniFileExeLocal->GetValueInt("MAIN", "Framerate", 0);  
          int framerateoverride = m_pIniFileExeGlobal->GetValueInt(srv.getNickname(), "OverrideFramerate", 0 );
          if (framerateoverride != 0) framerate = framerateoverride;


          m_grab_queue = new CQueue();
          if (m_grab_queue == NULL) CCERR("Could not create queue. This is a severe error.\nNo images were grabbed and saved.");

		  m_iGrabAndSaveProgress++;             

		  m_InfoDlg.UpdateText("Taking frames...");

          BOOL ret = m_pImageAcquire->GrabFrames( srv, m_grab_queue, m_iGrabAndSaveNumFrames, framerate);
          if (ret == TRUE)
          {
              DisableMenusForGrab();
              m_bTransferRunning = TRUE;
			  SetCaption( "Video Client 2 on", "", srv.getNickname() );
          }
		  else CCERR("Could not grab frames. This is a severe error.\nNo images were grabbed and saved.");
          return;
         }  
         break;  
  
  case 2:{
            m_InfoDlg.UpdateText("Processing frames...");
		   
		  int numframes = m_grab_queue->GetSize();
          tmpptr = (char *) m_grab_queue->GetHead();
          memman.memcpysw((char *) &vidH, tmpptr, sizeof(VIDHDR) );

          width = vidH.widthframe;
          height = vidH.heightframe;
		  bpp = vidH.bpp;

          // save old grab buffer, so if something happens
          // with the new one, we are able to restore the old one,
          // which may contain valuable data
          //unsigned char *pGrabBuffer_old;
          //int  iGrabBufferWidth_old;
          //int  iGrabBufferHeight_old;
          //int  iGrabBufferNumImages_old;

		  m_pImageSequence->AcquireDoocsProperties();
          CImageSequence *newseq=NULL;

		   m_pGSImageSequence = new CImageSequence( m_pCATineDlg, m_bTineALInitialized, m_pTineALDlg, this );
		   if (m_pGSImageSequence == NULL) CCERR("Could not allocate memory for image sequence. This is a severe error.\nNo images were grabbed and saved.");
		   newseq = m_pGSImageSequence;

          // the next block of code checks for two things: first we have to be sure that all frames 
          // were acquired from the same camera port (another client could have changed the camera port)
          // and whether not a single frame was dropped during the grabbing
      
          // loop over all grabbed frames
          for (int a=0;a<numframes;a++)
          {
           // extract 'a'# video header out of the grab buffer
           char *aktpos = (char *) m_grab_queue->GetElem(a);
           memman.memcpysw( (char *) &vidH, aktpos, sizeof(VIDHDR));

           // no port value set'ed
           if (port == -1)
           {
             lastframe = (unsigned) vidH.frameno; // set frame number to number of first frame
	         port = vidH.cameraport; // set port number to port number of first frame
           }
           else
           {
	         // if last port is not equal to camera port of actual frame 
             // then we have detected a port change
	         if (port != (signed) vidH.cameraport) portchange = TRUE;
	         // framenumber if not equal last_framenumber+1 the we have missed at least one frame
             if (vidH.frameno != (unsigned)(lastframe+1)) framesmissed = TRUE;
	         // set last frame number to number of actual frame
	         lastframe = vidH.frameno;
		   }
          }

          // if there was a port change, print out severe error message
          if (portchange == TRUE) CCERR("Attention: Not all grabbed frames came from the same cameraport !\nThis is a severe error. Frames have been discarded.\nNo images were grabbed and saved.");
         
          // if there were some frames missed, print out warning message
          if (framesmissed == TRUE) CCERR("Attention: Some frames were missed while grabbing. This is a severe error.\nFrames have been discarded. No images were grabbed and saved.");

          BOOL copysuccessful=TRUE;

          // copy frames into grabbuffer and free the queue memory
          for (a=0;a<numframes;a++)
          {
            char *src = (char *) m_grab_queue->GetElem(a);
   
            if (src != NULL)
            {
              BOOL ret = newseq->Add( (unsigned char *) src );
	          if (ret == FALSE) copysuccessful = FALSE;
            }
          }

		  if (copysuccessful == FALSE)
		  {
    		for (a=0;a<numframes;a++)
			{
				    newseq->RemoveFrame(0);
			}

			CCERR("Failed to store data into proper image sequence. This is a severe error.\nNo images were grabbed and saved.");
		  }

          delete m_grab_queue;
		  m_grab_queue = NULL;

          if (m_bDAQRunning) newseq->AcquireDoocsProperties();
          newseq->SetScale( vidH.scale );

		  if (m_bWasShutterOpen == TRUE) ctrl.OpenShutter(); else ctrl.CloseShutter();
		  m_InfoDlg.Hide();

		  SaveGrabbedAndStoredData(); 
		 }
         break; 
  
   default: break;
 }

 return;

err:
 DoCleanupAbortGrabAndSave(errormessage);
}

void CVideoclntDlg::SaveGrabbedAndStoredData()
{
 //if (m_pGSImageSequence == NULL) AfxMessageBox("img seq null");
 //if (m_pGSBAckgroundSequence == NULL) AfxMessageBox("bkg seq null");

 CInformationDialog dlg;

 dlg.Show("Saving data...");

 CString textfile = m_sGrabAndSavePath + m_sGrabAndSaveFilename + CString(".txt");
 CString file = m_sGrabAndSavePath + m_sGrabAndSaveFilename;
 CString background_c = m_sGrabAndSavePath + m_sGrabAndSaveFilename;

 BOOL all_fine = TRUE;
 BOOL ret;

 int ret2 = AfxMessageBox("Do you want to save additional information?", MB_YESNO);
 BOOL savetext = FALSE;
 if (ret2 == IDNO) savetext = TRUE;

 CString infotext;

 ret = m_pGSImageSequence->SaveToFile(FILE_IMC, TRUE, savetext, file, textfile, 0, NULL, &infotext, NULL, NULL);
 if (ret == FALSE) all_fine = FALSE;

 ret = m_pGSBackgroundSequence->SaveToFile(FILE_BKC, FALSE, FALSE, background_c, "", 0, NULL, NULL, NULL, NULL);
 if (ret == FALSE) all_fine = FALSE;


 delete m_pGSImageSequence;
 m_pGSImageSequence = NULL;

 delete m_pGSBackgroundSequence;
 m_pGSBackgroundSequence = NULL;

 dlg.Hide();

 if (all_fine == TRUE)
 {
    OwnMessageBox(MB_ICONINFORMATION, "Images, backgrounds and textual information were saved.");
 }
  else
 {
    OwnMessageBox(MB_ICONEXCLAMATION, "There was an error while saving the data to disk !");
 }

}

////////////////////////////////////////////////////////////////////////
// DownScaleTo8Bit() 
//
// This mathod scales image src (attributes: width, height and bpp) into 
// 8 bits memory location dst (attributes: width, height, bpp=8).
//
// One has to take care that memory location src is at least as big as 
//  width*height*bpp/8 
// and that dst is at least as big as
//  width*height
//

static MEMALIGNSW(16) unsigned char down16[256*256];
static MEMALIGNSW(16) unsigned char down32hi[256*256];
static MEMALIGNSW(16) unsigned char down32lo[256*256];
static int Gcalculated=0;


/*void CVideoclntDlg::DownScaleTo8Bit(unsigned char *src, unsigned char *dst, unsigned int width, unsigned int height, unsigned int bpp)
{

 if (bpp == 8)  // 8 bits per pixel, then just copy the data
 {
  memman.memcpysw( (char *) dst, (char *) src, width*height);
 }

 else if (bpp == 16) // 16 bits per pixel 
 {
  unsigned short maxval=0;
  unsigned short *srci = (unsigned short *) src;

  // look into source for maximum value
  for (unsigned int j=0;j<width*height;j++)
  {
   if (srci[j] > maxval) maxval = srci[j];
  }
  
  // scale into 8 bits accordingly to the maximum value
  unsigned long tmp = 65536L / (((unsigned long)maxval)+1);
  unsigned short tmp1 = (unsigned short) tmp;
  for (j=0;j<width*height;j++)
  {
   dst[j] = (unsigned char) ((srci[j] * tmp1) >> 8);
  }
 }
 else if (bpp == 32) // 32 bits per pixel
 {
  unsigned long *srcl = (unsigned long *) src;
  unsigned long maxval=0;

  // look into source for maximum value
  for (unsigned int j=0;j<width*height;j++)
  {
   if (srcl[j] > maxval) maxval = srcl[j];
  }
  
  // scale into 8 bits accordingly to the maximum value
  unsigned long tmp = 0xFFFFFFFF / (maxval);
  for (j=0;j<width*height;j++)
  {
   dst[j] = (unsigned char) ((srcl[j] * tmp) >> 24);
  }
 
 }

}
*/
BOOL CVideoclntDlg::GrabAndSaveCheckFiles(CString path, CString middlename)
{
 int count = 0;
 CString file;
 FILE *fp;
 
 file = path + middlename + ".bkc";
 fp = fopen( (LPCTSTR) file, "rb");
 if (fp != NULL)
 {
  fclose(fp);
  count++;
 }

 file = path + middlename + ".imc";
 fp = fopen( (LPCTSTR) file, "rb");
 if (fp != NULL)
 {
  fclose(fp);
  count++;
 }

 file = path + middlename + ".txt";
 fp = fopen( (LPCTSTR) file, "rb");
 if (fp != NULL)
 {
  fclose(fp);
  count++;
 }


 if (count == 0) return TRUE;

 CString msg;
 msg.Format("%d Files would be overwritten by this Grab and Save command.\n\n\nDo you REALLY want to do this ?", count);
 int id = AfxMessageBox( msg, MB_ICONEXCLAMATION | MB_YESNO );
 if (id == IDYES) return TRUE; else return FALSE;
}

void CVideoclntDlg::DoCleanupAbortGrabAndSave(CString abortmessage)
{
 CShutterControl ctrl( m_pIniFileExeGlobal, m_pCATineDlg );
 BOOL ret;
 CString adderror = "";
 
 if (m_bWasShutterOpen == TRUE)
 {
  ret = ctrl.OpenShutter();// open shutter
  if (ret == FALSE)
  {
   adderror = "\nIn addition, the shutter could not be opened (restored to the state before starting grab and save).\nPlease note that.";
  }
 }
  else
 {
  ret = ctrl.CloseShutter(); // close shutter
  if (ret == FALSE)
  {
   adderror = "\nIn addition, the shutter could not be closed (restored to the state before starting grab and save).\nPlease note that.";
  }
 }

 // do cleanup of grab and save variables, use if NULL if necessary
 // hide info dialog
 m_InfoDlg.Hide();

 // finish off grab queue if necessary 
 if (m_grab_queue != NULL)
 {
   m_grab_queue->EmptyQueue();
   delete m_grab_queue;
   m_grab_queue = NULL; 
 }

 // clean up average background (multiple) if necessary
 if (m_pGSBackgroundSequence != NULL) 
 {
	 delete m_pGSBackgroundSequence;
	 m_pGSBackgroundSequence = NULL;
 }

 // clean up average image sequence if necessary
 if (m_pGSImageSequence != NULL)
 {
	 delete m_pGSImageSequence;
	 m_pGSImageSequence = NULL;
 }

 OwnMessageBox(MB_ICONEXCLAMATION, (abortmessage + adderror) );
}

void CVideoclntDlg::OnApplicationKeepaspectratio() 
{
 if (m_bKeepAspectRatio == TRUE) m_bKeepAspectRatio = FALSE; else m_bKeepAspectRatio = TRUE;
 CheckMenuItem(ID_APPLICATION_KEEPASPECTRATIO, m_bKeepAspectRatio );
 PrintServerMessage("Aspect ratio mode changed.");
 OnSize();	
}

/*
extern "C" {

__declspec(dllexport) short PASCAL EXECLINKEx (char *devname,char *devprop,DTYPE *dout,void *dataout,DTYPE *din,void *datain,short access,long timeout);


}
*/

BOOL CVideoclntDlg::CheckAndConfigurePHISTServer()
{
 // switched off !
 return TRUE;
}


// TRUE: area is visible on the particular screen
// FALSE: area is NOT visible on the particular screen
BOOL CVideoclntDlg::NormalizeToArea(int &mousexpos, int &mouseypos, BOOL &xvalid, BOOL &yvalid, CStatic *frame, struct Screen* screen)
{
  int x = m_CPointCross.x;
  int y = m_CPointCross.y;
  RECT cross, cross1;

  cross.left = x;
  cross.top = y;
  cross.right = x+1;
  cross.bottom = y+1;
  
  if (frame != NULL) frame->ClientToScreen( &cross ); else ClientToScreen( &cross );

  if ( RectIntersectsMonitor( &cross, screen->hmon, &cross1 ) == TRUE)
  {
       RECT clientAreaAdj;
       RECT clientAreaWhole;

       if (frame != NULL) frame->GetWindowRect(&clientAreaWhole); else GetWindowRect(&clientAreaWhole); 
	   clientAreaAdj = clientAreaWhole;
       if (RectIntersectsMonitor( &clientAreaWhole, screen->hmon, &clientAreaAdj ) == TRUE)
	   {
		   x = cross1.left;
		   y = cross1.top;
   	 	   x -= clientAreaAdj.left;
     	   y -= clientAreaAdj.top;

		   mousexpos = x;
		   mouseypos = y;
		   xvalid = TRUE;
		   yvalid = TRUE;

		   return TRUE;


	   } // clientarea intersects monitor
		 
	 
  } // mouse cursor intersects monitor
  else
  { // so mouse cursor does not intersect monitor
       RECT clientAreaAdj;
       RECT clientAreaWhole;

       if (frame != NULL) frame->GetWindowRect(&clientAreaWhole); else GetWindowRect(&clientAreaWhole); 
	   clientAreaAdj = clientAreaWhole;
       if (RectIntersectsMonitor( &clientAreaWhole, screen->hmon, &clientAreaAdj ) == TRUE)
	   {
		   x = cross.left;
		   y = cross.top;

           if (x < clientAreaAdj.left || x > clientAreaAdj.right) 
		   { 
	         xvalid = FALSE; 
		   } 
	       else 
	         xvalid = TRUE; 

	       if (y < clientAreaAdj.top || y > clientAreaAdj.bottom)
		   {
	         yvalid = FALSE; 
		   } 
	       else 
			   yvalid = TRUE; 

		   x -= clientAreaAdj.left;
		   y -= clientAreaAdj.top;

		   mousexpos = x;
		   mouseypos = y;

		   return TRUE;
	   }
  }

  return FALSE;
}

void CVideoclntDlg::OnDAQStart() 
{
	CString DAQDirectory;
	if (m_bDAQRunning == TRUE)
	{
		// DAQstop was clicked

		// reset button to "DAQstart" string
		m_DAQ.SetWindowText("DAQstart");
		
		// disable DAQdiscard button
		m_CButtonDaqdiscard.EnableWindow(FALSE);
		
		// write DAQ data to file
		m_sDAQString = BeautifyCSVString( m_sDAQString, m_pIniFileExeLocal->GetValue("MAIN", "CSVComma", ","), m_pIniFileExeLocal->GetValue("MAIN", "CSVDelimiter", ";") );

  	    fputs( (const char *) (LPCTSTR) m_sDAQString, m_fpDAQFile );
        fclose( m_fpDAQFile );
		m_fpDAQFile = NULL;
		
		m_bDAQRunning = FALSE;
    }
	else
	{
		DAQDirectory = m_pIniFileProf->GetValue("MAIN", "DaqDirectory", "H:\\");

		// build filename
		m_sCurrentOnlineDAQFileName=DAQDirectory+CString( (const unsigned char *) GetTimeStr() )+CString(_T(".csv"));
		
		// write DAQ data to file
		m_sDAQString = BeautifyCSVString( m_sDAQString, m_pIniFileExeLocal->GetValue("MAIN", "CSVComma", ","), m_pIniFileExeLocal->GetValue("MAIN", "CSVDelimiter", ";") );

		m_fpDAQFile = fopen( (const char *) (LPCTSTR) m_sCurrentOnlineDAQFileName, "wt");
		
		if (m_fpDAQFile == NULL)
		{
			OwnMessageBox(MB_ICONINFORMATION, "Could not open DAQ output file for writing ! Online DAQ could not be started !\nPlease check the DAQ output directory using Application->Preferences.");
		}
		else
		{
			m_bDAQRunning = TRUE;
		}

	}
  
	if( m_bDAQRunning == TRUE) // if DAQ is running now: prepare variables
	{
		m_sDAQString.Empty();
        m_sDAQString.Format("X_Mean%sY_Mean%sX_RMS%sY_RMS%sTimestamp%sHumanTime%sSum_of_Pixels%s", SEPCHAR,SEPCHAR,SEPCHAR,SEPCHAR,SEPCHAR,SEPCHAR,SEPCHAR);
		CString str1;
		m_pImageSequence->returnPropertyDescriptionString( str1 );
		m_sDAQString += str1+CR;
		m_DAQ.SetWindowText("DAQstop");
		m_CButtonDaqdiscard.EnableWindow(TRUE);
	}

}

void CVideoclntDlg::OnDaqPublic()
{
	OnDAQStart();
}


CString CVideoclntDlg::ReturnLoadedDaqFileName()
{
 return m_sDAQFileName;
}

CString CVideoclntDlg::ReturnDefaultDaqFileName()
{
 return( m_pIniFileExeLocal->GetValue("MAIN", "DaqDefaultConfigFile", "daqproperties_default.cfg") );
}


CString CVideoclntDlg::BeautifyCSVString(CString src, CString CSVkomma, CString CSVDelimiter)
{
	// implementation is NOT very good, some character can not be replaced imho, like TAB, SPACE
 	int ret;

	ret = src.Replace( (LPCTSTR) ".", (LPCTSTR) CSVkomma );
	ret = src.Replace( (LPCTSTR) ";", (LPCTSTR) CSVDelimiter );

	return( src );
}

BOOL CVideoclntDlg::DeinitializeDAQFunction()
{
    if (m_bDAQRunning == TRUE) OnDAQStart();
	m_bDAQRunning = FALSE;
	
	if (m_bTineALInitialized == TRUE) if (m_pTineALDlg != NULL) m_pTineALDlg->DeinitializeTine();

	if (m_pTineALDlg != NULL) 
	{
			m_pTineALDlg->DestroyWindow();
			delete m_pTineALDlg;
			m_pTineALDlg = NULL;
	}
	
	m_bTineALInitialized = FALSE;
	
	return TRUE;
}

// FALSE critical error, program must quit !
// TRUE either success or non critical error, msgbox will tell on non critical error
BOOL CVideoclntDlg::InitializeDAQFunction()
{
	int retn;

	if (m_bTineALInitialized == TRUE) return TRUE;

	CString daq = m_pIniFileProf->GetValue("MAIN", "DaqConfigFile", "-**-");
	if (daq == "-**-") daq = m_pIniFileExeLocal->GetValue("MAIN", "DaqDefaultConfigFile", "daqproperties_default.cfg");

	m_sDAQFileName = daq;
    
    m_pTineALDlg = new CTineALDlg();
    if (m_pTineALDlg != NULL)
    {
       retn = m_pTineALDlg->Create(IDD_DIALOG_TINEAL, AfxGetMainWnd()->GetDesktopWindow() );
    }
    else return FALSE;

    if (retn == TRUE) 
    {
        retn = m_pTineALDlg->InitializeTine( this, ReturnAdditionalProperties() );
        if (retn == TRUE) { m_bTineALInitialized = TRUE; m_DAQ.EnableWindow(TRUE); } else { m_DAQ.EnableWindow(FALSE); }
        return TRUE;
    }
	else return FALSE;

}

struct AdditionalProperty * CVideoclntDlg::ReturnAdditionalProperties()
{
 return( m_pAdditionalProperties );
}

int CVideoclntDlg::ReturnNumAdditionalProperties()
{
 return( m_iNumAdditionalProperties );
}


LRESULT CVideoclntDlg::OnDisplaySettingsChanged(WPARAM wParam, LPARAM lParam)
{
 if (m_bDrawingInitialized == TRUE)
 {
	 // deinitialize drawing
	 DeinitializeDrawing();

	 // initialize drawing objects so that the video and the projection can be drawed
	 BOOL ret5 = InitializeDrawing(m_iFalseColor);  
	 //if (ret5 != TRUE) AfxMessageBox("", MB_ICONINFORMATION | MB_OK );

	 // quit application if it could not be initialized properly
	 if (ret5 == FALSE) 
	 {
	    OwnMessageBox(MB_ICONEXCLAMATION, "Could not reinitialize drawing forced by display change.\nThis is a sever error. Application must quit.");
		OnApplicationQuit();
	 }

	 //PrintServerMessage("Screen reinitialized!!!");
 }
 // display last frame again
 DisplayFunction(0, 0, TRUE);

 // call OnPaint function
 OnPaint();

 return 0;
}

BOOL CVideoclntDlg::CreateServerCheckLink(CString context, CString tinecontrolname)
{
	BOOL retval = TRUE;
	
	m_CACOPCtrlCamUpdate.SetDeviceContext(context);
	m_CACOPCtrlCamUpdate.SetDeviceGroup( (LPCTSTR) tinecontrolname );
	m_CACOPCtrlCamUpdate.SetDeviceName("GRABSRV");
	m_CACOPCtrlCamUpdate.SetDeviceProperty("C_CAMID"); 

	m_CACOPCtrlCamUpdate.SetAccessRate("900");
	m_CACOPCtrlCamUpdate.SetAccessMode("POLL");

    VARIANT camsize, camtype, camport, camportsize, camportdatatype;

	// set size (1 string)
	VariantInit( &camsize );
	V_VT( &camsize ) = VT_I4;
	camsize.lVal = 1;

	// set proper type name variant
	CString str2 = "NAME48";
	VariantInit( &camtype );
	V_VT( &camtype ) = VT_BSTR;
	V_BSTR( &camtype ) = str2.AllocSysString();

	// set up char variant defining the port we want the name from
	VariantInit( &camport );
	V_VT( &camport ) = VT_I1;
	camport.cVal = 0;

	// size of the char variant (1 byte)
	VariantInit( &camportsize );
	V_VT( &camportsize ) = VT_I4;
	camportsize.lVal = 1;

	// set up proper type
	CString str1="BYTE";
	VariantInit( &camportdatatype );
	V_VT( &camportdatatype ) = VT_BSTR;
	V_BSTR( &camportdatatype ) = str1.AllocSysString();

	m_lServerCheckLink = m_CACOPCtrlCamUpdate.AttachLink(&m_vNewCameraID, camsize, camtype, &camport, camportsize, camportdatatype);
    
	//m_lServerCheckLink = m_CACOPCtrl.Execute(&m_vNewCameraID, camsize, camtype, &camport, camportsize, camportdatatype);
	//CString camportstring = CString(m_vNewCameraID.bstrVal);
	
	if (m_lServerCheckLink < 0) { PrintServerMessage("Could not set up CamChangeListener...!"); retval = FALSE; }

	VariantClear( &camsize );
	VariantClear( &camtype );
	VariantClear( &camport );
	VariantClear( &camportsize );
	VariantClear( &camportdatatype );

	return( retval );
}

void CVideoclntDlg::CleanupServerCheckLink()
{
	if (m_lServerCheckLink != -1)
	{
		long ret = m_CACOPCtrlCamUpdate.CloseLink( CComVariant(m_lServerCheckLink) );
		m_lServerCheckLink = -1;
	}
}

// SW Docu from Apr 27, 2006 
//
// This function is called (via UpdateCameraPort) to adjust the server selection box in case the camera name 
// has changed on the current server. (i.e. when flashing (red / white) of the server selection box takes place,
// this function is about to be called)
//
void CVideoclntDlg::ReloadServerSettings(int actualserverpos)
{
	int pos = 1;
	int haveputin = 0;

	// remove information
    m_CComboCamera.ResetContent();

	CServer oldone;
	m_ServerList.getServer( actualserverpos, oldone);
     
    CString tinename = oldone.getTineControlName();
	CString tinecontext = oldone.getTineContext();

    // access server
    // download settings
    // add cam name to box

	CString	 camName;
	CString  camID;

	BOOL retval1;
	BOOL notasingleerror=TRUE;

    if (notasingleerror==TRUE) retval1 = GetCameraName( tinecontext, tinename, "C_CAMNAME", camName );
	if (retval1 == FALSE) { camName = ""; notasingleerror = FALSE;}

    if (notasingleerror==TRUE) retval1 = GetCameraName( tinecontext, tinename, "C_CAMID", camID );
	if (retval1 == FALSE) { camID = ""; notasingleerror = FALSE;}

	int listenport = oldone.getListenport();
	CString tineFrameEqp = oldone.getTineFrameEqpName();

    if (notasingleerror == TRUE)
	{
	    CServer srv( pos, oldone.getNickname(), oldone.getServername(), listenport, tineFrameEqp, camName, camID, tinename, oldone.getTineContext() );
        m_ServerList.modifyServer( actualserverpos, srv );

		m_sActualCameraID = camID;

        m_iActualServerPos = 1;

		int pos = 1;

		for (int i=0; i<m_ServerList.Count(); i++)
		{
			CString tmp;
			CServer srv1;

			m_ServerList.getServer(i+1, srv1);
			
			tmp.Format("%s: %s", srv1.getNickname(), srv1.getCamString());
			int lpos = m_CComboCamera.AddString((LPCTSTR) tmp);
			if (srv1.getNickname() == oldone.getNickname()) m_iActualServerPos = pos;

			m_CComboCamera.SetItemData( lpos, pos ); 
			pos++;
		}

		m_CComboCamera.SetCurSel( m_iActualServerPos-1 );
	}

}

// SW Docu from Apr 27, 2006 
//
// This function is called (via UpdateCameraPort, at least through "drop down the camera selection box") to 
// download new camera names from all servers so that when switching to a new server, the user can be almost 
// sure which camera is connected there.
//
void CVideoclntDlg::ReloadServerSettingsSmall()
{
	int pos = 1;
	int haveputin = 0;

	for (int i=0; i<m_ServerList.Count(); i++)
	{
		CServer oldone;

		m_ServerList.getServer( i+1, oldone);
		CString tinename = oldone.getTineControlName();
		CString tinecontext = oldone.getTineContext();

	    // access server
		// download settings
		// add cam name to box

		CString	 camName;
		CString  camID;

		BOOL retval1;
		BOOL notasingleerror;

		notasingleerror = TRUE;

		if (notasingleerror==TRUE) retval1 = GetCameraName( tinecontext, tinename, "C_CAMNAME", camName );
		if (retval1 == FALSE) { camName = ""; notasingleerror = FALSE;}

		if (notasingleerror==TRUE) retval1 = GetCameraName( tinecontext, tinename, "C_CAMID", camID );
		if (retval1 == FALSE) { camID = ""; notasingleerror = FALSE;}

		CServer srv( pos, oldone.getNickname(), oldone.getServername(), oldone.getListenport(), oldone.getTineFrameEqpName(), camName, camID, oldone.getTineControlName(), oldone.getTineContext() );
		//CString tmp;

		if (notasingleerror == TRUE)
		{
			m_ServerList.modifyServer( i+1, srv );
		}
		
	}

	// remove information
    m_CComboCamera.ResetContent();

	for (i=0; i<m_ServerList.Count(); i++)
	{
		CServer put;
		CString tmp;

		m_ServerList.getServer(i+1, put);
		tmp.Format("%s: %s", put.getNickname(), put.getCamString());

		int lpos = m_CComboCamera.AddString((LPCTSTR) tmp);
		m_CComboCamera.SetItemData( lpos, pos ); 
		pos++;

	}

	m_CComboCamera.SetCurSel( m_iActualServerPos-1 );

	CServer newsrv;
	m_ServerList.getServer( m_iActualServerPos, newsrv);

	m_sActualCameraID = newsrv.getCamID();
}


LRESULT CVideoclntDlg::OnServerSettingChanged(WPARAM wParam, LPARAM lParam)
{
	//PrintServerMessage("ServerSettingChanged called!");
	UpdateCameraPort(TRUE, FALSE);

	return( 0 );
}

void CVideoclntDlg::OnReceiveAcopctrl2Pollcamupdate(long LinkIndex, long StatusCode) 
{
	if ((LinkIndex == m_lServerCheckLink) && (StatusCode == 0))
	{
      CString localNewCamID = CString(m_pTineData);

	  if (m_sActualCameraID != localNewCamID) 
	  {
		  PostMessage(ID_MSG_UPDATECAMERA, 0, 0);	
	  }
	}
}



void CVideoclntDlg::SignalCameraSelectionBox(int mstimelength, int changeseveryms, COLORREF color)
{
	m_tFlashStartTime = time(NULL);
	m_tFlashDuration = mstimelength / 1000;

	if (m_nFlashTimer == 0) m_nFlashTimer = SetTimer(WM_TIMER_FLASH, changeseveryms, NULL);
}

void CVideoclntDlg::OnButton4Switchcam() 
{
    CString filePath;
    CString tmpFilePath;
	int nPlace=0;
	
    // find path to executed program	
	tmpFilePath=__argv[0];
	nPlace=tmpFilePath.ReverseFind('\\');
    
	if (nPlace!=-1)
	{
		filePath=tmpFilePath.Left(nPlace);
	}
	else
	{
		char curDir[MAX_PATH];
		GetCurrentDirectory(MAX_PATH,curDir);
		filePath=curDir;
	}
	
	// append the html file
	filePath += "\\";
    filePath += m_pIniFileExeLocal->GetValue("MAIN", "CameraSwitchingApp", "CamSwitchPanel.exe");

	CString params = m_pIniFileExeLocal->GetValue("MAIN", "CameraSwitchingAppParameters", "PITZ VIDMUX");

	//AfxMessageBox(filePath + " " + params);

    // open up default browser and display html file
    HINSTANCE ret = ::ShellExecute( this->m_hWnd, "open", (LPCTSTR) filePath, (LPCTSTR) params, "", SW_SHOWDEFAULT );	
	if (((unsigned int)ret) <=32 )
	{
		CString msg;
		msg.Format("Error starting camera switching application. Errorcode of ShellExecute was %u.", (unsigned int) ret);
		PrintServerMessage(msg);
		OwnMessageBox(MB_ICONEXCLAMATION, msg);
	}
}

void CVideoclntDlg::SetScaleFactorInGUI(double scalefac)
{
	char scalestr[20];

	sprintf(scalestr, "%#.7f", scalefac );
    
	m_CEditScale.SetWindowText( (LPCTSTR) scalestr );

	internalScaleFactor = scalefac;
}


// returns whether either starting or stopping was successful (TRUE) or not (FALSE)
BOOL CVideoclntDlg::TogglePollMode()
{
	BOOL bRet = FALSE;

	if (m_bPollMode == FALSE) // poll mode is set to false, then start it up
	{
		if (IsMenuItemEnabled(ID_IMAGE_POLL) == TRUE) // poll mode can be started ? 
		{
			// start up poll mode 
			bRet = StartPollMode();

			if (bRet == TRUE)
			{
				PrintServerMessage("Connected to server.");
				m_bPollMode = TRUE;
	   
				/* disable any item that could interfere with poll mode */
				SetMenuItem(ID_APPLICATION_PRINT, FALSE);
				SetMenuItem(ID_APPLICATION_PRINTWHOLEWINDOW, FALSE );
				SetMenuItem(ID_IMAGE_LOAD, FALSE);
				SetMenuItem(ID_IMAGE_SAVE, FALSE);
				SetMenuItem(ID_IMAGE_ANALYZE, FALSE);
				SetMenuItem(ID_BACKGROUND_GRAB, FALSE);
				SetMenuItem(ID_BACKGROUND_SHOW, FALSE);
				SetMenuItem(ID_BACKGROUND_ADD, FALSE);
				SetMenuItem(ID_APPLICATION_OPTIONS, FALSE);
				SetMenuItemByPos(1, 2, FALSE); /* Grab... */
				SetMenuItemByPos(1, 3, FALSE);
				SetMenuItemByPos(2, 4, FALSE); /* Background Get Envelope/Average */

				m_CEditScale.SetReadOnly(TRUE);

				// check poll mode (to indicate that it is on 
				CheckMenuItem( ID_IMAGE_POLL, TRUE);
			}
			else
			{
				OwnMessageBox(MB_ICONEXCLAMATION, "Error starting poll mode.");
			}
		}
	}
    else // poll mode is running, so shut it down
	{
		 PrintServerMessage("Leaving poll mode.");
		 // stop poll mode
		 bRet = StopPollMode();
		 if (bRet == FALSE)
		 {
			 OwnMessageBox(MB_ICONEXCLAMATION, "Error stopping poll mode.");
		 }

		 /* enable any item that was disabled when starting poll mode */
 		 SetMenuItem(ID_APPLICATION_PRINT, TRUE);
		 SetMenuItem(ID_APPLICATION_PRINTWHOLEWINDOW, TRUE );
		 SetMenuItem(ID_IMAGE_LOAD, TRUE);
		 SetMenuItem(ID_IMAGE_SAVE, TRUE);
		 SetMenuItem(ID_IMAGE_ANALYZE, TRUE);
		 SetMenuItem(ID_BACKGROUND_GRAB, TRUE);
		 SetMenuItem(ID_BACKGROUND_ADD, TRUE);
		 SetMenuItem(ID_BACKGROUND_SHOW, TRUE);
		 SetMenuItem(ID_APPLICATION_OPTIONS, TRUE);
		 SetMenuItemByPos(1, 2, TRUE); /* Grab */
		 SetMenuItemByPos(1, 3, TRUE);
		 SetMenuItemByPos(2, 4, TRUE);
		 m_CEditScale.SetReadOnly(FALSE);

		 // uncheck 'Poll' menuitem to indicate that poll mode is off
		 CheckMenuItem( ID_IMAGE_POLL, FALSE);

		 m_bPollMode = FALSE;
	}

	return bRet;
}

double CVideoclntDlg::GetCurrentScale()
{
	return( internalScaleFactor );
}

void CVideoclntDlg::OwnMessageBox(UINT additional_styles, const char *format, ...)
{
	char m_msg[1026];
	UINT styles;
	CString singleLine;
	BOOL b1;
	int i=0;
	
	va_list args;
	va_start(args, format);
	_vsnprintf(m_msg, 1024, format, args);
	va_end(args);

	styles = MB_OK | MB_SETFOREGROUND;
	styles |= additional_styles;
		
	::MessageBox( NULL, (LPCTSTR) m_msg, _T("Video Client 2"), styles);

	// split lines and put in log file afterwards (line by line)
	i=0;
	while ( b1 = AfxExtractSubString(singleLine,m_msg,i++,'\n') )
	{
		PutToErrorLog( singleLine );
	}
}

void CVideoclntDlg::PutToErrorLog(const char *format, ...)
{
	// SW! June 29, 2006   function added
	// no error handling here!
	FILE *logfile;
	char m_msg[1026];
	CString logfileName;

	logfileName = m_sExecutableDirectory+"\\videoclnt2.log";

	va_list args;
	va_start(args, format);
	_vsnprintf(m_msg, 1024, format, args);
	va_end(args);
	
	logfile = fopen((LPCTSTR) logfileName, "at");
	if (logfile == NULL) return;
	fprintf(logfile, "%s\n", m_msg);
	fclose(logfile);
}

//  1 exists and is writable
// -1 does not exists
// -2 exists but is not writable
int CVideoclntDlg::CheckDirectory(CString dir)
{
    BOOL dir_exists=FALSE;
	BOOL dir_writable=FALSE;

	// check, whether the directory exists
	if (GetFileAttributes((LPCTSTR) dir) != 0xFFFFFFFF)
	{
      dir_exists = TRUE;

      CString filename = dir+"___123456789.tmp";
	 
  	  FILE *fp = fopen((LPCTSTR) filename, "wb");
	  if (fp != NULL)
	  {
	   char buffer[10];
	   int ret = fwrite( buffer, 1, 10, fp);
	   if (ret == 10) dir_writable = TRUE;
	   fclose(fp);
	   remove( filename );
      }
	}

	if (dir_exists == FALSE) return( -1 );
	if (dir_writable == FALSE) return( -2 );

    return( 1 );
}

CString CVideoclntDlg::GetExecutableDirectory()
{
 return m_sExecutableDirectory;
}

BOOL CVideoclntDlg::CheckFrameheaderSettings(const VIDHDR &vidH)
{
	if ((vidH.widthframe == (unsigned)m_iActualWidth) && (vidH.heightframe == (unsigned)m_iActualHeight) && (vidH.bpp == (unsigned)m_iActualBpp) && (vidH.bpp_effective == (unsigned) m_iActualBppEffective))
		return TRUE;

	return FALSE;
}
